! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

! 外部型表現が存在する処理系に関しては型を示す文字列を、
! そうでない処理系に関しては空文字列を返す。

subroutine GTVarGetXtype(var, xtype)
    use gtdata_types, only: GT_VARIABLE
    use dc_string, only: VSTRING
    use gtdata_generic, only: get_attr
    implicit none
    type(GT_VARIABLE), intent(in):: var
    type(VSTRING), intent(out):: xtype
    call get_attr(var, "__xtype__", xtype, default="")
end subroutine

! C の sprintf(3) とは大分違うので注意。
!

subroutine DCStringPrintf(unit, fmt, i, r, d, L, s, n, c1, c2, c3)
    use dcstring_base, only: VSTRING, assignment(=), operator(//)
    implicit none
    type(VSTRING), intent(out):: unit
    character(*), intent(in):: fmt
    integer, intent(in), optional:: i(:), n(:)
    real, intent(in), optional:: r(:)
    double precision, intent(in), optional:: d(:)
    logical, intent(in), optional:: L(:)
    type(VSTRING), intent(in), optional:: s(:)
    character(*), intent(in), optional:: c1, c2, c3
    ! 上記配列のカウンタ
    integer:: ni, nr, nd, nl, ns, nc, nn
    integer:: cur, endp, ptr, repeat, m
    character(80):: cbuf
continue
    ni = 0;  nr = 0;  nd = 0;  nl = 0;  ns = 0;  nc = 0;  nn = 0
    unit = ""
    endp = 0
    MainLoop: do
        cur = endp + 1
        if (cur > len(fmt)) exit MainLoop
        !
        ! リテラルに転写できる文字列 fmt(cur:endp-1) を発見処理
        !
        endp = cur - 1 + scan(fmt(cur: ), '%')
        if (endp > cur) then
            unit = unit // fmt(cur:endp-1)
        else if (endp == cur - 1) then
            unit = unit // fmt(cur: )
            exit
        endif
        !
        ! % から書式指定文字までを fmt(cur:endp) とする
        !
        cur = endp + 1
        endp = cur - 1 + scan(fmt(cur: ), 'DdOoXxFfRrBbYySsCc%')
        if (endp < cur) then
            unit = unit // fmt(cur-1: )
            exit
        endif
        cbuf = fmt(cur:endp-1)
        if (cbuf(1:1) == '*') then
            nn = nn + 1
            if (nn > size(n)) then
                repeat = 1
            else
                repeat = n(nn)
            endif
        else if (cbuf == '') then
            repeat = 1
        else
            ptr = verify(cbuf, " 0123456789")
            if (ptr > 0) cbuf(ptr: ) = " "
            read(cbuf, "(I80)", iostat=ptr) repeat
        endif
        PercentRepeat: do, m = 1, repeat
            if (m > 1) unit = unit // ", "
            select case(fmt(endp:endp))
            case('d', 'D')
                if (.not. present(i)) cycle MainLoop
                ni = ni + 1;  if (ni > size(i)) cycle MainLoop
                write(cbuf, "(i20)") i(ni)
                unit = unit // trim(adjustl(cbuf))
            case('o', 'O')
                if (.not. present(i)) cycle MainLoop
                ni = ni + 1;  if (ni > size(i)) cycle MainLoop
                write(cbuf, "(o20)") i(ni)
                unit = unit // trim(adjustl(cbuf))
            case('x', 'X')
                if (.not. present(i)) cycle MainLoop
                ni = ni + 1;  if (ni > size(i)) cycle MainLoop
                write(cbuf, "(z20)") i(ni)
                unit = unit // trim(adjustl(cbuf))
            case('f', 'F')
                if (.not. present(d)) cycle MainLoop
                nd = nd + 1;  if (nd > size(d)) cycle MainLoop
                write(cbuf, "(g80.40)") d(nd)
                cbuf = adjustl(cbuf)
                ptr = verify(cbuf, " 0", back=.TRUE.)
                if (ptr > 0) cbuf(ptr+1: ) = " "
                unit = unit // trim(cbuf)
            case('r', 'R')
                if (.not. present(r)) cycle MainLoop
                nr = nr + 1;  if (nr > size(r)) cycle MainLoop
                write(cbuf, "(g80.40)") r(nr)
                cbuf = adjustl(cbuf)
                ptr = verify(cbuf, " 0", back=.TRUE.)
                if (ptr > 0) cbuf(ptr+1: ) = " "
                unit = unit // trim(cbuf)
            case('b', 'B')
                if (.not. present(L)) cycle MainLoop
                nl = nl + 1;  if (nl > size(L)) cycle MainLoop
                write(cbuf, "(L1)") L(nl)
                unit = unit // trim(adjustl(cbuf))
            case('y', 'Y')
                if (.not. present(L)) cycle MainLoop
                nl = nl + 1;  if (nl > size(L)) cycle MainLoop
                if (L(nl)) then
                  unit = unit // "yes"
                else
                  unit = unit // "no"
                endif
            case('s', 'S')
                if (.not. present(S)) cycle MainLoop
                ns = ns + 1;  if (ns > size(S)) cycle MainLoop
                unit = unit // s(ns)
            case('c', 'C')
                nc = nc + 1
                if (nc == 1) then
                    if (present(c1)) unit = unit // c1
                else if (nc == 2) then
                    if (present(c2)) unit = unit // c2
                else if (nc == 3) then
                    if (present(c3)) unit = unit // c3
                endif
            case('%')
                unit = unit // '%'
            end select
        enddo PercentRepeat
    enddo MainLoop
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

subroutine GTVarGetReal2(var, value, err)
    use gtdata_types, only: gt_variable
    use gtdata_generic, only: get_slice, gtvargetreal, inquire
    use gt_map, only: map_set_rank
    use dc_error, only: storeerror, dc_noerr
    implicit none
    type(gt_variable), intent(inout):: var
    real, pointer:: value(:, :)
    logical, intent(out), optional:: err
    integer:: stat, n(2)
continue
    call map_set_rank(var, 2, stat)
    if (stat /= dc_noerr) goto 999
    call get_slice(var, dimord=1, count=n(1), count_compact=.false.)
    call get_slice(var, dimord=2, count=n(2), count_compact=.false.)
    allocate(value(n(1), n(2)))
    call gtvargetreal(var, value, product(n), err)
999 continue
    call storeerror(stat, 'gtvargetreal2')
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

! dimord 番目の次元について入出力範囲指定を取り出す。
!
subroutine GTVarGetSlice(var, dimord, start, count, stride, count_compact)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: gt_dimmap, map_lookup, dimord_skip_compact
    implicit none
    type(gt_variable), intent(in):: var
    integer, intent(in):: dimord
    integer, intent(out), optional:: start
    integer, intent(out), optional:: count
    integer, intent(out), optional:: stride
    logical, intent(in), optional:: count_compact
    type(gt_dimmap), pointer:: map(:)
    integer:: vid, udimord, ndims
    logical:: allmode
continue
    allmode = .true.
    if (present(count_compact)) allmode = count_compact
    call map_lookup(var, vid=vid, ndims=ndims)
    if (vid < 0 .or. ndims <= 0) goto 999
    allocate(map(ndims))
    call map_lookup(var, map=map)
    if (allmode) then
        udimord = dimord
    else
        udimord = dimord_skip_compact(dimord, map)
    endif
    if (udimord < 1 .or. udimord > size(map)) goto 997

    if (present(start)) start = map(udimord)%start
    if (present(count)) count = map(udimord)%count
    if (present(stride)) stride = map(udimord)%stride
    deallocate(map)
    return

997 continue
    deallocate(map)
999 continue
    if (present(start)) start = -1
    if (present(count)) count = -1
    if (present(stride)) stride = -1
end subroutine

! getline.f90 - コマンド行読み取りモジュール
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved
! vi: set sw=4:

module getline

    use dc_string
    use varying_string_list
    implicit none
    private
    public:: ask, prompt, set_prompt, ask_tokens, get_tokens

    interface set_prompt
	module procedure set_prompt_chars
	module procedure set_prompt_string
    end interface

    type(VSTRING), save:: prompt_string
    logical, save:: first = .TRUE.

contains

    ! private
    subroutine initialize
	if (.not. first) return
	first = .FALSE.
	prompt_string = '> '
    end subroutine

    subroutine set_prompt_string(prompt)
	type(VSTRING), intent(in):: prompt
    continue
	call initialize
	prompt_string = prompt
    end subroutine

    subroutine set_prompt_chars(prompt)
	character(len=*), intent(in):: prompt
    continue
	call initialize
	prompt_string = prompt
    end subroutine

    type(VSTRING) function prompt()
	call initialize
	prompt = prompt_string
    end function

    subroutine ask(line, iostat, prompt)
	type(VSTRING), intent(out):: line
	integer, intent(out), optional:: iostat
	type(VSTRING), intent(in), optional:: prompt
    continue
	call initialize
	if (present(prompt)) then
	    call put(prompt)
	else
	    call put(prompt_string)
	endif
	call get(line, iostat=iostat)
    end subroutine

    subroutine get_tokens(line, tokens)
	type(VSTRING), intent(in):: line
	type(STRING_LIST), intent(inout):: tokens
	type(VSTRING):: buffer, word, sep
	character, parameter:: HT = char(8)
	character, parameter:: CR = char(13)
	character, parameter:: APOSTROPHE = "'"
	character, parameter:: DOUBLE_QUOTE = '"'
	character(len = *), parameter:: WHITESPACE = " " // HT // CR
	character(len = *), parameter:: DELIMITERS &
	    & = WHITESPACE // APOSTROPHE // DOUBLE_QUOTE
	integer:: start
    continue
	call clear(tokens)

	! 行頭が空白の場合読み飛ばす
	start = verify(char(line), set=WHITESPACE)
	! 空行に対しては何もしない
	if (start == 0) return

	! 字句解析開始
	buffer = extract(line, start)
	do
	    call split(buffer, set=DELIMITERS, word=word, separator=sep)
	    if (sep == APOSTROPHE) then
		call split(buffer, set=APOSTROPHE, word=word)
		call push(tokens, word)
		cycle
	    else if (sep == DOUBLE_QUOTE) then
		call split(buffer, set=DOUBLE_QUOTE, word=word)
		call push(tokens, word)
		cycle
	    endif
	    if (word /= "") call push(tokens, word)
	    start = verify(char(buffer), set=WHITESPACE)
	    if (start == 0) exit
	    buffer = extract(buffer, start)
	enddo
    end subroutine

    subroutine ask_tokens(tokens, iostat, prompt)
	type(STRING_LIST), intent(inout):: tokens
	integer, intent(out), optional:: iostat
	type(VSTRING), intent(in), optional:: prompt
	type(VSTRING):: line
    continue
	call ask(line, iostat=iostat, prompt=prompt)
	call get_tokens(line, tokens)
    end subroutine

end module

! gtdata_variable.f90 - gtool 変数の手続総称宣言
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

module gtdata_generic

    implicit none
    !
    ! 基本開閉動作
    !

    interface open

        ! 
        ! open(var, url, [writable], [err]) は url で識別される
        ! 変数を開き var に格納する。writable を真に指定すると
        ! 書き込み可で開こうとする。デフォルトは writable=.FALSE. である。
        ! エラーが発生した場合は err が真となる。err を与えなければプログラムは停止する。
        !
        subroutine GTVarOpen(var, url, writable, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(out):: var
            character(*), intent(in):: url
            logical, intent(in), optional:: writable
            logical, intent(out), optional:: err
        end subroutine
        
        !
        ! 既に開かれた変数 source_var の ord 番目の次元にあたる変数を
        ! 開き var に格納する。順序 ord は現在の入出力範囲が
        ! 幅１になっている (コンパクト化している）を飛ばした
        ! 順序であるが、count_compact に真を指定すると
        ! すべての次元のなかの順序になる。
        !
        ! ord == 0 の場合は変数自体を再度開く。これは参照カウンタを
        ! 増加させる手段である。
        !
        subroutine GTVarOpenByDimOrd(var, source_var, dimord, &
            count_compact, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(out):: var
            type(GT_VARIABLE), intent(in):: source_var
            integer, intent(in):: dimord
            logical, intent(in), optional:: count_compact
            logical, intent(out), optional:: err
        end subroutine

    end interface

    interface create
        !
        ! 従属変数 create
        !
        ! create(var, url, [dims], [xtype], [overwrite], [err]) は
        ! 場所 url に次元 dims を持った変数を作成し、それを開いた
        ! ものを var に格納する。型 xtype を省略すると "float" と
        ! みなされる。既存変数があるとき失敗するが
        ! overwrite が真であれば続行する。
        ! dims の省略は 0 次元変数の設定を意味する。
        !
        subroutine GTVarCreate(var, url, dims, xtype, long_name, overwrite, err)
            use gtdata_types, only: gt_variable
            type(gt_variable), intent(inout):: var
            character(len = *), intent(in):: url
            type(gt_variable), intent(in), optional:: dims(:)
            character(len = *), intent(in), optional:: xtype
            character(len = *), intent(in), optional:: long_name
            logical, intent(in), optional:: overwrite
            logical, intent(out), optional:: err
        end subroutine
        !
        ! 独立変数 create
        !
        ! 長さ length の自分自身を次元とする変数を作成する。
        ! 長さ length = 0 の変数は可変長である。
        !
        subroutine GTVarCreateD(var, url, length, xtype, long_name, overwrite, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: url
            integer, intent(in):: length
            character(len = *), intent(in), optional:: xtype
            character(len = *), intent(in), optional:: long_name
            logical, intent(in), optional:: overwrite
            logical, intent(out), optional:: err
        end subroutine
    end interface

    interface close
        subroutine GTVarClose(var, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            logical, intent(out), optional:: err
        end subroutine
    end interface

    !
    ! --- 属性関係 ---
    !

    interface attr_rewind
        subroutine GTVarAttrRewind(var)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
        end subroutine
    end interface

    interface attr_next
        subroutine GTVarAttrNext(var, name, end)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(*), intent(out):: name
            logical, intent(out), optional:: end
        end subroutine
    end interface

    ! 論理型読み取りは関数インターフェイスも提供
    interface attr_true
        logical function GTVarAttrTrue(var, name, default)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            logical, intent(in), optional:: default
        end function
    end interface

    interface get_attr

        ! 文字列として読み取る場合は元の長さは正確に受け取られる。
        ! 属性が存在しない場合 default 値を使う。

        subroutine GTVarGetAttrSC(var, name, value, default)
            use dc_string, only: VSTRING    
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            type(VSTRING), intent(out):: value
            character(len = *), intent(in), optional:: default
        end subroutine

        ! character 型で受け取る場合は通常の文字型代入と同様、
        ! 受け側変数の長さに合わせて切り捨て・空白埋めを行う。
        ! 属性が存在しない場合 default 値を使う。

        subroutine GTVarGetAttrCC(var, name, value, default)
            use dc_string, only: VSTRING    
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            character(len = *), intent(out):: value
            character(len = *), intent(in), optional:: default
        end subroutine

        ! スカラで受け取るのが一番簡単。解釈可能な値がとられ、残りは捨てられる。

        subroutine GTVarGetAttrR(var, name, value, default)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            real, intent(out):: value
            real, intent(in), optional:: default
        end subroutine

        subroutine GTVarGetAttrD(var, name, value, default)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            double precision, intent(out):: value
            double precision, intent(in), optional:: default
        end subroutine

        subroutine GTVarGetAttrI(var, name, value, default)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            integer, intent(out):: value
            integer, intent(in), optional:: default
        end subroutine

        ! ポインタ配列を使って受け取る場合は解釈可能な数だけ実体が割り付けられる。

        subroutine GTVarGetAttrRP(var, name, value)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            real, pointer:: value(:)
        end subroutine

        subroutine GTVarGetAttrDP(var, name, value)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            double precision, pointer:: value(:)
        end subroutine

        subroutine GTVarGetAttrIP(var, name, value)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            integer, pointer:: value(:)
        end subroutine

        ! integer 配列, real 配列として受け取る
        ! 場合は属性長があまっている場合には切り捨てられ、
        ! 属性長が足りない場合は default 値 (ポインタと違い必須) を埋める。

        subroutine GTVarGetAttrRA(var, name, value, default)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            real, intent(out):: value(:)
            real, intent(in):: default
        end subroutine

        subroutine GTVarGetAttrDA(var, name, value, default)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            double precision, intent(out):: value(:)
            double precision, intent(in):: default
        end subroutine

        subroutine GTVarGetAttrIA(var, name, value, default)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            integer, intent(out):: value(:)
            integer, intent(in):: default
        end subroutine

    end interface

    interface put_attr

        subroutine GTVarPutAttrString(var, name, value, err)
            use dc_string, only: VSTRING    
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: name
            type(VSTRING), intent(in):: value
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutAttrChar(var, name, value, xtype, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: name
            character(len = *), intent(in):: value
            character(len = *), intent(in), optional:: xtype
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutAttrReal(var, name, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: name
            real, intent(in):: value(:)
            real, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutAttrDouble(var, name, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: name
            double precision, intent(in):: value(:)
            real, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutAttrInt(var, name, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: name
            integer, intent(in):: value(:)
            real, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutAttrLogical(var, name, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: name
            logical, intent(in):: value
            real, intent(out), optional:: err
        end subroutine

    end interface

    interface del_attr
        subroutine GTVarDelAttr(var, name, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: name
            logical, intent(out), optional:: err
        end subroutine
    end interface

    interface copy_attr

        subroutine GTVarCopyAttr(to, attrname, from, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: to
            character(len = *), intent(in):: attrname
            type(GT_VARIABLE), intent(in):: from
            logical, intent(out), optional:: err
        end subroutine

        subroutine gtvarcopyattrall(to, from, err)
            use gtdata_types, only: gt_variable
            type(gt_variable), intent(inout):: to
            type(gt_variable), intent(inout):: from
            logical, intent(out):: err
        end subroutine

    end interface

    !
    ! --- 次元関係 ---
    !

    ! 現在の入出力範囲の大きさは inquire(var, size=) で取得できる

    interface slice

        ! おまかせ指示
        ! compatible を指定するとまったく同じに指定
        subroutine GTVarSliceAuto(var, compatible)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            type(GT_VARIABLE), intent(in), optional:: compatible
        end subroutine

        ! もじれつによるしじ
        subroutine GTVarSliceC(var, slicespec, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: slicespec
	    logical, intent(out):: err
        end subroutine

        ! 次元を指定した指示
        subroutine GTVarSlice(var, dimord, start, count, stride)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            integer, intent(in):: dimord
            integer, intent(in), optional:: start
            integer, intent(in), optional:: count
            integer, intent(in), optional:: stride
        end subroutine
    end interface

    interface get_slice

        ! 次元順番を指定して取得
        subroutine GTVarGetSlice(var, dimord, start, count, stride, count_compact)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            integer, intent(in):: dimord
            integer, intent(out), optional:: start
            integer, intent(out), optional:: count
            integer, intent(out), optional:: stride
            logical, intent(in), optional:: count_compact
        end subroutine

        ! 全次元について一括取得
        ! あらかじめ inquire(var, alldims) して配列を確保する。
        subroutine GTVarGetSliceAll(var, start, count, stride)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            integer, intent(out), optional:: start(:), count(:), stride(:)
        end subroutine

    end interface

    interface dimname_to_dimord
        integer function gtdim_name2ord(var, name)
            use gtdata_types, only: gt_variable
            type(gt_variable), intent(in):: var
            character(len = *), intent(in):: name
        end function
    end interface

    ! limit: 空間変換器機能のセットアップ
    !
    interface limit

        subroutine GTVarLimit(var, string, err)
            use gtdata_types, only: gt_variable
            type(gt_variable), intent(in):: var
            character(len = *), intent(in):: string
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarLimit_iiii(var, dimord, start, count, stride, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            integer, intent(in):: dimord
            integer, intent(in), optional:: start, count, stride
            logical, intent(out), optional:: err
        end subroutine

    end interface

    interface transform

        subroutine GTVarXformBinary(var1, var2, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var1, var2
            logical, intent(out), optional:: err
        end subroutine

    end interface

    ! 明示的空間変換機能

    ! 変数ハンドル var の dimord 番目の位置に次元
    ! dimvar を追加する。dimord 番目以降の次元は一つ後ろにずれる。
    ! もし dimord が var の有効次元数より大きければ (有効次元数 + 1)
    ! が与えられたものとみなされる。
    interface add_dim
        subroutine gtvaradddim(var, dimord, dimvar, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            type(GT_VARIABLE), intent(in):: dimvar
            integer, intent(in):: dimord
            logical, intent(out):: err
        end subroutine
    end interface

    ! 変数ハンドルから次元を「除去」する。実際には、
    ! 次元対応表の順位を下げ有効次元数をデクリメントするだけなので、
    ! 入出力に支障はない。
    interface del_dim
        subroutine gtvardeldim(var, dimord, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            integer, intent(in):: dimord
            logical, intent(out):: err
        end subroutine
    end interface

    ! 次元対応表の順位の交換
    interface exch_dim
        subroutine gtvarexchdim(var, dimord1, dimord2, count_compact, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            integer, intent(in):: dimord1, dimord2
            logical, intent(in), optional:: count_compact
            logical, intent(out):: err
        end subroutine
    end interface

    !
    ! --- 問い合わせ ---
    !

    interface inquire

        subroutine GTVarInquire(var, growable, &
            & rank, alldims, allcount, size, &
            & xtype, name, url)
            use gtdata_types, only: gt_variable
            type(gt_variable), intent(in):: var
            ! 外部型の名前
            character(len=*), intent(out), optional:: xtype
            ! name は変数名の最小の単位を返す。
            ! ファイル名を含まないためプログラム内での一意性は保証されない。
            character(len=*), intent(out), optional:: name
            ! url はファイル名のついた変数名を返す。プログラム内で
            ! 一意である。
            character(len=*), intent(out), optional:: url
            ! コンパクト(縮退)次元を数えない, 次元の数
            integer, intent(out), optional:: rank
            ! 縮退次元を含む全次元数。dimord には基本的にこちらを使う
            integer, intent(out), optional:: alldims
            ! 変数が次元変数である場合、総数を返す。エラーはゼロ。
            integer, intent(out), optional:: allcount
            ! 変数の入出力領域の大きさ。
            integer, intent(out), optional:: size
            ! 変数が次元変数である場合、自動拡張可能か否かを返す。
            ! そうでない場合は不定。
            logical, intent(out), optional:: growable
        end subroutine

        subroutine GTVarInquire2(var, allcount)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            ! alldims 個必要
            integer, intent(out):: allcount(:)
        end subroutine

        subroutine GTVarInquireD(var, dimord, url, allcount)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            integer, intent(in):: dimord
            character(len=*), intent(out), optional:: url
            integer, intent(out), optional:: allcount
        end subroutine

        subroutine GTVarInquireA(var, attrname, xtype)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len=*), intent(in):: attrname
            character(len=*), intent(out), optional:: xtype
        end subroutine
    end interface

    ! 総なめ用イテレータ
    interface slice_next
        subroutine GTVarSliceNext(var, dimord, err, stat)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in out):: var
            integer, intent(in), optional:: dimord
            logical, intent(out), optional:: err
            integer, intent(out), optional:: stat
        end subroutine
    end interface

    ! 同値判定
    interface operator(.equivalent.)
        logical function gtvarequivalent(var1, var2)
            use gtdata_types, only: gt_variable
            type(gt_variable), intent(in):: var1, var2
        end function
    end interface

    !
    ! === 入出力 ===
    !
    ! --- 入力 ---
    !
    ! get(var, value, nvalue, [err])
    ! 1次元配列に現在の入出力範囲を取得する。
    ! nvalue は利用者が配列長を格納しなければならない。
    ! 個別名 GTVarGetReal を用いると多次元配列に入力
    ! することもできるが、入出力範囲との関係に注意が必要。
    !
    ! get(var, value, [err]) は 1〜3 次元のポインタをとる。
    ! 入出力範囲をポインタ次元数に限定し、配列を確保し、
    ! 値を入れて返す。通常はこれを用いることになろう。
    !

    interface get

        subroutine GTVarGetReal(var, value, nvalue, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            real, intent(out):: value(*)
            integer, intent(in):: nvalue
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarGetReal1(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            real, pointer:: value(:)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarGetReal2(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            real, pointer:: value(:, :)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarGetReal3(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            real, pointer:: value(:, :, :)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarGetDouble(var, value, nvalue, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            double precision, intent(out):: value(*)
            integer, intent(in):: nvalue
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarGetDouble1(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            double precision, pointer:: value(:)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarGetDouble2(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            double precision, pointer:: value(:, :)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarGetDouble3(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            double precision, pointer:: value(:, :, :)
            logical, intent(out), optional:: err
        end subroutine

    end interface

    !
    ! --- 印字 ---
    !
    ! 印字というのは変数にしてみれば入力だしファイルにしてみれば出力だ。
    ! だから put と get を兼営しているようなものでまことにあやしいのだが、
    ! いちおう dc_string の手続名を継承して put_line にしておく。

    interface put_line
        subroutine GTVarPutLine(var, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            logical, intent(out), optional:: err
        end subroutine
    end interface

    !
    ! --- 出力 ---
    !

    interface put

        subroutine GTVarPutReal(var, value, nvalue, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            real, intent(in):: value(*)
            integer, intent(in):: nvalue
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutReal1(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            real, intent(in):: value(:)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutReal2(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            real, intent(in):: value(:, :)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutReal3(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            real, intent(in):: value(:, :, :)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutDouble(var, value, nvalue, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            double precision, intent(in):: value(*)
            integer, intent(in):: nvalue
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutDouble1(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            double precision, intent(in):: value(:)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutDouble2(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            double precision, intent(in):: value(:, :)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutDouble3(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            double precision, intent(in):: value(:, :, :)
            logical, intent(out), optional:: err
        end subroutine

    end interface

    !
    ! === 変数とファイルの関係 ===
    !

    interface GTVarSearch
        
        subroutine GTVarSearchInit(urlBase)
            character(len = *), intent(in):: urlBase
        end subroutine

        subroutine GTVarSearchNext(url, end)
            character(len = *), intent(out):: url
            logical, intent(out):: end
        end subroutine

    end interface        

    !
    ! === 安全のための脱出口 ===
    !
    ! SysDepAbort が呼び出すので、StoreError を呼んではならない
    !

    interface
        subroutine GTVarSync(var, stat)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout), optional:: var
            integer, intent(out), optional:: stat
        end subroutine
    end interface


    !
    ! === ユーティリティ ===
    !
    ! gtdata 層だけで書かれたライブラリ。

    ! Create(var, url, copyfrom, [copyvalue], [overwrite], [err])
    ! は変数 copyfrom と同じ次元、属性を持った変数を作成する。
    ! 必要ならば次元変数も複製される。
    ! copyvalue を真に指定すると値も複製される。
    !
    interface Create
        subroutine GTVarCreateCopyC(var, url, copyfrom, copyvalue, &
            & overwrite, err)
            use gtdata_types, only: GT_VARIABLE
            implicit none
            type(GT_VARIABLE), intent(out):: var
            character(len = *), intent(in):: url
            type(GT_VARIABLE), intent(inout):: copyfrom
            logical, intent(in), optional:: copyvalue
            logical, intent(in), optional:: overwrite
            logical, intent(out), optional:: err
        end subroutine
    end interface

    interface GTVarDel
        subroutine GTVarDel1(varname, err)
            character(len = *), intent(in):: varname
            logical, intent(out):: err
        end subroutine
    end interface

    !
    ! --- 構造体関係 ---
    !

    interface add_member
        subroutine GTVarAddMember(var, url, link_name)
            use gtdata_types, only: GT_VARIABLE
            use dc_string, only: VSTRING
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: url
            character(len = *), intent(in), optional:: link_name
        end subroutine
    end interface

    ! 一意な変数名の自動作成
    interface 
        subroutine GTDataTmpNam(file, base, result)
            character(len = *), intent(in):: file
            character(len = *), intent(in):: base
            character(len = *), intent(out):: result
        end subroutine
    end interface


end module

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

subroutine ANAttrGetChar(var, name, value, default, stat)
    use an_types, only: AN_VARIABLE, an_variable_entry
    use an_vartable, only: vtable_lookup
    use netcdf_f77
    use dc_url, only: GT_PLUS
    use dc_string, only: toChar
    use dc_trace, only: beginsub, endsub
    use dc_error
    implicit none
    type(AN_VARIABLE), intent(in):: var
    character(len = *), intent(in):: name
    character(len = *), intent(out):: value
    character(len = *), intent(in):: default
    integer, intent(out):: stat
    type(an_variable_entry):: ent
    character(len = 64):: buffer
    double precision, allocatable:: dbuf(:)
    integer, allocatable:: ibuf(:)
    character, allocatable:: cbuf(:)
    integer:: xtype, attrlen, i, iname, varid
    character(len = *), parameter:: subname = "anattrgetchar"
continue
    call beginsub(subname, "var=%d name=%c default=%c", i=(/var%id/), &
        & c1=trim(name), c2=trim(default))
    stat = vtable_lookup(var, ent)
    if (stat /= NF_NOERR) goto 900
    if (name(1:1) == GT_PLUS) then
        varid = nf_global
        iname = 2
    else
        varid = ent%varid
        iname = 1
    endif
    stat = nf_inq_att(ent%fileid, varid, name(iname:), xtype=xtype, len=attrlen)
    if (stat /= NF_NOERR) goto 900
    if (xtype == NF_CHAR .and. attrlen <= len(buffer)) then
        stat = nf_get_att_text(ent%fileid, varid, name(iname:), buffer)
        if (stat /= NF_NOERR) goto 900
        value = buffer(1: attrlen)
        if (attrlen > len(value)) stat = GT_ECHARSHORT
    else if (xtype == NF_CHAR) then
        ! UNIDATA NetCDF ライブラリでは文字列引数の長さを
        ! まったく取得していないので先頭が結合していれば OK のはず
        allocate(cbuf(attrlen))
        stat = nf_get_att_text(ent%fileid, varid, name(iname:), cbuf(1))
        if (stat /= NF_NOERR) goto 900
        do, i = 1, attrlen
            value(i:i) = cbuf(i)
        enddo
        if (attrlen < len(value)) value(attrlen + 1: ) = ' '
        if (attrlen > len(value)) stat = GT_ECHARSHORT
        deallocate(cbuf)
    else if (xtype == NF_DOUBLE .or. xtype == NF_FLOAT) then
        allocate(dbuf(attrlen))
        stat = nf_get_att_double(ent%fileid, varid, name(iname:), dbuf)
        if (stat /= NF_NOERR) goto 900
        value = toChar(dbuf)
        deallocate(dbuf)
    else
        allocate(ibuf(attrlen))
        stat = nf_get_att_int(ent%fileid, varid, name(iname:), ibuf)
        if (stat /= NF_NOERR) goto 900
        value = toChar(ibuf)
        deallocate(ibuf)
    endif
    call endsub(subname)
    return
    ! デフォルト処理
900 continue
    value = default
    call endsub(subname, "value := default")
    return
end subroutine

! gtfig.f90 - Definitions of Gtool Figure Subroutines
! Copyright (C) TOYODA Eizi, 2000.  All rights reserved.

! GTFigPutCont, GTFigPutLine はそれぞれ
! gtcontlib.f90, gtlinelib.f90 にある。

subroutine GTFigOpen(fig)
    use gtgraph_types, only: GT_FIGURE
    use dc_string
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_FIGURE), intent(out):: fig
    call beginsub('gtfigopen')
    nullify(fig%h_axis)
    nullify(fig%v_axis)
    nullify(fig%contours)
    nullify(fig%vectors)
    nullify(fig%line)
    fig%animate = .FALSE.
    fig%title = 'untitled'
    fig%projection = 1
    fig%stdlon = 180.0
    fig%stdlat = 0.0
    fig%rotate = 0.0
    fig%aspect = 0.0
    fig%fill = 0.6
    fig%shift = 0.025
    fig%ceil = 0.65
    call endsub('gtfigopen')
end subroutine

subroutine GtFigOption(fig, optname, value, err)
    use gtgraph_types, only: GT_FIGURE
    use gtgraph_generic, only: Option
    use dc_string, only: assignment(=)
    use dc_string, only: stoi, stod, toUpper, get_array
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(GT_FIGURE), intent(inout):: fig
    character(len = *), intent(in):: optname
    character(len = *), intent(in):: value
    character(len = len(optname)):: uc_name
    logical, intent(out):: err
continue
    call beginsub('gtfigoption', '<%c>=<%c>', c1=optname, c2=value)
    err = .FALSE.
    uc_name = optname
    call toUpper(uc_name)
    select case(uc_name)
    case("TITLE")
        fig%title = value
    case("-ANIMATE")
        fig%animate = .TRUE.
        call message('figure animation enabled')
    case("-NEXT")
        if (fig%animate) then
            call internal_next_slice
        else
            call message('figure animation disabled, so -next ignored')
            err = .TRUE.
        endif
    case('PROJ', '-PROJ', 'FIG/PROJ')
        fig%projection = stoi(value)
    case('STDLON', '-STDLON', 'PJX', 'FIG/PJX')
        fig%stdlon = stod(value)
    case('STDLAT', '-STDLAT', 'PJY', 'FIG/PJY')
        fig%stdlat = stod(value)
    case('ROTATE', '-ROTATE', 'ROT', 'FIG/ROT')
        fig%rotate = stod(value)
    case('ASPECT', '-ASPECT', 'ASP', 'FIG/ASP')
        fig%aspect = stod(value)
    case('FILL', '-FILL', 'FIL', 'FIG/FIL')
        fig%fill = stod(value)
    case('SHIFT', '-SHIFT', 'SHF', 'FIG/SHF')
        fig%shift = stod(value)
    case('CEIL', '-CEIL', 'CEL', 'FIG/CEL')
        fig%ceil = stod(value)
    case default
        err = .TRUE.
    end select
    call endsub('gtfigoption')
    return
contains

    subroutine internal_next_slice
        integer:: i
        logical:: alleof
        alleof = .TRUE.
        if (associated(fig%contours)) then
            do, i = 1, size(fig%contours)
                call Option(fig%contours(i), optname, value, err)
                if (.not. err) alleof = .FALSE.
            enddo
        endif
        if (associated(fig%line)) then
            do, i = 1, size(fig%line)
                call Option(fig%line(i), optname, value, err)
                if (.not. err) alleof = .FALSE.
            enddo
        endif
        err = alleof
    end subroutine

end subroutine

    ! 今のところ持ち物のうち axis だけを閉じる。なぜかというと axis 以外は
    ! 変数の reopen をサボっているので、ここで閉じるとおかしなことになるから。
subroutine GTFigClose(fig)
    use gtgraph_types, only: GT_FIGURE
    use gtgraph_generic, only: Close
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_FIGURE), intent(out):: fig
    call beginsub('gtfigclose')
    if (associated(fig%h_axis)) then
        call Close(fig%h_axis)
        deallocate(fig%h_axis)
    endif
    if (associated(fig%v_axis)) then
        call Close(fig%v_axis)
        deallocate(fig%v_axis)
    endif
    if (associated(fig%vectors)) then
        deallocate(fig%vectors)
    endif
    if (associated(fig%contours)) then
        deallocate(fig%contours)
    endif
    if (associated(fig%line)) then
        deallocate(fig%line)
    endif
    call endsub('gtfigclose')
end subroutine

subroutine GTFigBindAxis(fig, axis, vertical)
    use gtgraph_types, only: GT_FIGURE, GT_AXIS
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_FIGURE), intent(inout):: fig
    type(GT_AXIS), pointer:: axis
    logical, intent(in), optional:: vertical
continue
    if (present(vertical)) axis%vertical = vertical
    call beginsub('gtfigbindaxis')
    !
    ! 今は縦軸になるかどうかは最初から決定しているが、
    ! 将来はここで軸の立ちたがり度を勝負させる
    !
    if (axis%vertical) then
        if (.not. associated(fig%v_axis)) allocate(fig%v_axis)
        fig%v_axis => axis
    else
        if (.not. associated(fig%h_axis)) allocate(fig%h_axis)
        fig%h_axis => axis
    endif
    call endsub('gtfigbindaxis', 'vertical=%y', L=(/axis%vertical/))
end subroutine

subroutine GTFigDraw(fig, parent)
    use gtgraph_types, only: GT_FRAME, GT_FIGURE
    use gtgraph_generic, only: Draw, Option
    use dc_error
    !use dcl, only: DclNewFig, DclSetViewport, 
    use dcl
    use dc_string
    use dc_trace, only: beginsub, endsub
    use gtgraph_drawparam
    implicit none
    type(GT_FRAME), intent(in):: parent
    type(GT_FIGURE), intent(out):: fig
    ! 昔は  real:: vxmin=0.25, vxmax=0.80, vymin=0.15, vymax=0.52  に詰めた
    real:: vx0, vy0, vx1, vy1, vxlen, vylen
    real:: width, height
    real:: frame_width, frame_height
    integer:: i
    character(len = 30):: title

    call beginsub('gtfigdraw')

    if (.not. associated(fig%h_axis)) then
        call StoreError(GT_EFIGNOHAXIS, 'GTFigDraw')
        goto 999
    else if (.not. associated(fig%v_axis)) then
        call StoreError(GT_EFIGNOVAXIS, 'GTFigDraw')
        goto 999
    endif
    if (.not. parent%first_figure) then 
        call DclNewFig
    endif

    if (fig%aspect == 0.0) then
       vx0 = gt_figure_vxmin; vx1 = gt_figure_vxmax
       vy0 = gt_figure_vymin; vy1 = gt_figure_vymax
    else
       frame_width  = gt_figure_vxmax - gt_figure_vxmin
       frame_height = gt_figure_vymax - gt_figure_vymin
       if ( frame_height * fig%aspect > frame_width ) then
          vx0 = gt_figure_vxmin; vx1 = gt_figure_vxmax
          vy0 =  (gt_figure_vymin + gt_figure_vymax)/2 &
                - frame_width / fig%aspect/2
          vy1 =  (gt_figure_vymin + gt_figure_vymax)/2 &
                + frame_width / fig%aspect/2
       else
          vy0 = gt_figure_vymin; vy1 = gt_figure_vymax
          vx0 =  (gt_figure_vxmin + gt_figure_vxmax)/2 &
                - frame_height*fig%aspect/2
          vx1 =  (gt_figure_vxmin + gt_figure_vxmax)/2 &
                + frame_height*fig%aspect/2
       endif
    endif

!!$    if (fig%ceil == 0.0) fig%ceil = 0.65
!!$    if (fig%aspect == 0.0) fig%aspect = 1.0 / fig%ceil
!!$
!!$    ! 水平と鉛直の充填率が小さいほうを選ぶ
!!$    width = min(fig%fill, fig%fill / fig%aspect / fig%ceil)
!!$    height = fig%fill / fig%aspect
!!$    vx0 = 0.5 - width * 0.5 + fig%shift
!!$    vx1 = 0.5 + width * 0.5 + fig%shift
!!$    vy0 = (0.5 + fig%shift) * fig%ceil - 0.5 * height
!!$    vy1 = (0.5 + fig%shift) * fig%ceil + 0.5 * height
    call DCLSetViewPort(vx0, vx1, vy0, vy1)

    fig%h_axis%drawn = .FALSE.
    fig%v_axis%drawn = .FALSE.
    call Draw(fig%h_axis, fig%v_axis, parent=fig)
    if (associated(fig%contours)) then
        do, i = 1, size(fig%contours)
            call Draw(fig%contours(i), parent=fig)
        enddo        
    endif
    if (associated(fig%vectors)) then
        do, i = 1, size(fig%vectors)
            call Draw(fig%vectors(i), parent=fig)
        enddo        
    endif
    if (associated(fig%line)) then
        do, i = 1, size(fig%line)
            call Draw(fig%line(i), parent=fig)
        enddo        
    endif

!  現在のところ frame title と同じになるのでコメントアウト
!  (2002/09/22 S.Takehiro)
!    call DclDrawTextNormalized &
!         ( gt_figure_title_vx, gt_figure_title_vy, &
!           GTStringQuoteForDcl(fig%title), &
!           height=gt_figure_title_height, index=gt_figure_title_index, &
!           centering=gt_figure_title_centering )

999 continue
    call endsub('gtfigdraw')

end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

! 入出力範囲をおまかせ指示
subroutine GTVarSliceAuto(var, compatible)
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: Inquire, Get_Slice, GTVarSlice
    type(GT_VARIABLE), intent(inout):: var
    type(GT_VARIABLE), intent(in), optional:: compatible
    integer:: nd, i
    integer, allocatable:: start(:), count(:), stride(:)
    call Inquire(var, alldims=nd)
    if (nd <= 0) return
    allocate(start(nd), count(nd), stride(nd))
    if (present(compatible)) then
        call Get_Slice(compatible, start, count, stride)
        do, i = 1, nd
            call GTVarSlice(var, i, start(i), count(i), stride(i))
        enddo
    else
        call Get_Slice(var, start, count, stride)
        do, i = 1, nd
            if (count(i) < 1) count(i) = 1
            call GTVarSlice(var, i, start(i), count(i), stride(i))
        enddo
    endif
    deallocate(start, count, stride)
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.
!
! 独立変数 create
!
! 長さ length の自分自身を次元とする変数を作成する。
! 長さ length = 0 の変数は可変長である。
! 次元変数は自動生成されることが多いため、変数名部を欠く指定に対しては
! 名前を自動生成する。
!
subroutine GTVarCreateD(var, url, length, xtype, long_name, overwrite, err)
    use dc_string
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: GtDataTmpNam
    use an_generic, only: Create, Put_Attr, an_variable
    use gt_mem, only: Create, mem_variable
    use gt_map, only: map_create, vtb_class_memory, vtb_class_netcdf, gtvar_dump
    use dc_url, only: UrlSplit, UrlMerge
    use dc_trace, only: beginsub, endsub, message
    use dc_types, only: string
    implicit none
    type(GT_VARIABLE), intent(out):: var
    character(len = *), intent(in):: url
    integer, intent(in):: length
    character(len = *), intent(in), optional:: xtype
    character(len = *), intent(in), optional:: long_name
    logical, intent(in), optional:: overwrite
    logical, intent(out), optional:: err
    character(len = string):: fnam, vnam, new_url
    type(an_variable):: an
    type(mem_variable):: mem
continue
    call beginsub('gtvarcreate-d', 'url=<%c> length=%d', c1=trim(url), i=(/length/))
    if (strHead(url, "memory:")) then
        call Create(mem, url, length, xtype, long_name, overwrite, err)
        call map_create(var, vtb_class_memory, mem%id, 1, (/length/))
        call gtvar_dump(var)
        call endsub('gtvarcreate-d', 'class=memory mapid=%d', i=(/var%mapid/))
        return
    endif
    ! URL の検査
    call UrlSplit(url, file=fnam, var=vnam)
    if (vnam == "") then
        call GtDataTmpNam(file=fnam, base="dim", result=new_url)
    else
        new_url = url
    endif
    ! an 形式が選択される場合は
    call Create(var=an, url=new_url, length=length, xtype=xtype, &
        & overwrite=overwrite, err=err)
    if (present(long_name)) then
        call put_attr(an, 'long_name', long_name, err=err)
    endif
    call map_create(var, vtb_class_netcdf, an%id, 1, (/length/))
    call gtvar_dump(var)
    call endsub('gtvarcreate-d', 'class=netcdf mapid=%d', i=(/var%mapid/))
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

!
! 次元変数 create
!
! create(var, url, xtype, length, [overwrite], [err]) は
! 長さ length の次元変数を作成する。
!
subroutine ANVarCreateD(var, url, xtype, length, overwrite, err)
    use an_types, only: an_variable, an_variable_search
    use an_vartable, only: vtable_add
    use dc_string, only: strieq
    use dc_types, only: string
    use dc_url, only: UrlSplit
    use netcdf_f77, only: nf_noerr, nf_real, nf_int, nf_double, &
        nf_def_var, nf_def_dim
    use an_file, only: anfileopen, anfiledefinemode
    use dc_error, only: storeError, gt_enomem
    implicit none
    type(an_variable), intent(out):: var
    character(len = *), intent(in):: url
    character(len = *), intent(in):: xtype
    integer, intent(in):: length
    logical, intent(in), optional:: overwrite
    logical, intent(out), optional:: err
    type(an_variable_search):: ent
    character(len = string):: filename, varname
    integer:: stat
    integer:: nc_xtype
    !
    ! --- ファイルを用意 ---
    call UrlSplit(url, file=filename, var=varname)
    call ANFileOpen(ent%fileid, filename, stat=stat, writable=.TRUE., &
        overwrite=overwrite)
    if (stat /= NF_NOERR) goto 999
    stat = ANFileDefineMode(ent%fileid)
    if (stat /= NF_NOERR) goto 999
    !
    ! --- 型の決定 ---
    nc_xtype = NF_REAL
    if (strieq(xtype, "double") .or. &
        & strieq(xtype, "DOUBLEPRECISION")) then
        nc_xtype = NF_DOUBLE
    endif
    if (strieq(xtype, "int") .or. strieq(xtype, "INTEGER")) then
        nc_xtype = NF_INT
    endif
    !
    ! --- 次元変数の作成 ---
    stat = nf_def_dim(ent%fileid, trim(varname), len=length, &
        & dimid=ent%dimid)
    if (stat /= NF_NOERR) goto 999
    stat = nf_def_var(ent%fileid, trim(varname), &
        & xtype=nc_xtype, ndims=1, dimids=(/ent%dimid/), varid=ent%varid)
    if (stat /= NF_NOERR) goto 999
    !
    stat = vtable_add(var, ent)
    if (stat /= NF_NOERR) goto 999
    call StoreError(NF_NOERR, 'ANVarCreateD', err)
    return

999 continue
    call StoreError(stat, 'ANVarCreateD', err)
    var = an_variable(-1)
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

module gt_map

    ! GTOOL 変数表
    !
    ! gtool 変数というのは実はマップ表のキーとなる整数ハンドルである。
    ! マップ表 maptab には実体表のエントリ番号と次元書き換え／イテレータ
    ! の表が載っている。
    ! このレベルにおける参照カウントは作らないことにする。つまり、
    ! マップ表と実体表は一対一対応するし、
    ! ユーザがハンドルをコピーするのは勝手である。
    ! もちろんユーザには必ずただ１回
    ! 当該ハンドルを close すなわち maptabdelete する義務がある。

    use dc_types, only: string
    use gt_vartable

    implicit none

    ! 次元書き換え表
    type GT_DIMMAP
        ! 正ならば実体変数の次元番号, 他変数参照時は非正値
        integer:: dimno
        ! 次元変数の url
        character(len=string):: url
        ! --- 実体と gtool ユーザの格子番号対応 ---
        !    ユーザからみて 1..allcount が実体の
        !    (1..allcount) * step + offset に写像される。
        !    これらの値の変更の際は実体変数の許容添字範囲および
        !    成長可能性を確認する必要あり。
        ! start 値に対するオフセット
        integer:: offset
        ! 1 か -1 の値をとることが期待される。
        integer:: step
        ! 見掛けの格子番号上限: start + count * stride <= allcount
        integer:: allcount
        ! ---- イテレータ本体 ---
        ! 入出力範囲は (start:start+count*stride:stride) である。
        ! イテレータ start 値
        integer:: start
        ! イテレータ count 値
        integer:: count
        ! イテレータ stride 値
        integer:: stride
    end type

    ! マップ表の型
    type MAP_TABLE_ENTRY
        integer:: vid
        integer:: ndims
        type(GT_DIMMAP), pointer:: map(:)
    end type

    type(MAP_TABLE_ENTRY), save, target, allocatable:: maptab(:)
    integer, parameter:: maptab_init_size = 16

    public:: MapTabAdd, MapTabDelete, map_lookup
    public:: var_class, map_create, map_to_internal_specs, dimrange
    private:: maptab, maptab_init_size

    interface dimrange
        module procedure dimrange_by_dimno
    end interface

contains

    ! 変数と次元番号を指定して、当該次元の内部的添字番号範囲を得る
    subroutine dimrange_by_dimno(var, dimno, dimlo, dimhi)
        use gtdata_types, only: gt_variable
        use gtdata_generic, only: open, close
        use gtdata_internal, only: dimrange
        type(gt_variable), intent(in):: var
        integer, intent(in):: dimno
        integer, intent(out):: dimlo, dimhi
        type(gt_variable):: dimvar
        integer:: vid
        call open(dimvar, var, dimno, count_compact=.true.)
        call map_lookup(dimvar, vid=vid)
        call dimrange(vid, dimlo, dimhi)
        call close(dimvar)
    end subroutine

    ! 変数 source_var の複写 var を作成する
    subroutine map_dup(var, source_var)
        use gtdata_types, only: gt_variable
        use gt_vartable, only: VarTableAdd, VarTableLookup
        use dc_trace, only: message
        type(gt_variable), intent(out):: var
        type(gt_variable), intent(in):: source_var
        integer:: vid, mid1, mid2, vid2, nd, class, cid
        call map_lookup(source_var, vid=vid)
        if (vid < 0) then
            var = gt_variable(-1)
            return
        endif
        if (vid == 0) then
            vid2 = 0
        else
            call VartableLookup(vid, class=class, cid=cid)
            call VarTableAdd(vid2, class, cid)
        endif
        call MapTabAdd(var%mapid, vid2)
        mid1 = source_var%mapid
        mid2 = var%mapid
        maptab(mid2)%ndims = maptab(mid1)%ndims
        if (associated(maptab(mid1)%map)) then
            nd = size(maptab(mid1)%map)
            allocate(maptab(mid2)%map(nd))
            maptab(mid2)%map(1:nd) = maptab(mid1)%map(1:nd)
        else
            nullify(maptab(mid2)%map)
        endif
        call message('map_dup mapid(%d from %d) vid(%d from %d)', &
            & i=(/mid2, mid1, maptab(mid2)%vid, maptab(mid1)%vid/))
    end subroutine

    ! 変数 var を作成する。内部種別 class, 内部識別子 cid,
    ! 外見的次元数 ndims, 外見的次元長 allcount(:) を与える。
    ! オフセットゼロを仮定して諸元の初期化が行われる。
    subroutine map_create(var, class, cid, ndims, allcount)
        use gtdata_types, only: gt_variable
        use gt_vartable, only: VarTableAdd
        type(gt_variable), intent(out):: var
        integer, intent(in):: class, cid, ndims, allcount(:)
        type(gt_dimmap), pointer:: map(:)
        integer:: vid, i
        call VarTableAdd(vid, class, cid)
        call MapTabAdd(var%mapid, vid)
        call map_allocate(map, ndims)
        maptab(var%mapid)%ndims = ndims
        maptab(var%mapid)%map => map
        do, i = 1, ndims
            map(i)%dimno = i
            map(i)%allcount = allcount(i)
            map(i)%count = allcount(i)
            map(i)%offset = 0
            map(i)%start = 1
            map(i)%step = 1
            map(i)%stride = 1
        enddo
    end subroutine

    ! すでに実体表に追加されたエントリ番号 vid を指定して、
    ! マップ表にエントリを追加する。
    subroutine MapTabAdd(mapid, vid)
        integer, intent(out):: mapid
        integer, intent(in):: vid
        type(MAP_TABLE_ENTRY), allocatable:: tmp_maptab(:)
        integer:: i, n
        ! 必要なら初期確保
        if (.not. allocated(maptab)) then
            allocate(maptab(maptab_init_size))
            maptab(:)%vid = vid_invalid
            do, n = 1, maptab_init_size
                nullify(maptab(n)%map)
            enddo
        endif
        ! 空き地があればそこに割り当て
        do, i = 1, size(maptab)
            if (maptab(i)%vid == vid_invalid) then
                mapid = i
                maptab(mapid)%vid = vid
                return
            endif
        enddo
        ! 空き地はなかったのだから倍幅確保
        n = size(maptab)
        allocate(tmp_maptab(n))
        tmp_maptab(:) = maptab(:)
        deallocate(maptab)
        allocate(maptab(n * 2))
        ! 確保したところはクリア
        maptab(1:n) = tmp_maptab(1:n)
        do, i = n + 1, (2 * size(tmp_maptab))
            maptab(i)%vid = vid_invalid
            nullify(maptab(i)%map)
        enddo
        deallocate(tmp_maptab)
        mapid = n + 1
        maptab(mapid)%vid = vid
    end subroutine

    ! 変数 var をマップ表から削除する。
    ! 実体表には手をつけない。
    subroutine MapTabDelete(var, err)
        use dc_error, only: nf_enotvar, storeerror, dc_noerr
        use gtdata_types, only: gt_variable
        use dc_trace, only: message
        implicit none
        type(gt_variable), intent(in):: var
        logical, intent(out), optional:: err
        integer:: mapid
        mapid = var%mapid
        if (.not. allocated(maptab)) goto 999
        if (mapid <= 0 .or. mapid > size(maptab)) goto 999
        if (maptab(mapid)%vid == vid_invalid) goto 999
        maptab(mapid)%vid = vid_invalid
        if (associated(maptab(mapid)%map)) deallocate(maptab(mapid)%map)
        call storeerror(dc_noerr, 'maptabdelete', err)
        call message('gt_map table %d deleted', i=(/mapid/))
        return
    999 continue
        call storeerror(nf_enotvar, 'maptabdelete', err)
    end subroutine

    ! 同じファイル番号の変数表の中身を返す
    subroutine map_lookup(var, vid, map, ndims)
        use gtdata_types, only: gt_variable
        type(gt_variable), intent(in):: var
        integer, intent(out), optional:: vid
        type(gt_dimmap), intent(out), optional:: map(:)
        integer, intent(out), optional:: ndims
        if (.not. allocated(maptab)) goto 999
        if (var%mapid <= 0 .or. var%mapid > size(maptab)) goto 999
        if (maptab(var%mapid)%vid == vid_invalid) goto 999
        if (present(vid)) vid = maptab(var%mapid)%vid
        if (present(map)) map(:) = maptab(var%mapid)%map(1:size(map))
        if (present(ndims)) ndims = maptab(var%mapid)%ndims
        return
    999 continue
        if (present(vid)) vid = vid_invalid
        if (present(map)) then
            map(:)%dimno = -1
            map(:)%url = " "
        endif
        if (present(ndims)) ndims = 0
    end subroutine

    ! 同じファイル番号の変数表の値を設定する
    subroutine map_set(var, map, stat)
        use gtdata_types, only: gt_variable
        use dc_error, only: nf_enotvar, gt_enomoredims, dc_noerr
        type(gt_variable), intent(in):: var
        type(gt_dimmap), intent(in):: map(:)
        integer, intent(out):: stat
        if (.not. allocated(maptab)) goto 999
        if (var%mapid <= 0 .or. var%mapid > size(maptab)) goto 999
        if (maptab(var%mapid)%vid == vid_invalid) goto 999
        if (size(map) > size(maptab(var%mapid)%map)) then
            stat = gt_enomoredims
            return
        endif
        maptab(var%mapid)%map(1:size(map)) = map(:)
        stat = dc_noerr
        return
    999 continue
        stat = nf_enotvar
    end subroutine


    ! 変数 var を指定して、内部種別 class, 内部識別子 cid を得る。
    subroutine var_class(var, class, cid)
        use gtdata_types, only: gt_variable
        use gt_vartable, only: vartablelookup
        type(gt_variable), intent(in):: var
        integer, intent(out), optional:: class, cid
        integer:: vid
        call map_lookup(var, vid=vid)
        call vartablelookup(vid, class=class, cid=cid)
    end subroutine

    ! 変数 var の次元数を ndims に変える。
    subroutine map_set_ndims(var, ndims, stat)
        use gtdata_types, only: gt_variable
        use gt_vartable, only: vartablelookup
        use dc_error, only: nf_enotvar, gt_enomoredims, dc_noerr
        type(gt_variable), intent(in):: var
        integer, intent(in):: ndims
        integer, intent(out):: stat
        integer:: vid
        call map_lookup(var, vid=vid)
        if (vid == vid_invalid) then
            stat = nf_enotvar
            return
        endif
        if (.not. associated(maptab(var%mapid)%map)) then
            if (ndims == 0) then
                stat = dc_noerr
                maptab(var%mapid)%ndims = 0
            else
                stat = gt_enomoredims
            endif
        else
            if (ndims > size(maptab(var%mapid)%map)) then
                stat = gt_enomoredims
            else
                stat = dc_noerr
                maptab(var%mapid)%ndims = ndims
            endif
        endif
    end subroutine

    ! 変数 var のランク(非縮退次元数)を rank に減らすように
    ! count 値を1に減らす。ランクを増やすことや外見次元数の操作はしない。
    subroutine map_set_rank(var, rank, stat)
        use gtdata_types, only: gt_variable
        use gt_vartable, only: vartablelookup
        use dc_error, only: nf_enotvar, gt_enomoredims, dc_noerr
        type(gt_variable), intent(in):: var
        integer, intent(in):: rank
        integer, intent(out):: stat
        type(gt_dimmap), pointer:: tmpmap(:)
        integer:: ndims
        integer:: vid, nd
        call map_lookup(var, vid, ndims=ndims)
        if (vid == vid_invalid) then
            stat = nf_enotvar
            return
        endif
        if (ndims < rank) then
            stat = gt_enomoredims
            return
        endif
        tmpmap => maptab(var%mapid)%map
        do, nd = ndims, 1, -1
            if (count(tmpmap(1:ndims)%count > 1) <= rank) exit
            tmpmap(nd)%count = 1
        enddo
        stat = dc_noerr
    end subroutine

    ! マップ表から netCDF の引数にふさわしい start, count, stride, imap
    ! を作成する。ただし、stride が負になるばあいは対策されていない。
    ! (暫定的に anvarget/anvarput が対応している)
    subroutine map_to_internal_specs(var, specs, ndims)
        use gtdata_types, only: gt_variable
        use gtdata_internal, only: num_dimensions => ndims
        type(gt_variable), intent(in):: var
        integer, pointer:: specs(:, :)
        integer, intent(out), optional:: ndims
        type(gt_dimmap), pointer:: it
        integer:: vid, i, j, imap, internal_ndims
        integer:: external_ndims 
    continue
        call map_lookup(var, vid, ndims=external_ndims)
        internal_ndims = num_dimensions(vid)
        if (present(ndims)) ndims = internal_ndims
        allocate(specs(max(1, internal_ndims), 4))
        specs(:, 1) = 1
        specs(:, 2) = 1
        specs(:, 3) = 1
        specs(:, 4) = 0
        imap = 1
        do, i = 1, size(maptab(var%mapid)%map)
            it => maptab(var%mapid)%map(i)
            j = it%dimno
            if (j > 0 .and. j <= internal_ndims) then
                specs(j, 1) = it%start + it%offset
                specs(j, 2) = it%count
                if (i > external_ndims) specs(j, 2) = 1
                specs(j, 3) = it%stride * it%step
                specs(j, 4) = imap
            endif
            imap = imap * it%count
        enddo
    end subroutine

    ! 次元表エントリに ndims 個のエントリを割り付け初期化する。
    subroutine map_allocate(map, ndims)
        type(GT_DIMMAP), pointer:: map(:)
        integer, intent(in):: ndims
        if (ndims <= 0) then
            nullify(map)
            return
        endif
        allocate(map(1:ndims))
        map(1:ndims)%dimno = -1
        map(1:ndims)%url = ' '
        map(1:ndims)%allcount = 0
        map(1:ndims)%offset = 0
        map(1:ndims)%step = 1
        map(1:ndims)%start = 1
        map(1:ndims)%count = 0
        map(1:ndims)%stride = 1
    end subroutine

    ! 変数 var にマップ表 map を組み合わせる
    subroutine map_apply(var, map)
        use gtdata_types, only: gt_variable
        type(GT_VARIABLE), intent(inout):: var
        type(GT_DIMMAP), pointer:: map(:)
        type(GT_DIMMAP), pointer:: tmpmap(:), varmap
        integer:: i, nd
        nd = size(map)
        allocate(tmpmap(nd))
        do, i = 1, nd
            tmpmap(i)%allcount = map(i)%allcount
            tmpmap(i)%count = map(i)%count
            if (map(i)%dimno > 0) then
                varmap => maptab(var%mapid)%map(map(i)%dimno)
                tmpmap(i)%url = varmap%url
                tmpmap(i)%dimno = varmap%dimno
                tmpmap(i)%offset = varmap%offset + map(i)%offset
                tmpmap(i)%step = varmap%step * map(i)%step
            else
                tmpmap(i)%url = map(i)%url
                tmpmap(i)%dimno = 0
                tmpmap(i)%offset = map(i)%offset
                tmpmap(i)%step = map(i)%step
            endif
        enddo
        deallocate(map)
        map => tmpmap
    end subroutine

    ! 変数 var の次元表の大きさを変える
    subroutine map_resize(var, ndims)
        use gtdata_types, only: gt_variable
        type(GT_VARIABLE), intent(in):: var
        integer, intent(in):: ndims
        type(GT_DIMMAP), pointer:: newmap(:)
        type(GT_DIMMAP), pointer:: tmpmap(:)
        integer:: n
        if (associated(maptab(var%mapid)%map)) then
            tmpmap => maptab(var%mapid)%map
            call map_allocate(newmap, ndims)
            n = min(size(tmpmap), ndims)
            newmap(1:n) = tmpmap(1:n)
            deallocate(tmpmap)
            maptab(var%mapid)%map => newmap
            newmap(n+1:ndims)%dimno = -1
            newmap(n+1:ndims)%url = ' '
            newmap(n+1:ndims)%allcount = 0
            newmap(n+1:ndims)%offset = 0
            newmap(n+1:ndims)%step = 1
            newmap(n+1:ndims)%start = 1
            newmap(n+1:ndims)%count = 0
            newmap(n+1:ndims)%stride = 1
        else
            call map_allocate(maptab(var%mapid)%map, ndims)
            n = 1
        endif
    end subroutine

    ! 変数のプロパティを出力
    subroutine gtvar_dump(var)
        use gtdata_types, only: gt_variable
        use gt_vartable, only: vartable_dump
        use dc_trace, only: debug, message
        type(gt_variable), intent(in):: var
        integer:: idim, imap
        if (.not. debug()) return
        imap = var%mapid
        if (imap < 1 .or. imap > size(maptab)) then
            call message('[gt_variable %d: invalid id]', i=(/imap/))
            return
        endif
        if (associated(maptab(imap)%map)) then
            call message('[gt_variable %d: ndims=%d, map.size=%d]', &
                & i=(/imap, maptab(imap)%ndims, size(maptab(imap)%map)/))
            do, idim = 1, size(maptab(imap)%map)
                call message('[dim%d dimno=%d ofs=%d step=%d' &
                    &// ' all=%d start=%d count=%d stride=%d url=%c]', &
                    & c1=trim(maptab(imap)%map(idim)%url), &
                    & i=(/idim, maptab(imap)%map(idim)%dimno, &
                    & maptab(imap)%map(idim)%offset, &
                    & maptab(imap)%map(idim)%step, &
                    & maptab(imap)%map(idim)%allcount, &
                    & maptab(imap)%map(idim)%start, &
                    & maptab(imap)%map(idim)%count, &
                    & maptab(imap)%map(idim)%stride/))
            enddo
        else
            call message('[gt_variable %d: ndims=%d, map=null]', &
                & i=(/imap, maptab(imap)%ndims/))
        endif
        call vartable_dump(maptab(imap)%vid)
    end subroutine

    ! 次元表の中で非縮退次元だけを数えた次元番号 dimord の次元を
    ! 特定し、外部向けの次元番号を返す。
    integer function dimord_skip_compact(dimord, map) result(result)
        use dc_trace, only: message
        integer, intent(in):: dimord
        type(gt_dimmap), intent(in):: map(:)
        integer:: nd, id
        result = -1
        nd = 0
        do, id = 1, size(map)
            if (map(id)%count < 2) cycle
            nd = nd + 1
            if (nd < dimord) cycle
            result = id
            call message('compact dim skip: %d <= %d', i=(/result, dimord/))
            exit
        enddo
    end function

end module

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

! 問い合わせは型ごとに手続をわけた。

subroutine ANVarInquire(var, ndims, dimlen, growable, name, url, xtype)
    use an_types, only: an_variable, an_variable_entry
    use an_file, only: inquire
    use an_vartable, only: vtable_lookup
    use an_generic, only: ANXTypeName
    use dc_trace, only: beginsub, endsub, message
    use netcdf_f77, only: nf_noerr, nf_max_name, nf_inq_vartype, &
        & nf_inq_dimlen, nf_inq_unlimdim
implicit none
    type(an_variable), intent(in):: var
    ! 変数の次元数
    integer, intent(out), optional:: ndims
    ! 変数が１次元である場合、次元長
    integer, intent(out), optional:: dimlen
    ! 変数が成長可能次元を持つか
    logical, intent(out), optional:: growable
    ! 文字型引数が短いと値の切り詰めが起こりうる
    ! '?' のあとの変数名
    character(*), intent(out), optional:: name
    ! 変数名、少なくともファイル名を含む、なるべく長い名前
    character(*), intent(out), optional:: url
    ! 変数の型名
    character(*), intent(out), optional:: xtype
    ! 内部変数
    type(an_variable_entry):: ent
    integer:: stat, length, i, i_xtype, idim_growable
    character(len = *), parameter:: subname = 'anvarinqurie'
    character(len = nf_max_name):: buffer
    character(len = nf_max_name):: fbuffer
continue
    call beginsub(subname, 'var.id=%d', i=(/var%id/))

    ! フェイルセーフ用にエラー値をまず入れる
    if (present(ndims)) ndims = -1
    if (present(dimlen)) dimlen = -1

    ! 変数実体の探索
    stat = vtable_lookup(var, ent)
    if (stat /= nf_noerr) then
        call endsub(subname, 'var not found')
        return
    endif

    ! 各引数が与えられている場合について値を取得する動作を

    if (present(ndims)) then
        if (associated(ent%dimids)) then
            ndims = size(ent%dimids)
        else
            ndims = 0
        endif
    endif

    if (present(dimlen)) then
        dimlen = 1
        if (ent%dimid > 0) then
            ! 実体に次元としての問い合わせが可能な場合
            stat = nf_inq_dimlen(ent%fileid, ent%dimid, dimlen)
            if (stat /= nf_noerr) then
                dimlen = -1
                call endsub(subname, 'dimlen err')
                return
            endif
        else
            ! 実体が変数として問い合わせるしかない場合
            if (associated(ent%dimids)) then
                do, i = 1, size(ent%dimids)
                    stat = nf_inq_dimlen(ent%fileid, ent%dimids(i), length)
                    if (stat /= nf_noerr) then
                        dimlen = -1
                        exit
                    endif
                    dimlen = dimlen * length
                enddo
            endif
        endif
    endif

    if (present(xtype)) then
        stat = nf_inq_vartype(ent%fileid, ent%varid, xtype=i_xtype)
        if (stat /= NF_NOERR) i_xtype = 0
        call ANXTypeName(i_xtype, xtype)
    endif

    if (present(name)) then
        call local_getname(ent, buffer)
        name = buffer
    endif

    if (present(url)) then
        call local_getname(ent, buffer)
        call message('ent%%fileid=%d', i=(/ent%fileid/))
        call inquire(ent%fileid, name=fbuffer)
        url = trim(fbuffer) // '?' // buffer
    endif

    if (present(growable)) then
        growable = .false.
        stat = vtable_lookup(var, ent)
        if (stat /= nf_noerr) return
        stat = nf_inq_unlimdim(ent%fileid, idim_growable)
        if (stat /= nf_noerr) return

        if (ent%varid > 0) then
            if (.not. associated(ent%dimids)) return
            do, i = 1, size(ent%dimids)
                if (ent%dimids(i) == idim_growable) growable = .true.
            enddo
        else
            growable = (ent%dimid == idim_growable)
        endif
    endif

    ! 安全に終った
    call endsub(subname, 'ok')
    return

contains

    subroutine local_getname(ent, varname)
        use netcdf_f77, only: nf_inq_varname, nf_inq_dimname
        type(an_variable_entry), intent(in):: ent
        character(len = *), intent(out):: varname
        if (ent%dimid > 0) then
            stat = nf_inq_dimname(ent%fileid, ent%dimid, varname)
        else
            stat = nf_inq_varname(ent%fileid, ent%varid, varname)
        endif
        if (stat /= NF_NOERR) varname = ""
    end subroutine

end subroutine

! 二つの変数 var1, var2 に入出力範囲拘束を加えて次元配置を共通化する。
! 結果の次元構成はとりあえずモデルで使えるように決めた。
!    var2 の空間を保持する。var1 を変形する。
!    var2 の次元は (有幅・縮退ともに) var2 における幅がとられる。
!    したがって var1 においては存在しないか var2 をカバーする幅で
!    なければならない。
!    var2 にない var1 の次元は見えないようになるので縮退しているか
!    存在しないのでなければならない。
!
subroutine gtvarxformbinary(var1, var2, err)
    use gtdata_types, only: gt_variable
    use gtdata_generic, only: inquire, get_slice
    use gt_map, only: map_allocate, map_apply, gt_dimmap, gtvar_dump
    use dc_error, only: StoreError, GT_ENOMATCHDIM, GT_EFAKE, DC_NOERR
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(GT_VARIABLE), intent(inout):: var1, var2
    logical, intent(out), optional:: err
    integer:: ndim1, ndim2, ndimo
    integer, allocatable:: map1(:), map2(:)
    type(GT_DIMMAP), pointer:: newmap(:)
    integer:: i, j, stat
    character(*), parameter:: subnam = "gtvartransform-binary"
continue
    call beginsub(subnam, 'mapid=[%d, %d]', i=(/var1%mapid, var2%mapid/))
    call gtvar_dump(var1)
    call gtvar_dump(var2)
    !
    ! 二つの変数 var1, var2 から共有次元を調べ、対応表 map1, map2 をつくる。
    !
    if (present(err)) err = .false.
    call inquire(var1, alldims=ndim1)
    call inquire(var2, alldims=ndim2)
    ndimo = max(ndim1, ndim2, 0)
    allocate(map1(1:ndim1), map2(1:ndim2))
    call getmatch(var1, var2, ndim1, ndim2, map1, map2)
    call message('map1=%*d map2=%*d', i=(/map1(1:ndim1), map2(1:ndim2)/), n=(/ndim1, ndim2/))
    if (all(map2(1:ndim2) == 0)) then
        stat = gt_enomatchdim
        goto 999
    endif
    !
    ! 再配置テーブル作成開始
    !
    ndimo = ndim2 + count(map1(1:ndim1) == 0)
    call map_allocate(newmap, ndimo)
    !
    ! 1..ndim2 は map2 によって var2 の次元たちにマップする
    !
    newmap(1:ndim2)%dimno = map2(1:ndim2)
    call inquire(var2, allcount=newmap(1:ndim2)%allcount)
    call get_slice(var2, count=newmap(1:ndim2)%count)
    do, j = 1, ndim2
        if (map2(j) == 0) then
            newmap(j)%start = 1
            newmap(j)%stride = 1
            call inquire(var2, j, url=newmap(j)%url)
        else
            ! 位置対応によって var1 側での開始位置を決定する
            call adjust_slice(var1, var2, map2(j), j, &
                & newmap(j)%start, newmap(j)%stride)
        endif
    enddo
    !
    ! ndim2+1.. ndimo は var2 に対応させられない var1 の次元をおく
    !
    j = 0
    loop1: do, i = ndim2 + 1, ndimo
        do
            j = j + 1
            if (j > ndim1) exit loop1
            if (map1(j) <= 0) exit
        enddo
        newmap(i)%dimno = j
        call inquire(var1, dimord=j, allcount=newmap(i)%allcount)
        call get_slice(var1, dimord=j, start=newmap(i)%start, &
            & count=newmap(i)%count, stride=newmap(i)%stride)
    end do loop1
    !
    call map_apply(var1, map=newmap)
    !
    stat = dc_noerr
999 continue
    call StoreError(stat, subnam, err)
    call endsub(subnam, 'stat=%d', i=(/stat/))
    deallocate(map1, map2)
    return
contains

    !
    ! 二つの次元変数を調べ、軸上位置が対応するように
    ! start シフト数と stride ファクタを決定する
    !
    subroutine adjust_slice(var1, var2, idim1, idim2, offset, stepfact)
        use dc_units
        use gtdata_generic, only: get, open, close
        type(GT_VARIABLE), intent(in):: var1, var2
        integer, intent(in):: idim1, idim2
        integer, intent(out):: offset, stepfact
        type(GT_VARIABLE):: var_d
        integer:: n, buf(1)
        real, allocatable:: val1(:), val2(:)
    continue
        call beginsub('adjust_slice')
        call open(var_d, source_var=var1, dimord=idim1, count_compact=.true.)
        call inquire(var_d, size=n)
        allocate(val1(n))
        call get(var_d, val1, n)
        call close(var_d)
        !
        call open(var_d, source_var=var2, dimord=idim2, count_compact=.true.)
        call inquire(var_d, size=n)
        allocate(val2(n))
        call get(var_d, val2, n)
        call close(var_d)
        !
        buf(1:1) = minloc(abs(val1(:) - val2(1)))
        offset = buf(1) - 1
        if (size(val2) < 2 .or. size(val1) < 2) then
            stepfact = 1
        else
            buf(1:1) = minloc(abs(val1(:) - val2(2)))
            stepfact = buf(1) - (offset + 1)
        endif
        !
        deallocate(val1, val2)
        call endsub('adjust_slice')
    end subroutine

    !
    ! 二つの変数から共有次元を調べ、対応表 map1, map2 を作る。
    ! すなわち、それぞれの次元番号から相方の次元番号を得る表である。
    !
    subroutine getmatch(var1, var2, ndim1, ndim2, map1, map2)
        use dc_units
        use gtdata_generic, only: get_attr, open, close
        type(GT_VARIABLE), intent(in):: var1, var2
        integer, intent(in):: ndim1, ndim2
        integer, intent(out):: map1(:), map2(:)
        type(GT_VARIABLE):: var_d
        integer, allocatable:: map(:, :)
        integer:: i, j
        character(string):: su1, su2
        type(UNITS), allocatable:: u1(:), u2(:)
    continue
        call beginsub('getmatch')
        ! 返却値はデフォルト 0
        map1(:) = 0
        map2(:) = 0
        ! 表の構築: 初期値は消去法をとることを示す
        allocate(map(ndim1, ndim2))
        map(:, :) = 1

        ! 単位による対応 --- 加算可能でなければ対にしない
        ! 単位の構成
        allocate(u1(ndim1), u2(ndim2))
        do, i = 1, ndim1
            call open(var_d, var1, i, count_compact=.true.)
            call get_attr(var_d, 'units', su1)
            call close(var_d)
            call clear(u1(i))
            u1(i) = su1
        enddo
        do, j = 1, ndim2
            call open(var_d, var2, j, count_compact=.true.)
            call get_attr(var_d, 'units', su2)
            call close(var_d)
            call clear(u2(j))
            u2(j) = su2
        enddo
        ! 処理
        do, i = 1, ndim1
            do, j = 1, ndim2
                if (.not. add_okay(u1(i), u2(j))) &
                    & map(i, j) = 0
            enddo
        enddo
        ! 単位の廃棄
        do, i = 1, ndim1
            call deallocate(u1(i))
        enddo
        do, j = 1, ndim2
            call deallocate(u2(j))
        enddo
        deallocate(u1, u2)

        if (map_finished(map)) goto 1000

        ! --- it fails ---
        call endsub('getmatch', 'fail')
        return

    1000 continue
        do, i = 1, ndim1
            call message('map(%d, :)=%*d', i=(/i, map(i,:)/), n=(/ndim2/))
        enddo
        do, i = 1, ndim1
            if (all(map(i, :) <= 0)) then
                map1(i) = 0
            else
                map1(i:i) = maxloc(map(i, :))
            endif
        enddo
        do, j = 1, ndim2
            if (all(map(:, j) <= 0)) then 
                map2(j) = 0
            else
                map2(j:j) = maxloc(map(:, j), dim=1)
            endif
        enddo
        call endsub('getmatch', 'okay')
    end subroutine

    logical function map_finished(map) result(result)
        integer:: map(:, :)
        integer:: i, j, ni
    continue
        call beginsub('map_finished')
        ni = size(map, dim=1)
        do, i = 1, ni
            if (count(map(i, :) > 0) > 1) then
                result = .false.
                goto 999
            endif
        enddo
        do, j = 1, ni
            if (count(map(j, :) > 0) > 1) then
                result = .false.
                goto 999
            endif
        enddo
        result = .true.
    999 continue
        call endsub('map_finished')
    end function

end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

! 入出力範囲指定を全次元について一括取得
! あらかじめ inquire(var, alldims) して配列を確保しなければならない。
!
subroutine GTVarGetSliceAll(var, start, count, stride)
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: GTVarGetSlice
    implicit none
    type(GT_VARIABLE), intent(in):: var
    integer, intent(out), optional:: start(:), count(:), stride(:)
    integer:: nd, i
    logical:: all
    nd = HUGE(1)
    all = present(start) .and. present(count) .and. present(stride)
    if (present(start)) nd = min(nd, size(start))
    if (present(count)) nd = min(nd, size(count))
    if (present(stride)) nd = min(nd, size(stride))
    do, i = 1, nd
        if (all) then
            call GTVarGetSlice(var, i, start(i), count(i), stride(i))
            cycle
        endif
        if (present(start)) call GTVarGetSlice(var, i, start=start(i))
        if (present(count)) call GTVarGetSlice(var, i, count=count(i))
        if (present(stride)) call GTVarGetSlice(var, i, stride=stride(i))
    enddo
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

! 真偽値の判定基準 ... 偽の例を示す。例を lowercase にしたもの以外の値は全部真。
!   数値 0, 0.0
!   文字列 "0", "0.0", ".0", "0.", "0.0D0", "FALSE", ".FALSE.", "F"

subroutine ANVarGetAttrLogical(var, name, value, default)
    use an_types, only: AN_VARIABLE, an_variable_entry
    use an_vartable, only: vtable_lookup
    use an_generic, only: get_attr
    use an_file, only: inquire
    use dc_types, only: string
    use netcdf_f77
    use dc_error
    use dc_string
    implicit none
    type(AN_VARIABLE), intent(in):: var
    character(len = *), intent(in):: name
    logical, intent(out):: value
    logical, intent(in), optional:: default
    type(an_variable_entry):: ent
    character(len = STRING):: cbuffer
    character(len = 7):: c_default
    character(len = NF_MAX_NAME):: aname
    real, allocatable:: rbuf(:)
    integer:: stat, xtype, attrlen
    integer:: varid
    stat = vtable_lookup(var, ent)
    if (stat /= NF_NOERR) goto 999
    ! 大域属性サポート
    call inquire(var, name, &
        & varid=varid, nf_attrname=aname)
    stat = nf_inq_att(ent%fileid, varid, aname, &
        & xtype=xtype, len=attrlen)
    if (stat /= NF_NOERR) goto 999
    if (xtype == NF_CHAR) then
        c_default = "0"
        if (present(default)) then
            if (default) c_default = "1"
        endif
        call get_attr(var, name, cbuffer, c_default, stat)
        ! もうちょっとましな方法があるべきだが。
        select case(cbuffer)
        case("", "0", "0.0", "0.", ".0", "FALSE", "false", ".FALSE.", &
            & ".false.", "F", "f", "0.0D0", "0.0d0")
            value = .FALSE.    
        case default
            value = .TRUE.
        end select
    else
        allocate(rbuf(attrlen))
        stat = nf_get_att_real(ent%fileid, varid, aname, rbuf)
        if (stat /= NF_NOERR) goto 999
        value = (abs(rbuf(1)) > tiny(0.0))
    endif
    return

999 continue
    value = .FALSE.
    if (present(default)) value = default
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.
! gtlist - Îóµó°õ»ú¥Ä¡¼¥ë

program gtlist
    use gtool
    use dc_trace, only: setdebug
    implicit none
    character(string):: filename, varname, attrname, argument
    integer:: i
    integer:: showcount = 0
    logical:: url_mode = .FALSE.
    character:: format = "1"
continue
    do, i = 1, GtArgCount()
        call GtArgGet(i, argument)
        if (argument == "-url") then
            url_mode = .TRUE.
        else if (argument == "-debug") then
            call setdebug
        else if (argument(1:1) == "-" .and. len_trim(argument) == 2) then
            format = argument(2: )
        else
            showcount = showcount + 1
            call UrlSplit(argument, file=filename, var=varname)
            if (varname == '') then
                call list_variables
            else
                varname = argument
                call list_attributes
            endif
        endif
    enddo
    if (showcount == 0) then
        write(*, *) 'usage: gtlist [-url] [filename|varname] ...'
    endif
contains

    subroutine list_variables
        type(GT_VARIABLE):: var
        character(len = token):: xtype
        character(len = string):: cbuffer
        character(len = string):: fpart, vpart
        logical:: end
        cbuffer = argument
        call GTVarSearch(cbuffer)
        do
            call GTVarSearch(cbuffer, end)
            if (end) exit
            varname = trim(cbuffer)
            call UrlSplit(varname, file=fpart, var=vpart)
            if (url_mode) then
                vpart = UrlMerge(fpart, vpart)
            endif
            select case(format)
            case('l', 'L')
                call Open(var, varname)
                call Inquire(var=var, xtype=xtype)
                call put_line(trim(xtype) // ' ' // trim(vpart))
                call Close(var)
            case('m')
                call Open(var, varname)
                call Inquire(var=var, xtype=xtype)
                call put_line(trim(xtype) // ', ' // trim(vpart))
                call Close(var)
            case default
                call put_line(trim(vpart))
            end select
        enddo
    end subroutine

    subroutine list_attributes
        use dc_types, only: string, token
        character(len = string):: attrbasename
        type(GT_VARIABLE):: var
        character(len = token):: xtype
        logical:: end
        call Open(var, varname)
        call attr_rewind(var)
        do
            call attr_next(var, attrbasename, end)
            if (end) exit
            if (url_mode) then
                call inquire(var, url=attrname)
                attrname = trim(attrname) // ':' // attrbasename
            else
                attrname = attrbasename
            endif
            select case(format)
            case('l', 'L')
                call inquire(var, trim(attrname), xtype=xtype)
                call put_line(xtype // attrname)
            case('m')
                call inquire(var, trim(attrname), xtype=xtype)
                call put_line(trim(xtype) // ", " // trim(attrname))
            case default
                call put_line(trim(attrname))
            end select
        enddo
        call Close(var)
    end subroutine

end program

! gt3read.f90 - GTOOL3 file input module
! Copyright (C) by TOYODA Eizi, 2000.  All rights reserved.
! vi: set sw=4 ts=8:

module gt3read

    use dcl, only: DclGetUnitNum
    implicit none

    private

    type GT3_HEADER
        integer:: idfm
        character(len = 16):: dataset, item
        character(len = 16):: edit(8)
        integer:: file_number, data_number
        character(len = 16 * 2):: title
        character(len = 16):: unit
        character(len = 16):: edit_title(8)
        integer:: time
        character(len = 16):: datetime, time_unit
        integer:: time_duration
        character(len = 16):: axis_item(3)
        integer:: axis_start(3), axis_end(3)
        character(len = 16):: format
        real:: missing_value, range_max, range_min
        real:: div_small, div_large
        integer:: scaling
        character(len = 16):: option(3), memo(12)
        character(len = 16):: create_date, create_user
        character(len = 16):: modify_date, modify_user
        integer:: record_size
    end type

    type GT3_FILE
        private
        integer:: number
    end type

    public GT3_FILE, GT3_HEADER, Open, Close, GetHeader, GetData
    public SkipRecord, Rewind, GetUnit, Get

    interface Open;  module procedure Gt3Open;  end interface
    interface Close;  module procedure Gt3Close;  end interface
    interface Rewind;  module procedure Gt3Rewind;  end interface
    interface GetHeader;  module procedure Gt3GetHeader;  end interface
    interface GetData;  module procedure Gt3GetData;  end interface
    interface SkipRecord;  module procedure Gt3SkipRecord;  end interface
    interface GetUnit;  module procedure Gt3GetUnit;  end interface
    interface Get
        module procedure Gt3GetHeader, Gt3GetUnit
    end interface

    integer, public, parameter:: END_OF_FILE = -3000
    integer, public, parameter:: ERROR_OPEN = 3300
    integer, public, parameter:: ERROR_CLOSE = 3301
    integer, public, parameter:: ERROR_REWIND = 3302
    integer, public, parameter:: ERROR_BAD_MAGIC = 3303
    integer, public, parameter:: ERROR_BAD_GTOOL3 = 3304
    integer, public, parameter:: ERROR_READ = 3305

contains

    subroutine Gt3Open(unit, file, iostat)
        type(GT3_FILE), intent(out):: unit
        character(len = *), intent(in):: file
        integer, intent(out):: iostat
    continue
        unit%number = DclGetUnitNum()
        open(unit=unit%number, file=file, access='SEQUENTIAL', &
            & form='UNFORMATTED', iostat=iostat, status='OLD')
        if (iostat /= 0) iostat = ERROR_OPEN
    end subroutine

    subroutine Gt3Close(unit, iostat)
        type(GT3_FILE), intent(inout):: unit
        integer, intent(out):: iostat
    continue
        close(unit=unit%number, iostat=iostat)
        if (iostat /= 0) iostat = ERROR_CLOSE
        unit%number = -unit%number
    end subroutine

    subroutine Gt3Rewind(unit, iostat)
        type(GT3_FILE), intent(inout):: unit
        integer, intent(out):: iostat
    continue
        rewind(unit=unit%number, iostat=iostat)
        if (iostat /= 0) iostat = ERROR_REWIND
    end subroutine

    subroutine BufferToHeader(header, buffer, iostat)
        type(GT3_HEADER), intent(out):: header
        character(len = 16), intent(in):: buffer(64)
        integer, intent(out):: iostat
        integer, parameter:: IDFM_NEW = 9010
        integer, parameter:: IDFM_OLD = 9009
    continue
        read(buffer(1), fmt="(i16)", iostat=iostat) header%idfm
        if (iostat /= 0 .or. header%idfm /= IDFM_NEW) then
            read(buffer(1), fmt="(i10)", iostat=iostat) header%idfm
            if (iostat /= 0) goto 990
            if (header%idfm /= IDFM_OLD) then
                iostat = ERROR_BAD_MAGIC
                return
            endif
        endif
        header%dataset = buffer(2)
        header%item = buffer(3)
        header%edit(1: 8) = buffer(4: 11)
        read(buffer(12), fmt="(i16)", iostat=iostat) header%file_number
        if (iostat /= 0) goto 990
        read(buffer(13), fmt="(i16)", iostat=iostat) header%data_number
        if (iostat /= 0) goto 990
        header%title = transfer(buffer(14: 15), header%title)
        header%unit = buffer(16)
        if (header%unit == '') &
            header%unit = '1'
        header%edit_title(1: 8) = buffer(17: 24)
        read(buffer(25), fmt="(i16)", iostat=iostat) header%time
        if (iostat /= 0) goto 990
        header%time_unit = buffer(26)
        header%datetime = buffer(27)
        read(buffer(28), fmt="(i16)", iostat=iostat) header%time_duration
        if (iostat /= 0) goto 990
        header%axis_item(1: 3) = buffer(29: 35: 3)
        read(buffer(30), fmt='(i16)', iostat=iostat) header%axis_start(1) 
        if (iostat /= 0) goto 990
        read(buffer(33), fmt='(i16)', iostat=iostat) header%axis_start(2) 
        if (iostat /= 0) goto 990
        read(buffer(36), fmt='(i16)', iostat=iostat) header%axis_start(3) 
        if (iostat /= 0) goto 990
        read(buffer(31), fmt='(i16)', iostat=iostat) header%axis_end(1) 
        if (iostat /= 0) goto 990
        read(buffer(34), fmt='(i16)', iostat=iostat) header%axis_end(2) 
        if (iostat /= 0) goto 990
        read(buffer(37), fmt='(i16)', iostat=iostat) header%axis_end(3) 
        if (iostat /= 0) goto 990
        header%format = buffer(38)
        read(buffer(39), fmt='(e16.7)', iostat=iostat) header%missing_value
        if (iostat /= 0) goto 990
        read(buffer(40), fmt='(e16.7)', iostat=iostat) header%range_min
        if (iostat /= 0) goto 990
        read(buffer(41), fmt='(e16.7)', iostat=iostat) header%range_max
        if (iostat /= 0) goto 990
        read(buffer(42), fmt='(e16.7)', iostat=iostat) header%div_small
        if (iostat /= 0) goto 990
        read(buffer(43), fmt='(e16.7)', iostat=iostat) header%div_large
        if (iostat /= 0) goto 990
        read(buffer(44), fmt="(i16)", iostat=iostat) header%scaling
        if (iostat /= 0) goto 990
        header%option(1: 3) = buffer(45: 47)
        header%memo(1: 12) = buffer(48: 59)
        header%create_date = buffer(60)
        header%create_user = buffer(61)
        header%modify_date = buffer(62)
        header%modify_user = buffer(63)
        read(buffer(64), fmt="(i16)", iostat=iostat) header%record_size
        if (iostat /= 0) goto 990
        iostat = 0
        return
        ! --- error handler ---
    990 continue
        iostat = ERROR_BAD_GTOOL3
        return
    end subroutine

    subroutine Gt3GetHeader(unit, header, iostat)
        type(GT3_FILE), intent(inout):: unit
        type(GT3_HEADER), intent(out):: header
        integer, intent(out):: iostat
        character(len = 16):: buffer(64)
    continue
        read(unit=unit%number, iostat=iostat) buffer
        if (iostat > 0) then
            iostat = ERROR_READ
            return
        else if (iostat < 0) then
            iostat = END_OF_FILE
            return
        endif
        call BufferToHeader(header, buffer, iostat)
    end subroutine

    ! 外部表現と内部表現に関する仮定がある
    !
    subroutine Gt3GetData(unit, header, array, iostat)
        type(GT3_FILE), intent(in):: unit
        type(GT3_HEADER), intent(in):: header
        real, pointer:: array(:, :, :)
        integer, intent(out):: iostat
        double precision, pointer:: darray(:, :, :)
        integer:: xs, xe, ys, ye, zs, ze
        if (header%format == 'UR4' .or. header%format == 'UR8') then
            xs = header%axis_start(1)
            ys = header%axis_start(2)
            zs = header%axis_start(3)
            xe = header%axis_end(1)
            ye = header%axis_end(2)
            ze = header%axis_end(3)
            if (header%format == 'UR4') then
                allocate(array(xs:xe, ys:ye, zs:ze))
                read(unit=unit%number, iostat=iostat) array(:, :, :)
            else if (header%format == 'UR8') then
                allocate(darray(xs:xe, ys:ye, zs:ze))
                read(unit=unit%number, iostat=iostat) darray(:, :, :)
                allocate(array(xs:xe, ys:ye, zs:ze))
                array = darray
                deallocate(darray)
            endif
            if (iostat < 0) then
                iostat = END_OF_FILE
            else if (iostat > 0) then
                iostat = ERROR_READ
            endif
        else
            print "('GT3 external format <', a, '> not supported')", &
                & trim(header%format)
            iostat = ERROR_BAD_GTOOL3
        endif
    end subroutine

    subroutine Gt3GetUnit(unit, header, buffer, iostat)
        type(GT3_FILE), intent(inout):: unit
        type(GT3_HEADER), intent(out):: header
        integer, intent(out):: iostat
        real, pointer:: buffer(:, :, :)
    continue
        call GetHeader(unit, header, iostat)
        if (iostat /= 0) return
        call GetData(unit, header, buffer, iostat)
    end subroutine

    subroutine Gt3SkipRecord(unit, iostat)
        type(GT3_FILE), intent(in):: unit
        integer, intent(out):: iostat
    continue
        read(unit=unit%number, iostat=iostat)
        if (iostat < 0) then
            iostat = END_OF_FILE
        else if (iostat > 0) then
            iostat = ERROR_READ
        endif
    end subroutine

end module

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

module an_file

    use dc_types, only: string
    use dc_trace, only: beginsub, endsub, message

    implicit none
    private

    type FILE_MEMO_ENTRY
        integer:: id
        integer:: count
        logical:: writable
        character(len = string):: filename
        type(FILE_MEMO_ENTRY), pointer:: next
    end type

    type(FILE_MEMO_ENTRY), save, pointer:: memo_head
    logical, save:: memo_used = .FALSE.

    public:: ANFileOpen, ANFileClose, ANFileReopen
    public:: ANFileDataMode, ANFileDefineMode, ANFileSync
    public:: Inquire

    ! 非公開なので an_generic には置かない
    interface inquire
        subroutine ANAttrInquirePlus(var, attrname, varid, nf_attrname)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            character(len=*), intent(in):: attrname
            integer, intent(out):: varid
            character(len=*), intent(out):: nf_attrname
        end subroutine

        module procedure anfileinquirename
    end interface

contains

    subroutine anfileinquirename(fileid, name)
        use netcdf_f77, only: NF_ENOTNC
        use dc_error
        integer, intent(in):: fileid
        character(len = *), intent(out):: name
        type(FILE_MEMO_ENTRY), pointer:: memop
    continue
        call beginsub('anfilename', 'fileid=%d', i=(/fileid/))
        if (.not. memo_used) goto 999
        memop => memo_head
        do
            if (.not. associated(memop)) exit
            if (memop%id == fileid) then
                name = memop%filename
                call endsub('anfilename', 'name=<%c>', c1=trim(name))
                return
            endif
            memop => memop%next
        enddo
        999 continue
        call StoreError(NF_ENOTNC, "ANFileName")
        call endsub('anfilename', 'err')
    end subroutine

    subroutine ANFileSync(fileid, stat)
        use netcdf_f77, only: nf_sync, NF_NOERR
        use dc_error
        integer, intent(in), optional:: fileid
        integer, intent(out), optional:: stat
        integer:: ncid, mystat
        type(FILE_MEMO_ENTRY), pointer:: memop
        mystat = NF_NOERR
        if (present(fileid)) then
            ncid = fileid
            mystat = ANFileDataMode(ncid)
            if (mystat /= NF_NOERR) goto 999
            mystat = nf_sync(ncid)
        else if (memo_used) then
            memop => memo_head
            do
                if (.not. associated(memop)) exit
                ncid = memop%id
                mystat = ANFileDataMode(ncid)
                if (mystat /= NF_NOERR) exit
                mystat = nf_sync(ncid)
                if (mystat /= NF_NOERR) exit
                memop => memop%next
            enddo
        endif
        999 continue
        ! 自発的には StoreError しない。StoreError の SysdepAbort
        ! からも呼ばれる可能性があるためである。
        if (present(stat)) stat = mystat
    end subroutine

    subroutine ANFileOpen(fileid, filename, writable, overwrite, stat, err)
        use netcdf_f77, only: NF_WRITE, NF_NOWRITE, NF_ENOTNC, &
            NF_NOERR, NF_NOCLOBBER, NF_CLOBBER, NF_OPEN, NF_CREATE
        use dc_error, only: StoreError
        implicit none
        integer, intent(out):: fileid
        character(len = *), intent(in):: filename
        logical, intent(in), optional:: writable
        logical, intent(in), optional:: overwrite
        logical, intent(out), optional:: err
        integer, intent(out), optional:: stat
        logical:: writable_required
        logical:: overwrite_required
        type(FILE_MEMO_ENTRY), pointer:: memop, prev
        integer:: mystat, mode
        character(len = 256):: real_filename
    continue
        !
        ! オプションの解釈
        !
        writable_required = .FALSE.
        if (present(writable)) writable_required = writable
        if (present(overwrite)) then
            overwrite_required = overwrite
            if (overwrite) writable_required = .TRUE.
        else
            overwrite_required = .FALSE.
        endif
        call beginsub('anfileopen', 'writable=%y overwrite=%y file=%c', &
            & L=(/writable_required, overwrite_required/), c1=trim(filename))
        !
        ! 同じ名前で書込み可能性も適合していれば nf_open しないで済ませる
        !
        if (memo_used) then
            memop => memo_head
            nullify(prev)
            do
                if ((memop%filename == filename) &
                .and. (memop%writable .or. .not. writable_required)) then
                    fileid = memop%id
                    memop%count = memop%count + 1
                    if (present(err)) err = .FALSE.
                    if (present(stat)) stat = NF_NOERR
                    call endsub('anfileopen', 'id=%d', i=(/fileid/))
                    return
                endif
                prev => memop
                memop => memop%next
                if (.not. associated(memop)) exit
            enddo
            allocate(memop)
            prev%next => memop
        else
            nullify(prev)
            allocate(memo_head)
            memop => memo_head
            memo_used = .TRUE.
        endif
        nullify(memop%next)
        memop%filename = filename
        memop%writable = writable_required
        memop%count = 1
        !
        ! URL の部分的サポート
        !
        real_filename = filename
        if (real_filename(1:8) == 'file:///') then
            real_filename = real_filename(8: )
        else if (real_filename(1:5) == 'file:' .AND. real_filename(6:6) /= '/') then
            real_filename = real_filename(6: )
        endif
        !
        ! いざ nf_open
        !
        mode = NF_NOWRITE
        if (writable_required) mode = ior(mode, NF_WRITE)
        mystat = nf_open(real_filename, mode, memop%id)
        if (mystat /= NF_NOERR .and. writable_required) then
            mode = NF_NOCLOBBER
            if (overwrite_required) mode = NF_CLOBBER
            mystat = nf_create(real_filename, mode, memop%id)
        endif
        fileid = memop%id

        ! 失敗したら消しておく
        if (mystat /= NF_NOERR) then
            if (associated(prev)) then
                prev%next => memop%next
            else
                memo_head => memop%next
                if (.not. associated(memo_head)) memo_used = .FALSE.
            endif
            deallocate(memop)
            fileid = -1
        endif

        if (present(stat)) then
            stat = mystat
            if (present(err)) err = (stat /= NF_NOERR)
        else
            call StoreError(mystat, 'ANFileOpen', err, cause_c=filename)
        endif
        call endsub('anfileopen', 'id=%d stat=%d', i=(/fileid, mystat/))
    end subroutine

    ! 同じファイル番号の参照カウントを増加する。
    subroutine ANFileReopen(fileid, err)
        use netcdf_f77
        use dc_error, only: StoreError
        implicit none
        integer, intent(in):: fileid
        logical, intent(out), optional:: err
        type(FILE_MEMO_ENTRY), pointer:: memop
    continue
        call beginsub('anfilereopen', 'file=%d', i=(/fileid/))
        if (memo_used) then
            memop => memo_head
            do
                if (memop%id == fileid) then
                    memop%count = memop%count + 1
                    if (present(err)) err = .FALSE.
		    call endsub('anfilereopen', 'count=%d', i=(/memop%count/))
                    return
                endif
                memop => memop%next
                if (.not. associated(memop)) exit
            enddo
        endif
        call StoreError(NF_ENOTNC, 'ANFileReopen', err, cause_i=fileid)
        call endsub('anfilereopen', 'err')
    end subroutine

    ! おなじ id のファイルの参照カウンタを減算し、ゼロになったら閉じる
    subroutine ANFileClose(fileid, err)
        use netcdf_f77, only: NF_CLOSE, NF_ENOTNC, NF_NOERR
        use dc_error, only: StoreError
        integer, intent(in):: fileid
        logical, intent(out), optional:: err
        type(FILE_MEMO_ENTRY), pointer:: memop, prev
        integer:: stat
    continue
        call beginsub('anfileclose')
        stat = NF_ENOTNC
        if (.not. memo_used) goto 999
        memop => memo_head
        nullify(prev)
        do
            if (.not. associated(memop)) goto 999
            if (memop%id == fileid) exit
            prev => memop
            memop => memop%next
        enddo
        memop%count = memop%count - 1
        if (memop%count <= 0) then
            stat = nf_close(fileid)
            if (associated(prev)) then
                prev%next => memop%next
            else
                memo_head => memop%next
                if (.not. associated(memo_head)) memo_used = .FALSE.
            endif
            call message('anfileclose: <%c> closed', c1=trim(memop%filename))
            deallocate(memop)
        else
            call message('anfileclose: %d<%c> skipped for refcount=%d', &
                & c1=trim(memop%filename), i=(/fileid, memop%count/))
            stat = NF_NOERR
        endif
    999 continue
        call endsub('anfileclose')
        call StoreError(stat, 'ANFileClose', err)
    end subroutine

    integer function ANFileDefineMode(fileid) result(result)
        use netcdf_f77, only: nf_redef, NF_EINDEFINE, NF_NOERR
        integer, intent(in):: fileid
        call message('anfiledefinemode %d', i=(/fileid/))
        result = nf_redef(fileid)
        if (result == NF_EINDEFINE) result = NF_NOERR
    end function

    integer function ANFileDataMode(fileid) result(result)
        use netcdf_f77, only: nf_enddef, NF_ENOTINDEFINE, NF_NOERR
        integer, intent(in):: fileid
        call message('anfiledefinemode')
        result = nf_enddef(fileid)
        if (result == NF_ENOTINDEFINE) result = NF_NOERR
    end function

end module an_file

! Copyright (C) GFD Dennou Club, 2001.  All rights reserved
! generator of anvargetreal, anvargetdouble, etc.

SUBROUTINE ANVARGETREAL(VAR, START, CNT, STRIDE, IMAP, SIZ, VALUE, IOSTAT)
    USE AN_TYPES, ONLY: AN_VARIABLE
    USE AN_VARTABLE, ONLY: AN_VARIABLE_ENTRY, VTABLE_LOOKUP
    USE NETCDF_F77, ONLY: NF_NOERR, NF_EINVAL, NF_GET_VARM_REAL, &
        & NF_GET_VAR1_REAL
    USE DC_TRACE, ONLY: BEGINSUB, ENDSUB, MESSAGE
    IMPLICIT NONE
    TYPE(AN_VARIABLE), INTENT(IN):: VAR
    INTEGER, INTENT(IN):: START(:)
    INTEGER, INTENT(IN):: CNT(:)
    INTEGER, INTENT(IN):: STRIDE(:)
    INTEGER, INTENT(IN):: IMAP(:)
    INTEGER, INTENT(IN):: SIZ
    REAL, INTENT(OUT):: VALUE(SIZ)
    INTEGER, INTENT(OUT):: IOSTAT
    INTEGER:: ND, IPOS, I
    TYPE(AN_VARIABLE_ENTRY):: ENT
    INTEGER, ALLOCATABLE:: ISTART(:), ISTRIDE(:), IIMAP(:)
CONTINUE
    CALL BEGINSUB('anvargetREAL', &
        & FMT='varmap=%d, start=%*d, cnt=%*d, stride=%*d, imap=%*d siz=%d', &
        & I=(/VAR%ID, START(:), CNT(:), STRIDE(:), IMAP(:), SIZ/), &
        & N=(/SIZE(START), SIZE(CNT), SIZE(STRIDE), SIZE(IMAP)/))
    IOSTAT = VTABLE_LOOKUP(VAR, ENT)
    IF (IOSTAT /= NF_NOERR) GOTO 999
    ! --- ND CHECK ---
    ND = 0
    IF (ASSOCIATED(ENT%DIMIDS)) ND = SIZE(ENT%DIMIDS)
    IF (MIN(SIZE(START), SIZE(CNT), SIZE(STRIDE), SIZE(IMAP)) < ND) THEN
        IOSTAT = NF_EINVAL
        GOTO 999
    ENDIF
    IF (ND == 0) THEN
        IOSTAT = NF_GET_VAR1_REAL(ENT%FILEID, ENT%VARID, START, VALUE(1))
        GOTO 999
    ENDIF
    ! --- STRIDE KAKIKAE BUFFER ---
    ALLOCATE(ISTART(ND), ISTRIDE(ND), IIMAP(ND))
    ISTART(1:ND) = START(1:ND)
    ISTRIDE(1:ND) = STRIDE(1:ND)
    IIMAP(1:ND) = IMAP(1:ND)
    IPOS = 1
    ! --- DO READ ---
    IF (ENT%VARID <= 0 .OR. COUNT(CNT(1:ND) == 1) >= 0) THEN
        CALL BEGINSUB('fake_map_get')
        CALL FAKE_MAP_GET
        CALL ENDSUB('fake_map_get', 'iostat=%d', I=(/IOSTAT/))
    ELSE
        ! NEGATIVE STRIDE IS NOT ALLOWED FOR NETCDF
        DO, I = 1, ND
            IF (STRIDE(I) > 0) CYCLE
            IPOS = IPOS + (CNT(I) - 1) * IMAP(I)
            ISTART(I) = START(I) + (CNT(I) - 1) * STRIDE(I)
            ISTRIDE(I) = -STRIDE(I)
            IIMAP(I) = -IMAP(I)
            CALL MESSAGE('DIM %D NEGATE: STRIDE->%D START->%D MAP->%D', &
                & I=(/I, ISTRIDE(I), ISTART(I), IIMAP(I)/))
        ENDDO
        IOSTAT = NF_GET_VARM_REAL(ENT%FILEID, ENT%VARID, &
            & ISTART, CNT, ISTRIDE, IIMAP, VALUE(IPOS))
    ENDIF
    DEALLOCATE(ISTART, ISTRIDE, IIMAP)
999 CONTINUE
    CALL ENDSUB('anvargetREAL', 'iostat=%d', I=(/IOSTAT/))
    RETURN
CONTAINS

    SUBROUTINE FAKE_MAP_GET
        INTEGER:: OFS(ND), HERE(ND)
        INTEGER:: J
    CONTINUE
        IOSTAT = NF_NOERR
        OFS(1:ND) = 0
        DO
            J = IPOS + DOT_PRODUCT(OFS(1:ND), IMAP(1:ND))
            HERE(1:ND) = ISTART(1:ND) + OFS(1:ND) * ISTRIDE(1:ND)
            IF (J < 1 .OR. J > SIZ) THEN
                IOSTAT = NF_EINVAL
                CALL MESSAGE('nf_get_var1_REAL(ncid=%d, varid=%d,&
                    & indx=[%*d], out-ofs=%d)', &
                    & I=(/ENT%FILEID, ENT%VARID, HERE(1:ND), J/), N=(/ND/))
                RETURN
            ENDIF
            IF (ENT%VARID == 0) THEN
                VALUE(J) = J
                IOSTAT = NF_NOERR
            ELSE
                IOSTAT = NF_GET_VAR1_REAL(ENT%FILEID, ENT%VARID, &
                    & HERE(1), VALUE(J))
            ENDIF
            IF (IOSTAT /= NF_NOERR) RETURN
            OFS(1) = OFS(1) + 1
            DO, J = 1, ND - 1
                IF (OFS(J) < CNT(J)) EXIT
                OFS(J) = 0
                OFS(J + 1) = OFS(J + 1) + 1
            ENDDO
            IF (OFS(ND) >= CNT(ND)) EXIT
        ENDDO
    END SUBROUTINE

END SUBROUTINE

! GTLineSave - 図を変数として保存
! Copyright (C) TOYODA Eizi, 2000.  All rights reserved.

subroutine GTLineSave(Line, name, name_result)
    use gtgraph_generic, only: Save, GTGraphSaveName
    use gtgraph_types, only: GT_LINE
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: Create, Close, Put_Attr, get_attr, add_member, &
        & Inquire
    use dc_string
    use dc_types, only: STRING
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_LINE), intent(inout):: Line
    type(VSTRING), intent(in), optional:: name
    type(VSTRING), intent(out), optional:: name_result
    type(VSTRING):: title, member
    character(STRING):: url, cmember, vname
    type(GT_VARIABLE):: var
    character(*), parameter:: GTLN = "gt_graph_line_"
continue
    if (present(name)) then
        vname = name
    else
        call GTGraphSaveName(result = vname)
    endif
    call beginsub('gtlinesave', '%s', s=(/name/))
    call get_attr(Line%var, "long_name", title)
    title = "line graph of " .cat. title
    call Create(var, trim(vname), xtype="int", overwrite=.TRUE., &
        long_name=vchar(title, len(title)))
    call Put_Attr(var, "gt_structure_class", "LINE")
    call Put_Attr(var, GTLN // "index", (/line%index/))
    call Put_Attr(var, GTLN // "type", (/line%type/))
    call Put_Attr(var, GTLN // "mark", (/line%mark/))

    ! 図のメンバになっているものたちの書き出し
    call Inquire(Line%var, url=url)
    call add_member(var, url, link_name="data")
    if (associated(Line%v_axis)) then
        if (Line%v_axis%saved /= "") then
            call add_member(var, Line%v_axis%saved, link_name="vaxis")
        else
            call Save(Line%v_axis, resultname=member)
            cmember = member
            call add_member(var, cmember, link_name="vaxis")
        endif
    endif
    if (associated(Line%h_axis)) then
        if (Line%h_axis%saved /= "") then
            call add_member(var, Line%h_axis%saved, link_name="haxis")
        else
            call Save(Line%h_axis, resultname=member)
            cmember = member
            call add_member(var, cmember, link_name="haxis")
        endif
    endif
    
    call Close(var)
    print *, vchar(title, len(title)), " stored at ", trim(vname)
    if (present(name_result)) name_result = vname
    call endsub('gtlinesave')
end subroutine

! C の sprintf(3) とは大分違うので注意。
!

function DCStringCPrintf(fmt, i, r, d, L, s, n, c1, c2, c3) result(result)
    use dcstring_base, only: VSTRING
    use dc_types, only: string
    use dc_string, only: DCStringSPrintf
    implicit none
    character(len = string):: result
    character(*), intent(in):: fmt
    integer, intent(in), optional:: i(:), n(:)
    real, intent(in), optional:: r(:)
    double precision, intent(in), optional:: d(:)
    logical, intent(in), optional:: L(:)
    type(VSTRING), intent(in), optional:: s(:)
    character(*), intent(in), optional:: c1, c2, c3
continue
    call dcstringsprintf(result, fmt, i=i, r=r, d=d, L=L, s=s, n=n, &
        & c1=c1, c2=c2, c3=c3)
end function

! Copyright (C) GFD Dennou Club, 2001.  All rights reserved.


integer function gtdim_name2ord(var, name) result(result)
    use gtdata_types, only: gt_variable
    use dc_string, only: stoi
    use an_generic, only: an_variable, search_dim
    use gt_map, only: var_class, vtb_class_netcdf
    implicit none
    type(gt_variable), intent(in):: var
    character(len = *), intent(in):: name
    integer:: class, cid
    result = -1
    if (name == ' ') return
    result = stoi(name)
    if (result /= 0) return
    ! 個別層に問い合わせて次元番号を得ようと試みる。
    call var_class(var, class, cid)
    if (class == vtb_class_netcdf) then
        result = search_dim(an_variable(cid), name)
    endif
    ! map 表から次元名を使って次元番号を得ようと試みる。
end function

! dc_url.f90 - 変数 URL の文字列解析
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

module dc_url

    implicit none

    public:: UrlSplit, UrlResolve, url_chop_iorange

    interface UrlMerge
        module procedure url_merge_v_vvv
        module procedure url_merge_cccc
        module procedure url_merge_cc
    end interface

    interface UrlSplit
        module procedure url_split_v
        module procedure url_split_c
    end interface

    interface UrlResolve
        module procedure url_resolve_c
    end interface

    interface operator(.OnTheSameFile.)
        module procedure UrlOnTheSameFile
    end interface

    character, public, parameter:: GT_ATMARK = "@"
    character, public, parameter:: GT_COLON = ":"
    character, public, parameter:: GT_COMMA = ","
    character, public, parameter:: GT_QUESTION = '?'
    character, public, parameter:: GT_EQUAL = "="
    character, public, parameter:: GT_CIRCUMFLEX = "^"
    character, public, parameter:: GT_PLUS = "+"

contains

    ! ANUrlMerge - 変数 URL の合成
    ! 空文字列の成分はないとみなされる。

        type(VSTRING) function &
    url_merge_v_vvv(file, var, attr, iorange) result(result)
        use dc_string
        type(VSTRING), intent(in):: file
        type(VSTRING), intent(in), optional:: var
        type(VSTRING), intent(in), optional:: attr
        type(VSTRING), intent(in), optional:: iorange
        result = file // GT_ATMARK
        if (present(var)) result = result // var
        if (present(attr)) then
            if (attr /= "") result = result // GT_COLON // attr
        endif
        if (present(iorange)) then
            if (extract(iorange, 1, 1) == GT_COMMA) then
                result = result // iorange
            else if (iorange /= "") then
                result = result // GT_COMMA // iorange
            endif
        endif
    end function

    function url_merge_cccc(file, var, attr, iorange) result(result)
        use dc_types, only: string
        character(len = string):: result
        character(len = *), intent(in):: file
        character(len = *), intent(in):: var
        character(len = *), intent(in):: attr
        character(len = *), intent(in):: iorange
    continue
        if (file /= "") then
            result = trim(file) // gt_atmark
        else
            result = gt_atmark
        endif
        if (var /= "") result = trim(result) // var
        if (attr /= "") then
            result = trim(result) // gt_colon // attr
        endif
        if (iorange /= "") then
            if (iorange(1:1) == gt_comma) then
                result = trim(result) // iorange
            else
                result = trim(result) // gt_comma // iorange
            endif
        endif
    end function

    function url_merge_cc(file, var) result(result)
        use dc_types, only: string
        character(len = string):: result
        character(len = *), intent(in):: file
        character(len = *), intent(in):: var
    continue
        result = url_merge_cccc(file, var, "", "")
    end function

    ! url_chop_iorange - 変数 URL から iorange を除去
    subroutine url_chop_iorange(fullname, iorange, remainder)
        use dc_types, only: string
        character(len = *), intent(in):: fullname
        character(len = *), intent(out):: iorange, remainder
        character(string):: file, var, attr
        call urlsplit(fullname, file=file, var=var, attr=attr, iorange=iorange)
        remainder = url_merge_cccc(file=file, var=var, attr=attr, iorange="")
    end subroutine

    ! UrlSplit - 変数 URL の分解
    ! 見つからない成分には空文字列が代入される。

    subroutine url_split_c(fullname, file, var, attr, iorange)
        use dc_types, only: string
        character(len = *), intent(in):: fullname
        character(len = *), intent(out), optional:: file, var, attr, iorange
        character(len = string):: varpart
        integer:: atmark, colon, comma
        character(len = *), parameter:: VARNAME_SET &
            = "0123456789eEdD+-=^,.:_" &
            // "ABCDEFGHIJKLMNOPQRSTUVWXYZ" &
            // "abcdefghijklmnopqrstuvwxyz"
    continue
        ! まず URL と変数属性指定 (? または @ 以降) を分離する。
        ! URL は @ を含みうるため、最後の @ 以降に対して変数属性
        ! として許されない文字（典型的には '/'）が含まれていたら
        ! 当該 @ は URL の一部とみなす。
        atmark = index(fullname, GT_QUESTION)
        if (atmark == 0) then
            atmark = index(fullname, GT_ATMARK, back=.TRUE.)
            if (atmark /= 0) then
                if (verify(trim(fullname(atmark+1: )), VARNAME_SET) /= 0) then
                    atmark = 0
                endif
            endif
        endif
        if (atmark == 0) then
            ! 変数属性指定はなかった。
            if (present(file)) file = fullname
            if (present(var)) var = ''
            if (present(attr)) attr = ''
            if (present(iorange)) iorange = ''
            return
        endif
        varpart = fullname(atmark+1: )
        ! 変数属性指定があった。
        if (present(file)) file = fullname(1: atmark - 1)
        ! 範囲指定を探索する。
        comma = index(varpart, GT_COMMA)
        if (comma /= 0) then
            ! 範囲指定がみつかった。
            if (present(var)) var = varpart(1: comma - 1)
            if (present(attr)) attr = ''
            if (present(iorange)) iorange = varpart(comma + 1: )
            return
        endif
        if (present(iorange)) iorange = ''
        ! 範囲指定がなかったので、属性名の検索をする。
        colon = index(varpart, GT_COLON)
        if (colon == 0) then
            if (present(var)) var = varpart
            if (present(attr)) attr = ''
            varpart = ''
            return
        endif
        if (present(var)) var = varpart(1: colon - 1)
        if (present(attr)) attr = varpart(colon + 1: )
        varpart = ''
    end subroutine

    subroutine url_split_v(fullname, file, var, attr, iorange)
        use dc_string
        type(VSTRING), intent(in):: fullname
        type(VSTRING), intent(out), optional::        file, var, attr, iorange
        type(VSTRING):: varpart
        integer:: atmark, colon, comma
        character(len = *), parameter:: VARNAME_SET &
            = "0123456789eEdD+-=^,.:_" &
            // "ABCDEFGHIJKLMNOPQRSTUVWXYZ" &
            // "abcdefghijklmnopqrstuvwxyz"
    continue
        ! まず URL と変数属性指定 (? または @ 以降) を分離する。
        ! URL は @ を含みうるため、最後の @ 以降に対して変数属性
        ! として許されない文字（典型的には '/'）が含まれていたら
        ! 当該 @ は URL の一部とみなす。
        atmark = vindex(fullname, GT_QUESTION)
        if (atmark == 0) then
            atmark = vindex(fullname, GT_ATMARK, .TRUE.)
            if (atmark /= 0) then
                varpart = extract(fullname, atmark + 1)
                if (vverify(varpart, VARNAME_SET) /= 0) then
                    atmark = 0
                endif
            endif
        endif
        if (atmark == 0) then
            ! 変数属性指定はなかった。
            if (present(file)) file = fullname
            if (present(var)) var = ''
            if (present(attr)) attr = ''
            if (present(iorange)) iorange = ''
            return
        endif
        varpart = extract(fullname, atmark + 1)
        ! 変数属性指定があった。
        if (present(file)) file = extract(fullname, 1, atmark - 1)
        ! 範囲指定を探索する。
        comma = vindex(varpart, GT_COMMA)
        if (comma /= 0) then
            ! 範囲指定がみつかった。
            if (present(var)) var = extract(varpart, 1, comma - 1)
            if (present(attr)) attr = ''
            if (present(iorange)) iorange = extract(varpart, comma + 1)
            return
        endif
        if (present(iorange)) iorange = ''
        ! 範囲指定がなかったので、属性名の検索をする。
        colon = vindex(varpart, GT_COLON)
        if (colon == 0) then
            if (present(var)) var = varpart
            if (present(attr)) attr = ''
            varpart = ''
            return
        endif
        if (present(var)) var = extract(varpart, 1, colon - 1)
        if (present(attr)) attr = extract(varpart, colon + 1)
        varpart = ''
    end subroutine

    !
    ! === 同じファイルに載っているかどうか判定 ===
    !

    logical function UrlOnTheSameFile(url_a, url_b) result(result)
        use dc_string
        type(VSTRING), intent(in):: url_a
        type(VSTRING), intent(in):: url_b
        type(VSTRING):: filepart_a
        type(VSTRING):: filepart_b
        call UrlSplit(url_a, file=filepart_a)
        call UrlSplit(url_b, file=filepart_b)
        result = (filepart_a == filepart_b)
    end function

    !
    ! === 相対リンクを解決 ===
    !

    function url_resolve_c(relative, base) result(result)
        use dc_string, only: StrHead
        use dc_types, only: string
        use dc_trace, only: beginsub, endsub, message
        implicit none
        character(len = *), intent(in):: relative
        character(len = *), intent(in):: base
        character(len = STRING):: result
        integer, parameter:: FILE = 1, VAR = 2, ATTR = 3, IOR = 4
        character(len = STRING):: rel(FILE:IOR), bas(FILE:IOR)
        character(3), parameter:: PATHDELIM = "/:" // achar(94)
        integer:: idir_r, idir_b
        call beginsub('urlresolve', 'rel=<%c> base=<%c>', c1=relative, c2=base)
        call UrlSplit(trim(relative), file=rel(FILE), var=rel(VAR), &
            & attr=rel(ATTR), iorange=rel(IOR))
        call message('rel -> file=<%c> var=<%c> attr=<%c>', &
            & c1=trim(rel(FILE)), c2=trim(rel(VAR)), &
            & c3=(trim(rel(ATTR)) // '> ior=<' // trim(rel(IOR))))
        call UrlSplit(base, file=bas(FILE), var=bas(VAR), &
            & attr=bas(ATTR), iorange=bas(IOR))
        call message('base -> file=<%s> var=<%s> attr=<%s> ior=<%s>', &
            & c1=trim(bas(FILE)), c2=trim(bas(VAR)), &
            & c3=(trim(bas(ATTR)) // '> ior=<' // trim(bas(IOR))))
        if (rel(FILE) == "") then
            rel(FILE) = bas(FILE)
            if (rel(VAR) == "") &
                & rel(VAR) = bas(VAR)
            result = UrlMerge(file=rel(FILE), var=rel(VAR), &
                    & attr=rel(ATTR), iorange=rel(IOR))
            call endsub('urlresolve', '1 result=%c', c1=trim(result))
            return
        endif
        ! --- 相対パスのファイル名を解決 ---
        if (StrHead(rel(FILE), "file:") &
            & .OR. StrHead(rel(FILE), "http:") &
            & .OR. StrHead(rel(FILE), "ftp:") &
            & .OR. StrHead(rel(FILE), "news:") &
            & .OR. StrHead(rel(FILE), "www") &
            & .OR. StrHead(rel(FILE), "/") &
            & .OR. StrHead(rel(FILE), achar(94)) &
            & .OR. rel(FILE)(2:1) == ":" &
            ) then
            result = relative
            call endsub('urlresolve', '2 result=%c', c1=trim(result))
            return
        endif
        idir_b = scan(bas(FILE), PATHDELIM, back=.TRUE.) 
        if (idir_b == 0) then
            result = relative
            call endsub('urlresolve', '3 result=%c', c1=trim(result))
            return
        endif
        idir_r = scan(rel(FILE), PATHDELIM, back=.TRUE.)
        result = base(1: idir_b) // relative(idir_r: 1)
        call endsub('urlresolve', '4 result=%c', c1=trim(result))
    end function

end module

! dcunits_com - common private data for dc_units module

module dcunits_com

    use dc_types, only: DOUBLE, STRING
    implicit none

    ! scannter symbols
    integer, parameter:: S_EOF = -128
    integer, parameter:: S_SHIFT = 300
    integer, parameter:: S_TEXT = 301
    integer, parameter:: S_MULTIPLY = 302
    integer, parameter:: S_DIVIDE = 303
    integer, parameter:: S_EXPONENT = 304
    integer, parameter:: S_OPENPAR = 305
    integer, parameter:: S_CLOSEPAR = 306
    integer, parameter:: S_REAL = 307
    integer, parameter:: S_INTEGER = 308

    ! scanner buffer
    character(STRING), private, save:: thisline = ""
    integer, private, save:: i = 1

contains

    subroutine DCUnitsSetLine(line)
        implicit none
        character(*), intent(in):: line
        thisline = line
        i = 1
    end subroutine

    subroutine DCUnitsGetToken(tokentype, ivalue, dvalue, cvalue)
        use regex, only: match
        implicit none
        integer, intent(out):: tokentype
        integer, intent(out):: ivalue(5)
        double precision, intent(out):: dvalue
        character(*), intent(out):: cvalue
        integer:: iend, istr, ilen, ios
        ivalue = 0
        dvalue = 0.0d0
        cvalue = ""
        iend = len_trim(thisline)
        do
            if (i > iend) exit
            ! '#' 文字が現われれば EOF シンボルを返す
            call match("^##", thisline(i:), istr, ilen)
            if (istr > 0) then
                i = iend + 1
                tokentype = S_EOF
                return
            endif
            ! 空白を無視
            call match("^#s+", thisline(i:), istr, ilen)
            if (istr > 0) then
                i = i + ilen
                if (i > iend) exit
            endif
            ! シフト演算子チェック
            call match("^@", thisline(i:), istr, ilen)
            if (istr <= 0) call match("^from", thisline(i:), istr, ilen)
            if (istr <= 0) call match("^at", thisline(i:), istr, ilen)
            if (istr > 0) then
                i = i + ilen
                tokentype = S_SHIFT
                cvalue = thisline(i: i+ilen-1)
                return
            endif
            ! 名前チェック
            call match("^#a#w*#a", thisline(i:), istr, ilen)
            if (istr <= 0) call match("^[#a'""]", thisline(i:), istr, ilen)
            if (istr > 0) then
                tokentype = S_TEXT
                cvalue = thisline(i: i+ilen-1)
                i = i + ilen
                return
            endif
            ! '*' の前に '**' を認知せねば。
            call match("^#^", thisline(i:), istr, ilen)
            if (istr <= 0) call match("^#*#*", thisline(i:), istr, ilen)
            if (istr > 0) then
                tokentype = S_EXPONENT
                cvalue = thisline(i: i+ilen-1)
                i = i + ilen
                return
            endif
            ! 実数にならない小数点は S_MULTIPLY
            call match("^#.[^#d]", thisline(i:), istr, ilen)
            if (istr <= 0) call match("^#*", thisline(i:), istr, ilen)
            if (istr > 0) then
                tokentype = S_MULTIPLY
                cvalue = thisline(i: i+ilen-1)
                i = i + 1
                return
            endif
            ! 実数チェック. 小数点は語頭にあれば必ず数字が伴うので安心せよ
            call match("^[-+]?#d*#.#d*[EeDd][-+]?#d+", thisline(i:), istr, ilen)
            if (istr <= 0) call match("^[-+]?#d*#.#d*", thisline(i:), istr, ilen)
            if (istr > 0) then
                read(thisline(i: i+ilen-1), fmt=*, &
                    & iostat=ios) dvalue
                if (ios /= 0) dvalue = HUGE(dvalue)
                cvalue = thisline(i: i+ilen-1)
                tokentype = S_REAL
                i = i + ilen
                return
            endif
            ! 整数チェック
            call match("^[-+]?#d+", thisline(i:), istr, ilen)
            if (istr > 0) then
                read(thisline(i: i+ilen-1), fmt=*, &
                    & iostat=ios) ivalue(1)
                if (ios /= 0) ivalue(1) = HUGE(1)
                cvalue = thisline(i: i+ilen-1)
                tokentype = S_INTEGER
                i = i + ilen
                return
            endif
            ! ほかの１字トークンチェック
            if (thisline(i:i) == '/') then
                tokentype = S_DIVIDE
                cvalue = thisline(i:i)
                i = i + 1
                return
            endif
            if (thisline(i:i) == '(') then
                tokentype = S_OPENPAR
                cvalue = thisline(i:i)
                i = i + 1
                return
            endif
            if (thisline(i:i) == ')') then
                tokentype = S_CLOSEPAR
                cvalue = thisline(i:i)
                i = i + 1
                return
            endif
            ! だめだこりゃ。はい次いってみよう
            tokentype = ichar(thisline(i:i))
            cvalue = thisline(i:i)
            i = i + 1
            return
        enddo
        i = iend + 1
        tokentype = S_EOF
        cvalue = ""
    end subroutine

end module

! Copyright (C) GFD Dennou Club, 2000-2001.  All rights reserved

module dc_types

    implicit none

    integer, parameter:: DOUBLE = kind(0.0d0)
    integer, parameter:: TOKEN = 32
    integer, parameter:: STRING = 500

    !
    ! netCDF Fortran インターフェイスの型パラメタ
    ! (netcdf.inc には存在しない)
    !
    integer, parameter:: NF_KIND_INT1 = selected_int_kind(2)
    integer, parameter:: NF_KIND_INT2 = selected_int_kind(4)
end module

! an_generic.f90 - 抽象 netCDF インターフェイスの総称宣言
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.


module an_generic

    use an_types, only: an_variable

    implicit none
    !
    ! === 基本開閉動作 ===
    !

    !
    ! an ライブラリでは「ファイル」ではなく「変数」を開いたり閉じたりする。
    ! すべてのものは変数とその属性である。

    interface open
        ! 
        ! open(var, url, [writable], [err]) は url で識別される
        ! 変数を開き var に格納する。ここで変数とは netCDF 変数または
        ! netCDF 次元である。次元と同名の netCDF 変数がある場合には両者は
        ! 同一視される。writable を真に指定すると書き込み可で開こうとする。
        ! デフォルトは writable=.FALSE. である。エラーが発生した場合は
        ! err が真となる。err を与えなければプログラムは停止する。
        !
        recursive subroutine ANVarOpen(var, url, writable, err)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(out):: var
            character(len = *), intent(in):: url
            logical, intent(in), optional:: writable
            logical, intent(out), optional:: err
        end subroutine
        !
        ! an ライブラリの変数は netCDF の変数と次元を統合したもの
        ! である。次元構造体は存在しない。そこで、an の立場では
        ! 変数は任意個の次元と呼ばれる変数を持つということになる。
        ! 従来次元変数と呼ばれていたものは、変数が自分自身のみを
        ! 次元としてもつ場合を指す。
        !
        ! open(var, src_var, dimord, [count_compact], [err]) は
        ! 既に開かれた変数 src_var の ord 番目の次元にあたる変数を
        ! 開き var に格納する。順序 ord は現在の入出力範囲が
        ! 幅１になっている (コンパクト化している）を飛ばした
        ! 順序であるが、count_compact に真を指定すると
        ! すべての次元のなかの順序になる。
        !
        subroutine ANVarOpenByDimOrd(var, src_var, dimord, err)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(out):: var
            type(AN_VARIABLE), intent(in):: src_var
            integer, intent(in):: dimord
            logical, intent(out), optional:: err
        end subroutine
    end interface

    interface search_dim
        integer function an_search_dim(var, dimname)
            use an_types, only: an_variable
            type(an_variable), intent(in):: var
            character(len = *), intent(in):: dimname
        end function
    end interface

    interface create
        !
        ! 従属変数 create
        !
        ! create(var, url, dims, [xtype], [overwrite], [err]) は
        ! 場所 url に次元 dims を持った変数を作成し、それを開いた
        ! ものを var に格納する。型 xtype を省略すると real と
        ! みなされる。既存変数があるとき失敗するが
        ! overwrite が真であれば続行する。
        ! ゼロ次元変数を作るには dims に長さゼロの配列を渡すこと。
        !
        subroutine ANVarCreate(var, url, xtype, dims, overwrite, err)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(out):: var
            character(len = *), intent(in):: url
            character(len = *), intent(in):: xtype
            type(AN_VARIABLE), intent(in):: dims(:)
            logical, intent(in), optional:: overwrite
            logical, intent(out), optional:: err
        end subroutine
        !
        ! 次元変数 create
        !
        ! create(var, url, xtype, length, [overwrite], [err]) は
        ! 長さ length の次元変数を作成する。
        !
        subroutine ANVarCreateD(var, url, xtype, length, overwrite, err)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(out):: var
            character(len = *), intent(in):: url
            character(len = *), intent(in):: xtype
            integer, intent(in):: length
            logical, intent(in), optional:: overwrite
            logical, intent(out), optional:: err
        end subroutine
    end interface

    interface
        subroutine ANVarDel(varname, hint, stat)
            character(len = *), intent(in):: varname
            character(len = *), intent(in):: hint
            integer, intent(out):: stat
        end subroutine
    end interface

    interface close
        subroutine ANVarClose(var, err)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            logical, intent(out), optional:: err
        end subroutine
    end interface

    !
    ! === 変数に関する問い合わせ万般 ===
    !

    ! mainly for PRINT debugging
    interface toString
        function ANVarToString(var) result(result)
            use dc_types, only: STRING
            use an_types, only: AN_VARIABLE
            character(string):: result
            type(AN_VARIABLE), intent(in):: var
        end function
    end interface

    interface inquire

        subroutine ANVarInquire(var, ndims, dimlen, growable, name, url, xtype)
            use an_types, only: an_variable
            type(an_variable), intent(in):: var
            ! 変数の次元数
            integer, intent(out), optional:: ndims
            ! 変数が１次元である場合、次元長
            integer, intent(out), optional:: dimlen
            ! 変数が成長可能次元を持つか
            logical, intent(out), optional:: growable
            ! 文字型引数が短いと値の切り詰めが起こりうる
            ! '?' のあとの変数名
            character(*), intent(out), optional:: name
            ! 変数名、少なくともファイル名を含む、なるべく長い名前
            character(*), intent(out), optional:: url
            ! 変数の型名
            character(*), intent(out), optional:: xtype
        end subroutine

        ! 引数は ndims 個でなければならない
        subroutine ANVarInquireIA(var, dimlen)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            integer, intent(out):: dimlen(:)
        end subroutine

        subroutine ANAttrInquire(var, attrname, xtype)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            character(len=*), intent(in):: attrname
            character(len=*), intent(out), optional:: xtype
        end subroutine

    end interface

    !
    ! === 属性関係 ===
    !

    ! すべては変数という an ライブラリの立場から、
    ! 大域属性は変数属性とみなされる。
    ! 属性読み取り時には変数属性の次に大域属性を検索する。
    ! 属性書き込み時には一部の例外を除き変数属性として書き込む。
    ! gtool4 規約で大域属性と規定された属性 Conventions,
    ! gt_version, title, gt_subtitle, comment, source,
    ! institution, production, history についてはまず
    ! 大域属性として書き込もうとする。既存の値があった
    ! 場合 Conventions, gt_version は gtool4 同士ならば
    ! 版数が大きくなるようにする。history は規定どおり
    ! 追加動作を行う。その他の属性名については既存と異なる
    ! 属性値があれば変数属性として書き込む。

    !
    ! --- 属性の列挙 ---
    !

    ! ある変数 var に付随した属性をすべて取得するにはまず
    ! attr_rewind(var) を呼び出してから無限ループの中で
    ! attr_next(var, name, [end]) を呼び出す。name がひとつ
    ! ひとつの属性名を与える。name が空文字列になったとき、
    ! すべての属性を探索し終えたことになる。このとき end を
    ! 与えていればそれが真になることでも判定できる。

    interface attr_rewind
        subroutine ANVarAttrRewind(var)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
        end subroutine
    end interface

    interface attr_next
        subroutine ANVarAttrNext(var, name, end)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            character(len = *), intent(out):: name
            logical, intent(out), optional:: end
        end subroutine
    end interface

    ! 変数 var の属性 name を取得して value に格納する。
    ! 属性が存在しないか value の長さが不足している場合
    ! default が補われる。属性の型はなんでもよく型変換をする。

    interface get_attr

        subroutine ANAttrGetChar(var, name, value, default, stat)
            use dc_string, only: VSTRING    
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            character(len = *), intent(out):: value
            character(len = *), intent(in):: default
            integer, intent(out):: stat
        end subroutine

        subroutine ANVarGetAttrLogical(var, name, value, default)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            logical, intent(out):: value
            logical, intent(in), optional:: default
        end subroutine

        ! お客様向きではないけれど、情報落ちのないインターフェイスということで....
        ! stat = -1:  その属性は存在しなかった
        ! stat = 0 ... size(value):  その属性を全部読み取った。サイズは stat 個
        ! stat > size(value):  配列長不足のため属性が全部読み取れなかった。
        !                      サイズは stat 個必要

        subroutine AnAttrGetReal(var, name, value, stat, default)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            real, intent(out):: value(:)
            integer, intent(out):: stat
            real, intent(in), optional:: default
        end subroutine

        subroutine AnAttrGetDouble(var, name, value, stat, default)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            double precision, intent(out):: value(:)
            integer, intent(out):: stat
            double precision, intent(in), optional:: default
        end subroutine

        subroutine AnAttrGetInt(var, name, value, stat, default)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            integer, intent(out):: value(:)
            integer, intent(out):: stat
            integer, intent(in), optional:: default
        end subroutine

    end interface

    ! 変数 var の属性 name に value を格納する。
    ! 属性の型は value の型に適合するように設定される。
    ! 論理型は 1 文字の文字型として格納され、真は T,
    ! 偽は F となる。

    interface put_attr

        subroutine ANVarPutAttrReal(var, name, value, err)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            real, intent(in):: value(:)
            logical, intent(out), optional:: err
        end subroutine

        subroutine ANVarPutAttrDouble(var, name, value, err)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            double precision, intent(in):: value(:)
            logical, intent(out), optional:: err
        end subroutine

        subroutine ANVarPutAttrInt(var, name, value, err)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            integer, intent(in):: value(:)
            logical, intent(out), optional:: err
        end subroutine

        subroutine ANVarPutAttrLogical(var, name, value, err)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            logical, intent(in):: value
            logical, intent(out), optional:: err
        end subroutine

        subroutine ANVarPutAttrChar(var, name, value, xtype, err)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            character(len = *), intent(in):: value
            character(len = *), intent(in), optional:: xtype
            logical, intent(out), optional:: err
        end subroutine

    end interface

    interface del_attr
        subroutine ANVarDelAttr(var, name, err)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            logical, intent(out), optional:: err
        end subroutine
    end interface

    interface copy_attr
        subroutine ANVarAttrCopy(to, attrname, from, stat)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: to
            character(len = *), intent(in):: attrname
            type(AN_VARIABLE), intent(in):: from
            integer, intent(out):: stat
        end subroutine
    end interface

    !
    ! 入出力
    !

    interface get

        subroutine anvargetreal(var, start, count, stride, imap, &
        & siz, value, iostat)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            integer, intent(in):: start(:)
            integer, intent(in):: count(:)
            integer, intent(in):: stride(:)
            integer, intent(in):: imap(:)
            integer, intent(in):: siz
            real, intent(out):: value(siz)
            integer, intent(out):: iostat
        end subroutine

        subroutine anvargetdouble(var, start, count, stride, imap, &
        & siz, value, iostat)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            integer, intent(in):: start(:)
            integer, intent(in):: count(:)
            integer, intent(in):: stride(:)
            integer, intent(in):: imap(:)
            integer, intent(in):: siz
            double precision, intent(out):: value(siz)
            integer, intent(out):: iostat
        end subroutine

    end interface

    interface put

        subroutine anvarputreal(var, start, count, stride, imap, &
        & siz, value, iostat)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            integer, intent(in):: start(:)
            integer, intent(in):: count(:)
            integer, intent(in):: stride(:)
            integer, intent(in):: imap(:)
            integer, intent(in):: siz
            real, intent(in):: value(siz)
            integer, intent(out):: iostat
        end subroutine

        subroutine anvarputdouble(var, start, count, stride, imap, &
        & siz, value, iostat)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in):: var
            integer, intent(in):: start(:)
            integer, intent(in):: count(:)
            integer, intent(in):: stride(:)
            integer, intent(in):: imap(:)
            integer, intent(in):: siz
            double precision, intent(in):: value(siz)
            integer, intent(out):: iostat
        end subroutine

    end interface

    !
    ! === ファイル名から変数をさがす ===
    !

    interface var_search
        
        subroutine ANVarSearchInit(iter, urlBase)
            use an_types, only: AN_VARIABLE_SEARCH
            type(AN_VARIABLE_SEARCH), intent(out):: iter
            character(len = *), intent(in):: urlBase
        end subroutine

        subroutine ANVarSearchNext(iter, url, end)
            use an_types, only: AN_VARIABLE_SEARCH
            type(AN_VARIABLE_SEARCH), intent(inout):: iter
            character(len = *), intent(out):: url
            logical, intent(out):: end
        end subroutine

    end interface        

    !
    ! 非常脱出用。このルーチンは SysDepAbort からも呼ばれるため、
    ! 自分で StoreError することはない。
    !

    interface
        subroutine ANVarSync(var, stat)
            use an_types, only: AN_VARIABLE
            type(AN_VARIABLE), intent(in), optional:: var
            integer, intent(out), optional:: stat
        end subroutine
    end interface

    !
    ! an 層の内部的使用のためのルーチン
    !
    interface
        subroutine ANXTypeName(ixtype, xtype)
            integer, intent(in):: ixtype
            character(*), intent(out):: xtype
        end subroutine
    end interface

end module

!
! create(var, url, [dims], [xtype], [overwrite], [err]) は
! 場所 url に次元 dims を持った変数を作成し、それを開いた
! ものを var に格納する。型 xtype を省略すると "float" と
! みなされる。既存変数があるとき失敗するが
! overwrite が真であれば続行する。
!

subroutine GTVarCreate(var, url, dims, xtype, long_name, overwrite, err)
    use gtdata_types, only: gt_variable
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory, &
        & map_create, gtvar_dump
    use an_generic, only: create, put_attr, inquire
    use an_types, only: an_variable
    use netcdf_f77, only: nf_real, nf_int
    use dc_string, only: strhead
    use dc_error
    use dc_types, only: token
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(gt_variable), intent(inout):: var
    character(len = *), intent(in):: url
    type(gt_variable), intent(in), optional:: dims(:)
    character(len = *), intent(in), optional:: xtype
    character(len = *), intent(in), optional:: long_name
    logical, intent(in), optional:: overwrite
    logical, intent(out), optional:: err
    type(an_variable), allocatable:: an_dims(:)
    type(an_variable):: an
    integer, allocatable:: allcount(:)
    integer:: i, ndims
    character(len = token):: myxtype
continue
    call beginsub('gtvarcreate', 'url=%c ndims=%d', c1=trim(url), i=(/size(dims)/))
    if (strhead(url, "memory:")) then
        ! メモリ変数の作成
        call StoreError(GT_EFAKE, "GTVarCreate", err)
        call endsub('gtvarcreate')
        return
    else
        ! an 変数の作成
        if (present(err)) err = .false.
        if (present(xtype)) then
            myxtype = xtype
        else
            myxtype = "float"
        endif
        if (present(dims)) then
            ndims = size(dims)
            allocate(an_dims(ndims), allcount(ndims))
            do, i = 1, ndims
                call var_class(dims(i), cid=an_dims(i)%id)
                call message('dim=%d mapid=%d -> cid=%d', i=(/i, dims(i)%mapid, an_dims(i)%id/))
                call inquire(an_dims(i), dimlen=allcount(i))
            enddo
            call create(var=an, url=url, dims=an_dims, xtype=myxtype, &
                & overwrite=overwrite, err=err)
        else
            ndims = 0
            allocate(an_dims(1), allcount(1)) ! dummy
            call create(var=an, url=url, dims=an_dims(1:0), &
                & xtype=myxtype, overwrite=overwrite, err=err)
        endif
        call map_create(var, vtb_class_netcdf, an%id, ndims, allcount)
        deallocate(an_dims, allcount)
        if (present(long_name)) then
            call put_attr(an, 'long_name', long_name, err=err)
        endif
    endif
    call gtvar_dump(var)
    call endsub('gtvarcreate', 'var%%mapid=%d', i=(/var%mapid/))
end subroutine

! GTFigSave - 図を変数として保存

subroutine GTFigSave(fig, name, name_result)
    use gtgraph_generic, only: Save, GTGraphSaveName
    use gtgraph_types, only: GT_FIGURE
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: Create, Close, put_attr, add_member
    use dc_trace, only: beginsub, endsub
    use dc_string, only: VSTRING, vchar, len, ASSIGNMENT(=)
    use dc_types, only: STRING
    implicit none
    type(GT_FIGURE), intent(inout):: fig
    type(VSTRING), intent(in), optional:: name
    type(VSTRING), intent(out), optional:: name_result
    type(VSTRING):: childname
    type(GT_VARIABLE):: var
    character(LEN = STRING):: strbuf, vname, figtitle
    integer:: i
continue
    if (present(name)) then
        vname = name
    else
        call GTGraphSaveName(result=vname)
    endif
    call beginsub('gtfigsave', 'name=%c', c1=vname)
    figtitle = fig%title
    call Create(var, trim(vname), xtype="int", overwrite=.TRUE., &
        & long_name=trim(figtitle))
    call Put_Attr(var, "gt_structure_class", "figure")

    ! 図のメンバになっているものたちの書き出し
    if (associated(fig%contours)) then
        do, i = 1, size(fig%contours)
            call Save(fig%contours(i), resultname=childname)
            strbuf = childname
            call add_member(var, strbuf)
        enddo
    endif

    if (associated(fig%vectors)) then
        do, i = 1, size(fig%vectors)
            call Save(fig%vectors(i), resultname=childname)
            strbuf = childname
            call add_member(var, strbuf)
        enddo
    endif

    call Put_Attr(var, "gt_graph_aspect_ratio", (/fig%aspect/))

    call Close(var)
    print *, "figure ", trim(figtitle), " stored at ", trim(vname), "."
    if (present(name_result)) name_result = vname
    call endsub('gtfigsave', 'name=%c', c1=trim(vname))
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

recursive subroutine ANVarOpen(var, url, writable, err)
    use dc_types, only: string
    use an_types
    use an_vartable, only: vtable_add
    use an_file
    use dc_url
    use dc_error
    use dc_trace, only: beginsub, endsub
    use netcdf_f77
    implicit none
    type(AN_VARIABLE), intent(out):: var
    character(len = string), intent(in):: url
    logical, intent(in), optional:: writable
    logical, intent(out), optional:: err
    character(len = string):: filename, varname
    character(len = NF_MAX_NAME):: dimname
    integer:: stat, nvars, i
    type(an_variable_search):: e
continue
    call beginsub('anvaropen')
    call UrlSplit(url, file=filename, var=varname)
    if (filename == "") filename = "gtool.nc"
    call ANFileOpen(e%fileid, trim(filename), stat=stat, writable=writable)
    if (stat /= 0) goto 999
    !
    ! 名前から変数を探し出す
    !
    if (varname /= '') then
        e%varid = 0
        stat = nf_inq_varid(e%fileid, trim(varname), e%varid)
        if (stat == NF_ENOTVAR) then
            e%varid = 0
            stat = NF_NOERR
        endif
    else
        ! 名前が空ならできれば次元変数でない最初の変数をとりだす
        stat = nf_inq_nvars(e%fileid, nvars)
        if (stat /= 0) goto 999
        e%varid = 1
        do, i = 1, nvars
            stat = nf_inq_varname(e%fileid, i, dimname)
            if (stat /= NF_NOERR) goto 999
            stat = nf_inq_dimid(e%fileid, dimname, e%dimid)
            if (stat == NF_NOERR) cycle
            if (stat /= NF_EBADDIM) goto 999
            e%varid = i
            stat = NF_NOERR
            exit
        enddo
    endif
    if (stat /= NF_NOERR) goto 999
    !
    ! 次元id を調べる
    !
    stat = nf_inq_dimid(e%fileid, trim(varname), e%dimid)
    if (stat /= NF_NOERR) then
        if (e%varid <= 0) goto 999
        e%dimid = 0
    endif
    !
    stat = vtable_add(var, e)
    if (stat /= NF_NOERR) goto 999
    call endsub('anvaropen', 'an=%d file=%d var=%d', i=(/var%id, e%fileid, e%varid/))
    call StoreError(stat, 'ANVarOpen', err)
    return
    !
    ! エラー処理 (正常完了時も呼ぶ)
    !
999 continue
    var = an_variable(-1)
    call endsub('anvaropen', 'an=%d err', i=(/var%id/))
    call StoreError(stat, 'ANVarOpen', err, cause_c=url)
end subroutine

module gt3map

    use gt3read, only: gt3_file, gt3_header, open, close
    use dc_types, only: string, token
    use dc_trace, only: message
    use findfile, only: axis_t

implicit none

    type timetab_t
        double precision:: time
    end type


    ! 軸表のスキーマ
    type axistab_t
        ! 軸同定情報
        type(axis_t):: spec
        ! 軸変数の netCDF 名前
        character(len = token), pointer:: name
        ! 軸重み変数の netCDF 名前
        character(len = token), pointer:: name_w
        ! 軸位置、重みのヘッダ
        type(gt3_header):: header, header_w
        ! 軸位置、重みの値
        real, pointer:: value(:), value_w(:)
        ! 上下端の差 (周期的な場合だけ modulo として使用)
        real:: range
    end type

    type varspec_t
        ! 変数自体の要素名
        character(len = 16):: item
        ! 軸
        type(axis_t):: axis(3)
    end type

    type vartab_t
        character(len = token), pointer:: name
        type(gt3_header):: header
        type(varspec_t):: spec
    end type

    ! 元ファイルにあったすべてのユニットについてのデータベース
    type unitlist_t
        ! 記録番号
        integer:: recno
        ! ヘッダ部
        type(gt3_header):: header
        ! この記録を無視すべきか
        logical:: valid
        type(unitlist_t), pointer:: next
        type(unitlist_t), pointer:: prev
    end type

    ! ある GTOOL3 レコードストリームから gtool4 ファイルを構成するための情報
    ! これを使って直接読みだしも、理論的には可能
    type gt3_map
        type(gt3_file):: file
        ! 必須属性
        character(len = token):: title, source, institution
        character(len = string):: history
        ! 時刻の単位
        character(len = string):: time_unit
        ! ユニット・リスト
        type(unitlist_t), pointer:: unit
        integer:: n_units
        ! 変数リスト
        type(vartab_t), pointer:: vartab(:)
        integer:: n_vars
        ! 時刻リスト
        type(timetab_t), pointer:: timetab(:)
        integer:: n_times
        ! 軸リスト
        type(axistab_t), pointer:: axistab(:)
        integer:: n_axes
        ! 変数、時刻など gtool/NetCDF 変数の名前を一括管理する表
        character(len = token), pointer:: nametab(:)
    end type

    interface open
        module procedure gt3mapOpen
    end interface

    interface close
        module procedure gt3mapClose
    end interface

    interface get_axis
        module procedure gt3mapgetaxis
    end interface

    interface get_variable
        module procedure gt3mapgetvarinfo
    end interface

    interface getHeader
        module procedure gt3mapgetheader
    end interface

    interface operator(==)
        module procedure axisspec_eqv
        module procedure varspec_eqv
    end interface

    integer, parameter:: GT3_DUPITEM = 1000

contains

    logical function axisspec_eqv(a, b) result(result)
        type(axis_t), intent(in):: a, b
    continue
        result = (a%item == b%item) .and. (a%start == b%start) .and. &
            & (a%end == b%end)
    end function

    logical function varspec_eqv(a, b) result(result)
        type(varspec_t), intent(in):: a, b
    continue
        result = a%item == b%item
        result = result .and. all(a%axis(:)%item == b%axis(:)%item)
        result = result .and. all(a%axis(:)%start == b%axis(:)%start)
        result = result .and. all(a%axis(:)%end == b%axis(:)%end)
    end function

    function varspec_from_header(header) result(result)
        use gt3read, only: gt3_header
        type(gt3_header), intent(in):: header
        type(varspec_t):: result
        result%item = header%item
        result%axis(:)%item = header%axis_item(:)
        result%axis(:)%start = header%axis_start(:)
        result%axis(:)%end = header%axis_end(:)
    end function

    ! map 構造体に1個の GTOOL3 ヘッダを登録する。これは、
    ! 一時的に使用される両方向リンクトリスト map%unit に格納される
    subroutine StoreHeader(map, header, irec)
        use gt3read, only: gt3_header
        type(gt3_map), intent(inout):: map
        type(gt3_header), intent(in):: header
        integer, intent(in):: irec
        type(unitlist_t), pointer:: unit
    continue
        allocate(unit)
        if (.not. associated(map%unit)) then
            unit%next => unit
            unit%prev => unit
            map%unit => unit
        else if (associated(map%unit%next, map%unit)) then
            unit%next => map%unit
            unit%prev => map%unit
            map%unit%prev => unit
            map%unit%next => unit
        else
            unit%next => map%unit
            unit%prev => map%unit%prev
            map%unit%prev%next => unit
            map%unit%prev => unit
        endif
        map%n_units = map%n_units + 1
        unit%recno = irec
        unit%header = header
        unit%valid = .true.
    end subroutine

    ! 一時ユニット表 map%unit から時刻の表 map%timetab を作成する。
    ! 時刻の数は予期できないが、いったん両方向リンクトリストを
    ! 作成し、この大きさで結果配列 map%timetab を確保した後で
    ! リンクトリストを開放しながら配列に転写していく。
    !
    subroutine build_time_table(map, ios)
        type(gt3_map), intent(inout):: map
        integer, intent(out):: ios
        type(unitlist_t), pointer:: unit
        type timelist_t
            real:: time
            type(timelist_t), pointer:: next
            type(timelist_t), pointer:: prev
        end type
        type(timelist_t), pointer:: timelist
        integer:: i
    continue
        ios = 0
        map%n_times = 0
        nullify(timelist)
        unit => map%unit
        if (.not. associated(unit)) return
        do
            if (unit%valid) then
                call insert_time(timelist, unit%header%time, ios)
            endif
            unit => unit%next
            if (associated(unit, map%unit)) exit
        enddo

        if (associated(timelist)) then
            allocate(map%timetab(map%n_times))
            nullify(timelist%prev%next)
            i = 1
            do
                map%timetab(i)%time = timelist%time
                timelist => timelist%next
                if (.not. associated(timelist)) exit
                deallocate(timelist%prev)
                i = i + 1
            enddo
        else
            nullify(map%timetab)
        endif

    contains

        subroutine insert_time(head, time, ios)
            type(timelist_t), pointer:: head
            integer, intent(in):: time
            integer, intent(out):: ios
            type(timelist_t), pointer:: timeent, cursor
        continue
            ios = 0
            cursor => head
            if (associated(cursor)) then
                do
                    if (cursor%time == time) return
                    if (cursor%time > time) exit
                    cursor => cursor%next
                    if (associated(cursor, head)) exit
                enddo
            endif
            allocate(timeent)
            map%n_times = map%n_times + 1
            timeent%time = unit%header%time
            if (.not. associated(cursor)) then
                timeent%next => timeent
                timeent%prev => timeent
                head => timeent
            else if (associated(cursor%next, cursor)) then
                timeent%next => cursor
                timeent%prev => cursor
                cursor%prev => timeent
                cursor%next => timeent
            else
                timeent%next => cursor
                timeent%prev => cursor%prev
                cursor%prev%next => timeent
                cursor%prev => timeent
            endif
        end subroutine

    end subroutine build_time_table

    ! 一時ユニット表 map%unit から変数表を作成する。
    ! 手順は時間表を作成するのにほぼ同じ。
    subroutine build_var_table(map, ios)
        type(gt3_map), intent(inout):: map
        integer, intent(out):: ios
        type(unitlist_t), pointer:: unit
        type varlist_t
            type(varspec_t):: spec
            type(gt3_header):: header
            type(varlist_t), pointer:: next
            type(varlist_t), pointer:: prev
        end type
        type(varlist_t), pointer:: varlist
        integer:: i
    continue
        unit => map%unit
        ios = 0
        map%n_vars = 0
        if (.not. associated(unit)) return
        do
            call insert_variable(varlist, unit%header, ios)
            if (ios == GT3_DUPITEM) then
                unit%valid = .false.
                ios = 0
            endif
            unit => unit%next
            if (associated(unit, map%unit)) exit
        enddo

        if (associated(varlist)) then
            allocate(map%vartab(map%n_vars))
            nullify(varlist%prev%next)
            i = 1
            do
                map%vartab(i)%spec = varlist%spec
                map%vartab(i)%header = varlist%header
                if (.not. associated(varlist%next)) exit
                varlist => varlist%next
                deallocate(varlist%prev)
                i = i + 1
            enddo
            deallocate(varlist)
        else
            nullify(map%vartab)
        endif

        return
    contains

        subroutine insert_variable(head, header, ios)
            type(varlist_t), pointer:: head
            type(gt3_header), intent(in):: header
            type(varspec_t):: spec
            integer, intent(out):: ios
            type(varlist_t), pointer:: varent
        continue
            spec = varspec_from_header(header)
            varent => head
            if (associated(varent)) then
                do
                    if (varent%spec == spec) return
                    if (varent%spec%item == spec%item) then
                        ios = GT3_DUPITEM
                        return
                    endif
                    varent => varent%next
                    if (associated(varent, head)) exit
                enddo
            endif
            allocate(varent)
            map%n_vars = map%n_vars + 1
            varent%spec = spec
            varent%header = header
            if (.not. associated(head)) then
                varent%next => varent
                varent%prev => varent
                head => varent
            else if (associated(head%next, head)) then
                varent%next => head
                varent%prev => head
                head%prev => varent
                head%next => varent
            else
                varent%next => head
                varent%prev => head%prev
                head%prev%next => varent
                head%prev => varent
            endif
        end subroutine

    end subroutine build_var_table

    ! 変数表から軸の表を作成する。
    ! 最後の軸 map%axistab(map%n_axes) は時間軸である。
    subroutine build_axis_table(map, ios)
        use findfile, only: load_axis
        type(gt3_map), intent(inout):: map
        integer, intent(out):: ios
        type axislist_t
            type(axis_t):: axis
            type(axislist_t), pointer:: next
            type(axislist_t), pointer:: prev
        end type
        type(axislist_t), pointer:: axislist
        integer:: i, j
    continue
        call message("listing axes")
        ios = 0
        nullify(axislist)
        map%n_axes = 1
        do, j = 1, map%n_vars
            do, i = 1, 3
                if (map%vartab(j)%spec%axis(i)%item /= '') then
                    call insert_axis(axislist, map%vartab(j)%spec%axis(i), ios)
                endif
            enddo
        enddo

        call message("building axis table (%d entry)", i=(/map%n_axes/))
        allocate(map%axistab(map%n_axes))
        if (associated(axislist)) then
            nullify(axislist%prev%next)
            i = 1
            do
                map%axistab(i)%spec = axislist%axis
                if (.not. associated(axislist%next)) exit
                axislist => axislist%next
                deallocate(axislist%prev)
                i = i + 1
            enddo
            deallocate(axislist)
        endif
        map%axistab(map%n_axes)%spec = axis_t("time", 1, map%n_times)

        call message("collecting axis files")
        do, i = 1, map%n_axes - 1
            call load_axis(map%axistab(i)%spec, 'LOC', &
                & map%axistab(i)%header, map%axistab(i)%value, ios, &
                & fullrange=map%axistab(i)%range)
            if (ios /= 0) return
            call load_axis(map%axistab(i)%spec, 'WGT', &
                & map%axistab(i)%header_w, map%axistab(i)%value_w, ios)
            if (ios /= 0) then
                write(*, '(A)') "weight for axis " // &
		    & map%axistab(i)%spec%item // " fot found"
                ios = 0
            endif
        enddo
        return
    contains

        subroutine insert_axis(head, spec, ios)
            type(axislist_t), pointer:: head
            type(axis_t), intent(in):: spec
            integer, intent(out):: ios
            type(axislist_t), pointer:: axisent
        continue
            ios = 0
            axisent => head
            if (associated(axisent)) then
                do
                    if (axisent%axis == spec) return
                    axisent => axisent%next
                    if (associated(axisent, head)) exit
                enddo
            endif
            map%n_axes = map%n_axes + 1
            allocate(axisent)
            axisent%axis = spec
            if (.not. associated(head)) then
                axisent%next => axisent
                axisent%prev => axisent
                head => axisent
            else if (associated(head%next, head)) then
                axisent%next => head
                axisent%prev => head
                head%prev => axisent
                head%next => axisent
            else
                axisent%next => head
                axisent%prev => head%prev
                head%prev%next => axisent
                head%prev => axisent
            endif
        end subroutine insert_axis

    end subroutine build_axis_table

    subroutine build_name_table(map, ios)
        use regex, only: match
        use dc_string, only: tolower, tochar
    implicit none
        type(gt3_map), intent(inout):: map
        integer, intent(out):: ios
        integer:: i, length, istart, j, offset
        character(len = token):: try
    continue
        ! 変数名表の確保
        ! (軸数を倍にしているのは平均重みが入るから)
        allocate(map%nametab(map%n_vars + map%n_axes * 2 - 1))
        ! データ変数名。初期値として ITEM を入れる
        do, i = 1, map%n_vars
            map%nametab(i) = map%vartab(i)%spec%item
            map%vartab(i)%name => map%nametab(i)
        enddo
        ! 軸変数名の初期化 (軸重み変数名はあとまわし)
        offset = map%n_vars
        do, i = 1, map%n_axes
            map%nametab(i + offset) = map%axistab(i)%spec%item
            map%axistab(i)%name => map%nametab(i + offset)
        enddo
        ! まず GTOOL3 慣例の特定軸名称を置換する。末尾数字は残す
        do, i = 1, map%n_vars + map%n_axes
            try = map%nametab(i)
            call match('^GLON#d+$', try, start=istart, length=length)
            if (istart > 0) then
                map%nametab(i) = 'lon' // try(5: )
            endif
            call match('^GGLA#d+$', try, start=istart, length=length)
            if (istart > 0) then
                map%nametab(i) = 'lat' // try(5: )
            endif
            call match('^CSIG#d+$', try, start=istart, length=length)
            if (istart > 0) then
                map%nametab(i) = 'sigma' // try(5: )
            endif
            ! 大文字から小文字へ
            call tolower(map%nametab(i))
        enddo
        ! ついで名前の一意性を確保しつつ、簡略化を図る
        LOOP_U: do, i = 1, map%n_vars + map%n_axes
            ! もし数字を除去して一意名前が得られれば、そうする
            try = map%nametab(i)
            call match('^#a+#d+$', try, start=istart, length=length)
            if (istart > 0) then
                call match('^#a+', try, start=istart, length=length)
                try = try(1: length)
                if (all(map%nametab(:) /= try)) then
                    map%nametab(i) = try
                    cycle LOOP_U
                endif
            endif
            ! 逆に一意名前が得られないばあい...
            try = map%nametab(i)
            if (count(map%nametab(:) == try) == 1) cycle LOOP_U
            ! 数字で終わっていないなら数字を付加
            ! 数字で終わっているなら _数字 を付加
            call match('#d$', map%nametab(i), start=istart, length=length)
            do, j = 1, huge(1)
                if (istart == 0) then
                    try = trim(map%nametab(i)) // toChar(j)
                else
                    try = trim(map%nametab(i)) // '_' // toChar(j)
                endif
                if (all(map%nametab(:) /= try)) then
                    map%nametab(i) = try
                    cycle LOOP_U
                endif
            enddo
            ! もはや策なし。
            ios = -1
            return
        enddo LOOP_U

        ! 軸重み変数名
        offset = map%n_vars + map%n_axes
        do, i = 1, map%n_axes - 1
            map%nametab(i + offset) = trim(map%nametab(i + map%n_vars)) // "_wgt"
            map%axistab(i)%name_w => map%nametab(i + offset)
            if (.not. associated(map%axistab(i)%value_w)) then
                nullify(map%axistab(i)%name_w)
            endif
        enddo
        ! 時間については軸重みを付加しない
        nullify(map%axistab(map%n_axes)%name_w)
        ios = 0
    end subroutine

    subroutine gt3mapOpen(map, filename, ios)
        use gt3read, only: gt3_header, END_OF_FILE, &
            & getHeader, Open, Close, Rewind, SkipRecord
        use dc_string, only: toChar
    implicit none
        type(gt3_map), intent(out):: map
        character(len = *), intent(in):: filename
        integer, intent(out):: ios
        type(gt3_header):: header
        integer:: rec_no, ios2
    continue
        !
        ! 初期化。ファイルを開く。
        nullify(map%unit, map%vartab, map%timetab, map%axistab)
        nullify(map%nametab)
        map%n_units = 0
        map%n_times = 0
        map%n_vars = 0
        map%n_axes = 0
        call open(map%file, filename, ios)
        if (ios /= 0) return
        !
        ! ファイル開けたら、全記録を読んでヘッダ情報を map に格納。
        call message("prescanning...")
        rec_no = 0
        do
            call GetHeader(map%file, header, ios)
            if (ios == END_OF_FILE) exit
            if (ios /= 0) goto 900
            rec_no = rec_no + 1
            if (rec_no == 1) then
                map%title = header%dataset
                map%source = "GTOOL3 format " // trim(toChar(header%idfm))
                map%institution = header%modify_user
                map%time_unit = header%time_unit
                map%history = history_attr(header)
            endif
            call StoreHeader(map, header, rec_no)
            ! ユニット・リストを作成する
            call SkipRecord(map%file, ios)
            if (ios /= 0) goto 900
        enddo
        call message("%d units found.", i=(/rec_no/))
        ! ファイルは巻き戻すだけで閉じない。開かないで済む。
        ! (ただし、複数ファイルをサポートするならそうはいかない)
        call rewind(map%file, ios)
        if (ios /= 0) goto 900
        
        ! まず変数の表を作成する
        call build_var_table(map, ios)
        if (ios /= 0) goto 900
        ! ついで時刻の表を作成する
        call build_time_table(map, ios)
        if (ios /= 0) goto 900
        ! ついで次元の表を作成する
        call build_axis_table(map, ios)
        if (ios /= 0) goto 900
        ! 変数・次元に名前をつける
        call build_name_table(map, ios)
        if (ios /= 0) goto 900

        return
    900 continue
        call close(map%file, ios2)
        return
    contains

        function history_attr(h) result(result)
            character(len = string):: result
            type(gt3_header), intent(in):: h
            integer:: i, ilast
        continue
            result = trim(timefmt(h%create_date)) // " " // &
                & trim(h%create_user) // "> GTOOL3 create" // achar(10)
            ilast = 0
            do, i = 1, 8
                if (h%edit(i) == "") exit
                ilast = i
            enddo
            do, i = 1, ilast - 1
                result = trim(result) // "unknown unknown> GTOOL3 " // &
                    & trim(h%edit(i)) // ' ' // trim(h%edit_title(i)) // &
                    & achar(10)
            enddo
            i = ilast
            if (ilast > 0) then
                result = trim(result) // trim(timefmt(h%modify_date)) // &
                    & ' ' // trim(h%modify_user) // '> GTOOL3 ' // &
                    & trim(h%edit(i)) // ' ' // trim(h%edit_title(i)) // &
                    & achar(10)
            endif
            result = trim(result) // "unknown unknown> gt3conv" // &
                & achar(10)
        end function history_attr

    end subroutine gt3mapOpen

    function timefmt(gt3time) result(result)
        character(len = 19):: result
        character(len = *), intent(in):: gt3time
        character(len = token):: buffer
        integer:: y, m, d, h, mi, s, ios, i
    continue
        buffer = adjustl(gt3time)
        read(buffer, '(i4,i2,i2,1x3(i2))', iostat=ios) &
            & y, m, d, h, mi, s
        if (ios /= 0) then
            result = "unknown"
        else
            write(result, "(i4,2('-',i2),'T',2(i2,':'),i2)") &
                & y, m, d, h, mi, s
            do, i = 1, len(result)
                if (result(i:i) == ' ') result(i:i) = '0'
                if (result(i:i) == '*') result(i:i) = 'X'
            enddo
        endif
    end function

    subroutine gt3mapClose(map, ios)
        type(gt3_map), intent(inout):: map
        integer, intent(out):: ios
    continue
        call close(map%file, ios)
    end subroutine

    ! 属性のためにヘッダ情報を取得
    subroutine gt3mapGetHeader(map, class, order, header, varname)
    implicit none
        type(gt3_map), intent(in):: map
        character(len = *), intent(in):: class
        integer, intent(in):: order
        type(gt3_header), intent(out):: header
        character(len = *), intent(out):: varname
    continue
        select case(class)
            case("AXI")
                header = map%axistab(order)%header
                varname = map%axistab(order)%name
            case("WGT")
                header = map%axistab(order)%header_w
                varname = map%axistab(order)%name_w
            case("VAR")
                header = map%vartab(order)%header
                varname = map%vartab(order)%name
        end select
    end subroutine

    ! gtool_history の座標軸情報を得る
    subroutine gt3mapGetAxis(map, axis)
        use gtool_history, only: gt_history_axis
        type(gt3_map), intent(in):: map
        type(gt_history_axis), intent(out):: axis(:)
        integer:: i, length
    continue
        do, i = 1, size(axis)
            if (i == map%n_axes) then
                length = 0
                axis(i) = gt_history_axis( &
                    & map%axistab(i)%name, &
                    & length, &
                    & "time", &
                    & map%time_unit, &
                    & "float")
            else
                length = map%axistab(i)%spec%end - &
                    & map%axistab(i)%spec%start + 1
                axis(i) = gt_history_axis( &
                    & map%axistab(i)%name, &
                    & length, &
                    & map%axistab(i)%header%title, &
                    & map%axistab(i)%header%unit, &
                    & "float")
            endif
        enddo
    end subroutine

    ! すぐに historyAddVariable で使える変数情報 varinfo を発信
    subroutine gt3mapGetVarinfo(map, class, order, varinfo)
        use gtool_history, only: gt_history_varinfo
    implicit none
        type(gt3_map), intent(in):: map
        character(len = *), intent(in):: class
        integer, intent(in):: order
        type(gt_history_varinfo), intent(out):: varinfo
        character(len = token), pointer:: dimsp(:)
        integer:: ndims, stat, i, j
    continue
        select case (class)
        case('WGT')
	    if (.not. associated(map%axistab(order)%name_w)) goto 999
            allocate(dimsp(1), stat=stat)
            if (stat /= 0) goto 999
            dimsp(1) = map%axistab(order)%name
            varinfo = gt_history_varinfo( &
                & map%axistab(order)%name_w, &
                & dimsp, &
                & map%axistab(order)%header_w%title, &
                & map%axistab(order)%header_w%unit, &
                & "float" )
        case('VAR')
            ndims = count(map%vartab(order)%spec%axis(:)%item /= "")
            allocate(dimsp(ndims + 1), stat=stat)
            if (stat /= 0) goto 999
            i = 1
            do, j = 1, 3
                dimsp(i) = map%vartab(order)%spec%axis(j)%item
                if (dimsp(i) == "") cycle
                dimsp(i) = varname_3to4(map, dimsp(i))
                i = i + 1
            enddo
            dimsp(ndims + 1) = map%axistab(map%n_axes)%name
            varinfo = gt_history_varinfo( &
                & map%vartab(order)%name, &
                & dimsp, &
                & map%vartab(order)%header%title, &
                & map%vartab(order)%header%unit, &
                & "float" )
        end select
        return
    999 continue
        nullify(dimsp)
        varinfo = gt_history_varinfo("", dimsp, "", "", "")
        return
    end subroutine

    function varname_3to4(map, item) result(result)
        type(gt3_map), intent(in):: map
        character(len = token):: result
        character(len = *), intent(in):: item
        integer:: i
        do, i = 1, map%n_axes
            if (map%axistab(i)%spec%item == item) then
                result = map%axistab(i)%name
                return
            endif
        enddo
        do, i = 1, map%n_vars
            if (map%vartab(i)%spec%item == item) then
                result = map%vartab(I)%name
                return
            endif
        enddo
        result = ""
    end function

end module gt3map

subroutine GTDevOpen(dev, ws_id, err)
    use gtgraph_types, only: GT_DEVICE
    use gtgraph_com, only: gtdev_wsn_default
    use netcdf_f77, only: NF_EINVAL
    use dc_error, only: StoreError
    use sysdep, only: AbortProgram
    use dcl, only: DclOpenGraphics, DclSelectDevice
    use dc_trace, only: dbg_scratch, debug, dbg
implicit none
    type(GT_DEVICE), intent(out):: dev
    integer, intent(in), optional:: ws_id
    logical, intent(out), optional:: err
    integer, save:: opened_wsn = 0
    integer:: wsn
continue
    wsn = gtdev_wsn_default
    if (present(ws_id)) wsn = ws_id
    if (opened_wsn /= 0) then
        call StoreError(NF_EINVAL, 'GTDevOpen', err=err, cause_i=wsn)
        return
    else
        if (present(err)) err = .FALSE.
    endif
    if (wsn == 0) then
        !-- コンソール依存コード。いずれ選択化 --!
        wsn = DclSelectDevice()
        gtdev_wsn_default = wsn
    endif
    if (wsn == 3) call dbg_scratch(.true.)
    if (debug()) then
        call glistx('MSGUNIT', dbg)
    else
        call glistx('MSGLEV', 2)
    endif
    call DclOpenGraphics(wsn)
    dev%ws_id = wsn
    opened_wsn = wsn
end subroutine

subroutine GTDevClose(dev)
    use gtgraph_types, only: GT_DEVICE
    use dcl, only: DclCloseGraphics
    use dc_trace, only: dbg_scratch
implicit none
    type(GT_DEVICE), intent(inout):: dev
    integer:: iu
continue
    call DclCloseGraphics()
    call gliget('IOUNIT', iu)
    call glistx('MSGUNIT', iu)
    call dbg_scratch(.false.)
    dev%ws_id = 0
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

module dc_date_types

    implicit none
    ! 通日と通秒の対で日付時刻を表現する。

    type DC_DATETIME
        sequence
        integer:: day
        double precision:: sec
    end type

    ! 「1ヵ月後」という概念に対応するため、month 欄を持つ。
    ! 注意: 日付と違って月を normalize することはできない。
    type DC_DIFFTIME
        sequence
        integer:: mon
        integer:: day
        double precision:: sec
    end type

    integer, parameter:: CAL_CYCLIC = 1
    integer, parameter:: CAL_NOLEAP = 2
    integer, parameter:: CAL_JULIAN = 3
    integer, parameter:: CAL_GREGORIAN = 4
    integer, save:: caltype = CAL_GREGORIAN

    double precision, save:: cyclic_mdays = 30.6
    double precision, save:: day_seconds = 86400.0

end module

!表題  gtool_history Fortran 77 用インターフェース
!
!履歴  2000/12/26  竹広真一
!      2001/02/27  竹広真一  サブルーチン毎のファイルに分割
!
!  サブルーチン対応表
!     HistoryClose                 HSCLSE
!
subroutine hsclse

    use gtool_history

    CALL HistoryClose

  end subroutine hsclse

logical function gtvarequivalent(var1, var2) result(result)
    use gtdata_types, only: gt_variable
    use gt_map, only: var_class
    type(gt_variable), intent(in):: var1, var2
    integer:: class1, class2, cid1, cid2
    call var_class(var1, class1, cid1)
    call var_class(var2, class2, cid2)
    result = (class1 == class2) .and. (cid1 == cid2)
end function

!表題  gtool_history Fortran 77 用インターフェース
!
!履歴  2000/12/26  竹広真一
!      2001/02/27  竹広真一  サブルーチン毎のファイルに分割
!
!  サブルーチン対応表
!     HistoryAddVariable           HSAVAR
!
subroutine hsavar(varname,idim,dims,longname,unit,xtype)

    use gtool_history
    character(len=*),intent(in) :: varname, longname, unit, xtype
    integer,intent(in)          :: idim
    character(len=*),dimension(idim),intent(in) :: dims


    call HistoryAddVariable(varname=varname, &
        & dims=dims, &
        & longname=longname, units=unit, xtype=xtype)

  end subroutine hsavar

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

subroutine GtObjClear(obj)
    use gtgraph_types, only: GT_OBJECT
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_OBJECT), intent(out):: obj
    call beginsub('gtobjclear')
    nullify(obj%axis, obj%cont, obj%line)
    nullify(obj%fig, obj%frame, obj%next)
    call endsub('gtobjclear')
end subroutine

subroutine GtObjOpen(obj)
    use gtgraph_types, only: GT_OBJECT
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_OBJECT), intent(out):: obj
    call beginsub('gtobjopen')
    call GtObjClear(obj)
    call endsub('gtobjopen')
end subroutine

recursive subroutine GTObjLoadC(obj, varname, slice_spec)
    use gtgraph_types, only: GT_OBJECT
    use gtgraph_generic, only: Load
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: Open, Slice
    use dc_trace, only: beginsub, endsub
    use dc_types, only: STRING
    implicit none
    type(GT_OBJECT), intent(out):: obj
    character(len = STRING), intent(in):: varname
    character(len = string), intent(in), optional:: slice_spec
    type(GT_VARIABLE):: var
    logical:: err
    call beginsub('gtobjload', '%c', c1=trim(varname))
    call Open(var, varname)
    if (present(slice_spec)) then
        if (slice_spec /= "") then
            call slice(var, slice_spec, err)
        endif
    endif
    call Load(obj, var)
    call endsub('gtobjload')
end subroutine

recursive subroutine GTObjLoadVar(obj, var)
    use gtgraph_types, only: GT_OBJECT
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: get_attr, inquire
    use gtgraph_generic, only: Open, Clear, Load
    use dc_string, only: VSTRING, operator(==)
    use dc_trace, only: beginsub, endsub, message
    use dc_error
    implicit none
    type(GT_OBJECT), intent(out):: obj
    type(GT_VARIABLE), intent(in):: var
    type(VSTRING):: var_class
    integer:: ndims
continue
    call beginsub('gtobjloadvar', 'var.mapid=%d', i=(/var%mapid/))
    call Clear(obj)
    call get_attr(var, "gt_structure_class", var_class, default="data")
    if (var_class == "frame") then
        allocate(obj%frame)
        call Open(obj%frame)
        call Load(obj%frame, var)
    else if (var_class == "figure") then
        allocate(obj%fig)
        call Open(obj%fig)
        call Load(obj%fig, var)
    else if (var_class == "contours") then
        allocate(obj%cont)
        call Load(obj%cont, var)
    else if (var_class == "line") then
        allocate(obj%line)
        call Load(obj%line, var)
    else if (var_class == "axis") then
        allocate(obj%axis)
        call Load(obj%line, var)
    else
        call inquire(var, rank=ndims)
        call message('# rank = %d', i=(/ndims/))
        select case(ndims)
        case(1)
            allocate(obj%line)
            call Open(obj%line, var)
        case(2:)
            allocate(obj%cont)
            call Open(obj%cont, var)
        case default
            call StoreError(GT_EFAKE, 'GtObjLoadVar(ndims = 0)')
        end select
    endif
    call endsub('gtobjloadvar')
end subroutine

recursive subroutine GtObjClose(obj)
    use gtgraph_types, only: GT_OBJECT
    use gtgraph_generic, only: GTAxisClose, GTLineClose, GTContClose, &
        & GTFigClose, GTFrameClose
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(GT_OBJECT), intent(out):: obj
    call beginsub('gtobjclose')
    if (associated(obj%next)) then
        call GtObjClose(obj%next)
        deallocate(obj%next)
    endif
    if (associated(obj%axis)) then
        deallocate(obj%axis)
        call GTAxisClose(obj%axis)
    endif
    if (associated(obj%cont)) then
        deallocate(obj%cont)
        call GTContClose(obj%cont)
    endif
    if (associated(obj%line)) then
        deallocate(obj%line)
        call GTLineClose(obj%line)
    endif
    if (associated(obj%fig)) then
        deallocate(obj%fig)
        call GTFigClose(obj%fig)
    endif
    if (associated(obj%frame)) then
        deallocate(obj%frame)
        call GTFrameClose(obj%frame)
    endif
    call endsub('gtobjclose')
end subroutine

subroutine GtObjInquire(obj, type)
    use gtgraph_types, only: GT_OBJECT
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(GT_OBJECT), intent(in):: obj
    character(len = *), intent(out), optional:: type
    call beginsub('gtobjinquire')
    if (present(type)) then
        if (associated(obj%axis)) then
            type = "axis"
        else if (associated(obj%cont)) then
            type = "contours"
        else if (associated(obj%line)) then
            type = "line"
        else if (associated(obj%fig)) then
            type = "figure"
        else if (associated(obj%frame)) then
            type = "frame"
        else
            type = ""
        endif
    endif
    call endsub('gtobjinquire')
end subroutine

subroutine GtObjOption(obj, optname, value, err)
    use gtgraph_types, only: GT_OBJECT
    use gtgraph_generic, only: Option
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(GT_OBJECT), intent(inout):: obj
    character(len = *), intent(in):: optname
    character(len = *), intent(in):: value
    logical, intent(out):: err
continue
    call beginsub('gtobjoption', '<%c=%c>', c1=optname, c2=value)
    if (associated(obj%cont)) then
        call message('forwarding obj to cont')
        call Option(obj%cont, optname, value, err)
    else if (associated(obj%line)) then
        call message('forwarding obj to line')
        call Option(obj%line, optname, value, err)
    else if (associated(obj%fig)) then
        call message('forwarding obj to fig')
        call Option(obj%fig, optname, value, err)
    else
        err = .TRUE.
    endif
    call endsub('gtobjoption')
end subroutine

    ! --- GtObjBindObj --- 
    ! bind の原則
    !  child と parent のうち上位のクラスのものが保持される。
    !  同位クラスの場合は直上クラスを作成し両者を突っ込む。
    !  (両者ともに frame の場合は next に連鎖)
subroutine GTObjBindObj(parent, child)
    use gtgraph_types, only: GT_OBJECT
    use gtgraph_generic, only: Inquire, Bind, Clear, Open
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(GT_OBJECT), intent(inout), target:: parent
    type(GT_OBJECT), intent(inout):: child
    character(len = 8):: child_type, parent_type
    type(GT_OBJECT), pointer:: objp
continue
    call beginsub('gtobjbindobj')
    call Inquire(child, type=child_type)
    call Inquire(parent, type=parent_type)
    ! --- どちらかが空なら空でないほうを parent に ---
    if (child_type == "") return
    if (parent_type == "") then
        ! 親が空ならただ移すだけ
        parent = child
        call Clear(child)
        return
    endif
    ! --- next を誰かがもつ場合 ---
    ! とりあえず省略ね
    ! --- 図形要素どうしの操作 ---
    if (parent_type == "frame") then
        ! 親子ともに枠なら連鎖、それ以外のものは枠内に設置
        select case(child_type)
        case("frame")
            goto 1000
        case("figure")
            call Bind(parent%frame, child%fig)
        case("contours")
            allocate(child%fig)
            call Bind(child%fig, child%cont)
            call Bind(parent%frame, child%fig)
        case("line")
            allocate(child%fig)
            call Bind(child%fig, child%line)
            call Bind(parent%frame, child%fig)
        case("axis")
            allocate(child%fig)
            call Bind(child%fig, child%axis)
            call Bind(parent%frame, child%fig)
        end select
    else if (child_type == "frame") then
        ! 親は枠以下なので子の中に設置
        select case(parent_type)
        case("figure")
            call Bind(child%frame, parent%fig)
        case("contours")
            allocate(parent%fig)
            call Bind(parent%fig, parent%cont)
            call Bind(child%frame, parent%fig)
        case("line")
            allocate(parent%fig)
            call Bind(parent%fig, parent%line)
            call Bind(child%frame, parent%fig)
        case("axis")
            allocate(parent%fig)
            call Bind(parent%fig, parent%axis)
            call Bind(child%frame, parent%fig)
        end select
        call Clear(parent)
        parent%frame => child%frame
    else if (parent_type == "figure") then
        select case(child_type)
        case("figure")
            allocate(parent%frame)
            call Open(parent%frame)
            call Bind(parent%frame, parent%fig)
            nullify(parent%fig)
            call Bind(parent%frame, child%fig)
        case("contours")
            call Bind(parent%fig, child%cont)
        case("line")
            call Bind(parent%fig, child%line)
        case("axis")
            call Bind(parent%fig, child%axis)
        end select
    else if (child_type == "figure") then
        ! 親は図以下なので子の図の中に親の要素を置く
        select case(parent_type)
        case("contours")
            call Bind(child%fig, parent%cont)
        case("line")
            call Bind(child%fig, parent%line)
        case("axis")
            call Bind(child%fig, parent%axis)
        end select
        call Clear(parent)
        parent%fig => child%fig
    else
        ! 親も子も図以下の場合はとにかく図を作って両方投入
        allocate(parent%fig)
        call Open(parent%fig)
        select case(parent_type)
        case("contours")
            call Bind(parent%fig, parent%cont)
            nullify(parent%cont)
        case("line")
            call Bind(parent%fig, parent%line)
            nullify(parent%line)
        case("axis")
            call Bind(parent%fig, parent%axis)
            nullify(parent%axis)
        end select
        select case(child_type)
        case("contours")
            call Bind(parent%fig, child%cont)
        case("line")
            call Bind(parent%fig, child%line)
        case("axis")
            call Bind(parent%fig, child%axis)
        end select
    endif
    call Clear(child)
    call endsub('gtobjbindobj')
    return

    1000 continue
        objp => parent
        do
            if (.not. associated(objp%next)) exit
            objp => objp%next
        enddo
        ! child へのポインタは当サブルーチンを抜けると無効になるので、
        ! 別実体を割り当ててから代入する。所詮数個のポインタ代入なので高速。
        allocate(objp%next)
        objp%next = child
        call Clear(child)
        call endsub('gtobjbindobj')
    return
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

    ! 引数は ndims 個でなければならない。
subroutine ANVarInquireIA(var, dimlen)
    use an_types, only: an_variable, an_variable_entry
!    use an_vartable, only: an_variable_entry
    use an_vartable, only: vtable_lookup
    use netcdf_f77, only: nf_noerr, nf_inq_vardimid, nf_inq_dimlen
    type(AN_VARIABLE), intent(in):: var
    integer, intent(out):: dimlen(:)
    type(an_variable_entry):: ent
    integer:: stat, i

    dimlen(:) = -1

    stat = vtable_lookup(var, ent)
    if (stat /= nf_noerr) return

    if (ent%varid > 0) then
        if (.not. associated(ent%dimids)) return
        do, i = 1, min(size(dimlen), size(ent%dimids))
            stat = nf_inq_dimlen(ent%fileid, ent%dimids(i), dimlen(i))
            if (stat /= nf_noerr) exit
        enddo
    else
        stat = nf_inq_dimlen(ent%fileid, ent%dimid, dimlen(1))
        if (stat /= nf_noerr) dimlen(1) = -1
    endif
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

subroutine GTVarPutLine(var, err)
    use gtdata_types, only: GT_VARIABLE
    use dc_error
    use dc_string, only: toChar, put_line
    use gtdata_generic, only: Get, Inquire
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(GT_VARIABLE), intent(inout):: var
    logical, intent(out), optional:: err
    real, allocatable:: rvalue(:)
    integer:: siz, stat, i
    logical:: myerr

    call beginsub('gtvarputline', '%d', i=(/var%mapid/))
    call Inquire(var, size=siz)
    call message('size = %d', i=(/siz/))
    stat = 0
    allocate(rvalue(siz), stat=stat)
    if (stat /= 0) then
        stat = GT_ENOMEM
        goto 950
    endif
    call Get(var, rvalue, size(rvalue), err=myerr)
    if (myerr) then
        stat = errorcode()
        goto 950
    endif
    do, i = 1, size(rvalue)
        call put_line(trim(toChar(rvalue(i))))
    end do
    deallocate(rvalue, stat=stat)
    if (stat /= 0) stat = GT_ENOMEM
    !
950 continue
    call StoreError(stat, "GTVarPutLine", err)
    call endsub('gtvarputline', '%d stat=%d', i=(/var%mapid, stat/))
end subroutine

! gtvarclose.f90
! Copyright (C) TOYODA Eizi, 2000.  All rights reserved.

subroutine GTVarClose(var, err)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: vtb_class_netcdf, vtb_class_memory, &
        & maptabdelete, map_lookup
    use gt_vartable, only: vartabledelete, vartablelookup
    use an_generic, only: ANVarClose, an_variable
    use dc_error, only: StoreError, GT_EBADVAR, nf_enotvar, dc_noerr
    use dc_trace, only: beginsub, endsub, message
    use gt_mem
    implicit none
    type(GT_VARIABLE), intent(in), target:: var
    logical, intent(out), optional:: err
    integer:: vid, class, cid
    logical:: action, myerr
continue
    call beginsub('gtvarclose', fmt='var=%d', i=(/var%mapid/))
    call map_lookup(var, vid=vid)
    call maptabdelete(var, myerr)
    if (myerr) goto 999
    ! vid が 0 になるのは dup_dimmap で作られたハンドル
    if (vid == 0) goto 999
    call vartablelookup(vid, class, cid)
    call vartabledelete(vid, action, myerr)
    if (myerr) goto 999
    if (.not. action) then
        call message('refcount decrement only, no close internal var')
        goto 999
    else if (class == vtb_class_netcdf) then
        call ANVarClose(an_variable(cid), myerr)
        if (myerr) goto 999
    else if (class == vtb_class_memory) then
        call Close(mem_variable(cid))
        myerr = .false.
    else
        call StoreError(GT_EBADVAR, "GTVarClose", err)
        call endsub('GTVarClose', 'badvar')
        myerr = .true.
    endif
999 continue
    call endsub('gtvarclose')
    if (present(err)) err = myerr
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

subroutine GTVarGetAttrSC(var, name, value, default)
    use dc_string, only: VSTRING, assignment(=), vchar, len
    use dc_types, only: STRING
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: get_attr, an_variable
    use gt_mem, only: mem_variable, get_attr
    use dc_trace, only: beginsub, endsub
implicit none
    type(GT_VARIABLE), intent(in):: var
    character(len = *), intent(in):: name
    type(VSTRING), intent(out):: value
    character(len = *), intent(in), optional:: default
    logical:: err
    integer:: class, cid, stat
    character(len = string):: buffer
    character(len = string):: p_default
    character(len = *), parameter:: subnam = "gtvargetattrsc"
continue
    call beginsub(subnam)
    call var_class(var, class, cid)
    p_default = ""
    if (present(default)) p_default = default
    if (class == vtb_class_netcdf) then
        call get_attr(an_variable(cid), name, buffer, p_default, stat)
    else if (class == vtb_class_memory) then
        call get_attr(mem_variable(cid), name, buffer, err)
        if (err) buffer = p_default
    endif
    value = trim(buffer)
    call endsub(subnam, "%d:%d:%c = %c", i=(/class, cid/), &
        & c1=trim(name), c2=trim(buffer))
end subroutine

! character 型で受け取る場合は通常の文字型代入と同様、
! 受け側変数の長さに合わせて切り捨て・空白埋めを行う。
! 属性が存在しない場合 default 値を使う。

subroutine GTVarGetAttrCC(var, name, value, default)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: get_attr, an_variable
    use gt_mem, only: mem_variable, get_attr
    use dc_trace, only: beginsub, endsub
    use dc_types, only: string
implicit none
    type(GT_VARIABLE), intent(in):: var
    character(len = *), intent(in):: name
    character(len = *), intent(out):: value
    character(len = *), intent(in), optional:: default
    logical:: err
    integer:: class, cid, stat
    character(len = string):: p_default
    character(len = *), parameter:: subnam = "gtvargetattrcc"
continue
    call beginsub(subnam)
    call var_class(var, class, cid)
    p_default = ""
    if (present(default)) p_default = default
    if (class == vtb_class_netcdf) then
        call get_attr(an_variable(cid), name, value, p_default, stat)
    else if (class == vtb_class_memory) then
        call get_attr(mem_variable(cid), name, value, err)
        if (err) value = p_default
    endif
    call endsub(subnam, "%d:%d:%c = %c", i=(/class, cid/), &
        & c1=trim(name), c2=trim(value))
end subroutine

! 指定された変数のすべての属性を複写する。

subroutine gtvarcopyattrall(to, from, err)
    use gtdata_types, only: gt_variable
    use gtdata_generic, only: attr_rewind, attr_next, gtvarcopyattr
    use dc_error, only: dumperror
    use dc_trace, only: beginsub, endsub, message
    use dc_types, only: string
    type(gt_variable), intent(inout):: to
    type(gt_variable), intent(inout):: from
    logical, intent(out):: err
    character(len = *), parameter:: subnam = "gtvarcopyattrall"
    character(len = STRING):: aname
    logical:: end
    err = .false.
    call beginsub(subnam)
    call attr_rewind(from)
    do
        call attr_next(from, aname, end)
        if (end) exit
        call message("attr=%c", c1=aname)
        call gtvarcopyattr(to=to, attrname=aname, from=from, err=err)
        if (err) exit
    enddo
    call endsub(subnam)
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

subroutine ANAttrInquire(var, attrname, xtype)
    use an_types, only: AN_VARIABLE, an_variable_entry
    use an_vartable, only: vtable_lookup
    use an_generic, only: ANXTypeName
    use an_file, only: INQUIRE
    use dc_string, only: VSTRING, assignment(=)
    use netcdf_f77, only: NF_MAX_NAME, nf_inq_atttype, NF_NOERR
    use dc_url, only: GT_PLUS
    implicit none
    type(AN_VARIABLE), intent(in):: var
    character(len=*), intent(in):: attrname
    character(len=*), intent(out), optional:: xtype
    type(an_variable_entry):: ent
    integer:: varid, i_xtype, stat
    character(len=NF_MAX_NAME):: anam
    stat = vtable_lookup(var, ent)
    if (stat /= NF_NOERR) return
    if (present(xtype)) then
        call inquire(var, attrname, varid, anam)
        stat = nf_inq_atttype(ent%fileid, varid, anam, xtype=i_xtype)
        if (stat /= NF_NOERR) i_xtype = 0
        call ANXTypeName(i_xtype, xtype)
    endif
end subroutine

! 実際にアクセスするときに使う varid, attrname を得る
! attrname の先頭が '+' ---> 大域属性を強制指示
! attrname の先頭が '-' ---> 変数属性、大域属性の順で検索
! 利用するときは use an_file, only: inquire してね
!
subroutine ANAttrInquirePlus(var, attrname, varid, nf_attrname)
    use an_types, only: AN_VARIABLE, an_variable_entry
    use an_vartable, only: vtable_lookup
    use dc_url, only: GT_PLUS
    use netcdf_f77, only: NF_GLOBAL, nf_noerr, nf_inq_attlen
    type(AN_VARIABLE), intent(in):: var
    character(len=*), intent(in):: attrname
    integer, intent(out):: varid
    type(an_variable_entry):: ent
    character(len=*), intent(out):: nf_attrname
    integer:: stat, n
    stat = vtable_lookup(var, ent)
    if (stat /= NF_NOERR) return
    if (attrname(1:1) == GT_PLUS) then
        varid = NF_GLOBAL
        nf_attrname = attrname(2: )
    else if (attrname(1:1) == '-') then
        varid = ent%varid
        nf_attrname = attrname(2: )
        stat = nf_inq_attlen(ent%fileid, varid, nf_attrname, n)
        if (stat == NF_NOERR) return
        varid = NF_GLOBAL
    else
        varid = ent%varid
        nf_attrname = attrname
    endif
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

! --- 属性の列挙 ---

! ある変数 var に付随した属性をすべて取得するにはまず
! attr_rewind(var) を呼び出してから無限ループの中で
! attr_next(var, name, [end]) を呼び出す。name がひとつ
! ひとつの属性名を与える。name が空文字列になったとき、
! すべての属性を探索し終えたことになる。このとき end を
! 与えていればそれが真になることでも判定できる。

! 大域属性は、その名前の先頭に "+" が付加された普通の変数属性で
! あるかのように見える。

subroutine ANVarAttrRewind(var)
    use an_types, only: AN_VARIABLE, an_variable_entry
    use an_vartable, only: vtable_set_attrid
    use netcdf_f77, only: NF_NOERR
    use dc_trace, only: message
    implicit none
    type(AN_VARIABLE), intent(in):: var
    integer:: stat
    stat = vtable_set_attrid(var, 0)
    call message("anvarattrrewind %d", i=(/stat/))
end subroutine

subroutine ANVarAttrNext(var, name, end)
    use an_types, only: AN_VARIABLE, an_variable_entry
    use an_vartable, only: vtable_set_attrid, vtable_lookup
    use netcdf_f77
    use dc_url, only: GT_PLUS
    implicit none
    type(AN_VARIABLE), intent(inout):: var
    character(len = *), intent(out):: name
    type(an_variable_entry):: ent
    logical, intent(out), optional:: end
    character(len = NF_MAX_NAME):: attrname
    integer:: stat
    integer:: new_attrid

    stat = vtable_lookup(var, ent)
    if (stat /= NF_NOERR) goto 999

    new_attrid = ent%attrid
    ! 最初は変数属性の検索
    if (ent%attrid >= 0) then
        new_attrid = ent%attrid + 1
        stat = NF_INQ_ATTNAME(ent%fileid, ent%varid, new_attrid, attrname)
        if (stat == NF_NOERR) then
            name = attrname
            stat = vtable_set_attrid(var, new_attrid)
            end = .FALSE.
            return
        endif
        new_attrid = -1
    endif

    ! 次は大域属性の検索
    stat = NF_INQ_ATTNAME(ent%fileid, NF_GLOBAL, -new_attrid, attrname)
    if (stat == NF_NOERR) then
        new_attrid = new_attrid - 1
        name = GT_PLUS // attrname
        stat = vtable_set_attrid(var, new_attrid)
        end = .FALSE.
        return
    endif

999 continue
    ! ここでは attrid の再設定はしない。次呼んでもエラーになるのが適当。
    end = .TRUE.
    name = ""
    return
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved
! gtopt module for giving commandline option module

module gt_argtable

    ! 機能
    !
    ! ユーザは通常 gt_args モジュールに引用仕様を宣言した
    ! GtArgGet や GtArgCount を呼び出すべきである。これらは内部的に
    ! gt_argtable を参照し BuildArgTable を呼び出す。
    !
    ! sysdep  の類似関数との相違は、
    ! DCL のコマンドラインオプションがある場合、あたかもそれらが
    ! 存在しないかのように挙動する点である。
    ! sysdep の引数番号との対応表 argind_table は
    ! BuildArgTable によって作成される。
    !
    ! MS-Windows 環境においてはコマンドラインの長さに制限があるため、
    ! この層でレスポンスファイル入力ルーチンを実装するべきであろう。

    implicit none

    ! 添字は gt_args ユーザ向け、配列値は sysdepgetarg の引数
    integer, allocatable, save:: argind_table(:)
    integer, save:: argind_count = -1

contains

    subroutine BuildArgTable
        use sysdep
        use dc_types, only: STRING
        implicit none
        integer:: i, narg, nargmax
        character(len = STRING):: value
        integer, allocatable:: localtab(:)
    continue
        if (argind_count >= 0) return
        nargmax = SysdepArgCount()
        allocate(localtab(nargmax))
        narg = 0
        do, i = 1, nargmax
            call SysdepArgGet(i, value)
            if (i == 1 .and. value(1:5) == '-Wl,-') cycle
            if (value(1:1) == '-' .and. index(value, ':') > 1) cycle
            narg = narg + 1
            localtab(narg) = i
        enddo
        argind_count = narg
        allocate(argind_table(narg))
        argind_table(1: narg) = localtab(1: narg)
        deallocate(localtab)
    end subroutine

end module

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

subroutine ANVarAttrCopy(to, attrname, from, stat)
    use an_types, only: AN_VARIABLE, an_variable_entry
    use an_file, only: ANFileDefineMode, inquire
    use an_vartable, only: vtable_lookup
    use netcdf_f77
    use dc_url, only: GT_PLUS
    use dc_error
    implicit none
    type(AN_VARIABLE), intent(in):: to
    character(len = *), intent(in):: attrname
    type(AN_VARIABLE), intent(in):: from
    integer, intent(out):: stat
    character(NF_MAX_NAME):: nc_aname
    integer:: id_var_from, id_var_to
    logical:: myerr
    type(an_variable_entry):: to_ent, from_ent
    stat = vtable_lookup(to, to_ent)
    if (stat /= NF_NOERR) goto 999
    stat = vtable_lookup(from, from_ent)
    if (stat /= NF_NOERR) goto 999
    stat = ANFileDefineMode(to_ent%fileid)
    if (stat /= NF_NOERR) goto 999
    call inquire(from, attrname, id_var_from, nc_aname)
    call inquire(to, attrname, id_var_to, nc_aname)
    stat = nf_copy_att(from_ent%fileid, id_var_from, nc_aname, &
        to_ent%fileid, id_var_to)
999 continue
    call StoreError(stat, "ANVarAttrCopy", myerr)
    return
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

subroutine ANVarClose(var, err)
    use an_types, only: AN_VARIABLE
    use an_file, only: ANFileClose, ANFileSync
    use an_vartable, only: vtable_delete
    use dc_error
    implicit none
    type(AN_VARIABLE), intent(in):: var
    logical, intent(out), optional:: err
    integer:: fileid
continue
    fileid = vtable_delete(var)
    if (fileid < 0) then
        call StoreError(fileid, 'ANVarClose', err)
        return
    endif
    call ANFileSync(fileid)
    call ANFileClose(fileid, err)
end subroutine

! gtvaropenbydimord.f90 - open(GT_VARIABLE, GT_VARIABLE, integer)
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved
!
! open(dimvar, var, dimord, [count_compact], [err]) は
! 既に開かれた変数 var の ord 番目の次元にあたる変数を
! 開き dimvar に格納する。
! 順序 dimord は現在の入出力範囲が
! 幅 1 になっている (コンパクト化している）を飛ばした
! 順序であるが、count_compact に真を指定すると
! すべての次元のなかの順序になる。
!
subroutine GTVarOpenByDimOrd(var, source_var, dimord, count_compact, err)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory, &
        & map_dup, map_create, map_lookup, gt_dimmap, &
        & map_set, dimord_skip_compact
    use an_generic, only: Open, an_variable, inquire
    use gtdata_generic, only: gt_open => open
    use dc_trace, only: beginsub, endsub, message
    use dc_string, only: var_str
    use dc_error
    implicit none
    type(GT_VARIABLE), intent(out):: var
    type(GT_VARIABLE), intent(in):: source_var
    integer, intent(in):: dimord
    logical, intent(in), optional:: count_compact
    logical, intent(out), optional:: err
    integer:: sclass, scid, ld, sndims, stat, udimord, idimord
    type(an_variable):: an
    type(gt_dimmap), allocatable:: map_src(:)
    type(gt_dimmap):: map_result(1)
    logical:: cnt_compact
continue
    call beginsub('gtvaropen-by-dimord', 'var.mapid=%d dimord=%d', &
        & i=(/source_var%mapid, dimord/))

    ! 変数それ自体を開き直す処理
    if (dimord == 0) then
        call map_dup(var, source_var)
        if (present(err)) err = .false.
        call endsub('gtvaropen-by-dimord', 'dup')
        return
    endif

    ! 表を引き、dimord 番 (count_compact に注意) の次元の内部変数
    ! 次元番号を調べる。
    call map_lookup(source_var, ndims=sndims)
    if (sndims <= 0 .or. dimord > sndims) then
        stat = gt_enomoredims
        goto 999
    endif
    allocate(map_src(sndims))
    call map_lookup(source_var, map=map_src)
    cnt_compact = .false.
    if (present(count_compact)) cnt_compact = count_compact
    if (cnt_compact) then
        udimord = dimord
    else
        udimord = dimord_skip_compact(dimord, map=map_src)
    endif
    if (udimord <= 0 .or. udimord > size(map_src)) then
        stat = gt_enomoredims
        goto 999
    endif

    idimord = map_src(udimord)%dimno
    if (idimord < 1) then
        call gt_open(var, map_src(udimord)%url, err=err)
        ! storeerror はしなくてよい
        deallocate(map_src)
        goto 1000
    endif

    ! 実態種別に合わせ「次元変数オープン」処理
    call var_class(source_var, sclass, scid)
    if (sclass == vtb_class_netcdf) then
        call Open(an, an_variable(scid), idimord, err)
        call inquire(an, dimlen=ld)
        call map_create(var, vtb_class_netcdf, an%id, 1, (/ld/))
        call map_lookup(var, map=map_result)
        map_result(1)%offset = map_src(udimord)%offset
        map_result(1)%step = map_src(udimord)%step
        map_result(1)%allcount = map_src(udimord)%allcount
        map_result(1)%start = map_src(udimord)%start
        map_result(1)%count = map_src(udimord)%count
        map_result(1)%stride = map_src(udimord)%stride
        call map_set(var, map=map_result, stat=stat)
    else if (sclass == vtb_class_memory) then
        var = source_var
        stat = dc_noerr
    else
        stat = gt_efake
    endif

    deallocate(map_src)
999 continue
    call StoreError(stat, "gtvaropen-by-dimord", cause_i=dimord)
1000 continue
    call endsub('gtvaropen-by-dimord', 'result_var=%d', i=(/var%mapid/))
end subroutine

! vi: set sw=4 ts=8:

module gt3conv_tools
    use gt3read
    use gtool
    implicit none

!    private
    public dims_table, vars_table

    type VARTABLE_ENTRY
	integer:: first_unit
	type(VSTRING):: netcdf_name
	integer:: time_ord
!	type(NC_VARIABLE):: var
        ! NC_VARIABLE 未定義
	type(GT3_HEADER):: header
    end type

    type(VARTABLE_ENTRY), save, allocatable:: vars_table(:)

    ! DIMTABLE_ENTRY : 次元変数に関する情報
    type DIMTABLE_ENTRY
	character(len = 30):: name    ! 軸の名前. lon, lat など
	character(len = 16):: item    ! 軸ファイルなら ITEM, ATIM?
	character(len = 16 * 2):: long_name ! 長い名前
	character(len = 16):: unit ! 単位
	integer:: lower, upper        ! ASTR1 と AEND1
	integer:: dim                 ! 軸の格子点数
	real, pointer:: values(:)     ! 例えば格子点値
    end type

    type(DIMTABLE_ENTRY), save, pointer:: dims_table(:)

contains

    integer function LookupVariable(header) result(result)
	type(GT3_HEADER), intent(in):: header
    continue
	do, result = 1, size(vars_table)
	    if (header%item /= vars_table(result)%header%item) cycle
	    if (all(header%axis_item == vars_table(result)%header%axis_item)) return
	enddo
	result = 0
    end function

        ! 新しい変数を vars_table に格納する。もし未割り付けならば
	! 1 エントリだけ割り付ける。新しい vars_table の大きさを返す。
    integer function StoreVariable(header, cur_unit) result(result)
	type(GT3_HEADER), intent(in):: header
	integer, intent(in):: cur_unit
	type(VARTABLE_ENTRY), allocatable:: tmp_table(:)
	integer:: n
    continue
	if (.not. allocated(vars_table)) then
            allocate(vars_table(1))
	    result = 1
	else
            n = size(vars_table)
	    allocate(tmp_table(n))
	    tmp_table(1:n) = vars_table(1:n)
	    deallocate(vars_table)
            allocate(vars_table(n + 1))
	    vars_table(1:n) = vars_table(1:n)
	    result = n + 1
	endif
	vars_table(result)%first_unit = cur_unit
	vars_table(result)%header = header
	call GiveUniqueName(vars_table, result)
    end function

    subroutine GiveUniqueName(vars_table, idx)
	type(VARTABLE_ENTRY), intent(inout):: vars_table(:)
	integer, intent(in):: idx
	type(VSTRING):: candidate
	integer:: i, n
    continue
NLOOP:	do, n = 0, 999
	    candidate = NetcdfName(vars_table(idx)%header%item, n)
	    do, i = 1, idx - 1
		if (vars_table(i)%netcdf_name == candidate) cycle NLOOP
	    enddo
	    vars_table(idx)%netcdf_name = candidate
	    return
	enddo NLOOP
	stop 'gt3conv_tool#GiveUniqueName detected too many variables'
    end subroutine

    type(VSTRING) function NetcdfName(namebase, revno) result(result)
	character(len = *), intent(in):: namebase
	integer, intent(in):: revno
	character(len = len(namebase)):: buffer
	character(len = *), parameter:: &
	    & Lowercase = 'abcdefghijklmnopqrstuvwxyz_-0123456789', &
	    & Uppercase = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
	integer:: i, j, k
	character:: c
    continue
	j = 0
	do, i = 1, len(namebase)
	    c = namebase(i: i)
	    if (c == ' ') cycle
	    k = index(Uppercase, c)
	    if (k > 0) then
		j = j + 1
		buffer(j: j) = Lowercase(k: k)
	    else if (index(Lowercase, c) > 0) then
		j = j + 1
		buffer(j: j) = c
	    endif
	enddo
	if (revno <= 0) then
	    result = buffer(1: j)
	else
	    result = buffer(1: j) // '-' // char(revno)
	endif
    end function

    type(VSTRING) function AxisFilename(item, weight) result(result)
	character(len = 16), intent(in):: item
	logical, intent(in), optional:: weight
	character(len = *), parameter:: GTAXDIR_L = '/var/spool/gt3-dcl5/'
	character(len = *), parameter:: GTAXDIR_W = '/home/momoko/lib/gt3/'
	character(len = 8):: prefix
	logical:: exist
    continue
	print *, 'item=', trim(item)
	prefix = 'GTAXLOC.'
	if (present(weight)) then
	    if (weight) prefix = 'GTAXWGT.'
	endif
	result = prefix // trim(item)
	inquire(file=vchar(result,len(result)), exist=exist)
	if (exist) return
	result = GTAXDIR_L // prefix // trim(item)
	inquire(file=vchar(result,len(result)), exist=exist)
	if (exist) return
	result = GTAXDIR_W // prefix // trim(item)
	inquire(file=vchar(result,len(result)), exist=exist)
!	if (exist) return
!	result = GtoolGetenv('GTAXDIR') // prefix // trim(item)
!	inquire(file=vchar(result,len(result)), exist=exist)
!           環境変数の取り込みってどうやるの????
    end function


    subroutine ReadAxisFile(dim)
	type(DIMTABLE_ENTRY), intent(inout):: dim
	type(GT3_FILE):: axisfile
	type(GT3_HEADER):: header
	real, pointer:: buffer(:, :, :)
	integer:: lb, ub
    continue
	call Open(axisfile, &
                & vchar(AxisFilename(dim%item), len(AxisFilename(dim%item))))
	call Get(axisfile, header, buffer)
	call Close(axisfile)

	lb = lbound(buffer, 1)
	ub = ubound(buffer, 1)
	if (dim%lower < lb) then
	    print *, 'gt3conv#ReadAxisFile: requested lower bound ', &
		& dim%lower, ' is less than axis file value ', lb
	    stop
	endif
	if (dim%upper > ub) then
	    print *, 'gt3conv#ReadAxisFile: requested upper bound ', &
		& dim%upper, ' is greater than axis file value ', ub
	    stop
	endif
	allocate(dim%values(lb: ub))
	dim%values(:) = buffer(lb: ub, lbound(buffer, 2), lbound(buffer, 3))
        dim%long_name = header%title
	if (header%unit /= '') then
	    dim%unit = UnitString(header)
	endif
    end subroutine

    type(VSTRING) function Dimname3to4(item, usedname) result(result)
	character(len = *), intent(in):: item
	character(len = *), intent(in):: usedname(:)
	character(len = len(item)):: buffer
	type(VSTRING):: name, grids, suffix
	integer:: a, b, c
    continue
	buffer = adjustl(item)
	a = scan(buffer, '0123456789')
	name = buffer(1: a-1)
	b = verify(buffer(a: ), '0123456789')
	if (b == 0) b = len(buffer)
	grids = buffer(a: b)
	suffix = trim(buffer(b + 1: ))

	if (name == 'CSIG' .and. suffix == '.M') then
	    result = 'sigma_bound'
	else if (name == 'CSIG') then
	    result = 'sigma'
	else if (name == 'GLON') then
	    result = 'lon'
	else if (name == 'GGLA') then
	    result = 'lat'
	else
	    result = item
	endif
	if (all(usedname(:) /= vchar(result,len(result)))) return

	result = result // grids
	if (all(usedname(:) /= vchar(result,len(result)))) return

	name = result
	do, c = 1, huge(c)
	    result = name // char(c)
	    if (all(usedname(:) /= vchar(result,len(result)))) return
	enddo
	stop 'gt3conv#Dimname3to4'
    end function

    subroutine StoreDimension(header, ia)
        type(GT3_HEADER), intent(in):: header
        ! integer:: length
        integer, intent(in):: ia
        integer, save:: num_dims
	character(len = 16):: item
        integer:: idim
        type(DIMTABLE_ENTRY), pointer:: dims_tmp(:)
    continue
        ! 空なら飛ばす
	item = header%axis_item(ia)
	if (item == '') return

        ! 登録済みかどうかの確認
        do, idim = 1, num_dims
            if (item == dims_table(idim)%item) then
                 continue ! 上下端の確認くらいはするようにする.
                 return
            end if
        end do

        ! 未登録なら登録
        num_dims = num_dims +1
	    if (num_dims > size(dims_table)) then
		allocate(dims_tmp(size(dims_table) + 1))
                ! 豊田君のソースでは + 2 になってたけど....
		dims_tmp(1: size(dims_table)) = dims_table(:)
	        ! deallocate(dims_table)
                ! deallocate(dims_table) やってしまうとエラーになる.
		dims_table => dims_tmp
	    endif
        dims_table(num_dims)%item =  header%axis_item(ia)
        dims_table(num_dims)%lower =  header%axis_start(ia)
        dims_table(num_dims)%upper = header%axis_end(ia)
        dims_table(num_dims)%dim = dims_table(num_dims)%upper &
                 & - dims_table(num_dims)%lower + 1
   end subroutine

    type(VSTRING) function UnitString(header)
	type(GT3_HEADER), intent(in):: header
    continue
	if (header%unit == 'deg') then
	    if (header%item(1: 4) == 'GLON') then
		UnitString = 'degree_east'
	    else
		UnitString = 'degree_north'
	    endif
	else if (header%unit == '') then
            ! 無次元軸(sigma 等)の時は単位は空文字. 
            ! 本当にこれしか方法が無いんかな?
            UnitString = ' '
	else
	    UnitString = header%unit
	endif
    end function

end module

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

subroutine GTVarGetReal1(var, value, err)
    use gtdata_types, only: gt_variable
    use gtdata_generic, only: get_slice, get, inquire
    use gt_map, only: map_set_rank
    use dc_error, only: storeerror, dc_noerr
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(gt_variable), intent(inout):: var
    real, pointer:: value(:)
    logical, intent(out), optional:: err
    integer:: stat, n
continue
    call beginsub('gtvargetreal1', 'var.mapid=%d', i=(/var%mapid/))
    call map_set_rank(var, 1, stat)
    if (stat /= dc_noerr) goto 999
    call get_slice(var, dimord=1, count=n, count_compact=.false.)
    allocate(value(n))
    call get(var, value, n, err)
    call message('max=%r min=%r', r=(/maxval(value), minval(value)/))
999 continue
    call endsub('gtvargetreal1', 'n=%d', i=(/n/))
    call storeerror(stat, 'gtvargetreal1')
end subroutine

module dc_trace

    use dc_types, only: token
    implicit none
    private

    logical, save:: lfirst = .true.
    integer, save, public:: dbg = -1
    integer, save:: level = 0
    integer, parameter:: trace_stack_size = 128
    character(token), save:: table(trace_stack_size)

    public:: beginsub, endsub, debug, setdebug, message, dbg_scratch
    public:: sublevel

contains

    integer function sublevel() result(result)
        result = level
    end function

    subroutine dbg_scratch(on)
        logical, intent(in):: on
        integer, save:: saved_dbg = -1
        logical:: x, p
        character(80):: line
        integer:: ios
    continue
        if (on) then
            if (dbg < 0) return
            saved_dbg = dbg
            dbg = 98
            do
                inquire(unit=dbg, exist=x, opened=p)
                if (x .and. .not. p) then
                    open(unit=dbg, status='SCRATCH')
                    return
                endif
                dbg = dbg - 1
                if (dbg < 0) exit
            enddo
            dbg = saved_dbg
            saved_dbg = -1
        else
            if (saved_dbg < 0) return
            rewind(dbg, err=100)
            do
                read(dbg, '(A)', iostat=ios) line
                if (ios /= 0) exit
                write(saved_dbg, '(A)', iostat=ios) trim(line)
                if (ios /= 0) exit
            enddo
            100 continue
            close(dbg, iostat=ios)
            dbg = saved_dbg
            saved_dbg = -1
        endif
    end subroutine

    subroutine setdebug(debug)
        integer, intent(in), optional:: debug
        integer:: ios
        if (present(debug)) then
            dbg = debug
            write(dbg, "('#setdebug: dbg =', i4)", iostat=ios) dbg
            if (ios == 0) return
        else
            dbg = 0
            write(dbg, "('#setdebug: dbg = 0')", iostat=ios)
            if (ios == 0) return
            dbg = 6
            write(dbg, "('#setdebug: dbg = 6')", iostat=ios)
            if (ios == 0) return
        endif
        dbg = -1
    end subroutine

    logical function debug() result(result)
        result = dbg >= 0
    end function

    subroutine initialize
        table(:) = ' '
        lfirst = .false.
    end subroutine

    subroutine beginsub(name, fmt, i, r, d, L, s, n, c1, c2, c3)
        use dc_types, only: string
        use dcstring_base, only: vstring
        use dc_string, only: cprintf
        character(*), intent(in):: name
        character(*), intent(in), optional:: fmt
        integer, intent(in), optional:: i(:), n(:)
        real, intent(in), optional:: r(:)
        double precision, intent(in), optional:: d(:)
        logical, intent(in), optional:: L(:)
        type(vstring), intent(in), optional:: s(:)
        character(*), intent(in), optional:: c1, c2, c3
        character(string):: cbuf
    continue
        if (lfirst) call initialize
        if (debug()) then
            if (present(fmt)) then
                cbuf = cprintf(fmt, i, r, d, L, s, n, c1, c2, c3)
                write(dbg, "('#', A, 'call ', A, ' ', A)") &
                    & repeat(' ', level), trim(name), trim(cbuf)
            else
                write(dbg, "('#', A, 'call ',A)") &
                    & repeat(' ', level), trim(name)
            endif
        endif
        ! call errtra ! --- for Fujitsu debug
        if (level > size(table)) return
        level = level + 1
        table(level) = name
    end subroutine

    subroutine message(fmt, i, r, d, L, s, n, c1, c2, c3)
        use dc_types, only: string
        use dcstring_base, only: vstring
        use dc_string, only: cprintf
        character(*), intent(in):: fmt
        integer, intent(in), optional:: i(:), n(:)
        real, intent(in), optional:: r(:)
        double precision, intent(in), optional:: d(:)
        logical, intent(in), optional:: L(:)
        type(vstring), intent(in), optional:: s(:)
        character(*), intent(in), optional:: c1, c2, c3
        character(string):: cbuf
    continue
        if (.not. debug()) return
        cbuf = cprintf(fmt, i, r, d, L, s, n, c1, c2, c3)
        write(dbg, "('#', A, A)") repeat(' ', level), trim(cbuf)
    end subroutine

    subroutine endsub(name, fmt, i, r, d, L, s, n, c1, c2, c3)
        use dc_types, only: string
        use dcstring_base, only: vstring
        use dc_string, only: cprintf
        character(*), intent(in):: name
        character(*), intent(in), optional:: fmt
        integer, intent(in), optional:: i(:), n(:)
        real, intent(in), optional:: r(:)
        double precision, intent(in), optional:: d(:)
        logical, intent(in), optional:: L(:)
        type(vstring), intent(in), optional:: s(:)
        character(*), intent(in), optional:: c1, c2, c3
        character(string):: cbuf
    continue
        if (lfirst) call initialize
        if (debug()) then
            if (present(fmt)) then
                cbuf = cprintf(fmt, i, r, d, L, s, n, c1, c2, c3)
                write(dbg, "('#', A, 'end ', A, ' ', A)") &
                    & repeat(' ', level), trim(name), trim(cbuf)
            else
                write(dbg, "('#', A, 'end ', A)") &
                    & repeat(' ', level), trim(name)
            endif
        endif
        ! call errtra ! --- for Fujitsu debug
        if (level <= 0) then
            write(*, "('#Warning endsub[',A,'] without beginsub')") trim(name)
        else if (name /= table(level)) then
            write(*, "('#Warning endsub[',A,'] but tos[',A,']')") &
                & trim(name), trim(table(level))
        else
            level = level - 1
        endif
    end subroutine

end module

program gt3conv

    use gtool, only: string, gtargcount, gtargget, abortprogram
    use gtool_history, only: gt_history_axis, HistoryCreate, &
        & historyClose, gt_history_varinfo, HistoryAddVariable, &
        & historyPut, HistorySetTime, HistoryAddAttr
    use dc_trace, only: setdebug
    use gt3map

implicit none

    integer:: i, iostat, ndims
    character(len = string):: arg, input
    character(len = string):: output = ""
    type(gt3_map):: map
    type(gt_history_axis), allocatable:: axis(:)
    type(gt_history_varinfo):: varinfo

    integer:: verbose = 2
    logical:: explicit_valid_range = .false.

continue

    ! 引数の読み込み(最後の引数がファイル名)
    do, i = 1, GtArgCount()
        call GtArgGet(i, arg)
        if (arg == '-debug') then
            call setdebug
        else if (arg(1:2) == '-h') then
            goto 900
        else if (arg(1:2) == '-q') then
            verbose = verbose - 1
        else if (arg(1:2) == '-v') then
            verbose = verbose + 1
        else if (arg(1:6) == '-valid') then
            explicit_valid_range = .true.
        else if (arg(1:4) == 'out=') then
            output = arg
        else
            input = arg
        endif
    enddo
    if (output == "") output = OutputFilename(input, ".nc")

    if (verbose > 0) then
        write(*, fmt='(A)') &
            & "gt3conv: from " // trim(input) // " to " // trim(output)
    endif
    call open(map, input, iostat)
    if (iostat /= 0) goto 900

    allocate(axis(map%n_axes))
    call get_axis(map, axis)
    call HistoryCreate(trim(output), trim(map%title), &
        & trim(map%source), trim(map%institution), &
        & axis, origin=0.0, interval=0.0)

    ! データ変数の作成
    do, i = 1, map%n_vars
        call get_variable(map, "VAR", i, varinfo)
        call HistoryAddVariable(varinfo)
        call make_attr(map, "VAR", i)
    enddo
    ! 大域属性は 1 つ変数を作った後で (gtool_history のバグ)
    call HistoryAddAttr("", "history", trim(map%history))

    ! 軸重み変数の作成
    do, i = 1, map%n_axes - 1
        call make_attr(map, "AXI", i)
        call get_variable(map, "WGT", i, varinfo)
	if (varinfo%name == '') cycle
        call HistoryAddVariable(varinfo)
        call make_attr(map, "WGT", i)
    enddo

    ! 軸変数の値を作成
    do, i = 1, map%n_axes - 1
        call HistoryPut(map%axistab(i)%name, map%axistab(i)%value)
	if (.not. associated(map%axistab(i)%name_w)) cycle
        call HistoryPut(map%axistab(i)%name_w, map%axistab(i)%value_w)
    enddo

    ! 時間軸をいったん全部書き込み
    do, i = 1, map%n_times
        call HistoryPut(map%axistab(map%n_axes)%name, map%timetab(i)%time)
    enddo

    ! データ変数の中身を読み書き
    call history_copy(map)

    call HistoryClose()
    call close(map, iostat)
    if (iostat /= 0) goto 900
    stop

900 continue
    print *, "error ", iostat
    print *, "usage: gt3conv [-debug] [out=output] input"
    call abortprogram("")

contains

    subroutine make_attr(map, class, order)
        use gt3read, only: gt3_header
    implicit none
        type(gt3_map), intent(in):: map
        character(len = *):: class
        integer, intent(in):: order
        type(gt3_header):: header
        character(len = token):: varname
        character(len = string):: comment
        integer:: i
    continue
        call getHeader(map, class, order, header, varname)
        if (class == 'AXI') then
            ! 軸重み
            if (associated(map%axistab(order)%name_w)) then
                call HistoryAddAttr(varname, "gt_calc_weight", &
                    & trim(map%axistab(order)%name_w))
            endif
            if (header%dataset(1:1) == 'C') then
                if (size(map%axistab(order)%value) > header%record_size / 2) then
                    call HistoryAddAttr(varname, "topology", &
                        & "circular")
                endif
                call HistoryAddAttr(varname, "modulo", map%axistab(order)%range)
            endif
        endif
        ! 何に使うのだろう... もうちょっと考えたほうがよい
        call HistoryAddAttr(varname, &
            & "gt_user_gtool3_tdur", header%time_duration)
        ! 欠損値
        call HistoryAddAttr(varname, "missing_value", &
            & header%missing_value)
        call HistoryAddAttr(varname, "_FillValue", &
            & header%missing_value)
        ! とてもお勧めできるとは思えない
        if (explicit_valid_range) then
            if (header%missing_value > 0) then
               call HistoryAddAttr(varname, "valid_max", &
                    & header%missing_value * (1.0 - epsilon(1.0)))
            else
                call HistoryAddAttr(varname, "valid_min", &
                    & header%missing_value * (1.0 - epsilon(1.0)))
            endif
        endif
        ! 描画範囲
        if (header%range_min /= header%range_max) then
            call HistoryAddAttr(varname, &
                & "gt_graph_range", (/header%range_min, header%range_max/))
        endif
        ! コンター間隔関係設定
        if (header%div_small /= 0.0) then
            call HistoryAddAttr(varname, &
                & "gt_graph_smalltick_interval", header%div_small)
            call HistoryAddAttr(varname, &
                & "gt_graph_contours_interval", header%div_small)
        endif
        if (header%div_large /= 0.0) then
            call HistoryAddAttr(varname, &
                & "gt_graph_tick_interval", header%div_large)
            call HistoryAddAttr(varname, &
                & "gt_graph_contours_thick_interval", header%div_large)
        endif
        ! 軸投影関係設定
        if (abs(header%scaling) == 2) then
            call HistoryAddAttr(varname, "gt_graph_logscale", "yes")
        endif
        if (header%scaling > 0) then
            call HistoryAddAttr(varname, "positive", "up")
        else
            call HistoryAddAttr(varname, "positive", "down")
        endif
        ! 予約欄
        if (header%option(1) /= "") then
            call HistoryAddAttr(varname, "gt_user_gtool3_optn1", &
                & trim(header%option(1)))
        endif
        if (header%option(2) /= "") then
            call HistoryAddAttr(varname, "gt_user_gtool3_optn2", &
                & trim(header%option(2)))
        endif
        if (header%option(3) /= "") then
            call HistoryAddAttr(varname, "gt_user_gtool3_optn3", &
                & trim(header%option(3)))
        endif
        ! コメント欄
        comment = ""
        do, i = 1, 12
            comment = trim(comment) // " " // trim(header%memo(i))
        enddo
        if (comment /= "") then
            call HistoryAddAttr(varname, "comment", trim(comment))
        endif
    end subroutine

    subroutine history_copy(map)
        use gt3read, only: gt3_header, getunit
    implicit none
        type(gt3_map):: map
        type(gt3_header):: header
        real, pointer:: buffer(:, :, :)
        integer:: iostat, irec
        type(unitlist_t), pointer:: ulist
    continue
        irec = 0
        ulist => map%unit%prev
        do
            irec = irec + 1
            call GetUnit(map%file, header, buffer, iostat)
            if (iostat /= 0) return
            ! 格子不整合で invalid になる場合除去
            ulist => ulist%next
            if (.not. ulist%valid) cycle
            ! いざ書き出し
            call HistorySetTime(real(header%time))
            call HistoryPut(varname_3to4(map, header%item), buffer)
            if (verbose > 1) then
                write(*, fmt='(A,I6,"/",I6)') &
                    achar(27) // '[A', irec, map%n_units
            endif
        enddo
    end subroutine

    function OutputFilename(src, suffix) result(result)
        character(len = string):: result
        character(len = *), intent(in):: src, suffix
        character(len = *), parameter:: pathdelim = ':/' // achar(92)
        character(len = *), parameter:: ANS = "ABCDEFGHIJKLMNOPQRSTUVW&
            &XYZabcdefghijklmnopqrstuvwxyz0123456789_ "
        integer:: basename, period, i
    continue
        ! ディレクトリ成分らしきものは除去
        basename = scan(src, pathdelim, back=.true.)
        if (basename > 0) then
            result = src(basename + 1: )
        else
            result = src
        endif
        ! 最後の '.' 以降を除去
        period = index(result, '.', back=.true.)
        if (period /= 0) result(period: ) = ""
        ! 変な文字を下線に置換
        do
            i = verify(result, ANS)
            if (i == 0) exit
            result(i:i) = '_'
        enddo
        ! 拡張子を強要
        result = trim(result) // suffix
    end function

end program

! コマンドラインオプション
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

module gt_args

    implicit none
    private

    character(len = *), parameter:: WORDCHARS &
        = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz_:"

    interface GtArgGet

        subroutine GtArgGetC(ord, value, default)
            integer, intent(in):: ord
            character(len = *), intent(out):: value
            character(len = *), intent(in), optional:: default
        end subroutine

    end interface

    interface GtOptionForm
        module procedure GtOptionFormV
        module procedure GtOptionFormC
    end interface

    interface

        integer function GtArgCount()
        end function

    end interface

    public:: GTOptionForm, GtArgCount, GtArgGet, GtOptionLineIndex

contains

    subroutine GtOptionLineIndex(idx, optname, optvalue, err)
        use dc_string, only: toUpper, stoi
        integer, intent(inout):: idx
        character(len = *), intent(in):: optname
        character(len = *), intent(in):: optvalue
        logical, intent(out):: err
        character(len = len(optname)):: uc_name
        character(len = len(optvalue)):: uc_value
    continue
        uc_name = optname
        uc_value = optvalue
        call toUpper(uc_name)
        call toUpper(uc_value)
        if (uc_name == "COLOR" .or. uc_name == "COLOUR") then
            select case(uc_value)
            case("DEFAULT", "WHITE", "BLACK")
                idx = mod(idx, 10) + 10
            case("RED")
                idx = mod(idx, 10) + 20
            case("GREEN")
                idx = mod(idx, 10) + 30
            case("BLUE")
                idx = mod(idx, 10) + 40
            case("YELLOW")
                idx = mod(idx, 10) + 50
            case default
                idx = mod(idx, 10) + 10 * stoi(uc_value)
            end select
        else if (uc_name == "THICKNESS" .or. uc_name == "LINEWIDTH") then
            select case(uc_value)
            case("THIN")
                idx = idx - mod(idx, 10) + 1
            case("MEDIUM")
                idx = idx - mod(idx, 10) + 3
            case("THICK")
                idx = idx - mod(idx, 10) + 5
            case default
                idx = idx - mod(idx, 10) + stoi(uc_value)
            end select
        else if (uc_name == "INDEX" .or. uc_name == "LINEINDEX") then
            select case(uc_value)
            case("DEFAULT", "WHITE", "BLACK")
                idx = 10
            case("RED")
                idx = 20
            case("GREEN")
                idx = 30
            case("BLUE")
                idx = 40
            case("YELLOW")
                idx = 50
            case("THIN")
                idx = 1
            case("MEDIUM")
                idx = 3
            case("THICK")
                idx = 5
            case default
                idx = stoi(uc_value)
            end select
        else
            err = .TRUE.
            return
        endif
        err = .FALSE.
    end subroutine

        logical function &
    GTOptionFormC(argument, name, value) result(result)
        implicit none
        character(len = *), intent(in):: argument
        character(len = *), intent(out):: name, value
        integer:: equal
        if (argument(1:1) == '-') then
            equal = index(argument, '=')
            if (equal == 0) then
                name = argument
                value = ""
            else
                name = argument(1:equal-1)
                value = argument(equal+1: )
            endif
            result = .true.
        else
            equal = index(argument, '=')
            if (equal == 0) then
                result = .false.
                name = ""
                value = ""
            else if (verify(argument(1:equal-1), WORDCHARS) == 0) then
                result = .true.
                name = argument(1:equal-1)
                value = argument(equal+1: )
            else
                result = .false.
                name = ""
                value = ""
            endif
        endif
    end function

        logical function &
    GTOptionFormV(argument, name, value) result(result)
        use dc_string
        implicit none
        type(VSTRING), intent(in):: argument
        type(VSTRING), intent(out):: name, value
        integer:: equalPos
    continue
        if (extract(argument, 1, 1) == '-') then
            equalPos = vindex(argument, "=")
            if (equalPos == 0) then
                name = argument
                value = ""
            else
                name = extract(argument, 1, equalPos - 1)
                value = extract(argument, equalPos + 1)
            endif
            result = .TRUE.
        else
            result = NameValueForm(argument, name, value)
        endif            
    end function

    ! なつかしの K&R スタイル :) 
        logical function &
    NameValueForm(argument, name, value) result(result)
        use dc_string
        type(VSTRING), intent(in):: argument
        type(VSTRING), intent(out):: name, value
        integer:: i
    continue
        i = vindex(argument, "=")
        if (i == 0) goto 999
        name = extract(argument, 1, i - 1)
        if (vverify(name, WORDCHARS) /= 0) goto 999
        result = .TRUE.
        value = extract(argument, i + 1)
        return

    999 continue
        result = .FALSE.
        name = ""
        value = ""
    end function

end module

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved
! GrADS ファイルの機能を提供

module gr_file

    use dc_string, only: VSTRING
    implicit none

    ! 属性は単連結リストで表現。
    type GR_ATTR_ENTRY
        character(len = 8):: var
        character(len = 72):: attr
        type(VSTRING):: value
        type(GR_ATTR_ENTRY), pointer:: next
    end type

    type GR_FILE_ENTRY
        integer:: id
        integer:: count
        logical:: writable
        type(VSTRING):: ctlfile
        type(VSTRING):: dsetfile
        type(GR_FILE_ENTRY), pointer:: next
        ! コントロールファイル情報
        type(VSTRING):: title
        real:: undef
        ! 次元変数は4つだけ
        real, pointer:: lon(:)
        real, pointer:: lat(:)
        real, pointer:: lev(:)
        character(len = 16):: time_origin
        character(len = 2):: time_unit
        integer:: time_step
        integer:: time_count
        ! 変数表情報
        integer:: nvars
        character(len = 8), pointer:: varname(:)
        type(VSTRING), pointer:: vardesc(:)
        integer, pointer:: levels(:)
        ! 属性表
        type(GR_ATTR_ENTRY), pointer:: attr_table
    end type

    type(GR_FILE_ENTRY), save, pointer:: file_table_head
    logical, save:: file_table_used = .FALSE.

contains

    subroutine GRFileName(fileid, result)
        use dc_string
        use dc_error
        integer, intent(in):: fileid
        type(VSTRING), intent(out):: result
        type(GR_FILE_ENTRY), pointer:: cursor
        if (.not. file_table_used) goto 999
        cursor => file_table_head
        do
            if (.not. associated(cursor)) exit
            if (cursor%id == fileid) then
                result = cursor%ctlfile
                return
            endif
            cursor => cursor%next
        enddo
        999 continue
        result = ""
        call StoreError(GR_ENOTGR, "GRFileName")
    end subroutine

    subroutine parse_ctl_file(grfile, filename, writable, mystat)
        implicit none
        type(GR_FILE_ENTRY), intent(out):: grfile
        character(len = *), intent(in):: filename
        logical, intent(in):: writable
        integer, intent(out):: mystat
        mystat = 0
        grfile%count = 1
        grfile%writable = writable
        grfile%ctlfile = filename
    end subroutine 

    subroutine GRFileOpen(fileid, filename, writable, overwrite, stat, err)
        use dc_string
        use netcdf_f77
        use dc_error
        use dcl, only: DclGetUnitNum
        implicit none
        integer, intent(out):: fileid
        character(len = *), intent(in):: filename
        logical, intent(in), optional:: writable
        logical, intent(in), optional:: overwrite
        logical, intent(out), optional:: err
        integer, intent(out), optional:: stat
        logical:: writable_required
        logical:: overwrite_required
        type(GR_FILE_ENTRY), pointer:: cursor, prev
        integer:: mystat
        integer:: recl
        character(len = 7):: new
        character(len = 256):: dsetname
    continue
        !
        ! オプション操作
        !
        writable_required = .FALSE.
        if (present(writable)) writable_required = writable
        if (present(overwrite)) then
            writable_required = .TRUE.
            overwrite_required = overwrite
        else
            overwrite_required = .FALSE.
        endif
        !
        ! 同じ名前で書込み可能性も適合していれば open しないで済ませる
        !
        if (file_table_used) then
            cursor => file_table_head
            nullify(prev)
            do
                if ((cursor%ctlfile == filename) &
                .and. (cursor%writable .or. .not. writable_required)) &
                then
                    fileid = cursor%id
                    cursor%count = cursor%count + 1
                    if (present(err)) err = .FALSE.
                    return
                endif
                prev => cursor
                cursor => cursor%next
                if (.not. associated(cursor)) exit
            enddo
            allocate(cursor)
            prev%next => cursor
        else
            nullify(prev)
            allocate(file_table_head)
            cursor => file_table_head
            file_table_used = .TRUE.
        endif
        !
        ! ファイル表の新しく確保したエントリに書き込む
        !
        nullify(cursor%next, cursor%lat, cursor%lon, cursor%lev)
        call parse_ctl_file(cursor, filename, writable_required, mystat)
        if (mystat /= 0) goto 900
        dsetname = cursor%dsetfile

        inquire(iolength=recl) 0.0
        cursor%id = DclGetUnitNum()
        if (.not. writable_required) then
            open(unit=cursor%id, file=dsetname, access="DIRECT", &
                recl=recl, form="UNFORMATTED", status="OLD", &
                action="READ", iostat=mystat)
        else
            open(unit=cursor%id, file=dsetname, access="DIRECT", &
                recl=recl, form="UNFORMATTED", status="OLD", &
                action="READWRITE", iostat=mystat)
            if (mystat /= 0) then
                new = "NEW"
                if (overwrite_required) new = "REPLACE"
                open(unit=cursor%id, file=dsetname, access="DIRECT", &
                    recl=recl, form="UNFORMATTED", status=new, &
                    action="READWRITE", iostat=mystat)
            endif
        endif
        fileid = cursor%id

    900 continue
        ! 失敗したら GR_FILE 表から消しておく
        if (mystat /= 0) then
            if (associated(prev)) then
                prev%next => cursor%next
            else
                file_table_head => cursor%next
                if (.not. associated(file_table_head)) file_table_used = .FALSE.
            endif
            deallocate(cursor)
            fileid = -1
        endif

        if (present(stat)) then
            stat = mystat
            if (present(err)) err = (stat /= 0)
        else if (present(err)) then
            err = (stat /= 0)
        else
            call StoreError(mystat, 'GrFileOpen', err, cause_s=var_str(filename))
        endif
    end subroutine

end module

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

! あるファイル名 urlBase に依存する変数すべてを取得するにはまず
! var_search(iter, urlbase) を呼び出してから無限ループの中で
! attr_next(iter, url, end) を呼び出す。url がひとつ
! ひとつの属性名を与える。end が真にになったとき、
! すべての属性を探索し終えたことになる。

subroutine ANVarSearchInit(iter, urlBase)
    use dc_types, only: string
    use an_types, only: AN_VARIABLE_SEARCH
    use dc_url, only: UrlSplit
    use an_file, only: ANFileOpen
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(AN_VARIABLE_SEARCH), intent(out):: iter
    character(len = *), intent(in):: urlBase
    character(len = string):: file
    logical:: err
    call beginsub('anvarsearchinit', 'urlbase=<%c>', c1=trim(urlbase))
    call UrlSplit(trim(urlbase), file=file)
    call ANFileOpen(iter%fileid, filename=file, writable=.FALSE., err=err)
    if (err) iter%fileid = -1
    iter%varid = 0
    iter%dimid = 0 
    call endsub('anvarsearchinit', 'file=%d', i=(/iter%fileid/))
end subroutine

subroutine ANVarSearchNext(iter, url, end)
    use an_types, only: AN_VARIABLE_SEARCH
    use dc_types, only: string
    use netcdf_f77
    use dc_url, only: UrlMerge
    use an_file, only: inquire, AnFileClose
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(AN_VARIABLE_SEARCH), intent(inout):: iter
    character(len = *), intent(out):: url
    logical, intent(out):: end
    character(len = string):: filename
    character(len = NF_MAX_NAME):: varname
    integer:: stat, varid_tmp
continue
    call beginsub('anvarsearchnext')
    if (iter%fileid <= 0) then
        end = .TRUE.
        url = ''
        call endsub('anvarsearchnext', "bad file %d", i=(/iter%fileid/))
        return
    endif
    if (iter%varid >= 0) then
        iter%varid = iter%varid + 1
        stat = NF_INQ_VARNAME(iter%fileid, iter%varid, varname)
        if (stat == NF_NOERR) goto 900
        iter%varid = -1
    endif
    do while (iter%dimid >= 0)
        iter%dimid = iter%dimid + 1
        ! --- 指定番号の次元がなければエラー ---
        stat = NF_INQ_DIMNAME(iter%fileid, iter%dimid, varname)
        if (stat /= NF_NOERR) exit
        ! --- 指定番号の次元と同名の変数があれば却下、次番号へ ---
        stat = NF_INQ_VARID(iter%fileid, varname, varid_tmp)
        if (stat /= NF_NOERR) goto 900
    enddo
    end = .TRUE.
    url = ""
    call ANFileClose(iter%fileid)
    iter%dimid = -1
    call endsub('anvarsearchnext', "end file %d", i=(/iter%fileid/))
    return

900 continue
    call inquire(iter%fileid, name=filename)
    url = UrlMerge(file=trim(filename), var=trim(varname))
    end = .FALSE.
    call endsub('anvarsearchnext', "file=%d url=<%c>", &
        & i=(/iter%fileid/), c1=trim(url))
    return
end subroutine

! Copyright (C) GFD-Dennou Club, 2001.  All rights reserved.

module gt_mem
    !
    ! いわゆるメモリ変数サポート (いまのところ１次元だけ)

    use dc_types, only: string, token

    implicit none

    type attr_chain
        type(attr_chain), pointer:: next
        character(token):: name
        character, pointer:: cbuf(:)
    end type

    type MEM_VARIABLE_ENTRY
        character(token):: name
        character(token):: xtype
        double precision, pointer:: dbuf(:)
        type(attr_chain), pointer:: attr
        type(attr_chain), pointer:: current
    end type

    type MEM_VARIABLE
        integer:: id
    end type

    type(mem_variable_entry), allocatable, save, target:: memtab(:)
    private:: memtab

    interface Create
        module procedure MemCreateD
    end interface

    interface Close
        module procedure MemClose
    end interface

    interface Attr_Rewind
        module procedure MemAttrRewind
    end interface

    interface attr_next
        module procedure MemAttrNext
    end interface

    interface attr_true
        module procedure MemAttrTrue
    end interface

    interface del_attr
        module procedure MemAttrDel
    end interface

    interface put_attr
        module procedure memattradd_v
        module procedure memattradd
    end interface

    interface get_attr
        module procedure MemAttrGet
        module procedure MemAttrGetV
    end interface

    private:: memtab_add, memtab_lookup

contains

    integer function memtab_add(var, name) result(stat)
        use dc_error, only: gt_enomem
        type(mem_variable), intent(out):: var
        character(len = *), intent(in):: name
        type(mem_variable_entry), allocatable:: tmptab(:)
        integer:: i, n

        if (.not. allocated(memtab)) then
            allocate(memtab(16), stat=stat)
            if (stat /= 0) then
                stat = gt_enomem
                return
            endif
            do, i = 1, size(memtab)
                memtab(i)%name = ""
                memtab(i)%xtype = ""
                nullify(memtab(i)%dbuf)
                nullify(memtab(i)%attr, memtab(i)%current)
            enddo
        endif
        do, i = 1, size(memtab)
            if (memtab(i)%name == "") then
                stat = 0
                var = mem_variable(i)
                memtab(i)%name = name
                return
            endif
        end do

        n = size(memtab)
        allocate(tmptab(n), stat=stat)
        if (stat /= 0) then
            stat = gt_enomem
            return
        endif
        tmptab(:) = memtab(:)
        deallocate(memtab)
        allocate(memtab(n * 2), stat=stat)
        if (stat /= 0) then
            stat = gt_enomem
            return
        endif
        memtab(1:n) = tmptab(1:n)
        deallocate(tmptab)
        do, i = n + 1, n * 2
            memtab(i)%name = ""
            nullify(memtab(i)%dbuf)
            nullify(memtab(i)%attr, memtab(i)%current)
        enddo

        i = n + 1
        var = mem_variable(i)
        memtab(i)%name = name
    end function

    subroutine memcreated(var, url, length, xtype, long_name, overwrite, err)
        use dc_error
        type(MEM_VARIABLE), intent(out):: var
        character(*), intent(in):: url
        integer, intent(in):: length
        character(*), intent(in), optional:: xtype, long_name
        logical, intent(in), optional:: overwrite
        logical, intent(out), optional:: err
        type(mem_variable_entry), pointer:: ent
        integer:: stat
    continue
        stat = memtab_add(var, url)
        if (stat /= 0) then
            if (present(err)) err = .true.
            return
        endif
        ent => memtab(var%id)
        if (present(xtype)) then
            ent%xtype = xtype
        else
            ent%xtype = "real"
        endif
        allocate(ent%dbuf(length))
        nullify(ent%attr, ent%current)
        if (present(long_name)) call memattradd(var, "long_name", long_name)
        if (present(err)) err = .false.
    end subroutine

    integer function memtab_lookup(var, ent) result(stat)
        use netcdf_f77, only: nf_enotvar, nf_noerr
        type(mem_variable), intent(in):: var
        type(mem_variable_entry), pointer:: ent
        if (.not. allocated(memtab)) goto 999
        if (var%id <= 0 .or. var%id > size(memtab)) goto 999
        if (memtab(var%id)%name == "") goto 999
        ent => memtab(var%id)
        stat = 0
    999 continue
        nullify(ent)
        stat = nf_enotvar
    end function

    subroutine memclose(var)
        type(mem_variable), intent(in):: var
        type(mem_variable_entry), pointer:: ent
        if (memtab_lookup(var, ent) /= 0) return
        deallocate(ent%dbuf)
        if (associated(ent%attr)) deallocate(ent%attr)
        if (associated(ent%current)) deallocate(ent%current)
        ent%name = ""
    end subroutine

    subroutine MemAttrGet(var, name, value, err)
        use dc_error
        use netcdf_f77, only: nf_enotatt, nf_noerr
        type(mem_variable), intent(in):: var
        character(len = *), intent(in):: name
        character(len = *), intent(out):: value
        logical, intent(out), optional:: err
        type(mem_variable_entry), pointer:: ent
        type(attr_chain), pointer:: p
        integer:: i, stat
        stat = memtab_lookup(var, ent)
        if (stat == nf_noerr) then
            if (associated(ent%current)) then
                p => ent%current
                if (p%name == name) goto 100
            endif
            p => ent%attr
            do, while (associated(p))
                if (p%name == name) goto 100
                p => p%next
            enddo
            stat = nf_enotatt
        endif
        call StoreError(stat, "MemAttrGet", err, cause_c=name)
        return

        100 continue
        if (associated(p%cbuf)) then
            do, i = 1, len(value)
                value(i:i) = p%cbuf(i)
            enddo
        else
            value = ""
        endif

    end subroutine

    subroutine MemAttrGetV(var, name, value, err)
        use dc_error
        use dc_string, only: vstring, assignment(=), operator(==), len
        use netcdf_f77, only: nf_enotatt, nf_noerr
        type(mem_variable), intent(in):: var
        character(len = *), intent(in):: name
        type(vstring), intent(out):: value
        logical, intent(out), optional:: err
        type(mem_variable_entry), pointer:: ent
        type(attr_chain), pointer:: p
        integer:: i, stat
        stat = memtab_lookup(var, ent)
        if (stat == nf_noerr) then
            if (associated(ent%current)) then
                if (ent%current%name == name) then
                    p => ent%current
                    goto 100
                endif
            endif
            p => ent%attr
            do, while (associated(p))
                if (p%name == name) goto 100
                p => p%next
            enddo
            stat = nf_enotatt
        endif
        call StoreError(stat, "MemAttrGet", err, cause_c=name)
        return

        100 continue
        if (associated(p%cbuf)) then
            do, i = 1, len(value)
                value = p%cbuf(:)
            enddo
        else
            value = ""
        endif
        call StoreError(nf_noerr, "MemAttrGet", err)
        return

    end subroutine

    subroutine MemAttrDel(var, name, err)
        use dc_error
        use dc_string, only: operator(==)
        use netcdf_f77, only: NF_ENOTATT, nf_noerr
        type(MEM_VARIABLE), intent(in):: var
        character(len = *), intent(in):: name
        logical, intent(out), optional:: err
        type(mem_variable_entry), pointer:: ent
        type(attr_chain), pointer:: p, prev
        integer:: stat
        stat = memtab_lookup(var, ent)
        if (stat /= nf_noerr) goto 999
        nullify(prev)
        p => ent%attr
        do, while (associated(p))
            if (p%name == name) then
                if (associated(p%cbuf)) deallocate(p%cbuf)
                prev%next => p%next
                deallocate(p)
                call StoreError(nf_noerr, "MemAttrDel", err)
                return
            endif
            prev => p
            p => p%next
        enddo
        stat = nf_enotatt
    999 continue
        call StoreError(stat, "MemAttrDel", err, cause_c=name)
    end subroutine

    logical function MemAttrTrue(var, name, default) result(result)
        use dc_string, only: str_to_logical
        use netcdf_f77, only: nf_noerr
        type(MEM_VARIABLE), intent(in):: var
        character(len = *), intent(in):: name
        logical, intent(in), optional:: default
        type(mem_variable_entry), pointer:: ent
        type(attr_chain), pointer:: p
        character(10):: s
        integer:: stat, i

        stat = memtab_lookup(var, ent)
        if (stat /= nf_noerr) goto 999
        p => ent%attr
        do, while (associated(p))
            if (p%name == name) then
                if (associated(p%cbuf)) then
                    s = ""
                    do, i = 1, min(len(s), size(p%cbuf))
                        s(i:i) = p%cbuf(i)
                    enddo
                    result = str_to_logical(s)
                else
                    exit
                endif
                return
            endif
            p => p%next
        enddo
    999 continue
        result = .false.
        if (present(default)) result = default
        return
    end function

    subroutine memAttrRewind(var)
        use netcdf_f77, only: nf_noerr
        type(MEM_VARIABLE), intent(in):: var
        type(mem_variable_entry), pointer:: ent

        if (memtab_lookup(var, ent) /= nf_noerr) return
        nullify(ent%current)
    end subroutine

    subroutine memAttrNext(var, name, err)
        use dc_string
        use netcdf_f77, only: nf_noerr
        type(MEM_VARIABLE), intent(in):: var
        character(len = *), intent(out):: name
        logical, intent(out), optional:: err
        type(mem_variable_entry), pointer:: ent

        if (memtab_lookup(var, ent) /= nf_noerr) goto 999
        if (.not. associated(ent%current)) then
            ent%current => ent%attr
        else
            ent%current => ent%current%next
        endif
        if (.not. associated(ent%current)) goto 999
        name = ent%current%name
        if (present(err)) err = .false.
        return
        !
    999 continue
        if (present(err)) err = .true.
    end subroutine

    subroutine memattradd(var, attrname, attrval)
        use netcdf_f77, only: nf_noerr, nf_enotatt
        type(MEM_VARIABLE), intent(in):: var
        character(*), intent(in):: attrname
        character(*), intent(in):: attrval
        type(mem_variable_entry), pointer:: ent
        type(attr_chain), pointer:: p
        integer:: i, stat

        stat = memtab_lookup(var, ent)
        if (stat == nf_noerr) then
            if (associated(ent%current)) then
                if (ent%current%name == attrname) then
                    p => ent%current
                    goto 100
                endif
            endif
            p => ent%attr
            do, while (associated(p))
                if (p%name == attrname) goto 100
                p => p%next
            enddo
            stat = nf_enotatt
        endif
        allocate(p)
        nullify(p%next)
        goto 120

        100 continue
        if (associated(p%cbuf)) then
            deallocate(p%cbuf)
        endif

        120 continue
        allocate(p%cbuf(len(attrval)))
        do, i = 1, len(attrval)
            p%cbuf(i) = attrval(i:i)
        enddo
        return
    end subroutine

    subroutine memattradd_v(var, attrname, attrval)
        use netcdf_f77, only: nf_noerr, nf_enotatt
        use dc_string
        type(MEM_VARIABLE), intent(in):: var
        character(*), intent(in):: attrname
        type(vstring), intent(in):: attrval
        type(mem_variable_entry), pointer:: ent
        type(attr_chain), pointer:: p
        integer:: stat

        stat = memtab_lookup(var, ent)
        if (stat == nf_noerr) then
            if (associated(ent%current)) then
                if (ent%current%name == attrname) then
                    p => ent%current
                    goto 100
                endif
            endif
            p => ent%attr
            do, while (associated(p))
                if (p%name == attrname) goto 100
                p => p%next
            enddo
            stat = nf_enotatt
        endif
        allocate(p)
        nullify(p%next)
        goto 120

        100 continue
        if (associated(p%cbuf)) then
            deallocate(p%cbuf)
        endif

        120 continue
        allocate(p%cbuf(len(attrval)))
        p%cbuf(:) = attrval
        return
    end subroutine


end module

! gtlinelib.f90 - 線オブジェクトの取り扱い

subroutine GTLineOpen(result, var)
    use gtgraph_types, only: GT_LINE
    use gtgraph_generic, only: Open
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: Open
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_LINE), intent(out):: result
    type(GT_VARIABLE), intent(in):: var
continue
    call beginsub('gtlineopen')
    call Open(result%var, var, 0)
    allocate(result%h_axis, result%v_axis)
    call Open(result%v_axis, var, 0)
    call Open(result%h_axis, var, 1)
    result%index = 1
    result%type = 1
    result%mark = 0
    result%animate = .false.
    call endsub('gtlineopen')
end subroutine

subroutine GtLineClose(Line)
    use gtgraph_types, only: GT_Line
    use gtgraph_generic, only: Close
    use gtdata_generic, only: Close
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_Line), intent(inout):: Line
    call beginsub('gtlineclose')
    call Close(Line%h_axis)
    call Close(Line%v_axis)
    deallocate(Line%h_axis, Line%v_axis)
    call Close(Line%var)
    call endsub('gtlineclose')
end subroutine

subroutine GtLineOption(line, optname, value, err)
    use gtdata_generic, only: slice_next
    use gtgraph_types, only: GT_LINE
    use dc_string, only: StoI, toUpper
    use gt_args, only: GtOptionLineIndex
    use dc_trace, only: beginsub, endsub, message
    use dc_error, only: GT_ENOMOREDIMS, DC_NOERR
    implicit none
    type(GT_LINE), intent(inout):: line
    character(len = *), intent(in):: optname
    character(len = *), intent(in):: value
    character(len = len(optname)):: uc_optname
    character(len = len(value)):: uc_value
    logical, intent(out):: err
    integer:: stat
continue
    call beginsub('gtlineoption', '<%c=%c>', c1=optname, c2=value)
    uc_optname = optname
    uc_value = value
    call toUpper(uc_optname)
    call toUpper(uc_value)
    call GtOptionLineIndex(line%index, uc_optname, uc_value, err)
    if (.not. err) then
        goto 999
    endif
    if (uc_optname == "-ANIMATE") then
        line%animate = .true.
        err = .FALSE.
    else if (uc_optname == "-NEXT") then
        if (line%animate) then
            call slice_next(line%var, stat=stat)
            err = (stat /= DC_NOERR)
            call message('line next okay=%y stat=%d', L=(/.not. err/), i=(/stat/))
        else
            err = .TRUE.
        endif
    else if (uc_optname == "TYPE") then
        select case(uc_value)
        case("SOLID")
            line%type = 1
        case("DASH", "DASHED")
            line%type = 2
        case("DOT", "DOTTED")
            line%type = 3
        case("DOTDASHED")
            line%type = 4
        case default
            line%type = stoi(value)
        end select
        err = .FALSE.
    else if (uc_optname == "MARK") then
        if (index("0123456789", uc_value(1:1)) >= 1) then
            line%mark = stoi(value)
        else
            line%mark = iachar(value(1:1))
        endif
        err = .FALSE.
    endif
999 continue
    call endsub('gtlineoption', 'err=%y', L=(/err/))
end subroutine

subroutine GTFigBindLine(fig, line)
    use gtgraph_types, only: GT_FIGURE, GT_LINE
    use gtdata_generic, only: get_attr, inquire
    use gtgraph_generic, only: close, operator(.equivalent.)
    use dc_types, only: STRING
    use dc_error
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_FIGURE), intent(inout):: fig
    type(GT_LINE), intent(in):: line
    type(GT_LINE), pointer:: newlines(:)
    character(STRING):: title
    integer:: nlines, stat
    real:: h_lower, h_upper, v_lower, v_upper
    
    call beginsub('gtfigbindline')
    stat = GT_EFAKE
    if (associated(fig%h_axis) .or. associated(fig%v_axis)) then
        if (.not. associated(fig%h_axis)) goto 999
        if (.not. associated(fig%v_axis)) goto 999
        if (.not. (fig%h_axis .equivalent. line%h_axis)) goto 999
        if (.not. (fig%v_axis .equivalent. line%v_axis)) goto 999
        h_lower = min(line%h_axis%lower, fig%h_axis%lower)
        v_lower = min(line%v_axis%lower, fig%v_axis%lower)
        h_upper = max(line%h_axis%upper, fig%h_axis%upper)
        v_upper = max(line%v_axis%upper, fig%v_axis%upper)
        fig%h_axis => line%h_axis
        fig%v_axis => line%v_axis
        fig%h_axis%lower = h_lower
        fig%h_axis%upper = h_upper
        fig%v_axis%lower = v_lower
        fig%v_axis%upper = v_upper
    else
        fig%h_axis => line%h_axis
        fig%v_axis => line%v_axis
    endif
    !
    call get_attr(line%var, 'long_name', title)
    if (title == '') call Inquire(line%var, name=title)
    if (fig%title == "untitled") then
        fig%title = title
    else
        fig%title = trim(fig%title) // ", " // title
    endif
    if (line%animate) fig%animate = .true.
    !
    if (associated(fig%line)) then
        nlines = size(fig%line)
        allocate(newlines(nlines + 1))
        newlines(1: nlines) = fig%line(1: nlines)
        deallocate(fig%line)
    else
        nlines = 0
        allocate(newlines(1))
    endif
    newlines(nlines + 1) = line
    fig%line => newlines
    stat = 0
    999 continue
    call endsub('gtfigbindline')
    call StoreError(stat, 'GTFigPutLine')
end subroutine

subroutine GTLineDraw(line, parent)
    use gtgraph_types, only: GT_LINE, GT_FIGURE
    use gtgraph_generic, only: Draw
    use gtdata_generic, only: Get
    use dc_trace, only: beginsub, endsub
    use dcl
    implicit none
    type(GT_LINE), intent(inout):: line
    type(GT_FIGURE), intent(in):: parent
    real, pointer:: value(:)
    real, pointer:: abscissa(:)
    call beginsub('gtlinedraw')
    call Get(line%var, value)
    call Get(line%h_axis%var, abscissa)
    ! 線グラフの描画
    if (line%index /= 0) then
        call DclDrawLine(abscissa, value, index=line%index, type=line%type)
    endif
    if (line%mark /= 0) then
        call DclDrawMarker(abscissa, value, index=line%index, type=line%mark)
    endif
    deallocate(abscissa, value)
    call endsub('gtlinedraw')
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

subroutine ANVarPutAttrInt(var, name, value, err)
    use an_types, only: AN_VARIABLE, AN_VARIABLE_ENTRY
    use an_file, only: ANFileDefineMode
    use an_vartable, only: vtable_lookup
    use netcdf_f77, only: NF_PUT_ATT_INT, NF_NOERR, NF_DEL_ATT, &
        NF_ENOTINDEFINE, NF_INT, NF_GLOBAL
    use dc_url, only: GT_PLUS
    use dc_error
    implicit none
    type(AN_VARIABLE), intent(in):: var
    character(len = *), intent(in):: name
    type(an_variable_entry):: ent
    integer, intent(in):: value(:)
    logical, intent(out), optional:: err
    integer:: stat
continue
    stat = vtable_lookup(var, ent)
    if (stat /= NF_NOERR) goto 999
    if (size(value) == 0) then
        if (name(1:1) == GT_PLUS) then
            stat = nf_del_att(ent%fileid, NF_GLOBAL, name=name(2:))
        else
            stat = nf_del_att(ent%fileid, ent%varid, name=name)
        endif
        goto 999
    endif
    stat = ANFileDefineMode(ent%fileid)
    if (stat /= NF_NOERR) goto 999
    if (name(1:1) == GT_PLUS) then
        stat = nf_put_att_int(ent%fileid, NF_GLOBAL, name=name(2:), &
            xtype=NF_INT, len=size(value), ivals=value)
    else
        stat = nf_put_att_int(ent%fileid, ent%varid, name=name, &
            xtype=NF_INT, len=size(value), ivals=value)
    endif
    999 continue
    call StoreError(stat, 'ANVarPutAttrInt', err)
end subroutine

! Copyright (C) GFD Dennou Club, 2001.  All rights reserved.

subroutine GTVarLimit_iiii(var, dimord, start, count, stride, err)
    use gtdata_types, only: gt_variable
    use gt_map, only: map_lookup, gt_dimmap, dimrange, map_set
    use dc_error, only: dc_noerr, nf_einval, storeerror
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(gt_variable), intent(in):: var
    integer, intent(in):: dimord, start, count, stride
    logical, intent(out), optional:: err
    type(gt_dimmap), allocatable:: map(:)
    integer:: iolo, iohi, uilo, uihi, lowerlim, upperlim, dimlo, dimhi
    integer:: ndims, stat

    stat = nf_einval
    call beginsub('gtvarlimit_iiii', &
        & 'var%d-dim%d start=%d count=%d stride=%d', &
        & i=(/var%mapid, dimord, start, count, stride/))
    ! エラーチェック
    if (dimord < 1) goto 999
    if (stride == 0) goto 999
    call map_lookup(var, ndims=ndims)
    if (ndims <= 0) goto 999
    if (dimord > ndims) goto 999
    allocate(map(ndims))
    call map_lookup(var, map=map)
    ! (/lowerlim, upperlim/) は内部格子の範囲 (降順可)
    lowerlim = min(start, start + (count - 1) * stride)
    upperlim = max(start, start + (count - 1) * stride)
    call dimrange(var, dimord, dimlo, dimhi)
    if (lowerlim < dimlo) goto 999
    if (upperlim > dimhi) goto 999

    call message('@ lowerlim=%d upperlim=%d', i=(/lowerlim, upperlim/))

    ! 入出力範囲を内部格子番号に変えておく
    uilo = map(dimord)%start
    iolo = 1 + map(dimord)%step * (uilo - 1) + map(dimord)%offset
    uihi = map(dimord)%start + (map(dimord)%count - 1) * map(dimord)%stride
    iohi = 1 + map(dimord)%step * (uihi - 1) + map(dimord)%offset

    call message('@ userindex=%d %d, internal=%d %d', &
        & i=(/uilo, uihi, iolo, iohi/))
    call message('@ message offset %d -> %d step=%d', &
        & i=(/map(dimord)%offset, (start-1), stride/))

    ! 制限を課す。offset が変わればユーザ格子番号の意味が変わる
    map(dimord)%offset = start - 1
    map(dimord)%allcount = count
    map(dimord)%step = stride

    ! 入出力範囲を内部格子番号からユーザ格子番号に戻す
    uilo = 1 + (iolo - 1 - map(dimord)%offset) / map(dimord)%step
    uihi = 1 + (iohi - 1 - map(dimord)%offset) / map(dimord)%step
    call message('@ userindex=%d %d', i=(/uilo, uihi/))

    ! それぞれは制限 [1 .. allcount] の中になければならない
    uilo = max(1, min(map(dimord)%allcount, uilo))
    uihi = max(1, min(map(dimord)%allcount, uihi))

    call message('@ userindex=%d %d orig_stride=%d', &
        & i=(/uilo, uihi, map(dimord)%stride/))

    ! 元のストライドの符号は無視し、正に固定する
    map(dimord)%stride = max(1, abs(map(dimord)%stride))
    map(dimord)%start = min(uilo, uihi)
    map(dimord)%count = 1 + abs(uihi - uilo) / map(dimord)%stride

    call map_set(var, map, stat)
    if (stat /= 0) call message("map_set fail")

999 continue
    call storeerror(stat, 'gtvarlimit_iiii', err)
    call endsub('gtvarlimit_iiii')
end subroutine

! 変数 var に string によるマップ操作を行う。
! string はコンマで区切られた変換指定の列である。
! 変換指定は領域設定と次元順序変換のどちらかである。
! 領域設定は英数字で始まるもので、<dim>=<lower>, <dim>=<lower>:<upper>,
!   <dim>=<lower>:<upper>:<stride> のような形式である。
!   ここで、dim は次元番号または次元名であり、<lower>, <upper>
!   は ^ を前置した座標即値または格子番号である。
!   <stride> は格子数である。
! (未実装) 次元順序変換は = で始まるもので、
!   IGN:<dim>=<pos>
! の形態をとる。

subroutine GTVarLimit(var, string, err)
    use gtdata_types, only: gt_variable
    use dc_trace, only: beginsub, endsub
    use dc_url, only: gt_comma
    use gt_map, only: gtvar_dump
    type(gt_variable), intent(in):: var
    character(len = *), intent(in):: string
    logical, intent(out), optional:: err
    integer:: is, ie
continue
    call beginsub('gtvarlimit', 'var=%d lim=<%c>', i=(/var%mapid/), c1=string)
    call gtvar_dump(var)
    ! コンマで区切って解釈
    is = 1
    do
        ie = index(string(is: ), gt_comma)
        if (ie == 0) exit
        call limit_one(string(is: is+ie-2))
        is = is + ie
        if (is > len(string)) exit
    enddo
    call limit_one(string(is: ))
    if (present(err)) err = .false.
    call endsub('gtvarlimit')
    return
contains

    subroutine limit_one(string)
        use dc_url, only: gt_equal
        use dc_string, only: strieq, stoi
        use gtdata_generic, only: del_dim, dimname_to_dimord
        character(len = *), intent(in):: string
        integer:: equal, dimord
        integer:: start, count, stride
        logical:: myerr

        if (string == '') return

        if (strieq(string(1:4), "IGN:")) then
            ! 隠蔽型指定子 ign:<dim> または ign:<dim>=<start>
            equal = index(string, gt_equal)
            if (equal == 0) then
                start = 1
            else
                start = stoi(string(equal+1: ), default=1)
            endif
            dimord = dimname_to_dimord(var, string(5: equal-1))
            call gtvarlimit_iiii(var, dimord, start, 1, 1, err)
            call del_dim(var, dimord, myerr)
            return
        endif

        ! 限定型指定子 <dim>=<start>:<finish>:<stride>
        !
        equal = index(string, gt_equal)
        if (equal == 0) return
        dimord = dimname_to_dimord(var, string(1: equal-1))
        if (dimord <= 0) return
        !
        call region_spec(dimord, string(equal+1: ), start, count, stride)
        call gtvarlimit_iiii(var, dimord, start, count, stride, err)
    end subroutine

        !
        ! 範囲指定の = のあとを : で区切ってマップにいれる
        !
    subroutine region_spec(dimord, string, start, count, stride)
        use dc_types, only: token
        use dc_string, only: index_ofs, stoi
        use dc_url, only: gt_circumflex, gt_colon
        use gt_map, only: dimrange
        integer, intent(in):: dimord
        integer, intent(out):: start, count, stride
        character(len = *), intent(in):: string
        integer:: colon, prev_colon, finish, dimlo, dimhi
        character(len = token):: val(3)
    continue
        colon = index(string, gt_colon)
        if (colon == 0) then
            ! コロンがない場合は上下端に同じ値
            val(1) = string(1: )
            val(2) = val(1)
            val(3) = ""
        else
            val(1) = string(1: colon - 1)
            prev_colon = colon
            colon = index_ofs(string, colon + 1, gt_colon)
            if (colon > 0) then
                val(2) = string(prev_colon + 1: colon - 1)
                val(3) = string(colon + 1: )
            else
                val(2) = string(prev_colon + 1: )
                val(3) = ""
            endif
        endif
        if (val(3) == "") val(3) = "^1"

        if (val(1)(1:1) == gt_circumflex) then
            start = stoi(val(1)(2: ))
        else if (val(1) == val(2)) then
            start = nint(value_to_index(dimord, val(1)))
        else
            start = floor(value_to_index(dimord, val(1)))
        endif
        if (val(2) == val(1)) then
            finish = start
        else if (val(2)(1:1) == gt_circumflex) then
            finish = stoi(val(2)(2: ))
        else
            finish = ceiling(value_to_index(dimord, val(2)))
        endif

        call dimrange(var, dimord, dimlo, dimhi)
        start = min(max(dimlo, start), dimhi)
        finish = min(max(dimlo, finish), dimhi)
        count = abs(finish - start) + 1

        if (val(3)(1:1) == gt_circumflex) then
            stride = stoi(val(3)(2: ))
        else
            stride = stoi(val(3))
        endif
        stride = sign(stride, finish - start)
    end subroutine

    real function value_to_index(dimord, value) result(result)
        use gtdata_types, only: gt_variable
        use gtdata_generic, only: get, open, close
        use dc_string, only: stod
        use dc_trace, only: beginsub, endsub, message
        integer, intent(in):: dimord
        character(len = *), intent(in):: value
        type(gt_variable):: axisvar
        real, pointer:: axisval(:)
        real:: val
        integer:: i

        call beginsub('value_to_index', 'var=%d dimord=%d value=%c', &
            & i=(/var%mapid, dimord/), c1=trim(value))

        call Open(axisvar, var, dimord, count_compact=.true.)
        call Get(axisvar, axisval)
        call Close(axisvar)
        if (.not. associated(axisval)) then
            result = -1.0
            return
        else if (size(axisval) < 2) then
            result = 1.0
            goto 900
        endif

        val = stod(value)

        ! call message('value=%f axis=(/%*r/)', r=(/val, axisval(:)/), &
        !    & n=(/size(axisval)/))

        do, i = 1, size(axisval) - 1
            if (axisval(i + 1) == axisval(i)) then
                result = real(i) + 0.5
                goto 900
            endif
            result = i + (val - axisval(i)) / (axisval(i + 1) - axisval(i))
            if (result <= (i + 1)) goto 900
        enddo

    900 continue
        call endsub('value_to_index', '(%c) = %r', &
            & c1=trim(value), r=(/result/))
        deallocate(axisval)
    end function

end subroutine

! gtvarattrtrue.f90 - 論理型属性の入力
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

logical function GTVarAttrTrue(var, name, default) result(result)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: get_attr, an_variable
    use gt_mem, only: Attr_True, memvar_t => mem_variable
    use dc_error
    implicit none
    type(GT_VARIABLE), intent(in):: var
    character(len = *), intent(in):: name
    logical, intent(in), optional:: default
    integer:: class, cid
    call var_class(var, class, cid)
    if (class == vtb_class_netcdf) then
        call Get_Attr(an_variable(cid), name, result, default)
    else if (class == vtb_class_memory) then
        result = Attr_True(memvar_t(cid), name, default)
    else
        call StoreError(GT_ENOTVAR, "GTVarAttrTrue(NO VARIABLE)")
        result = .FALSE.
    endif
end function

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

module gtvarsearch
    use an_types, only: AN_VARIABLE_SEARCH
    type(AN_VARIABLE_SEARCH), save:: an
end module

subroutine GTVarSearchInit(urlBase)
    use an_generic, only: var_search
    use gtvarsearch
    use dc_trace, only: beginsub, endsub
    character(len = *), intent(in):: urlBase
    call beginsub('gtvarsearchinit', 'urlbase=<%c>', c1=trim(urlbase))
    call var_search(an, urlBase=urlBase)
    call endsub('gtvarsearchinit')
end subroutine

subroutine GTVarSearchNext(url, end)
    use an_generic, only: var_search
    use gtvarsearch
    use dc_trace, only: beginsub, endsub
    character(len = *), intent(out):: url
    logical, intent(out):: end
    call beginsub('gtvarsearchnext')
    call var_search(an, url=url, end=end)
    call endsub('gtvarsearchnext', 'url=%c end=%y', c1=trim(url), L=(/end/))
end subroutine

! gtgraph_drawparam.f90 -- 描画パラメターモジュール
! 
! 
module gtgraph_drawparam

  implicit none

 !--------------- FIGURE ---------------
  real :: gt_figure_vxmin=0.2, gt_figure_vxmax=0.8      ! 図割り付け位置(X)
  real :: gt_figure_vymin=0.2, gt_figure_vymax=0.5      ! 図割り付け位置(Y)

  real :: gt_figure_note_vxmin=0.82, gt_figure_note_vxmax=0.90 ! 注記位置(X)
  real :: gt_figure_note_vymin=0.15, gt_figure_note_vymax=0.52 ! 注記位置(Y)
  real :: gt_figure_note_size=0.01                             ! 注記文字高
  integer :: gt_figure_note_index=1                            ! 注記文字線種
  character(1) :: gt_figure_note_position='L'                  ! 注記センタリング
  real :: gt_figure_title_vx=0.2                        ! タイトル割り付け位置
  real :: gt_figure_title_vy=0.55                       ! タイトル割り付け位置
  real :: gt_figure_title_height=0.025                  ! タイトル文字文字高
  integer :: gt_figure_title_index=3                    ! タイトル文字線種
  integer :: gt_figure_title_centering=-1               ! タイトルセンタリング

 !--------------- AXIS ---------------
  real :: gt_axis_label_height1=0.02
  real :: gt_axis_title_height1=0.02

 !--------------- CONTOUR ---------------
  real :: gt_contour_contour_msg_height=0.012

  real :: gt_contour_tonescale_vxloc   = 0.05      ! トーンスケール位置(X)
  real :: gt_contour_tonescale_vyloc   = 0.04      ! トーンスケール位置(Y)
  real :: gt_contour_tonescale_vxwidth = 0.22      ! トーンスケール幅(X)
  real :: gt_contour_tonescale_vywidth = 0.02      ! トーンスケール幅(Y)
  real :: gt_contour_tonescale_labelheit = 0.008 ! トーンラベル文字高
  integer :: gt_contour_tonescale_labelnum = 6  ! トーンスケールラベル数

 !--------------- VECTOR ---------------

 !--------------- LINE ---------------


end module gtgraph_drawparam

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.


subroutine GTVarAttrRewind(var)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: attr_rewind, an_variable
    use gt_mem, only: attr_rewind, mem_variable
    implicit none
    type(GT_VARIABLE), intent(inout), target:: var
    integer:: class, cid
    call var_class(var, class, cid)
    select case(class)
    case(vtb_class_netcdf)
        call attr_rewind(an_variable(cid))
    case(vtb_class_memory)
        call attr_rewind(mem_variable(cid))
    end select
end subroutine

subroutine GTVarAttrNext(var, name, end)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: attr_next, an_variable
    use gt_mem, only: attr_next, mem_variable
    implicit none
    type(GT_VARIABLE), intent(inout), target:: var
    character(len = *), intent(out):: name
    logical, intent(out), optional:: end
    integer:: class, cid
    call var_class(var, class, cid)
    select case(class)
    case(vtb_class_netcdf)
        call attr_next(an_variable(cid), name, end)
    case(vtb_class_memory)
        call attr_next(mem_variable(cid), name, end)
    end select
end subroutine

! Copyright (C) GFD Dennou Club, 2000-2001.  All rights reserved.

SUBROUTINE GTVARGETDOUBLE(VAR, VALUE, NVALUE, ERR)
    USE GTDATA_TYPES, ONLY: GT_VARIABLE
    USE GT_MAP, ONLY: VAR_CLASS, VTB_CLASS_NETCDF, &
        & MAP_TO_INTERNAL_SPECS, GTVAR_DUMP
    USE AN_GENERIC, ONLY: GET, AN_VARIABLE
    USE DC_TRACE, ONLY: BEGINSUB, ENDSUB
    USE DC_ERROR
    IMPLICIT NONE
    TYPE(GT_VARIABLE), INTENT(INOUT):: VAR
    DOUBLE PRECISION, INTENT(OUT):: VALUE(*)
    INTEGER, INTENT(IN):: NVALUE
    LOGICAL, INTENT(OUT), OPTIONAL:: ERR
    INTEGER:: CLASS, CID, STAT
    INTEGER, POINTER:: SPECS(:, :)
    CALL VAR_CLASS(VAR, CLASS, CID)
    CALL BEGINSUB('gtvargetDOUBLE')
    CALL GTVAR_DUMP(VAR)
    CALL MAP_TO_INTERNAL_SPECS(VAR, SPECS)
    IF (CLASS == VTB_CLASS_NETCDF) THEN
        CALL GET(AN_VARIABLE(CID), START=SPECS(:, 1), COUNT=SPECS(:, 2), &
            & STRIDE=SPECS(:, 3), IMAP=SPECS(:, 4), SIZ=NVALUE, VALUE=VALUE, &
            & IOSTAT=STAT)
    ELSE
        STAT = GT_EFAKE
    ENDIF
    IF (ASSOCIATED(SPECS)) DEALLOCATE(SPECS)
    CALL STOREERROR(STAT, "gtvargetDOUBLE", ERR)
    CALL ENDSUB('gtvargetDOUBLE', 'stat=%d', I=(/STAT/))
END SUBROUTINE

! anvaropenbydimord.f90 - open(AN_VARIABLE, AN_VARIABLE, integer)
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved
!
! open(dimvar, var, dimord, [err]) は
! 既に開かれた変数 var の ord 番目の次元にあたる変数を
! 開き dimvar に格納する。
!
subroutine ANVarOpenByDimOrd(var, src_var, dimord, err)
    use an_types, only: AN_VARIABLE, an_variable_entry, an_variable_search
    use an_vartable, only: vtable_lookup, vtable_add
    use an_file
    use netcdf_f77
    use dc_error
    implicit none
    type(AN_VARIABLE), intent(out):: var
    type(AN_VARIABLE), intent(in):: src_var
    integer, intent(in):: dimord
    logical, intent(out), optional:: err
    type(an_variable_entry):: src_ent
    type(an_variable_search):: ent
    character(len = NF_MAX_NAME):: dimname
    integer:: stat
continue
    stat = vtable_lookup(src_var, src_ent)
    if (stat /= NF_NOERR) goto 999
    !
    if (dimord <= 0) then
        !
        ! dimord == 0 の特別扱いは廃止 (gtdata 層でやる)。
        ! (同じハンドルを返すと参照カウントが増えないので多重クローズが
        ! 禁止されてしまい、Open のセマンティクスに不適合なため。)
        !
        var = src_var
        stat = NF_EINVAL
        goto 999
    endif
    if (.not. associated(src_ent%dimids)) then
        stat = GT_ENOMOREDIMS
        goto 999
    else if (dimord > size(src_ent%dimids)) then
        stat = GT_ENOMOREDIMS
        goto 999
    endif
    !
    ! 決定された次元 id を使って変数 id の確定を試みる
    !
    ent%fileid = src_ent%fileid
    ent%dimid = src_ent%dimids(dimord)
    stat = nf_inq_dimname(ent%fileid, ent%dimid, dimname)
    if (stat /= NF_NOERR) goto 999
    stat = nf_inq_varid(ent%fileid, dimname, ent%varid)
    if (stat == NF_ENOTVAR) then
        ! 変数が対応しなければ無視するだけ
        ent%varid = 0
        stat = NF_NOERR
    else if (stat /= NF_NOERR) then
        goto 999
    endif
    !
    ! 成功しそうなので参照カウント値を増やす
    call ANFileReopen(ent%fileid)
    ! 不適合な変数が開かれている場合は vtable_add が変数部を無視する。
    stat = vtable_add(var, ent)
    if (stat /= nf_noerr) then
        call anfileclose(ent%fileid)
        goto 999
    endif
    call StoreError(nf_noerr, 'ANVarOpenByDimOrd', err)
    return

999 continue
    call StoreError(stat, 'ANVarOpenByDimOrd', err, cause_i=dimord)
    return
end subroutine

! Copyright (C) GFD Dennou Club, 2001.  All rights reserved.

    ! dup_dimmap で得たハンドル var の dimord 番目の位置に次元
    ! dimvar を追加する。dimord 番目以降の次元は一つ後ろにずれる。
    ! もし dimord が var の有効次元数より大きければ (有効次元数 + 1)
    ! が与えられたものとみなされる。

subroutine gtvaradddim(var, dimord, dimvar, err)
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: inquire
    use gt_map, only: map_lookup, gt_dimmap, map_set_ndims, map_set
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(GT_VARIABLE), intent(in):: var
    type(GT_VARIABLE), intent(in):: dimvar
    integer, intent(in):: dimord
    logical, intent(out):: err
    type(gt_dimmap), pointer:: map(:)
    type(gt_dimmap):: tmpmap
    integer:: id, nd, ndimsp, stat, vid
    character(*), parameter:: subname = 'gtvaradddim'
continue
    err = .true.
    call beginsub(subname)

    if (dimord < 1) then
        call endsub(subname, "negative dimord=%d invalid", i=(/dimord/))
        return
    endif

    ! dimvar をチェックしマップ設定を tmpmap に保存
    call map_lookup(dimvar, vid=vid, ndims=nd)
    if (vid < 0) then
        call endsub(subname, "dimvar invalid")
        return
    endif
    if (nd <= 0) then
        call endsub(subname, "dimvar nondimensional")
        return
    else if (nd > 1) then
        call endsub(subname, "dimvar multidimensional")
        return
    endif
    allocate(map(nd))
    call map_lookup(dimvar, map=map)
    tmpmap = map(1)
    deallocate(map)

    ! dimord 番目 (ただし ndimsp + 1 を越えない) に挿入する隙間をあける
    call map_lookup(var, ndims=ndimsp)
    if (dimord > ndimsp + 1) then
        id = ndimsp + 1
    else
        id = dimord
    endif
    allocate(map(nd + 1))
    call map_resize(var, nd + 1)
    call map_lookup(var, map=map)
    map(id+1: nd+1) = map(id: nd)

    ! 新しい次元への参照を挿入
    map(id)%dimno = -1
    call inquire(dimvar, url=map(id)%url)
    map(id)%allcount = tmpmap%allcount
    map(id)%offset = tmpmap%offset
    map(id)%step = tmpmap%step
    map(id)%start = tmpmap%start
    map(id)%count = tmpmap%count
    map(id)%stride = tmpmap%stride

    ! 登録
    call map_set(var, map=map, stat=stat)
    if (stat /= 0) goto 999
    call map_set_ndims(var, ndims=ndimsp + 1, stat=stat)

999 continue
    err = (stat /= 0)
    call endsub(subname)
end subroutine

! netcdf_f77.f90 - netCDF original interface module
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved
! ex: set sw=4:

! 2000-01-10 豊田英司        初版

!
! 本モジュール群は netCDF オリジナルの netcdf.inc の代わりに
! 利用すべきものである。netcdf.inc への参照はしていない。
!

module netcdf_f77

    use dc_types, only: NF_KIND_INT1, NF_KIND_INT2

    implicit none

!
! --- symbols ---
!

    !
    ! external netCDF data type ID
    !

    integer, parameter:: NF_BYTE = 1
    integer, parameter:: NF_INT1 = NF_BYTE
    integer, parameter:: NF_CHAR = 2
    integer, parameter:: NF_SHORT = 3
    integer, parameter:: NF_INT2 = NF_SHORT
    integer, parameter:: NF_INT = 4
    integer, parameter:: NF_FLOAT = 5
    integer, parameter:: NF_REAL = NF_FLOAT
    integer, parameter:: NF_DOUBLE = 6

    !
    ! default fill values
    !

    integer, parameter:: NF_FILL_BYTE = -127
    integer, parameter:: NF_FILL_INT1 = NF_FILL_BYTE
    integer, parameter:: NF_FILL_CHAR = 0
    integer, parameter:: NF_FILL_SHORT = -32767
    integer, parameter:: NF_FILL_INT2 = NF_FILL_SHORT
    integer, parameter:: NF_FILL_INT = -2147483647
    real, parameter:: NF_FILL_FLOAT = 9.9692099683868690e+36
    real, parameter:: NF_FILL_REAL = NF_FILL_FLOAT
    double precision, parameter:: &
            & NF_FILL_DOUBLE = 9.9692099683868690e+36

    !
    ! mode flags for opening and creating a netcdf dataset:
    !

    integer, parameter:: NF_NOWRITE = 0
    integer, parameter:: NF_WRITE = 1
    integer, parameter:: NF_CLOBBER = 0
    integer, parameter:: NF_NOCLOBBER = 4
    integer, parameter:: NF_FILL = 0
    integer, parameter:: NF_NOFILL = 256
    integer, parameter:: NF_LOCK = 1024
    integer, parameter:: NF_SHARE = 2048
    integer, parameter:: NF_SIZEHINT_DEFAULT = 0
    integer, parameter:: NF_ALIGN_CHUNK = -1

    !
    ! size argument for defining an unlimited dimension:
    !

    integer, parameter:: NF_UNLIMITED = 0

    !
    ! global attribute id:
    !

    integer, parameter:: NF_GLOBAL = 0

    !
    ! implementation limits:
    !

    integer, parameter:: NF_MAX_DIMS = 100
    integer, parameter:: NF_MAX_ATTRS = 2000
    integer, parameter:: NF_MAX_VARS = 2000
    integer, parameter:: NF_MAX_NAME = 128
    integer, parameter:: NF_MAX_VAR_DIMS = NF_MAX_DIMS

    !
    ! error codes:
    !

    integer, parameter:: NF_NOERR = 0
    integer, parameter:: NF_EBADID = -33
    integer, parameter:: NF_EEXIST = -35
    integer, parameter:: NF_EINVAL = -36
    integer, parameter:: NF_EPERM = -37
    integer, parameter:: NF_ENOTINDEFINE = -38
    integer, parameter:: NF_EINDEFINE = -39
    integer, parameter:: NF_EINVALCOORDS = -40
    integer, parameter:: NF_EMAXDIMS = -41
    integer, parameter:: NF_ENAMEINUSE = -42
    integer, parameter:: NF_ENOTATT = -43
    integer, parameter:: NF_EMAXATTS = -44
    integer, parameter:: NF_EBADTYPE = -45
    integer, parameter:: NF_EBADDIM = -46
    integer, parameter:: NF_EUNLIMPOS = -47
    integer, parameter:: NF_EMAXVARS = -48
    integer, parameter:: NF_ENOTVAR = -49
    integer, parameter:: NF_EGLOBAL = -50
    integer, parameter:: NF_ENOTNC = -51
    integer, parameter:: NF_ESTS = -52
    integer, parameter:: NF_EMAXNAME = -53
    integer, parameter:: NF_EUNLIMIT = -54
    integer, parameter:: NF_ENORECVARS = -55
    integer, parameter:: NF_ECHAR = -56
    integer, parameter:: NF_EEDGE = -57
    integer, parameter:: NF_ESTRIDE = -58
    integer, parameter:: NF_EBADNAME = -59
    integer, parameter:: NF_ERANGE = -60
    integer, parameter:: NF_ENOMEM = -61

    !
    ! error handling modes:
    !

    integer, parameter:: NF_FATAL = 1
    integer, parameter:: NF_VERBOSE = 2

!
! --- interfaces ---
!

    interface

    !
    ! --- 雑多な関数 ---
    !

        ! netCDF ライブラリのバージョンを返す
        !
        function nf_inq_libvers(ncerr)
            character(len=80)::                nf_inq_libvers
            integer, intent(in)::        ncerr
        end function

        ! (ドキュメントされていない関数)
        ! エラーコードが netCDF ではなく C ライブラリによるとき真
        !
        logical function nf_issyserr(ncerr)
            integer, intent(in)::        ncerr
        end function

        ! エラーコードから netCDF のメッセージを返す
        !
        character(len=80) function nf_strerror(ncerr)
            integer, intent(in)::        ncerr
        end function

        ! (ドキュメントされていない関数)
        ! PE の操作らしい
        !
        integer function nf_inq_base_pe(ncid, pe)
            integer, intent(in)::        ncid, pe
        end function

        ! (ドキュメントされていない関数)
        ! PE の操作らしい
        !
        integer function nf_set_base_pe(ncid, pe)
            integer, intent(in)::        ncid, pe
        end function

    !
    ! --- ファイルを作る・開く・閉じる・基礎的操作 ---
    !

        ! ファイルを作成する (開かれた状態となる)
        !
        integer function nf_create(path, cmode, ncid)
            character(len=*), intent(in)::        path
            integer, intent(in)::                cmode
            integer, intent(out)::                ncid
        end function

        ! (ドキュメントされていない関数)
        integer function nf__create(path, cmode, initialsz, &
            & chunksizehint, ncid)
            character(len=*), intent(in)::        path
            integer, intent(in):: cmode, initialsz, chunksizehint
            integer, intent(out)::                ncid
        end function

        ! (ドキュメントされていない関数)
        integer function nf__create_mp(path, cmode, initialsz, &
            & basepe, chunksizehint, ncid)
            character(len=*), intent(in)::        path
            integer, intent(in):: cmode, initialsz, basepe, chunksizehint
            integer, intent(out)::                ncid
        end function

        ! ファイルを開く
        !
        integer function nf_open(path, cmode, ncid)
            character(len=*), intent(in)::        path
            integer, intent(in)::                cmode
            integer, intent(out)::                ncid
        end function

        ! (ドキュメントされていない関数)
        integer function nf__open(path, cmode, initialsz, &
            & chunksizehint, ncid)
            character(len=*), intent(in)::        path
            integer, intent(in):: cmode, initialsz, chunksizehint
            integer, intent(out)::                ncid
        end function

        ! (ドキュメントされていない関数)
        integer function nf__open_mp(path, cmode, initialsz, &
            & basepe, chunksizehint, ncid)
            character(len=*), intent(in)::        path
            integer, intent(in):: cmode, initialsz, basepe, chunksizehint
            integer, intent(out)::                ncid
        end function

        ! fill モードの設定/解除
        integer function nf_set_fill(ncid, fillmode, old_mode)
            integer, intent(in)::        ncid, fillmode
            integer, intent(out)::        old_mode
        end function

        ! 定義モードへの移行
        integer function nf_redef(ncid)
            integer, intent(in)::        ncid
        end function

        ! 定義モードからの脱出
        integer function nf_enddef(ncid)
            integer, intent(in)::        ncid
        end function

        ! 定義モードからの脱出
        ! (ドキュメントされていない関数)
        integer function nf__enddef(ncid, h_minfree, v_align, &
            & v_minfree, r_align)
            integer, intent(in)::        ncid
            integer, intent(in):: h_minfree, v_align, &
                & v_minfree, r_align
        end function

        ! 同期
        integer function nf_sync(ncid)
            integer, intent(in)::        ncid
        end function

        ! 閉じる
        integer function nf_close(ncid)
            integer, intent(in)::        ncid
        end function

        ! 閉じる際に定義モードにある場合に呼ばれる
        ! (ユーザが呼ぶ必要のない関数)
        integer function nf_abort(ncid)
            integer, intent(in)::        ncid
        end function

        ! MP用 ファイルの削除
        ! (ドキュメントされていない関数)
        integer function nf_delete(path)
            character(len=*), intent(in)::        path
        end function

    !
    ! --- ファイルの問い合わせ ---
    !

        ! 開かれたファイル ncid に対しすべての問い合わせを行う
        !
        integer function nf_inq(ncid, ndims, nvars, ngatts, unlimdimid)
            integer, intent(in)::        ncid
            integer, intent(out)::        ndims, nvars, ngatts
            integer, intent(out)::        unlimdimid
        end function

        ! 次元数 ndims を問い合わせる
        integer function nf_inq_ndims(ncid, ndims)
            integer, intent(in)::        ncid
            integer, intent(out)::        ndims
        end function

        ! 変数の数 nvars を問い合わせる
        integer function nf_inq_nvars(ncid, nvars)
            integer, intent(in)::        ncid
            integer, intent(out)::        nvars
        end function

        ! 大域属性の数 ngatts を問い合わせる
        integer function nf_inq_natts(ncid, ngatts)
            integer, intent(in)::        ncid
            integer, intent(out)::        ngatts
        end function

        ! 無制限次元のID unlimdimid を問い合わせる
        ! もしなければ 1 が返る
        integer function nf_inq_unlimdim(ncid, unlimdimid)
            integer, intent(in)::        ncid
            integer, intent(out)::        unlimdimid
        end function

    !
    ! --- 次元に関するルーチン ---
    !

        ! 名称 name, 長さ len を持つ次元を定義する
        ! 割り当てられた次元 ID (正の整数) が dimid に返される
        integer function nf_def_dim(ncid, name, len, dimid)
            integer, intent(in)::                ncid
            character(len=*), intent(in)::        name
            integer, intent(in)::                len
            integer, intent(out)::                dimid
        end function

        ! 名前に対する次元 ID を問い合わせる
        integer function nf_inq_dimid(ncid, name, dimid)
            integer, intent(in)::                ncid
            character(len=*), intent(in)::        name
            integer, intent(out)::                dimid
        end function

        ! 次元 ID から名前 name と長さ len を問い合わせる
        ! name には必要な長さがなければならない
        integer function nf_inq_dim(ncid, dimid, name, len)
            integer, intent(in)::                ncid
            integer, intent(in)::                dimid
            character(len=*), intent(out)::        name
            integer, intent(out)::                len
        end function

        ! 次元 ID から名前 name を問い合わせる
        ! name には必要な長さがなければならない
        integer function nf_inq_dimname(ncid, dimid, name)
            integer, intent(in)::                ncid
            integer, intent(in)::                dimid
            character(len=*), intent(out)::        name
        end function

        ! 次元 ID から長さ len を問い合わせる
        integer function nf_inq_dimlen(ncid, dimid, len)
            integer, intent(in)::                ncid
            integer, intent(in)::                dimid
            integer, intent(out)::                len
        end function

    !
    ! --- 属性 ---
    !
    ! 属性は文字型スカラ変数か、数値型配列である。
    ! 長さとは文字型では長さパラメタ、数値型では配列の大きさである。
    ! 属性は変数 varid に所属するか、大域属性となる。
    ! 大域属性の varid としては NF_GLOBAL を用いる。

        !
        ! --- 属性に関する問い合わせ ---
        !

        ! 変数 varid の属性 name の型 xtype と長さ len の問い合わせ
        integer function nf_inq_att(ncid, varid, name, xtype, len)
            integer, intent(in)::        ncid, varid
            character(len=*), intent(in):: name
            integer, intent(out)::        xtype
            integer, intent(out)::        len
        end function

        ! 変数 varid の属性 name の型 xtype の問い合わせ
        integer function nf_inq_atttype(ncid, varid, name, xtype)
            integer, intent(in)::        ncid, varid
            character(len=*), intent(in):: name
            integer, intent(out)::        xtype
        end function

        ! 変数 varid の属性 name の長さ len の問い合わせ
        integer function nf_inq_attlen(ncid, varid, name, len)
            integer, intent(in)::        ncid, varid
            character(len=*), intent(in):: name
            integer, intent(out)::        len
        end function

        ! 変数 varid の属性 name の番号 attnum の問い合わせ
        integer function nf_inq_attid(ncid, varid, name, attnum)
            integer, intent(in)::        ncid, varid
            character(len=*), intent(in):: name
            integer, intent(out)::        attnum
        end function

        ! 変数 varid の属性 attnum の名前 name の問い合わせ
        ! name には必要な長さがなければならない
        integer function nf_inq_attname(ncid, varid, attnum, name)
            integer, intent(in)::        ncid, varid
            integer, intent(in)::        attnum
            character(len=*), intent(out):: name
        end function

        !
        ! --- 属性の読み書き以外の操作 ---
        !

        integer function nf_copy_att(ncid_in, varid_in, name, &
        & ncid_out, varid_out)
            integer, intent(in)::                ncid_in, varid_in
            character(len=*), intent(in)::        name
            integer, intent(in)::                ncid_out, varid_out
        end function

        integer function nf_rename_att(ncid, varid, curname, newname)
            integer, intent(in)::                ncid, varid
            character(len=*), intent(in)::        curname
            character(len=*), intent(in)::        newname
        end function

        integer function nf_del_att(ncid, varid, name)
            integer, intent(in)::                ncid, varid
            character(len=*), intent(in)::        name
        end function

        !
        ! --- 属性の設定 ---
        !

        integer function nf_put_att_text(ncid, varid, name, len, text)
            integer, intent(in)::                ncid, varid
            character(len=*), intent(in)::        name
            integer, intent(in)::                len
            character(len=*), intent(in)::        text
        end function

        integer function nf_put_att_int1(ncid, varid, name, &
        & xtype, len, i1vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            character(len=*), intent(in)::        name
            integer, intent(in)::                xtype, len
            integer(NF_KIND_INT1), intent(in):: i1vals(*)
        end function

        integer function nf_put_att_int2(ncid, varid, name, &
        & xtype, len, i2vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            character(len=*), intent(in)::        name
            integer, intent(in)::                xtype, len
            integer(NF_KIND_INT2), intent(in):: i2vals(*)
        end function

        integer function nf_put_att_int(ncid, varid, name, &
        & xtype, len, ivals)
            integer, intent(in)::                ncid, varid
            character(len=*), intent(in)::        name
            integer, intent(in)::                xtype, len
            integer, intent(in)::                ivals(*)
        end function

        integer function nf_put_att_real(ncid, varid, name, &
        & xtype, len, rvals)
            integer, intent(in)::                ncid, varid
            character(len=*), intent(in)::        name
            integer, intent(in)::                xtype, len
            real, intent(in)::                        rvals(*)
        end function

        integer function nf_put_att_double(ncid, varid, name, &
        & xtype, len, dvals)
            integer, intent(in)::                ncid, varid
            character(len=*), intent(in)::        name
            integer, intent(in)::                xtype, len
            double precision, intent(in)::        dvals(*)
        end function

        !
        ! --- 属性の読み取り ---
        !

        integer function nf_get_att_text(ncid, varid, name, text)
            integer, intent(in)::                ncid, varid
            character(len=*), intent(in)::        name
            character(len=*), intent(out)::        text
        end function

        integer function nf_get_att_int1(ncid, varid, name, i1vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            character(len=*), intent(in)::        name
            integer(NF_KIND_INT1), intent(in):: i1vals(*)
        end function

        integer function nf_get_att_int2(ncid, varid, name, i2vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            character(len=*), intent(in)::        name
            integer(NF_KIND_INT2), intent(in):: i2vals(*)
        end function

        integer function nf_get_att_int(ncid, varid, name, ivals)
            integer, intent(in)::                ncid, varid
            character(len=*), intent(in)::        name
            integer, intent(in)::                ivals(*)
        end function

        integer function nf_get_att_real(ncid, varid, name, rvals)
            integer, intent(in)::                ncid, varid
            character(len=*), intent(in)::        name
            real, intent(in)::                        rvals(*)
        end function

        integer function nf_get_att_double(ncid, varid, name, dvals)
            integer, intent(in)::                ncid, varid
            character(len=*), intent(in)::        name
            double precision, intent(in)::        dvals(*)
        end function

    !
    ! --- 変数 ---
    !
    ! 変数は次元によってきまる配列である。
    ! 定義した次元すべてを使わなくてはいけないわけではない。
    !

        ! 名前 name の変数を定義する。
        ! データ型 xtype, 次元数 ndims とし,
        ! 各次元の ID は dimids で与える。
        ! 変数 ID は varid に返される。
        integer function nf_def_var(ncid, name, &
        & xtype, ndims, dimids, varid)
            integer, intent(in)::                ncid
            character(len=*), intent(in)::        name
            integer, intent(in)::                xtype, ndims
            integer, intent(in)::                dimids(*)
            integer, intent(out)::                varid
        end function

        !
        ! --- 変数に関する問い合わせ ---
        !

        ! 変数名 name から ID varid を知る
        integer function nf_inq_varid(ncid, name, varid)
            integer, intent(in)::                ncid
            character(len=*), intent(in)::        name
            integer, intent(out)::                varid
        end function

        ! 変数 varid から何でも問いあわせ (以下の関数参照)
        ! dimids は必要な大きさがなければならない
        integer function nf_inq_var(ncid, varid, &
        & name, xtype, ndims, dimids, natts)
            integer, intent(in)::                ncid, varid
            character(len=*), intent(out)::        name
            integer, intent(out)::                xtype, ndims, natts 
            integer, intent(out)::                dimids(*)
        end function

        ! 変数 varid から変数名 name を知る
        ! name には必要な長さがなければならない
        integer function nf_inq_varname(ncid, varid, name)
            integer, intent(in)::                ncid, varid
            character(len=*), intent(out)::        name
        end function

        ! 変数 varid から型 xtype を知る
        integer function nf_inq_vartype(ncid, varid, xtype)
            integer, intent(in)::                ncid, varid
            integer, intent(out)::                xtype
        end function

        ! 変数 varid から次元数 ndims を知る
        integer function nf_inq_varndims(ncid, varid, ndims)
            integer, intent(in)::                ncid, varid
            integer, intent(out)::                ndims
        end function

        ! 変数 varid から次元ID 配列 dimids を得る
        integer function nf_inq_vardimid(ncid, varid, dimids)
            integer, intent(in)::                ncid, varid
            integer, intent(out)::                dimids(*)
        end function

        ! 変数 varid から属性数 natts を知る
        integer function nf_inq_varnatts(ncid, varid, natts)
            integer, intent(in)::                ncid, varid
            integer, intent(out)::                natts
        end function

        !
        ! --- 変数に関する読み書き以外の操作 ---
        !

        ! 変数 varid を name に改名する
        integer function nf_rename_var(ncid, varid, name)
            integer, intent(in)::                ncid, varid
            character(len=*), intent(in)::        name
        end function

        ! 変数 varid を別の netCDF データセット ncid_out にコピーする
        integer function nf_copy_var(ncid, varid, ncid_out)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                ncid_out
        end function

    !
    ! --- 変数の書き込み ---
    !

        !
        ! 変数の単要素書き込み
        !

        integer function nf_put_var1_text(ncid, varid, index, chval)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                index(*)
            character, intent(in)::                chval
        end function

        integer function nf_put_var1_int1(ncid, varid, index, i1val)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                index(*)
            integer(NF_KIND_INT1), intent(in):: i1val
        end function

        integer function nf_put_var1_int2(ncid, varid, index, i2val)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                index(*)
            integer(NF_KIND_INT2), intent(in):: i2val
        end function

        integer function nf_put_var1_int(ncid, varid, index, ival)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                index(*)
            integer, intent(in)::                 ival
        end function

        integer function nf_put_var1_real(ncid, varid, index, rval)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                index(*)
            real, intent(in)::                         rval
        end function

        integer function nf_put_var1_double(ncid, varid, index, dval)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                index(*)
            double precision, intent(in)::         dval
        end function

        !
        ! 変数の全体書き込み
        !

        integer function nf_put_var_text(ncid, varid, text)
            integer, intent(in)::                ncid, varid
            character(len=*), intent(in)::        text
        end function

        integer function nf_put_var_int1(ncid, varid, i1vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer(NF_KIND_INT1), intent(in):: i1vals(*)
        end function

        integer function nf_put_var_int2(ncid, varid, i2vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer(NF_KIND_INT2), intent(in):: i2vals(*)
        end function

        integer function nf_put_var_int(ncid, varid, ivals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                 ivals(*)
        end function

        integer function nf_put_var_real(ncid, varid, rvals)
            integer, intent(in)::                ncid, varid
            real, intent(in)::                         rvals(*)
        end function

        integer function nf_put_var_double(ncid, varid, dvals)
            integer, intent(in)::                ncid, varid
            double precision, intent(in)::         dvals(*)
        end function

        !
        ! 変数の部分配列書き込み
        !

        integer function nf_put_vara_text(ncid, varid, &
        & start, count, text)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            character(len=*), intent(in)::        text
        end function

        integer function nf_put_vara_int1(ncid, varid, &
        & start, count, i1vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer(NF_KIND_INT1), intent(in):: i1vals(*)
        end function

        integer function nf_put_vara_int2(ncid, varid, &
        & start, count, i2vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer(NF_KIND_INT2), intent(in):: i2vals(*)
        end function

        integer function nf_put_vara_int(ncid, varid, &
        & start, count, ivals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                 ivals(*)
        end function

        integer function nf_put_vara_real(ncid, varid, &
        & start, count, rvals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            real, intent(in)::                         rvals(*)
        end function

        integer function nf_put_vara_double(ncid, varid, &
        start, count, dvals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            double precision, intent(in)::         dvals(*)
        end function

        !
        ! 変数の標本配列書き込み
        !
        ! 各次元ごとに標本間隔 stride(i) ごとに書き込み点を選ぶ
        !

        integer function nf_put_vars_text(ncid, varid, &
        & start, count, stride, text)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*)
            character(len=*), intent(in)::        text
        end function

        integer function nf_put_vars_int1(ncid, varid, &
        & start, count, stride, i1vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*)
            integer(NF_KIND_INT1), intent(in):: i1vals(*)
        end function

        integer function nf_put_vars_int2(ncid, varid, &
        & start, count, stride, i2vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*)
            integer(NF_KIND_INT2), intent(in):: i2vals(*)
        end function

        integer function nf_put_vars_int(ncid, varid, &
        & start, count, stride, ivals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*)
            integer, intent(in)::                 ivals(*)
        end function

        integer function nf_put_vars_real(ncid, varid, &
        & start, count, stride, rvals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*)
            real, intent(in)::                         rvals(*)
        end function

        integer function nf_put_vars_double(ncid, varid, &
        & start, count, stride, dvals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*)
            double precision, intent(in)::         dvals(*)
        end function

        !
        ! 変数の写像配列書き込み
        !
        ! 標本配列書き込み機能に加え次元を並べ替える機能が付く
        !

        integer function nf_put_varm_text(ncid, varid, &
        & start, count, stride, imap, text)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*), imap(*)
            character(len=*), intent(in)::        text
        end function

        integer function nf_put_varm_int1(ncid, varid, &
        & start, count, stride, imap, i1vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*), imap(*)
            integer(NF_KIND_INT1), intent(in):: i1vals(*)
        end function

        integer function nf_put_varm_int2(ncid, varid, &
        & start, count, stride, imap, i2vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*), imap(*)
            integer(NF_KIND_INT2), intent(in):: i2vals(*)
        end function

        integer function nf_put_varm_int(ncid, varid, &
        & start, count, stride, imap, ivals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*), imap(*)
            integer, intent(in)::                 ivals(*)
        end function

        integer function nf_put_varm_real(ncid, varid, &
        & start, count, stride, imap, rvals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*), imap(*)
            real, intent(in)::                         rvals(*)
        end function

        integer function nf_put_varm_double(ncid, varid, &
        & start, count, stride, imap, dvals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*), imap(*)
            double precision, intent(in)::         dvals(*)
        end function


    !
    ! --- 変数の読み取り ---
    !

        !
        ! 変数の単要素読み取り
        !

        integer function nf_get_var1_text(ncid, varid, index, chval)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                index(*)
            character, intent(out)::                chval
        end function

        integer function nf_get_var1_int1(ncid, varid, index, i1val)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                index(*)
            integer(NF_KIND_INT1), intent(out):: i1val
        end function

        integer function nf_get_var1_int2(ncid, varid, index, i2val)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                index(*)
            integer(NF_KIND_INT2), intent(out):: i2val
        end function

        integer function nf_get_var1_int(ncid, varid, index, ival)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                index(*)
            integer, intent(out)::                 ival
        end function

        integer function nf_get_var1_real(ncid, varid, index, rval)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                index(*)
            real, intent(out)::                 rval
        end function

        integer function nf_get_var1_double(ncid, varid, index, dval)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                index(*)
            double precision, intent(out)::         dval
        end function

        !
        ! 変数の全体読み取り
        !

        integer function nf_get_var_text(ncid, varid, text)
            integer, intent(in)::                ncid, varid
            character(len=*), intent(out)::        text
        end function

        integer function nf_get_var_int1(ncid, varid, i1vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer(NF_KIND_INT1), intent(out):: i1vals(*)
        end function

        integer function nf_get_var_int2(ncid, varid, i2vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer(NF_KIND_INT2), intent(out):: i2vals(*)
        end function

        integer function nf_get_var_int(ncid, varid, ivals)
            integer, intent(in)::                ncid, varid
            integer, intent(out)::                 ivals(*)
        end function

        integer function nf_get_var_real(ncid, varid, rvals)
            integer, intent(in)::                ncid, varid
            real, intent(out)::                 rvals(*)
        end function

        integer function nf_get_var_double(ncid, varid, dvals)
            integer, intent(in)::                ncid, varid
            double precision, intent(out)::         dvals(*)
        end function

        !
        ! 変数の部分配列読み取り
        !

        integer function nf_get_vara_text(ncid, varid, &
        & start, count, text)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            character(len=*), intent(out)::        text
        end function

        integer function nf_get_vara_int1(ncid, varid, &
        & start, count, i1vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer(NF_KIND_INT1), intent(out):: i1vals(*)
        end function

        integer function nf_get_vara_int2(ncid, varid, &
        & start, count, i2vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer(NF_KIND_INT2), intent(out):: i2vals(*)
        end function

        integer function nf_get_vara_int(ncid, varid, &
        & start, count, ivals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(out)::                 ivals(*)
        end function

        integer function nf_get_vara_real(ncid, varid, &
        & start, count, rvals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            real, intent(out)::                 rvals(*)
        end function

        integer function nf_get_vara_double(ncid, varid, &
        start, count, dvals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            double precision, intent(out)::         dvals(*)
        end function

        !
        ! 変数の標本配列読み取り
        !

        integer function nf_get_vars_text(ncid, varid, &
        & start, count, stride, text)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*)
            character(len=*), intent(out)::        text
        end function

        integer function nf_get_vars_int1(ncid, varid, &
        & start, count, stride, i1vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*)
            integer(NF_KIND_INT1), intent(out):: i1vals(*)
        end function

        integer function nf_get_vars_int2(ncid, varid, &
        & start, count, stride, i2vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*)
            integer(NF_KIND_INT2), intent(out):: i2vals(*)
        end function

        integer function nf_get_vars_int(ncid, varid, &
        & start, count, stride, ivals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*)
            integer, intent(out)::                 ivals(*)
        end function

        integer function nf_get_vars_real(ncid, varid, &
        & start, count, stride, rvals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*)
            real, intent(out)::                 rvals(*)
        end function

        integer function nf_get_vars_double(ncid, varid, &
        & start, count, stride, dvals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*)
            double precision, intent(out)::         dvals(*)
        end function

        !
        ! 変数の写像配列読み取り
        !

        integer function nf_get_varm_text(ncid, varid, &
        & start, count, stride, imap, text)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*), imap(*)
            character(len=*), intent(out)::        text
        end function

        integer function nf_get_varm_int1(ncid, varid, &
        & start, count, stride, imap, i1vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*), imap(*)
            integer(NF_KIND_INT1), intent(out):: i1vals(*)
        end function

        integer function nf_get_varm_int2(ncid, varid, &
        & start, count, stride, imap, i2vals)
            use dc_types
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*), imap(*)
            integer(NF_KIND_INT2), intent(out):: i2vals(*)
        end function

        integer function nf_get_varm_int(ncid, varid, &
        & start, count, stride, imap, ivals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*), imap(*)
            integer, intent(out)::                 ivals(*)
        end function

        integer function nf_get_varm_real(ncid, varid, &
        & start, count, stride, imap, rvals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*), imap(*)
            real, intent(out)::                 rvals(*)
        end function

        integer function nf_get_varm_double(ncid, varid, &
        & start, count, stride, imap, dvals)
            integer, intent(in)::                ncid, varid
            integer, intent(in)::                start(*), count(*)
            integer, intent(in)::                stride(*), imap(*)
            double precision, intent(out)::         dvals(*)
        end function

    end interface
end module netcdf_f77

! Copyright (C) GFD Dennou Club, 2002.  All rights reservied.

    ! 次元対応表の順位の交換
subroutine gtvarexchdim(var, dimord1, dimord2, count_compact, err)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: map_lookup, gt_dimmap, map_set_ndims, map_set, &
        & dimord_skip_compact
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(gt_variable), intent(in):: var
    integer, intent(in):: dimord1, dimord2
    logical, intent(in), optional:: count_compact
    logical, intent(out):: err
    type(gt_dimmap), allocatable:: map(:)
    type(gt_dimmap):: tmpmap
    integer:: ndimsp, stat, idim1, idim2
    logical:: direct_mode
    character(*), parameter:: subname = 'gtvarexchdim'
continue
    err = .true.
    direct_mode = .false.
    if (present(count_compact)) then
        direct_mode = count_compact
    endif
    call beginsub(subname)
    if (dimord1 < 1 .or. dimord2 < 1) then
        call endsub(subname, "negative dimord=%d %d invalid", i=(/dimord1, dimord2/))
        return
    endif
    call map_lookup(var, ndims=ndimsp)
    if (ndimsp <= 0) then
        call endsub(subname, "variable invalid")
        return
    else if (dimord1 > ndimsp .or. dimord2 > ndimsp) then
        call endsub(subname, "dimord=%d %d not exist", i=(/dimord1, dimord2/))
        return
    endif

    allocate(map(ndimsp))
    call map_lookup(var, map=map)

    if (.not. direct_mode) then
        idim1 = dimord_skip_compact(dimord1, map)
        idim2 = dimord_skip_compact(dimord2, map)
        if (idim1 < 0 .or. idim2 < 0) then
            call endsub(subname, "dimord=%d %d not found after compaction", &
                & i=(/dimord1, dimord2/))
            deallocate(map)
            return
        endif
    else
        idim1 = dimord1
        idim2 = dimord2
    endif

    tmpmap = map(idim1)
    map(idim1) = map(idim2)
    map(idim2) = tmpmap
    call map_set(var, map, stat)
    deallocate(map)

    err = stat /= 0
    call endsub(subname)
end subroutine

! Fortran 90 による簡略正規表現ライブラリ

! 正規表現と称しているが、有限オートマトンを構築する手間をはぶくため、
! 和演算は単独文字間に限っている。つまり、[...] はあるが | はない。

module regex

    use dc_string
    implicit none

    integer, parameter:: CHAR_MAX = 255
    integer, parameter:: SYMBOL_EPSILON = CHAR_MAX + 1
    integer, parameter:: SYMBOL_EOL = CHAR_MAX + 2

    integer, parameter:: INT_WIDTH = bit_size(0)
    integer, parameter:: SYMTABLEN = (SYMBOL_EOL - 1) / INT_WIDTH + 1

    type regbranch
        integer:: symtab(SYMTABLEN)
        type(regstat), pointer:: next
        type(regbranch), pointer:: another
        logical:: cyclic
    end type

    type regstat
        logical:: living
        logical:: next_life
        type(regbranch), pointer:: choice
    end type

    type(regstat), pointer, save:: automata
    logical, save:: automata_built = .FALSE.
    logical, save:: automata_headed = .FALSE.

    interface match
        module procedure  match_cc
    end interface

contains

    recursive subroutine pat_dispose(stat)
        type(regstat), pointer:: stat
        type(regbranch), pointer:: branch, branch_backup
        branch => stat%choice
        do, while(associated(branch))
            if (.not. branch%cyclic) call pat_dispose(branch%next)
            branch_backup => branch
            branch => branch%another
            deallocate(branch_backup)
        enddo
        deallocate(stat)
    end subroutine

    logical function accept(branch, code) result(result)
        type(REGBRANCH), intent(in):: branch
        integer, intent(in):: code
        integer:: idx, ishift
        idx = code / INT_WIDTH
        ishift = mod(code, INT_WIDTH)
        result = btest(branch%symtab(idx), ishift)
    end function

    subroutine branch_clear(branch)
        type(REGBRANCH), intent(out):: branch
        nullify(branch%another, branch%next)
        branch%cyclic = .FALSE.
        branch%symtab(:) = 0
    end subroutine

    subroutine branch_setchar(branch, c)
        character, intent(in):: c
        type(REGBRANCH), intent(inout):: branch
        integer:: idx, ishift
        idx = ichar(c) / INT_WIDTH
        ishift = mod(ichar(c), INT_WIDTH)
        branch%symtab(idx) = ibset(branch%symtab(idx), ishift)
    end subroutine

    subroutine branch_negate(branch)
        type(REGBRANCH), intent(inout):: branch
        branch%symtab(:) = not(branch%symtab(:))
    end subroutine

    integer function element_add(cursor, pat) result(result)
        character(len = *), intent(in):: pat
        type(regstat), pointer:: cursor
        integer:: i
        allocate(cursor%choice)
        call branch_clear(cursor%choice) 
        if (pat(1:1) == '.') then
            call branch_negate(cursor%choice)
        else if (pat(1:1) == '[' .and. index(pat, ']') > 2) then
            result = index(pat(3: ), ']') + 2
            do, i = 2, result - 1
                call branch_stetchar(cursor%choice, pat(i:i))
            enddo
        else
            call branch_setchar(cursor%choice, pat(1:1))
        endif
        allocate(cursor%choice%next)
        cursor => cursor%choice%next
        nullify(cursor%choice)
        result = 1
    end function

    subroutine pat_compile(pat)
        character(len = *), intent(in):: pat
        type(regstat), pointer:: cursor
        integer:: i
        if (.not. automata_built) then
            nullify(automata)
            automata_built = .TRUE.
        endif
        if (associated(automata)) call pat_dispose(automata)
        if (pat(1:1) == '^') then
            automata_headed = .TRUE.
            i = 2
        else
            automata_headed = .FALSE.
            i = 1
        endif
        allocate(automata)
        cursor => automata
        nullify(cursor%choice)
        do, while (i < len(pat))
            i = i + element_add(cursor, pat(i: ))
        enddo
   end subroutine


    logical function match_cc(test, pat) result(result)
        character(len = *), intent(in):: test
        character(len = *), intent(in):: pat
        result = .TRUE.
    end function

end module

! Copyright (C) TOYODA Eizi, 2000.  All rights reserved.

subroutine GTVarAddMember(var, member_url, link_name)
    use gtdata_types, only: GT_VARIABLE
    use dc_types, only: STRING
    use dc_url, only: UrlSplit
    use gtdata_generic, only: put_attr, get_attr
    use dc_error
    implicit none
    type(GT_VARIABLE), intent(inout):: var
    character(len = *), intent(in):: member_url
    character(len = *), intent(in), optional:: link_name
    character(len = string):: members, myshortname, conv
continue
    ! 短縮名称の決定
    ! 既存のメンバ名に重複しないものを選ぶ
    call get_attr(var, 'gt_structure_member', members)
    if (present(link_name)) then
        if (index(members, ' ' //link_name) == 0) then
            myshortname = link_name
            goto 1000
        endif
    endif
    conv = member_url
    call UrlSplit(conv, var=myshortname)
    ! fake 判定
    if (index(members, trim(myshortname)) /= 0) then
        call StoreError(GT_EFAKE, "GTVarAddMember(making unique name)")
    endif
    1000 continue
    members = trim(members) // ' ' // trim(myshortname)
    call put_attr(var, 'gt_structure_member', trim(members))
    myshortname = 'gt_structure_link_' // trim(myshortname)
    call put_attr(var, myshortname, trim(member_url))

end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

subroutine GTVarCopyAttr(to, attrname, from, err)
    use gtdata_types, only: GT_VARIABLE
    use dc_string
    use gtdata_generic, only: GET_ATTR, PUT_ATTR
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: copy_attr, an_variable
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_VARIABLE), intent(inout):: to
    character(len = *), intent(in):: attrname
    type(GT_VARIABLE), intent(in):: from
    logical, intent(out), optional:: err
    type(VSTRING):: svalue
    integer:: from_class, from_cid, to_class, to_cid, stat
continue
    if (present(err)) err = .false.
    call beginsub('gtvarcopyattr', 'mapid to=%d from=%d name=%c', &
        & i=(/to%mapid, from%mapid/), c1=attrname)
    call var_class(from, from_class, from_cid)
    call var_class(to, to_class, to_cid)
    if (from_class == vtb_class_netcdf .and. to_class == vtb_class_netcdf) then
        call Copy_Attr(an_variable(to_cid), attrname, &
            & an_variable(from_cid), stat)
    else
        ! とりあえず文字列で入出力しておく
        call Get_Attr(from, attrname, svalue, default="")
        call Put_Attr(to, attrname, svalue, err)
        stat = 0
    endif
    call endsub('gtvarcopyattr', 'stat = %d', i=(/stat/))
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved
! 重要 (暦法を知っている) サブルーチン

type(DC_DATETIME) function DCDateTime(mon, day, sec) result(result)
    use dc_date_types, only: DC_DATETIME, caltype, cyclic_mdays, &
        & CAL_NOLEAP, CAL_JULIAN, CAL_CYCLIC
    implicit none
    integer, intent(in):: mon, day
    double precision, intent(in):: sec
    integer:: iday, month, year, century
    integer, parameter:: four_years = 365 * 4 + 1
continue
    iday = day + floor(sec / 86400.0_8)     
    result%sec = modulo(sec, 86400.0_8)
    if (caltype == CAL_CYCLIC) then
        result%day = iday + mon * cyclic_mdays
	return
    endif
    month = modulo(mon - 3, 12) + 3
    year = (mon - month) / 12
    iday = iday + (month * 306 - 914) / 10
    if (caltype == CAL_NOLEAP) then
        result%day = iday + year * 365 + month + 90
    else
	iday = iday + (year * four_years - modulo(year * four_years, 4)) / 4
	if (caltype == CAL_JULIAN .or. iday < 640116) then
	    result%day = iday + 91
        else
            century = (year - modulo(year, 100)) / 100 + 1
	    result%day = iday - (century * 3 - modulo(century * 3, 4)) / 4 + 93
        endif
    endif
end function

program test
    integer:: case
    write(*, *) '1: token;  2: parse'
    read(*, *) case
    if (case == 1) then
        call test_token
    else
        call test_parse
    endif
end program

subroutine test_parse
    use dc_units
    implicit none
    character(STRING):: buffer, output, op
    integer:: ios
    type(units):: u, v
    call clear(u)
    call clear(v)
    do
        write(*, fmt='(A)', advance='NO') 'units> '
        read(*, '(A)', iostat=ios) buffer
        if (ios /= 0) exit
	u = buffer

        write(*, fmt='(A)', advance='NO') 'op>    '
        read(*, '(A)', iostat=ios) op
        if (ios /= 0) exit

	if (op == '' .or. op == '=') then
	    output = u
	    write(*, "(A)") trim(output)
	    cycle
        endif
	write(*, fmt='(A)', advance='NO') 'operand> '
	read(*, '(A)', iostat=ios) buffer
	if (ios /= 0) exit
	v = buffer
	if (op == '*' .or. op == '.') then
	    u = u * v
	else if (op == '/') then
	    u = u / v
	else if (op == '+') then
	    u = u + v
	endif
	output = u
	write(*, "(A)") trim(output)

    enddo
end subroutine

subroutine test_token
    use dc_units
    use dcunits_com
    implicit none
    character(STRING):: buffer, cvalue
    integer:: ios, tokentype, ivalue(5)
    double precision:: dvalue
    do
        write(*, fmt='(A)', advance='NO') '> '
        read(*, '(A)', iostat=ios) buffer
        if (ios /= 0) exit
        write(*, fmt='(A,A,A)') '[', trim(buffer), ']'
        call DCUnitsSetLine(buffer)
        do
            call DCUnitsGetToken(tokentype, ivalue, dvalue, cvalue)
            select case (tokentype)
            case (S_EOF)
                print "('EOF')"
                exit
            case (S_SHIFT)
                print "('SHIFT @')"
            case (S_TEXT)
                print "('TEXT <', a, '>')", trim(cvalue)
            case (S_MULTIPLY)
                print "('MULTIPLY *')"
            case (S_DIVIDE)
                print "('DIVIDE /')"
            case (S_EXPONENT)
                print "('EXPONENT ^')"
            case (S_OPENPAR)
                print "('OPENPAR (')"
            case (S_CLOSEPAR)
                print "('CLOSEPAR )')"
            case (S_REAL)
                print "('REAL', g10.3)", dvalue
            case (S_INTEGER)
                print "('INTEGER', i6)", ivalue(1)
            case default
                print "(A, i4)", "unknown token type", tokentype
            end select
        enddo
    enddo
end subroutine

program histtest
    use gtool
    use dc_trace, only: setdebug
    use gtool_history
implicit none
    integer:: i
    character(len = string):: arg
continue

    do, i = 1, gtArgCount()
	call gtArgGet(i, arg)
	if (arg == '-debug') then
	    call setdebug
        endif
    enddo

    call HistoryCreate(file='xhist1.nc', title='gtool_history test 1', &
        & source='gtool4/Fortran library test kit', &
	& institution='GFD Dennou Club', &
	& dims=(/'time'/), &
	& dimsizes=(/0/), &
	& longnames=(/'time'/), &
	& units=(/'s @ 2001-12-16T10:00'/), &
	& origin=0.0, interval=0.0, &
	& xtypes=(/'real'/))
    call HistoryAddVariable('u', dims=(/'time'/), longname='any quantity', &
	units='non-dimensional')
    do, i = 1, 24
        call HistoryPut('time', real(i))
        call HistoryPut('u', sin(real(i) / 10.0))
    enddo
    call HistoryClose

    call HistoryCreate(file='xhist2.nc', title='gtool_history test 2', &
	& source='gtool4/Fortran library test kit', &
	& institution='GFD DennouClub', &
	& axes=(/ &
	& GT_HISTORY_AXIS('x', 3, 'eastward length', 'm', 'float'), &
	& GT_HISTORY_AXIS('time', 0, 'time', 's', 'float') &
	& /), origin=0.0, interval=0.0) 
    call HistoryAddVariable('u', dims=(/'x   ', 'time'/), &
	& longname='foo quantity', units='m/s')
    call HistoryAddVariable('v', dims=(/'x   ', 'time'/), &
	& longname='foo quantity', units='m/s')
    call HistoryPut('x', (/0.0, 1.0, 2.0/))
    call HistoryPut('time', 0.0)
    call HistoryPut('u', (/0.0, 0.1, 0.2/))
    call HistoryPut('v', (/1.0, 1.1, 1.2/))
    call HistoryPut('time', 1.0)
    call HistoryPut('u', (/2.0, 2.1, 2.2/))
    call HistoryPut('time', 2.0)
    call HistoryPut('u', (/3.0, 3.1, 3.2/))
    call HistoryPut('v', (/4.0, 4.1, 4.2/))
    call HistoryClose

    call HistoryCreate(file='xhist3.nc', title='gtool_history test 3', &
	& source='gtool4/Fortran library test kit', &
	& institution='GFD DennouClub', &
	& axes=(/ &
	& GT_HISTORY_AXIS('x', 3, 'eastward length', 'm', 'float'), &
	& GT_HISTORY_AXIS('time', 0, 'time', 's', 'float') &
	& /), origin=0.0, interval=0.0) 
    call HistoryAddVariable('u', dims=(/'x   ', 'time'/), &
	& longname='foo quantity', units='m/s')
    call HistoryAddVariable('v', dims=(/'x   ', 'time'/), &
	& longname='foo quantity', units='m/s')
    call HistoryPut('x', (/0.0, 1.0, 2.0/))
    call HistorySetTime(0.0)
    call HistoryPut('u', (/0.0, 0.1, 0.2/))
    call HistoryPut('v', (/1.0, 1.1, 1.2/))
    call HistorySetTime(1.0)
    call HistoryPut('u', (/2.0, 2.1, 2.2/))
    call HistorySetTime(2.0)
    call HistoryPut('u', (/3.0, 3.1, 3.2/))
    call HistorySetTime(1.0)
    call HistoryPut('v', (/4.0, 4.1, 4.2/))
    call HistorySetTime(2.0)
    call HistoryPut('v', (/5.0, 5.1, 5.2/))
    call HistoryClose

end program

! 軸ファイル探索モジュール
module findfile

    use gt3read
    use dc_types, only: string
    use dc_trace, only: message

implicit none

    character(len = string):: apath(4)
    ! 設定があればそちらが優先する
    data apath(1)/ "%GTAXDIR%"/
    ! UNIX の標準ディレクトリ
    data apath(2)/ "/var/spool/gt3-dcl5/"/
    ! Windows の標準ディレクトリ
    data apath(3)/ "c:/dennou/gt3/"/
    ! カレントディレクトリ
    data apath(4)/ "./" /

    ! 軸リストと軸表で共有する、GTOOL3 から得られる同定情報
    type axis_t
        ! 軸の要素名
        character(len = 16):: item
        ! 軸の開始格子番号、終了格子番号
        integer:: start, end
    end type

contains

    ! 本来 sysdep にあるべき
    subroutine GtoolEnvGet(name, value)
        character(len = *), intent(in):: name
        character(len = *), intent(out):: value
    continue
        CALL OSGENV(name, value)
    end subroutine

    subroutine make_axis_path(item, class, path)
        use dc_string, only: replace
    implicit none
        character(len = *), intent(in):: item
        character(len = *), intent(in):: class
        character(len = *), intent(out):: path
        integer:: i
        logical:: exist
        character(len = string):: buf
    continue
        if (apath(1)(1:1) == '%') then
            buf = ""
            call GtoolEnvGet('GTAXDIR', buf)
            if (buf == "") then
                apath(1) = "./"
            else
                apath(1) = replace(apath(1), '%GTAXDIR%', trim(buf) // "/")
            endif
        endif
        do, i = 1, size(apath)
            path = trim(apath(i)) // 'GTAX' // trim(class) // '.' // &
                & trim(item)
            inquire(file=path, exist=exist)
            if (exist) return
        enddo
        path = ""        
    end subroutine

    subroutine load_axis(axis, class, header, value, iostat, fullrange)
        type(axis_t), intent(in):: axis
        character(len = *), intent(in):: class
        type(gt3_header), intent(out):: header
        real, pointer:: value(:), buf3(:, :, :)
        integer, intent(out):: iostat
        real, intent(out), optional:: fullrange
        type(gt3_file):: file
        character(len = string):: path
        integer:: siz
    continue
        call make_axis_path(axis%item, class, path)
        if (path == "") then
            iostat = 1
	    print *, "axis file GTAX"//class//"."//trim(axis%item)//" not found"
	    nullify(value)
            return
        endif
        call open(file, path, iostat)
        if (iostat /= 0) goto 999
        call getunit(file, header, buf3, iostat)
        if (iostat /= 0) goto 999
        call close(file, iostat)
        if (iostat /= 0) goto 999
        siz = axis%end - axis%start + 1
        allocate(value(siz), stat=iostat)
        if (iostat /= 0) goto 999
        value = buf3(axis%start:axis%end, 1, 1)
        if (present(fullrange)) then
            fullrange = maxval(buf3) - minval(buf3)
        endif
        deallocate(buf3)
	call message("axis file %c used", c1=trim(path))
	return
    999 continue
	call message("axis file %c caused error %d", c1=trim(path), i=(/iostat/))
        nullify(value)
    end subroutine

end module

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

subroutine DCDateTimeEval(time, mon, day, sec)
    use dc_date_types, only: DC_DATETIME, &
        & caltype, cyclic_mdays, CAL_NOLEAP, CAL_JULIAN, CAL_CYCLIC
    implicit none
    type(DC_DATETIME), intent(in):: time
    integer, intent(out):: mon, day
    double precision, intent(out):: sec
    integer:: year, month
    integer, parameter:: four_years = 365 * 4 + 1
    integer, parameter:: four_century = 365 * 400 + 97
continue
    sec = time%sec
    if (caltype == CAL_CYCLIC) then
        day = modulo(dble(time%day - 1), cyclic_mdays) + 1
        mon = (time%day - 1) / cyclic_mdays
        return
    endif
    if (caltype == CAL_NOLEAP) then
        day = modulo(time%day - 91, 365)
        year = (time%day - 91 - day) / 365
    else
        if (caltype == CAL_JULIAN .or. time%day < 640196) then
            day = modulo(time%day - 92, four_years)
            year = (time%day - 92 - day) / four_years * 4
        else
            day = modulo(time%day - 94, four_century)
            year = (time%day - 94 - day) / four_century * 400
            if (day == four_century - 1) then
                year = year + 300
                day = 36525
            else
                year = year + day / 36524 * 100
                day = modulo(day, 36524)
            endif
            year = year + day / four_years * 4
            day = modulo(day, four_years)
        endif
        if (day == four_years - 1) then
            year = year + 3
            day = 365
        else
            year = year + day / 365
            day = modulo(day, 365)
        endif
    endif
    day = day * 10 + 922
    month = day / 306
    mon = mod(month - 1, 12) + 1
    year = year + (month - mon) / 12
    day = mod(day, 306) / 10  + 1
end subroutine

*-----------------------------------------------------------------------
*     UEGTLA
*-----------------------------------------------------------------------
*     Copyright (C) 2000 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE UEGTLA(XMIN,XMAX,DX)

      LOGICAL   LBOUND
      EXTERNAL  RGNGE,IRLE,IRGE


      IF (.NOT.(XMIN.LT.XMAX)) THEN
        CALL MSGDMP('E','UEGTLA','XMIN SHOULD BE LEAST THAN XMAX.')
      END IF

      CALL UEIGET('NLEV    ',NLEV  )
      CALL UEIGET('ITPAT   ',ITPAT )
      CALL UEIGET('ICOLOR1 ',ICLR1 )
      CALL UEIGET('ICOLOR2 ',ICLR2 )
      CALL UELGET('LBOUND  ',LBOUND)

      IF (DX.GT.0) THEN
        DZ=DX
      ELSE IF (DX.EQ.0) THEN
        DZ=RGNGE((XMAX-XMIN)/NLEV)
      ELSE
        NL=MAX(1,NINT(ABS(DX)))
        DZ=RGNGE((XMAX-XMIN)/NL)
      END IF

      ZMIN=IRLE(XMIN/DZ)*DZ
      ZMAX=IRGE(XMAX/DZ)*DZ
      N=NINT((ZMAX-ZMIN)/DZ)

      CALL UEITLV

      DO 10 I=1,N

        TLEV1=DZ*NINT((ZMIN+(I-1)*DZ)/DZ)
        TLEV2=TLEV1+DZ
        IF (LBOUND .AND. I.EQ.1) TLEV1=MAX(TLEV1,XMIN)
        IF (LBOUND .AND. I.EQ.N) TLEV2=MIN(TLEV2,XMAX)

        IF (N.EQ.1) THEN
          IPAT=(ICLR2-ICLR1)/2*1000+ITPAT
        ELSE
          IPAT=NINT((ICLR2-ICLR1)/REAL(N-1)*(I-1)+ICLR1)*1000+ITPAT
        END IF

        CALL UESTLV(TLEV1,TLEV2,IPAT)

   10 CONTINUE

      END

! GTDataTmpNam - 変数名の自動作成
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

subroutine GTDataTmpNam(file, base, result)
    use dc_types, only: string
    use dc_url, only: UrlMerge
    use gtdata_generic, only: Open, Close
    use gtdata_types, only: GT_VARIABLE
implicit none
    character(len = *), intent(in):: file
    character(len = *), intent(in):: base
    character(len = *), intent(out):: result
    type(GT_VARIABLE):: var
    integer:: n
    logical:: failed
    character(len = string):: fnam, vnam, vnambase
continue
    if (file == "") then
        fnam = "gtool.nc"
    else
        fnam = file
    endif
    if (base == "") then
        vnambase = "tmp"
    else
        vnambase = base
    endif
    n = 0
    do
        n = n + 1
        ! compatibility note (2001-12-02, TOYODA Eizi)
        ! dc_string の toChar を使いたいのだが FQS Fortran が失敗する
        write(unit=vnam, fmt="(i32)") n
        vnam = trim(vnambase) // trim(adjustl(vnam))
        result = UrlMerge(file=fnam, var=vnam)
        call Open(var, result, writable=.FALSE., err=failed)
        if (failed) return
        call Close(var)
    enddo
end subroutine

! ansearchdim.f90 - search_dim(an_variable, name)
! Copyright (C) GFD Dennou Club, 2001.  All rights reserved
!
integer function an_search_dim(var, name) result(result)
    use an_types, only: AN_VARIABLE, an_variable_entry, an_variable_search
    use an_vartable, only: vtable_lookup
    use an_file
    use netcdf_f77
    use dc_error
    use dc_trace, only: beginsub, endsub
    implicit none
    type(AN_VARIABLE), intent(in):: var
    character(len = *), intent(in):: name
    type(an_variable_entry):: ent
    integer:: stat, dimid, i
continue
    call beginsub('an_search_dim', 'var=%d name=%c', i=(/var%id/), c1=trim(name))
    result = nf_ebaddim
    stat = vtable_lookup(var, ent)
    if (stat /= NF_NOERR) goto 999

    stat = nf_inq_dimid(ent%fileid, name, dimid)
    if (stat /= NF_NOERR) goto 999

    if (dimid == ent%dimid) then
        result = 1
        goto 999
    endif

    if (.not. associated(ent%dimids)) then
        stat = gt_enomoredims
        goto 999
    endif
    do, i = 1, size(ent%dimids)
        if (ent%dimids(i) == dimid) then
            result = i
            goto 999
        endif
    enddo

999 continue
    call endsub('an_search_dim', 'result=%d', i=(/result/))
    return
end function

! Copyright (C) GFD Dennou Club, 2001.  All rights reserved

module an_vartable

    use an_types, only: an_variable, an_variable_entry, an_variable_search
    use dc_error
    use netcdf_f77
    use dc_trace, only: message
    implicit none
    private

    type(an_variable_entry), save, target, allocatable:: antab(:)
    integer, parameter:: antab_init_size = 16

    public:: vtable_add, vtable_delete, vtable_lookup, an_variable_entry
    public:: vtable_set_attrid

contains

    integer function vtable_add(var, entry) result(result)
        type(an_variable), intent(out):: var
        type(an_variable_search), intent(in):: entry
        type(an_variable_entry), allocatable:: tmp_table(:)
        integer:: i, n

        ! --- 必要なら初期確保 ---
        if (.not. allocated(antab)) then
            allocate(antab(antab_init_size), stat=result)
            if (result /= 0) goto 999
            do, i = 1, antab_init_size
                antab(i)%fileid = 0
                antab(i)%varid = 0
                antab(i)%dimid = 0
                antab(i)%attrid = 0
                nullify(antab(i)%dimids)
            enddo
        endif
        ! --- 同じ内容が既登録ならばそれを返す (attrid は変更しない) ---
        do, i = 1, size(antab)
            if (antab(i)%fileid == entry%fileid &
                & .and. antab(i)%varid == entry%varid &
                & .and. antab(i)%dimid == entry%dimid) then
                var = an_variable(i)
                result = NF_NOERR
                call message('an_vartable.add: found %d', i=(/i/))
                return
            endif
        enddo
        !
        ! --- 空き地があればそこに割り当て ---
        var = an_variable(-1)
        do, i = 1, size(antab)
            if (antab(i)%fileid == 0) then
                var = an_variable(i)
                exit
            endif
        enddo
        if (var%id == -1) then
            ! --- 空き地はなかったのだから倍幅確保 ---
            n = size(antab)
            allocate(tmp_table(n), stat=result)
            if (result /= 0) goto 999
            tmp_table(:) = antab(:)
            deallocate(antab, stat=result)
            if (result /= 0) goto 999
            allocate(antab(n * 2), stat=result)
            if (result /= 0) goto 999
            antab(1:n) = tmp_table(1:n)
            deallocate(tmp_table, stat=result)
            if (result /= 0) goto 999
            !
            antab(n+2)%fileid = 0
            antab(n+2)%varid = 0
            antab(n+2)%dimid = 0
            antab(n+2)%attrid = 0
            nullify(antab(n+2)%dimids)
            antab(n+3: n*2) = antab(n+2)
            ! 確保域の先頭を使用
            var = an_variable(n + 1)
        endif
        antab(var%id)%fileid = entry%fileid
        antab(var%id)%varid = entry%varid
        antab(var%id)%dimid = entry%dimid
        !
        ! --- 次元表の確保 ---
        call internal_build_dimids(antab(var%id), result)
        if (result /= nf_noerr) goto 999
        !
        result = nf_noerr
        call message('an_vartable.add: added %d', i=(/var%id/))
        return
        !
    999 continue
        var = an_variable(-1)
        result = NF_ENOMEM
        return

    contains

        subroutine internal_build_dimids(ent, stat)
            use netcdf_f77, only: nf_noerr, nf_inq_varndims, nf_inq_vardimid
            type(an_variable_entry), intent(inout):: ent
            integer, intent(out):: stat
            integer:: ndims
            if (ent%varid > 0) then
                stat = nf_inq_varndims(ent%fileid, ent%varid, ndims)
                if (stat /= nf_noerr) return
                if ((ent%dimid > 0) .and. (ndims /= 1)) goto 100
                if (ndims == 0) then
                    nullify(ent%dimids)
                    stat = nf_noerr
                    return
                endif
                allocate(ent%dimids(ndims), stat=stat)
                if (stat /= 0) then
                    stat = nf_enomem
                    return
                endif
                stat = nf_inq_vardimid(ent%fileid, ent%varid, ent%dimids)
                if (stat /= nf_noerr) return
                if ((ent%dimid > 0) .and. (ent%dimids(1) /= ent%dimid)) then
                    deallocate(ent%dimids)
                    goto 100
                endif
            else
                allocate(ent%dimids(1), stat=stat)
                if (stat /= 0) then
                    stat = nf_enomem
                    return
                endif
                ent%dimids(1) = ent%dimid
            endif
            stat = nf_noerr
            return

        100 continue
            ent%varid = 0
            allocate(ent%dimids(1))
            ent%dimids(1) = ent%dimid
        end subroutine

    end function

    ! 成功時は fileid を、失敗時は NF_ENOTVAR を返す
    !
    integer function vtable_delete(var) result(result)
        type(an_variable), intent(in):: var
        if (.not. allocated(antab)) goto 999
        if (var%id <= 0 .or. var%id > size(antab)) goto 999
        if (antab(var%id)%fileid == 0) goto 999
        result = antab(var%id)%fileid
        antab(var%id)%fileid = 0
        antab(var%id)%varid = 0
        antab(var%id)%dimid = 0
        antab(var%id)%attrid = 0
        if (associated(antab(var%id)%dimids)) &
            & deallocate(antab(var%id)%dimids)
        call message('an_vartable.delete: delete %d', i=(/var%id/))
        return
        !
    999 continue
        result = NF_ENOTVAR
    end function

    integer function vtable_lookup(var, entry) result(result)
        type(an_variable), intent(in):: var
        type(an_variable_entry), intent(out):: entry
        if (.not. allocated(antab)) goto 999
        if (var%id <= 0 .or. var%id > size(antab)) goto 999
        if (antab(var%id)%fileid == 0) goto 999
        entry = antab(var%id)
        result = NF_NOERR
        return
        !
    999 continue
        nullify(entry%dimids)
        entry%fileid = -1
        entry%varid = -1
        entry%dimid = -1
        entry%attrid = -1
        result = NF_ENOTVAR
    end function

    integer function vtable_set_attrid(var, attrid) result(result)
        type(an_variable), intent(in):: var
        integer, intent(in):: attrid
    continue
        if (.not. allocated(antab)) goto 999
        if (var%id <= 0 .or. var%id > size(antab)) goto 999
        if (antab(var%id)%fileid == 0) goto 999
        antab(var%id)%attrid = attrid
        result = NF_NOERR
        return
        !
    999 continue
        result = NF_ENOTVAR
    end function

end module

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

module dc_date

    ! 日付時刻と時間間隔を区別する。
    ! 型宣言によって自明に定まるサブルーチンは dc_date_types に置く。
    use dc_date_types, only: DC_DATETIME, DC_DIFFTIME
    implicit none

    interface operator(+)
        module procedure dcdate_add_ft
        module procedure dcdate_add_tf
        module procedure dcdate_add_ff
    end interface

    interface operator(-)
        module procedure dcdate_sub_tt
        module procedure dcdate_sub_tf
    end interface

    interface operator(*)
        module procedure dcdate_mul_if
        module procedure dcdate_mul_rf
        module procedure dcdate_mul_df
        module procedure dcdate_mul_fi
        module procedure dcdate_mul_fr
        module procedure dcdate_mul_fd
    end interface

    interface operator(/)
        module procedure dcdate_div_fi
        module procedure dcdate_div_fr
        module procedure dcdate_div_fd
        module procedure dcdate_div_ff
    end interface

    interface mod
        module procedure dcdate_mod_ff
    end interface

    interface assignment(=)

        subroutine DCDateLetFC(diff, string)
            use dc_date_types, only: DC_DIFFTIME
            type(DC_DIFFTIME), intent(out):: diff
            character(len = *), intent(in):: string
        end subroutine

        subroutine DCDateLetFS(diff, string)
            use dc_date_types, only: DC_DIFFTIME
            use dc_string, only: VSTRING
            type(DC_DIFFTIME), intent(out):: diff
            type(VSTRING), intent(in):: string
        end subroutine

        subroutine DCDateLetTC(time, string)
            use dc_date_types, only: DC_DATETIME
            type(DC_DATETIME), intent(out):: time
            character(len = *), intent(in):: string
        end subroutine

        subroutine DCDateLetTS(time, string)
            use dc_date_types, only: DC_DATETIME
            use dc_string, only: VSTRING
            type(DC_DATETIME), intent(out):: time
            type(VSTRING), intent(in):: string
        end subroutine

    end interface

    interface toString

        type(VSTRING) function DCDateDiffToString(diff)
            use dc_date_types, only: DC_DIFFTIME
            use dc_string, only: VSTRING
            type(DC_DIFFTIME), intent(in):: diff
        end function

        type(VSTRING) function DCDateTimeToString(time)
            use dc_date_types, only: DC_DATETIME
            use dc_string, only: VSTRING
            type(DC_DATETIME), intent(in):: time
        end function

    end interface

    interface Eval

        subroutine DCDateTimeEval(time, mon, day, sec)
            use dc_date_types, only: DC_DATETIME
            type(DC_DATETIME), intent(in):: time
            integer, intent(out):: mon, day
            double precision, intent(out):: sec
        end subroutine

        subroutine DCDateTimeEval2(time, &
            & year, mon, day, hour, min, sec)
            use dc_date_types, only: DC_DATETIME
            type(DC_DATETIME), intent(in):: time
            integer, intent(out), optional:: year, mon, day, hour, min, sec
        end subroutine

        module procedure DCDateDiffEval

    end interface

    interface DiffTime
        type(DC_DIFFTIME) function DCDiffTime( &
            & year, mon, day, hour, min, sec)
            use dc_date_types, only: DC_DIFFTIME
            integer, intent(in), optional:: year, mon, day, hour, min, sec
        end function
    end interface

    interface DateTime
        type(DC_DATETIME) function DCDateTime(mon, day, sec)
            use dc_date_types, only: DC_DATETIME
            integer, intent(in):: mon, day
            double precision, intent(in):: sec
        end function

        type(DC_DATETIME) function DCDateTime2( &
            & year, mon, day, hour, min, sec)
            use dc_date_types, only: DC_DATETIME
            integer, intent(in), optional:: year, mon, day, hour, min, sec
        end function
    end interface

contains

    subroutine dcdate_normalize(day, sec)
        use dc_date_types, only: DAY_SECONDS
        integer, intent(inout):: day
        double precision, intent(inout):: sec
        integer:: sgn
        if (abs(sec) > DAY_SECONDS) then
            day = day + int(sec / DAY_SECONDS)
            sec = modulo(sec, DAY_SECONDS)
        end if
        if ((sec > 0.0 .and. day < 0) .or. (sec < 0.0 .and. day > 0)) then
            sgn = sign(day, 1)
            day = day - sgn
            sec = sec + sgn * DAY_SECONDS
        endif
    end subroutine
    
    type(DC_DATETIME) function dcdate_add_ft(diff, time) result(result)
        type(DC_DIFFTIME), intent(in):: diff
        type(DC_DATETIME), intent(in):: time
        result = DateTime(diff%mon, time%day + diff%day, time%sec + diff%sec)
    end function

    type(DC_DATETIME) function dcdate_add_tf(time, diff) result(result)
        type(DC_DATETIME), intent(in):: time
        type(DC_DIFFTIME), intent(in):: diff
        result = DateTime(diff%mon, time%day + diff%day, time%sec + diff%sec)
    end function

    type(DC_DIFFTIME) function dcdate_add_ff(diff1, diff2) result(result)
        type(DC_DIFFTIME), intent(in):: diff1, diff2
        result%mon = diff1%mon + diff2%mon
        result%day = diff1%day + diff2%day
        result%sec = diff1%sec + diff2%sec
        call dcdate_normalize(result%day, result%sec)
    end function

    type(DC_DIFFTIME) function dcdate_sub_tt(time1, time2) result(result)
        type(DC_DATETIME), intent(in):: time1, time2
        result%day = time1%day - time2%day
        result%sec = time1%sec - time2%sec
        call dcdate_normalize(result%day, result%sec)
    end function

    type(DC_DATETIME) function dcdate_sub_tf(time, diff) result(result)
        type(DC_DATETIME), intent(in):: time
        type(DC_DIFFTIME), intent(in):: diff
        result = DateTime(-diff%mon, time%day - diff%day, time%sec - diff%sec)
    end function

    type(DC_DIFFTIME) function dcdate_mul_if(factor, diff) result(result)
        integer, intent(in):: factor
        type(DC_DIFFTIME), intent(in):: diff
        result%mon = factor * diff%mon
        result%day = factor * diff%day
        result%sec = factor * diff%sec
        call dcdate_normalize(result%day, result%sec)
    end function

    ! 月差を非整数倍すると近似的結果になるおそれがある
    type(DC_DIFFTIME) function dcdate_mul_rf(factor, diff) result(result)
        use dc_date_types, only: CYCLIC_MDAYS
        real, intent(in):: factor
        type(DC_DIFFTIME), intent(in):: diff
        result%mon = int(factor) * diff%mon
        result%day = factor * diff%day + CYCLIC_MDAYS * mod(factor, 1.0)
        result%sec = factor * diff%sec
        call dcdate_normalize(result%day, result%sec)
    end function

    ! 月差を非整数倍すると近似的結果になるおそれがある
    type(DC_DIFFTIME) function dcdate_mul_df(factor, diff) result(result)
        use dc_date_types, only: CYCLIC_MDAYS
        double precision, intent(in):: factor
        type(DC_DIFFTIME), intent(in):: diff
        result%mon = int(factor) * diff%mon
        result%day = factor * diff%day + CYCLIC_MDAYS * mod(factor, 1.0)
        result%sec = factor * diff%sec
        call dcdate_normalize(result%day, result%sec)
    end function

    type(DC_DIFFTIME) function dcdate_mul_fi(diff, factor) result(result)
        type(DC_DIFFTIME), intent(in):: diff
        integer, intent(in):: factor
        result%mon = factor * diff%mon
        result%day = factor * diff%day
        result%sec = factor * diff%sec
        call dcdate_normalize(result%day, result%sec)
    end function

    ! 近似的結果になるおそれがある
    type(DC_DIFFTIME) function dcdate_mul_fr(diff, factor) result(result)
        use dc_date_types, only: CYCLIC_MDAYS, DAY_SECONDS
        type(DC_DIFFTIME), intent(in):: diff
        real, intent(in):: factor
        double precision:: month, day
        month = factor * diff%mon
        result%mon = int(month)
        day = factor * diff%day + int(CYCLIC_MDAYS * (month - result%mon))
        result%day = int(day)
        result%sec = factor * diff%sec + (day - result%day) * DAY_SECONDS
        call dcdate_normalize(result%day, result%sec)
    end function

    ! 近似的結果になるおそれがある
    type(DC_DIFFTIME) function dcdate_mul_fd(diff, factor) result(result)
        use dc_date_types, only: CYCLIC_MDAYS, DAY_SECONDS
        type(DC_DIFFTIME), intent(in):: diff
        double precision, intent(in):: factor
        double precision:: month, day
        month = factor * diff%mon
        result%mon = int(month)
        day = factor * diff%day + int(CYCLIC_MDAYS * (month - result%mon))
        result%day = int(day)
        result%sec = factor * diff%sec + (day - result%day) * DAY_SECONDS
        call dcdate_normalize(result%day, result%sec)
    end function

    ! 月差を除算すると近似的結果になるおそれがある
    type(DC_DIFFTIME) function dcdate_div_fi(diff, denominator) result(result)
        use dc_date_types, only: CYCLIC_MDAYS, DAY_SECONDS
        type(DC_DIFFTIME), intent(in):: diff
        integer, intent(in):: denominator
    continue
        result%mon = diff%mon / denominator
        ! 月からの近似的繰り下がりは日単位でしか行わない
        result%day = diff%day / denominator + &
            & int((CYCLIC_MDAYS * mod(diff%mon, denominator)) / &
            &     denominator)
        result%sec = diff%sec / denominator + &
            & (DAY_SECONDS * mod(diff%day, denominator)) / &
            & denominator
    end function

    ! 月差を除算すると近似的結果になるおそれがある
    type(DC_DIFFTIME) function dcdate_div_fr(diff, denominator) result(result)
        use dc_date_types, only: CYCLIC_MDAYS, DAY_SECONDS
        type(DC_DIFFTIME), intent(in):: diff
        real, intent(in):: denominator
        double precision:: month, day
        month = diff%mon / denominator
        result%mon = int(month)
        day = diff%day / denominator + int(CYCLIC_MDAYS * (month - result%mon))
        result%day = int(day)
        result%sec = diff%sec / denominator + (day - result%day) * DAY_SECONDS
        call dcdate_normalize(result%day, result%sec)
    end function

    ! 月差を除算すると近似的結果になるおそれがある
    type(DC_DIFFTIME) function dcdate_div_fd(diff, denominator) result(result)
        use dc_date_types, only: CYCLIC_MDAYS, DAY_SECONDS
        type(DC_DIFFTIME), intent(in):: diff
        double precision, intent(in):: denominator
        double precision:: month, day
        month = diff%mon / denominator
        result%mon = int(month)
        day = diff%day / denominator + int(CYCLIC_MDAYS * (month - result%mon))
        result%day = int(day)
        result%sec = diff%sec / denominator + (day - result%day) * DAY_SECONDS
        call dcdate_normalize(result%day, result%sec)
    end function

    ! 月差と日時の混在する除算は近似的結果になるおそれがある
    double precision function dcdate_div_ff(diff1, diff2) result(result)
        use dc_date_types, only: CYCLIC_MDAYS, DAY_SECONDS
        type(DC_DIFFTIME), intent(in):: diff1, diff2
        ! ゼロ割対応コードが必要か?
        result = (DAY_SECONDS * (CYCLIC_MDAYS * diff1%mon + diff1%day) + &
            &     diff1%sec) / &
            & (DAY_SECONDS * (CYCLIC_MDAYS * diff2%mon + diff2%day) + &
            &  diff2%sec)
    end function

    ! 月差と日時の混在する除算は近似的結果になるおそれがある
    type(DC_DIFFTIME) function dcdate_mod_ff(diff1, diff2) result(result)
        use dc_date_types, only: CYCLIC_MDAYS, DAY_SECONDS
        type(DC_DIFFTIME), intent(in):: diff1, diff2
        double precision:: sec1, sec2
        if (diff1%day == 0 .and. diff2%day == 0 .and. &
            & diff1%sec == 0.0 .and. diff2%sec == 0.0) then
            result%mon = mod(diff1%mon, diff2%mon)
            result%day = 0
            result%sec = 0.0
        else if (diff1%sec == 0.0 .and. diff2%sec == 0.0) then
            result%mon = 0
            result%day = mod((CYCLIC_MDAYS * diff1%mon + diff1%day), &
                & (CYCLIC_MDAYS * diff2%mon + diff2%day))
            result%sec = 0.0
        else
            sec1 = DAY_SECONDS * (CYCLIC_MDAYS * diff1%mon + diff1%day) &
                 & + diff1%sec
            sec2 = DAY_SECONDS * (CYCLIC_MDAYS * diff2%mon + diff2%day) &
                 & + diff2%sec
            result%sec = mod(sec1, sec2)
            result%day = 0.0
            result%mon = 0.0
            call dcdate_normalize(result%day, result%sec)
        endif
    end function

    subroutine DCDateDiffEval(diff, &
        & year, mon, day, hour, min, sec)
        use dc_date_types, only: DC_DIFFTIME
        type(DC_DIFFTIME), intent(in):: diff
        integer, intent(out), optional:: year, mon, day, hour, min, sec
        if (present(year)) then
            year = diff%mon / 12
        endif
        if (present(mon)) then
            mon = mod(diff%mon, 12)
        endif
        if (present(day)) then
            day = diff%day
        endif
        if (present(hour)) then
            hour = int(diff%sec / 3600.0)
        endif
        if (present(min)) then
            min = int(mod(diff%sec, 3600.0) / 60.0)
        endif
        if (present(sec)) then
            sec = mod(diff%sec, 60.0)
        endif
    end subroutine

end module

!表題  gtool_history Fortran 77 用インターフェース
!
!履歴  2000/12/26  竹広真一
!      2001/02/27  竹広真一  サブルーチン毎のファイルに分割
!
!  サブルーチン対応表
!     HistoryAddAttr               HSAATC,HSAATR,HSAATD,HSAATI
!
subroutine hsaatr(varname, attrname, value,i)
    use gtool_history
    character(len=*), intent(in) :: varname
    character(len=*), intent(in) :: attrname
    real, intent(in) :: value(i)
    integer          :: i

    call HistoryAddAttr(varname, attrname, value)

  end subroutine hsaatr

! rawread.exe - raw array to gtool4 convertor
! Copyright (C) TOYODA Eizi, 2000.  All rights reserved.
! vi: set sw=4:

module rawread_file
    use dc_string
    use varying_strings
    implicit none
    private
    public:: file_status, file_read, file_open, file_name
    public:: file_direct, file_formatted, file_skip, file_recl

    integer, save:: unit = 0
    type(VSTRING):: file
    character(len = 11):: form = 'UNFORMATTED'
    character(len = 10):: access = 'SEQUENTIAL'
    logical, save:: exist = .FALSE.
    logical, save:: opened = .FALSE.
    integer, save:: recl = 1
    integer, save:: iostat = 0
    integer, save:: skip_file = 0
    integer, save:: skip_record = 0
    
contains

    subroutine file_formatted(formatted)
	logical, intent(in):: formatted
    continue
	if (formatted) then
	    form = 'FORMATTED'
	else
	    form = 'UNFORMATTED'
	endif
    end subroutine

    subroutine file_direct(direct)
	logical, intent(in):: direct
    continue
	if (direct) then
	    access = 'DIRECT'
	else
	    access = 'SEQUENTIAL'
	endif
    end subroutine

    subroutine file_status(tokens)
	use dcl
	type(STRINGS), intent(in):: tokens
    continue
	if (unit == 0) then
	    unit = DclGetUnitNum()
	    file = ""
	endif
	inquire(file=file, recl=recl, opened=opened, exist=exist)
	print "('--- file module status ---')"
	print "(' unit=',i3,' iostat=',i3,' &
	    & open=',L1,' exist=',L1,' file=',a20)", &
	    & unit, iostat, opened, exist, char(file)
	print "(' access=',a10,' form=',a11,' recl=',i8)", access, form, recl
    end subroutine

    subroutine file_open
	if (access == 'DIRECT') then
	    open(unit=unit, file=char(file), access=access, form=form, &
		& recl=recl, iostat=iostat)
	else
	    open(unit=unit, file=char(file), access=access, form=form, &
		& iostat=iostat)
	endif
    end subroutine

    subroutine file_name(tokens)
	type(STRINGS), intent(inout):: tokens
	character(len=3) fmt, unf, seq, drc
	integer:: f_unit
    continue
	file = pop(tokens)
	inquire(file=file, formatted=fmt, unformatted=unf, sequential=seq, &
	    & direct=drc, opened=f_unit, exist=exist)
	if (f_unit > 0) unit = f_unit
	if (fmt == 'YES' .and. unf == 'YES') then
	    form = '(both ok)'
	else if (fmt == 'YES') then
	    form = 'FORMATTED'
	else if (unf == 'YES') then
	    form = 'UNFORMATTED'
	endif
	if (seq == 'YES' .and. drc == 'YES') then
	    access = '(both ok)'
	else if (seq == 'YES') then
	    access = 'SEQUENTIAL'
	else if (drc == 'YES') then
	    access = 'DIRECT'
	else
	    access = '(both bad)'
	endif
    end subroutine

    subroutine file_skip(tokens)
	type(STRINGS), intent(inout):: tokens
    continue
	if (len(tokens) <= 0) then
	    print *, 'skip (file, record): ', skip_file, skip_record
	else
	    skip_file = stoi(shift(tokens))
	    skip_record = stoi(shift(tokens))
	endif
    end subroutine

    subroutine file_recl(tokens)
	type(STRINGS), intent(inout):: tokens
    continue
	if (len(tokens) <= 0) then
	    print *, 'recl = ', recl
	else
	    recl = stoi(shift(tokens))
	endif
    end subroutine

    subroutine file_read(tokens)
	type(STRINGS), intent(in):: tokens
    end subroutine

end module rawread_file


module rawread_array

    use dc_string
    use varying_strings
    implicit none
    private
    public:: array_size, array_type

contains

    subroutine array_size(tokens)
	type(STRINGS), intent(in):: tokens
    end subroutine

    subroutine array_type(type)
	type(VSTRING), intent(in):: type
    end subroutine

end module


program rawread
    use dc_string
    use varying_strings
    use getline
    use rawread_array
    use rawread_file
    type(VSTRING):: command
    type(STRINGS):: tokens
    integer:: iostat
continue
    call init(tokens)
    call set_prompt('rawread> ')
    do
	call ask_tokens(tokens, iostat=iostat)
	if (iostat /= 0) exit
	command = shift(tokens)
	if (command == "") cycle
	if (command == 'exit' .or. command == 'quit' .or. command == 'q') exit
	if (command == 'sta') command = 'status'
	if (command == 'seq') command = 'sequential'
	if (command == 'help') then 
	    call help
	else if (command == 'cd') then
	    call cd(pop(tokens)) 
	else if (command == 'ascii') then
	    call file_formatted(.TRUE.)
	else if (command == 'binary') then
	    call file_formatted(.FALSE.)
	else if (command == 'endian') then
	    print *, 'unsupported command'
	else if (command == 'exec' .or. command == '!') then
	    call exec(tokens)
	else if (command == 'direct') then
	    call file_direct(.TRUE.) 
	else if (command == 'file') then
	    call file_name(tokens)
	else if (command == 'format') then
	    print *, 'unsupported command'
	    ! call file_format(tokens)
	else if (command == 'integer') then
	    call array_type(command)
	else if (command == 'list') then
	    print *, 'unsupported command'
	    ! call listmode
	else if (command == 'ls') then 
	    call exec(tokens, insert='ls')
	else if (command == 'open') then
	    call file_open()
	else if (command == 'read') then
	    call file_read(tokens)
	else if (command == 'real') then
	    call array_type(command)
	else if (command == 'recl') then
	    call file_recl(tokens)
	else if (command == 'save') then
	    print *, 'unsupported command'
	    ! call savemode(tokens)
	else if (command == 'size') then
	    call array_size(tokens)
	else if (command == 'sequential') then
	    call file_direct(.FALSE.)
	else if (command == 'show') then
	    print *, 'unsupported command'
	    ! call showmode
	else if (command == 'skip') then
	    call file_skip(tokens)
	else if (command == 'status') then
	    call file_status(tokens)
	else if (command == 'unformatted') then
	    call file_formatted(.FALSE.)
	else
	    call put_line("unknown command: " // command);
	endif
    enddo
    ! プロセスが続くなら call dispose(tokens) すべきところ
    stop
contains

    subroutine help
	print *, "rawread by TOYODA Eizi <toyoda@gfd-dennou.org>, 2000."
	print *, "commands:"
	print *, "    ascii binary endian exit direct format help integer list"
	print *, "    read real recl save size sequential show skip status unformatted"
    end subroutine

    subroutine exec(tokens, insert)
	use dcl
	type(STRINGS), intent(in):: tokens
	type(STRINGS):: list
	character(len = *), intent(in), optional:: insert
	type(VSTRING):: command, word
    continue
	call init(list)
	list = tokens
	if (present(insert)) call unshift(list, var_str(insert))
	command = ''
	do
	    if (len(list) == 0) exit
	    word = shift(list)
	    if (index(word, ' ') > 0) word = '"' // word // '"'
	    command = command // ' ' // word
	enddo
	call put_line('> ' // command)
	call osexec(char(command))
	call dispose(list)
    end subroutine

    subroutine cd(dir)
	use dfport
	type(VSTRING), intent(in):: dir
	integer:: errno
    continue
	errno = chdir(char(dir))
	if (errno == 0) return
	if (errno == ENOENT) then
	    call put_line('cd: ' // dir // ' not exists.')
	else if (errno == ENOTDIR) then
	    call put_line('cd: ' // dir // ' is not a directory.')
	else
	    call put_line('cd: unknown error')
	endif
    end subroutine

end program

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

subroutine GTAxisLoadByName(Axis, varname)
    use gtgraph_types, only: GT_AXIS
    use gtgraph_generic, only: Load
    use gtdata_generic, only: Open, Close
    use gtdata_types, only: GT_VARIABLE
    implicit none
    type(GT_AXIS), intent(out):: axis
    character(*), intent(in):: varname
    type(GT_VARIABLE):: tmpvar
    call Open(tmpvar, varname)
    call Load(axis, tmpvar)
    call Close(tmpvar)
end subroutine

subroutine GTAxisLoad(Axis, var)
    use gtgraph_types, only: GT_Axis
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: get_attr, Open, attr_true, Close
    use gtgraph_generic, only: Open
    use dc_types, only: STRING
    use dc_error
    implicit none
    type(GT_Axis), intent(out):: Axis
    type(GT_VARIABLE), intent(in):: var
    type(GT_VARIABLE):: datavar
    character(STRING):: varname
continue
    call get_attr(var, "gt_structure_link_data", varname)
    if (varname == "") then
        call StoreError(GT_EBADLINK, "GTContLoad(data variable)")
        return
    endif
    call Open(datavar, varname)
    call Open(axis, datavar, 0)
    call Close(datavar)
    axis%vertical = attr_true(var, "gt_graph_axis_vertical", default=.false.)
end subroutine

! Copyright (C) TOYODA Eizi, 2000.  All rights reserved.
! gtprint - °õ»ú¥Ä¡¼¥ë

program gtprint
    use gtool
    use dc_trace, only: setdebug
    implicit none
    type(VSTRING):: argument
    type(VSTRING):: attrname, fn, ior, v
    character(STRING):: value
    character(STRING):: varname
    type(GT_VARIABLE):: var
    integer:: i
    integer:: showcount = 0
continue
    do, i = 1, GtArgCount()
        call GtArgGet(i, argument)
	if (argument == "-debug") then
	    call setdebug
	    cycle
	endif
        call UrlSplit(argument, attr=attrname)
        if (attrname == '') then
            varname = argument
            call Open(var, varname)
            call put_line(var)
            call Close(var)
        else
            call UrlSplit(argument, file=fn, var=v, iorange=ior)
            varname = UrlMerge(fn, v, iorange=ior)
            call Open(var, varname)
            call get_attr(var, vchar(attrname, len(attrname)), value)
            call printq(value)
            call Close(var)
        endif
        showcount = showcount + 1
    enddo
    if (showcount == 0) then
        write(*, *) 'usage: gtprint [varname|attrname] ...'
    endif
contains

    subroutine printq(str)
        character(*), intent(in):: str
        character(len(str) * 3):: buf
        integer:: i, j, imax, c
        character(*), parameter:: escape = "0123456abtnvfr"
        j = 1
        do, i = 1, len_trim(str)
            select case(iachar(str(i:i)))
            case(0:13)
                c = iachar(str(i:i)) + 1
                buf(j: j+1) = achar(92) // escape(c:c)
                j = j + 2
            case(27)
                buf(j: j+1) = achar(92) // 'e'
                j = j + 2
            case(34, 39, 92)
                buf(j: j+1) = achar(92) // str(i:i)
                j = j + 2
            case (14:26, 28:31, 127:)
                buf(j: j+1) = achar(92) // 'x'
		write(buf(j+2: j+2), "(Z2)") iachar(str(i:i))
                if (buf(j+2: j+2) == ' ') &
                    buf(j+2: j+2) = '0'
		j = j + 4
            case default
                buf(j:j) = str(i:i)
                j = j + 1
            end select
        enddo
        write(*, '(A)') buf(1: j-1)
    end subroutine

end program

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

subroutine GTVarSlice(var, dimord, start, count, stride)
    use gtdata_types, only: gt_variable
    use gtdata_internal, only: query_growable
    use gt_map, only: map_lookup, map_set, gt_dimmap, gtvar_dump
    use dc_error, only: nf_enotvar, StoreError
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(gt_variable), intent(in):: var
    integer, intent(in):: dimord
    integer, intent(in), optional:: start
    integer, intent(in), optional:: count
    integer, intent(in), optional:: stride
    type(gt_dimmap), allocatable:: map(:)
    integer:: vid, maxindex, maxcount, nd, stat
    logical:: growable_dimension

    call beginsub('gtvarslice', 'var%%mapid=%d dimord=%d', &
        & i=(/var%mapid, dimord/))
    call gtvar_dump(var)
    call map_lookup(var, vid=vid, ndims=nd)
    if (vid < 0) then
        call StoreError(nf_enotvar, "GTVarSlice")
    endif

    if (vid > 0) then
        call query_growable(vid, growable_dimension)
    else
        growable_dimension = .false.
    endif

    if (nd == 0) goto 999
    allocate(map(nd))    
    call map_lookup(var, map=map)

    if (dimord <= 0 .or. dimord > size(map)) goto 998

    call message('map(dimord): originally start=%d count=%d stride=%d', &
        & i=(/map(dimord)%start, map(dimord)%count, map(dimord)%stride/))
    if (.not. growable_dimension) then
        maxindex = map(dimord)%allcount
        call message('maxindex=%d', i=(/maxindex/))
    endif

    if (present(start)) then
        if (start < 0) then
            map(dimord)%start = max(1, maxindex + 1 + start)
        else if (growable_dimension) then
            map(dimord)%start = max(1, start)
        else
            map(dimord)%start = min(maxindex, max(1, start))
        endif
        call message('start=%d (%d specified)', i=(/map(dimord)%start, start/))
    endif

    if (present(stride)) then
        map(dimord)%stride = stride
        if (stride == 0) map(dimord)%stride = 1
        call message('stride=%d (%d specified)', &
            & i=(/map(dimord)%stride, stride/))
    endif

    if (present(count)) then
        map(dimord)%count = abs(count)
        if (count == 0) map(dimord)%count = 1
        call message('count=%d (%d specified)', &
            & i=(/map(dimord)%count, count/))
    endif

    if (.not. growable_dimension) then
        maxcount = 1 + (maxindex - map(dimord)%start) / map(dimord)%stride
        map(dimord)%count = max(1, min(maxcount, map(dimord)%count))
        call message('count=%d ', i=(/map(dimord)%count/))
    endif
    call map_set(var, map, stat)
    if (stat /= 0) goto 998

    call endsub('gtvarslice')
    deallocate(map)
    return

998 continue
    deallocate(map)
999 continue
    call endsub('gtvarslice', 'err skipped')
end subroutine

! 変数 var に string によるマップ操作を行う。
! string はコンマで区切られた変換指定の列である。
! 変換指定は領域設定と次元順序変換のどちらかである。
! 領域設定は英数字で始まるもので、<dim>=<lower>, <dim>=<lower>:<upper>,
!   <dim>=<lower>:<upper>:<stride> のような形式である。
!   ここで、dim は次元番号または次元名であり、<lower>, <upper>
!   は ^ を前置した座標即値または格子番号である。
!   <stride> は格子数である。
! (未実装) 次元順序変換は = で始まるもので、
!   IGN:<dim>=<pos>
! の形態をとる。

subroutine GTVarSliceC(var, string, err)
    use gtdata_types, only: gt_variable
    use dc_trace, only: beginsub, endsub
    use dc_url, only: gt_comma
    use gt_map, only: gtvar_dump
    type(gt_variable), intent(in):: var
    character(len = *), intent(in):: string
    logical, intent(out):: err
    integer:: is, ie
continue
    call beginsub('gtvarslicec', 'var=%d lim=<%c>', i=(/var%mapid/), c1=string)
    call gtvar_dump(var)
    ! コンマで区切って解釈
    is = 1
    do
        ie = index(string(is: ), gt_comma)
        if (ie == 0) exit
        call limit_one(string(is: is+ie-2))
        is = is + ie
        if (is > len(string)) exit
    enddo
    call limit_one(string(is: ))
    err = .false.
    call endsub('gtvarslicec')
    return
contains

    subroutine limit_one(string)
        use dc_url, only: gt_equal
        use dc_string, only: strieq, stoi
        use gtdata_generic, only: del_dim, dimname_to_dimord
        character(len = *), intent(in):: string
        integer:: equal, dimord
        integer:: start, count, stride
        logical:: myerr

        if (string == '') return

        if (strieq(string(1:4), "IGN:")) then
            ! 隠蔽型指定子 ign:<dim> または ign:<dim>=<start>
            equal = index(string, gt_equal)
            if (equal == 0) then
                start = 1
            else
                start = stoi(string(equal+1: ), default=1)
            endif
            dimord = dimname_to_dimord(var, string(5: equal-1))
            call gtvarslice(var, dimord, start, 1, 1)
            call del_dim(var, dimord, myerr)
            return
        endif

        ! 限定型指定子 <dim>=<start>:<finish>:<stride>
        !
        equal = index(string, gt_equal)
        if (equal == 0) return
        dimord = dimname_to_dimord(var, string(1: equal-1))
        if (dimord <= 0) return
        !
        call region_spec(dimord, string(equal+1: ), start, count, stride)
        call gtvarslice(var, dimord, start, count, stride)
    end subroutine

        !
        ! 範囲指定の = のあとを : で区切ってマップにいれる
        !
    subroutine region_spec(dimord, string, start, count, stride)
        use dc_types, only: token
        use dc_string, only: index_ofs, stoi
        use dc_url, only: gt_circumflex, gt_colon
        use gt_map, only: dimrange
        integer, intent(in):: dimord
        integer, intent(out):: start, count, stride
        character(len = *), intent(in):: string
        integer:: colon, prev_colon, finish, dimlo, dimhi
        character(len = token):: val(3)
    continue
        colon = index(string, gt_colon)
        if (colon == 0) then
            ! コロンがない場合は上下端に同じ値
            val(1) = string(1: )
            val(2) = val(1)
            val(3) = ""
        else
            val(1) = string(1: colon - 1)
            prev_colon = colon
            colon = index_ofs(string, colon + 1, gt_colon)
            if (colon > 0) then
                val(2) = string(prev_colon + 1: colon - 1)
                val(3) = string(colon + 1: )
            else
                val(2) = string(prev_colon + 1: )
                val(3) = ""
            endif
        endif
        if (val(3) == "") val(3) = "^1"

        if (val(1)(1:1) == gt_circumflex) then
            start = stoi(val(1)(2: ))
        else if (val(1) == val(2)) then
            start = nint(value_to_index(dimord, val(1)))
        else
            start = floor(value_to_index(dimord, val(1)))
        endif
        if (val(2) == val(1)) then
            finish = start
        else if (val(2)(1:1) == gt_circumflex) then
            finish = stoi(val(2)(2: ))
        else
            finish = ceiling(value_to_index(dimord, val(2)))
        endif

        call dimrange(var, dimord, dimlo, dimhi)
        start = min(max(dimlo, start), dimhi)
        finish = min(max(dimlo, finish), dimhi)
        count = abs(finish - start) + 1

        if (val(3)(1:1) == gt_circumflex) then
            stride = stoi(val(3)(2: ))
        else
            stride = stoi(val(3))
        endif
        stride = sign(stride, finish - start)
    end subroutine

    real function value_to_index(dimord, value) result(result)
        use gtdata_types, only: gt_variable
        use gtdata_generic, only: get, open, close
        use dc_string, only: stod
        use dc_trace, only: beginsub, endsub, message
        integer, intent(in):: dimord
        character(len = *), intent(in):: value
        type(gt_variable):: axisvar
        real, pointer:: axisval(:)
        real:: val
        integer:: i

        call beginsub('value_to_index', 'var=%d dimord=%d value=%c', &
            & i=(/var%mapid, dimord/), c1=trim(value))

        call Open(axisvar, var, dimord, count_compact=.true.)
        call Get(axisvar, axisval)
        call Close(axisvar)
        if (.not. associated(axisval)) then
            result = -1.0
            return
        else if (size(axisval) < 2) then
            result = 1.0
            goto 900
        endif

        val = stod(value)

        ! call message('value=%f axis=(/%*r/)', r=(/val, axisval(:)/), &
        !    & n=(/size(axisval)/))

        do, i = 1, size(axisval) - 1
            if (axisval(i + 1) == axisval(i)) then
                result = real(i) + 0.5
                goto 900
            endif
            result = i + (val - axisval(i)) / (axisval(i + 1) - axisval(i))
            if (result <= (i + 1)) goto 900
        enddo

    900 continue
        call endsub('value_to_index', '(%c) = %r', &
            & c1=trim(value), r=(/result/))
        deallocate(axisval)
    end function

end subroutine

! gr_types.f90 - derived type interface for grads variable interface
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved
! vi: set ts=8 sw=4:

module gr_types

    implicit none
    integer, parameter:: GR_VARNAME_MAX = 8
    integer, parameter:: GR_NDIMS_ALL = 4

    type GR_VARIABLE
        !
        ! ID 情報
        !        変数 (gr_variable 実体) は (/fileid, varname/) で
        !        同定される。正当な変数の fileid は必ず正である。
        !  
        integer:: fileid
        character(len = GR_VARNAME_MAX):: varname
        !
        ! 入出力範囲限定
        !       変数は必ず 4 次元であるためこれらの配列は固定長で確保される。
        !  
        integer:: start(GR_NDIMS_ALL)
        integer:: count(GR_NDIMS_ALL)
        integer:: stride(GR_NDIMS_ALL)
        integer:: allcount(GR_NDIMS_ALL)
    end type

end module

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

subroutine GTLineLoad(Line, var)
    use gtgraph_types, only: GT_Line
    use gtgraph_generic, only: Load
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic
    use dc_trace, only: beginsub, endsub
    use dc_error
    use dc_types, only: STRING
    implicit none
    type(GT_Line), intent(out):: Line
    type(GT_VARIABLE), intent(in):: var
    character(STRING):: varname
    character(*), parameter:: GTLN = "gt_graph_line_"
continue
    ! リンク名が data であることを仮定
    call beginsub('gtlineload')
    call get_attr(var, "gt_structure_link_data", varname)
    call Open(line%var, varname)
    allocate(line%h_axis, line%v_axis)
    call get_attr(var, "gt_structure_link_haxis", varname)
    call Load(line%h_axis, varname)
    call get_attr(var, "gt_structure_link_vaxis", varname)
    call Load(line%v_axis, varname)
    ! オプションの初期化
    call get_attr(var, GTLN // 'index', line%index, default=0)
    call get_attr(var, GTLN // 'type', line%type, default=0)
    call get_attr(var, GTLN // 'mark', line%mark, default=0)
    call endsub('gtlineload')
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.
! テスト用の浅水波モデル

program gtshallow

    use shallow_water
    use gtool_history

    implicit none

    integer:: nx = 9
    integer:: ny = 9
    integer:: ktmax = 1000
    real(double):: dt = 0.01_double
    real(double):: dx = 1.0_double
    real(double):: H = 1.0_double
    real(double):: g = 9.80665_double
    real(double):: f = 0.0_double
    character(len = 78):: filename = "gtshallow.nc"
    character(len = 78):: user = ""
    character(len = 78):: init(5)
    data init/"P", 4 * ' '/
    namelist /config/ nx, ny, dt, ktmax, g, H, f, init, filename, user

    type(shallow):: past, current, future
    integer:: kt, i 

continue

    write(*, *) '--- please enter configuration ---'
    write(*, config)
    read(*, config)
    write(*, *) '--- run config ---'
    write(*, config)

    call HistoryCreate(file=filename, title="shallow water simulation", &
        & source="gtshallow version 1", institution=user, &
        & dims=(/"x", "y", "t"/), &
        & dimsizes=(/nx, ny, 0/), &
        & longnames=(/"eastward length", "northward length", "time"/), &
        & units=(/"m", "m", "s"/), &
        & origin=0.0, interval=real(dt))

    call HistoryPut("x", (/(real(i * dx), i = 1, nx)/))
    call HistoryPut("y", (/(real(i * dx), i = 1, ny)/))

    call nullify(past)
    call allocate(current, nx, ny, H)
    call nullify(future)
    call modify(current, init)

    call HistoryAddVariable(varname="u", &
        & dims=(/"x", "y", "t"/), &
        & longname="eastward velocity", units="m/s")
    call HistoryAddVariable(varname="v", &
        & dims=(/"x", "y", "t"/), &
        & longname="northward velocity", &
        & units="m/s")
    call HistoryAddVariable(varname="h", &
        & dims=(/"x", "y", "t"/), &
        & longname="depth", units="m")

    future = current + dt * tendency(current)
    call history_put_all(current)
    call history_put_all(future)

    do, kt = 1, ktmax
        call deallocate(past)
        past = current
        current = future
        future = past + dt * tendency(current)
        call history_put_all(future)
        print "(9(' ', f7.3))", current%h(4, :) - H
    enddo

    call HistoryClose

contains

    subroutine history_put_all(stat)
        type(shallow):: stat
        call HistoryPut("u", real(stat%u))
        call HistoryPut("v", real(stat%v))
        call HistoryPut("h", real(stat%h))
    end subroutine

    type(shallow) function tendency(stat) result(result)
        type(shallow):: stat
        call allocate(result, nx, ny, temporary=.TRUE.)
        !
        ! 微分量を中間変数に確保、算出
        !
        allocate(stat%Ux(nx, ny), stat%Vx(nx, ny), stat%Hx(nx, ny), &
            stat%Uy(nx, ny), stat%Vy(nx, ny), stat%Hy(nx, ny))
        !
        stat%ux = (CShift(stat%U, -1, dim=1) - CShift(stat%U, 1, dim=1)) / 2.0 / dx
        stat%vx = (CShift(stat%V, -1, dim=1) - CShift(stat%V, 1, dim=1)) / 2.0 / dx
        stat%hx = (CShift(stat%H, -1, dim=1) - CShift(stat%H, 1, dim=1)) / 2.0 / dx
        stat%uy = (CShift(stat%U, -1, dim=2) - CShift(stat%U, 1, dim=2)) / 2.0 / dx
        stat%vy = (CShift(stat%V, -1, dim=2) - CShift(stat%V, 1, dim=2)) / 2.0 / dx
        stat%hy = (CShift(stat%H, -1, dim=2) - CShift(stat%H, 1, dim=2)) / 2.0 / dx
        !
        ! u_t = - u u_x - v u_y + f v - g h_x
        !
        result%U = - stat%U * stat%Ux - stat%V * stat%Uy &
            & + f * stat%V - g * stat%Hx
        !
        ! v_t = - u v_x - v v_y - f u - g h_y
        !
        result%V = - stat%V * stat%Vx - stat%V * stat%Vy &
            & - f * stat%U - g * stat%Hy
        !
        ! h_t = - (u h)_x - (v h)_y
        !
        result%H = - stat%U * stat%Hx - stat%Ux * stat%H &
            - stat%V * stat%Hy - stat%Vy * stat%H
        !
        ! 微分量バッファの後始末
        !
        deallocate(stat%Ux, stat%Vx, stat%Hx, stat%Uy, stat%Vy, stat%Hy)
    end function

    subroutine modify(stat, init)
        type(SHALLOW):: stat
        character(len = *), intent(in):: init(:)
        integer:: n, i, j
    continue
        do, n = 1, size(init)
            if (init(n) == "P") then
                i = size(stat, 1) / 2
                j = size(stat, 2) / 2
                stat%h(i, j) = stat%h(i, j) + h * 0.2
            else if (init(n) == "") then
                continue
            else
                print *, "modify: unknown specification <", trim(init(n)), ">"
            endif
        enddo
    end subroutine

end program 

!表題  gtool_history Fortran 77 用インターフェース
!
!履歴  2000/12/26  竹広真一
!
!  サブルーチン対応表
!     HistoryAddAttr               HSAATC,HSAATR,HSAATD,HSAATI
!
subroutine hsaatc(varname, attrname, value)
    use gtool_history
    character(len = *), intent(in):: varname
    character(len = *), intent(in):: attrname
    character(len = *), intent(in):: value

    call HistoryAddAttr(varname, attrname, value)

  end subroutine hsaatc

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

subroutine GTVarSliceNext(var, dimord, err, stat)
    use gtdata_types, only: GT_VARIABLE
    use dc_error, only: GT_EFAKE, StoreError, DC_NOERR, gt_enomoredims, &
        & nf_einval, nf_enotvar
    use gt_map, only: map_lookup, gt_dimmap, map_set
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(GT_VARIABLE), intent(in out):: var
    integer, intent(in), optional:: dimord
    logical, intent(out), optional:: err
    integer, intent(out), optional:: stat
    type(gt_dimmap), allocatable:: map(:)
    integer:: mystat, vid, id, nd, idim_lo, idim_hi, ilast

    call beginsub('gtvarslicenext')
    if (present(dimord)) call message('dimord=%d', i=(/dimord/))

    call map_lookup(var, vid=vid, ndims=nd)
    if (vid < 0) then
        mystat = nf_enotvar
        goto 999
    endif
    if (nd <= 0) then
        call message('dimension map not associated')
        mystat = gt_enomoredims
        goto 999
    endif
    allocate(map(nd))
    call map_lookup(var, map=map)

    if (present(dimord)) then
        if (dimord < 0 .or. dimord <= size(map)) then
            call message('dimord=%d is out of 1..%d', i=(/dimord, size(map)/))
            mystat = nf_einval
            goto 995
        endif
        idim_lo = dimord
        idim_hi = dimord
    else
        idim_lo = 1
        idim_hi = size(map)
    endif
    call message('idim scan range=(%d:%d)', i=(/idim_lo, idim_hi/))

    mystat = gt_enomoredims
    do, id = idim_lo, idim_hi
        ilast = map(id)%start + (map(id)%count * 2 - 1) * map(id)%stride
        call message('last_index=%d allcount=%d', &
            & i=(/ilast, map(id)%allcount/))
        if (ilast >= 1 .and. ilast <= map(id)%allcount) then
            map(id)%start = map(id)%start + map(id)%count * map(id)%stride
            mystat = dc_noerr
            exit
        endif
    enddo
    if (mystat /= dc_noerr) goto 995
    call map_set(var, map, mystat)

995 continue
    deallocate(map)

999 continue
    if (present(stat)) then
        stat = mystat
        if (present(err)) err = (mystat /= DC_NOERR)
    else
        call StoreError(mystat, "GTVarSliceNext", err)
    endif
    call endsub('gtvarslicenext', 'stat=%d', i=(/mystat/))
end subroutine

!表題  gtool_history Fortran 77 用インターフェース
!
!履歴  2000/12/26  竹広真一
!      2001/02/27  竹広真一  サブルーチン毎のファイルに分割
!
!  サブルーチン対応表
!     HistoryPut                   HSP1D, HSP2D, HSP3D, HSP1R, HSP2R, HSP3R
!
subroutine hsp1r(varname,var,i)

    use gtool_history
    character(len=*) :: varname
    real             :: var(i)
    integer          :: i

    call HistoryPut(varname,var)

  end subroutine hsp1r

! GTContSave - 図を変数として保存
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

subroutine GTContSave(cont, name, name_result)
    use gtgraph_generic, only: Save, GTGraphSaveName
    use gtgraph_types, only: GT_CONTOURS
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: Create, Close, Put_Attr, get_attr, add_member, &
        & Inquire
    use dc_string
    use dc_types, only: STRING
    implicit none
    type(GT_CONTOURS), intent(inout):: cont
    type(VSTRING), intent(in), optional:: name
    type(VSTRING), intent(out), optional:: name_result
    type(VSTRING):: member
    character(STRING):: member_c, url, vname, title
    type(GT_VARIABLE):: var
    character(len = *), parameter:: GTCT = "gt_graph_contours_"
continue
    if (present(name)) then
        vname = name
    else
        call GTGraphSaveName(result=vname)
    endif
    call get_attr(cont%var, "long_name", title)
    title = "contours of " // title
    call Create(var, trim(vname), xtype="int", overwrite=.TRUE., &
        long_name=trim(title))
    call Put_Attr(var, "gt_structure_class", "contours")
    call Put_Attr(var, GTCT // "draw_shade", cont%shade)
    call Put_Attr(var, GTCT // "draw_contours", cont%contours)
    if (cont%cint /= 0.0) then
        call Put_Attr(var, GTCT // "interval", (/cont%cint/))
    endif
    if (cont%icycle /= 0) then
        call Put_Attr(var, GTCT // "thick_cycle", (/cont%icycle/))
    endif
    if (associated(cont%levels)) then
        call Put_Attr(var, GTCT // "levels", cont%levels)
    endif
    if (associated(cont%skiplevels)) then
        call Put_Attr(var, GTCT // "skiplevels", cont%skiplevels)
    endif
    if (cont%map /= "") then
        call Put_Attr(var, "gt_graph_draw_map", trim(cont%map))
    endif
    ! experimental
    if (associated(cont%tones)) then
        call Put_Attr(var, GTCT // "tone_number", cont%tones)
    endif

    ! 図のメンバになっているものたちの書き出し
    call Inquire(cont%var, url=url)
    call add_member(var, url, link_name="data")
    if (associated(cont%v_axis)) then
        if (cont%v_axis%saved /= "") then
            call add_member(var, cont%v_axis%saved, link_name="vaxis")
        else
            call Save(cont%v_axis, resultname=member)
            member_c = member
            call add_member(var, member_c, link_name="vaxis")
        endif
    endif
    if (associated(cont%h_axis)) then
        if (cont%h_axis%saved /= "") then
            call add_member(var, cont%h_axis%saved, link_name="haxis")
        else
            call Save(cont%h_axis, resultname=member)
            member_c = member
            call add_member(var, member_c, link_name="haxis")
        endif
    endif
    
    call Close(var)
    print *, trim(title), " stored at ", trim(vname), "."
    if (present(name_result)) name_result = vname
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

subroutine ANVarCreate(var, url, xtype, dims, overwrite, err)
    use an_types, only: AN_VARIABLE, an_variable_entry, an_variable_search
    use dc_types, only: string
    use dc_string, only: strieq
    use an_vartable, only: vtable_add, vtable_lookup
    use an_file, only: ANFileOpen, ANFileDefineMode
    use dc_url, only: UrlSplit
    use dc_trace, only: beginsub, endsub, message
    use an_generic, only: toString ! for debug
    use netcdf_f77, only: NF_NOERR, nf_def_var, NF_REAL, NF_INT, NF_DOUBLE, &
        NF_EBADDIM, nf_inq_unlimdim
    use dc_error, only: StoreError, GT_ENOMEM, GT_EOTHERFILE, &
        GT_EDIMNODIM, GT_EDIMMULTIDIM
    implicit none
    type(AN_VARIABLE), intent(out):: var
    character(len = *), intent(in):: url
    character(len = *), intent(in):: xtype
    type(AN_VARIABLE), intent(in):: dims(:)
    logical, intent(in), optional:: overwrite
    logical, intent(out), optional:: err
    type(an_variable_search):: ent
    type(an_variable_entry):: ent_dim
    character(len = string):: filename, varname
    integer, allocatable:: dimids(:)
    integer:: stat, nvdims, i
    integer:: nc_xtype
    logical:: clobber
    intrinsic trim
    character(len = *), parameter:: subnam = "anvarcreate"
continue
    clobber = .false.
    if (present(overwrite)) clobber = overwrite
    call beginsub(subnam)
    call message('url=%c', c1=trim(url))
    call message('xtype=%c', c1=trim(xtype))
    call message('dims=(/%*d/)', i=dims(:)%id, n=(/size(dims)/))
    call message('ovwr=%y', L=(/clobber/))

    ! もし必要ならファイル作成
    call UrlSplit(url, filename, varname)
    call ANFileOpen(ent%fileid, filename, stat=stat, writable=.TRUE., &
        overwrite=clobber)
    if (stat /= NF_NOERR) goto 999

    ! 次元にまつわる準備
    nvdims = size(dims)
    allocate(dimids(max(1, nvdims)), stat=stat)
    if (stat /= 0) goto 990
    do, i = 1, nvdims
        stat = vtable_lookup(dims(i), ent_dim)
        if (stat /= NF_NOERR) then
            stat = NF_EBADDIM
            goto 999
        endif
        if (ent%fileid /= ent_dim%fileid) then
            stat = GT_EOTHERFILE
            goto 999
        endif
        if (ent_dim%dimid <= 0) then
            stat = GT_EDIMMULTIDIM
            goto 999
        endif
        dimids(i) = ent_dim%dimid
    enddo
    ent%dimid = 0

    ! 変数の型の判定
    nc_xtype = NF_REAL
    if (strieq(xtype, "double") .or. strieq(xtype, "DOUBLEPRECISION")) then
        nc_xtype = NF_DOUBLE
    endif
    if (strieq(xtype, "int") .or. strieq(xtype, "INTEGER")) then
        nc_xtype = NF_INT
    endif

    ! 本当の変数作成操作
    stat = ANFileDefineMode(ent%fileid)
    if (stat /= NF_NOERR) goto 999
    stat = nf_def_var(ent%fileid, trim(varname), &
        & xtype=nc_xtype, ndims=nvdims, dimids=dimids, varid=ent%varid)
    if (stat /= NF_NOERR) goto 999

    ! 登録
    stat = vtable_add(var, ent)
    if (stat /= NF_NOERR) goto 999
    call StoreError(stat, subnam, err, cause_c=url)
    call endsub(subnam, 'varid=%d', i=(/var%id/))
    return

990 continue
    stat = GT_ENOMEM
999 continue
    var = an_variable(-1)
    call StoreError(stat, subnam, err, cause_c=url)
    call endsub(subnam, 'error=%d', i=(/stat/))
end subroutine

! gtfigdisplay.f90 - irregular subroutine
! Copyright (C) TOYODA Eizi, 2000.  All rights reserved.

! open(Frame) まではしたくないユーザのために
! 簡便な手段を提供する。

subroutine GTFigDisplay(dev, fig)
    use gtgraph_types, only: GT_DEVICE, GT_FIGURE, GT_FRAME
    use gtgraph_generic, only: Open, Bind, Display, Close
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_DEVICE), intent(inout):: dev
    type(GT_FIGURE), intent(inout):: fig
    type(GT_FRAME):: dummy_frame
continue
    call beginsub('gtfigdisplay')
    call Open(dummy_frame)
    call Bind(dummy_frame, fig)
    call Display(dev, dummy_frame)
    ! Close(dummy_frame) 時に Close(fig) させないために
    ! とりあえず関連付けの削除
    deallocate(dummy_frame%figs)
    call Close(dummy_frame)
    call endsub('gtfigdisplay')
end subroutine

!
! 文字列
! 
! とりあえずそのものが出せるようにする。
!
function GTStringQuoteForDcl(str) result(result)
    use dc_types, only: STRING
    use dcl, only: DclSetParm
    implicit none
    character(*), intent(in):: str
    character(STRING):: result
    logical, save:: lfirst = .TRUE.
    integer, parameter:: MY_SUPERSCRIPT = 16 * 11 + 15
    integer, parameter:: MY_SUBSCRIPT = 16 * 11 + 14
    integer, parameter:: MY_RESETSCRIPT = 16 * 12 + 5
continue
    if (lfirst) then
        lfirst = .FALSE.
        call DclSetParm('GRAPH:ISUP', MY_SUPERSCRIPT)
        call DclSetParm('GRAPH:ISUB', MY_SUBSCRIPT)
        call DclSetParm('GRAPH:IRST', MY_RESETSCRIPT)
    endif
    result = str
end function

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

subroutine ANXTypeName(ixtype, xtype)
    use netcdf_f77, only: NF_BYTE, NF_CHAR, NF_SHORT, NF_INT, &
        & NF_FLOAT, NF_DOUBLE
    implicit none
    integer, intent(in):: ixtype
    character(*), intent(out):: xtype
    select case(ixtype)
    case(0)
        xtype = "error"
    case(NF_CHAR)
        xtype = "char"
    case(NF_BYTE)
        xtype = "byte"
    case(NF_SHORT)
        xtype = "short"
    case(NF_INT)
        xtype = "int"
    case(NF_FLOAT)
        xtype = "float"
    case(NF_DOUBLE)
        xtype = "double"
    case default
        xtype = ""
    end select
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

subroutine GTFrameLoad(frame, var)
    use gtgraph_types, only: GT_FRAME
    use gtdata_types, only: GT_VARIABLE
    use dc_error
    implicit none
    type(GT_FRAME):: frame     ! should be intent(out)
    type(GT_VARIABLE), intent(in):: var
    call StoreError(GT_EFAKE, "GTFrameLoad")
    stop
end subroutine

! Copyright (C) GFD Dennou Club, 2001.  All rights reserved

SUBROUTINE ANVARPUTREAL(VAR, START, COUNT, STRIDE, IMAP, SIZ, VALUE, IOSTAT)
    USE AN_TYPES, ONLY: AN_VARIABLE
    USE AN_VARTABLE, ONLY: AN_VARIABLE_ENTRY, VTABLE_LOOKUP
    USE NETCDF_F77, ONLY: NF_NOERR, NF_EINVAL, NF_PUT_VARM_REAL
    USE AN_FILE, ONLY: ANFILEDATAMODE
    USE DC_TRACE, ONLY: BEGINSUB, ENDSUB, MESSAGE
    IMPLICIT NONE
    TYPE(AN_VARIABLE), INTENT(IN):: VAR
    INTEGER, INTENT(IN):: START(:)
    INTEGER, INTENT(IN):: COUNT(:)
    INTEGER, INTENT(IN):: STRIDE(:)
    INTEGER, INTENT(IN):: IMAP(:)
    INTEGER, INTENT(IN):: SIZ
    REAL, INTENT(IN):: VALUE(SIZ)
    INTEGER, INTENT(OUT):: IOSTAT
    INTEGER:: NDIMS
    TYPE(AN_VARIABLE_ENTRY):: ENT
    CHARACTER(LEN = *), PARAMETER:: SUBNAME = "ANVARPUTREAL"
CONTINUE
    CALL BEGINSUB(SUBNAME)
    IOSTAT = VTABLE_LOOKUP(VAR, ENT)
    IF (IOSTAT /= NF_NOERR) GOTO 999
    NDIMS = 0
    IF (ASSOCIATED(ENT%DIMIDS)) NDIMS = SIZE(ENT%DIMIDS)
    IF (MIN(SIZE(START), SIZE(COUNT), SIZE(STRIDE), SIZE(IMAP)) < NDIMS) THEN
        IOSTAT = NF_EINVAL
        GOTO 999
    ENDIF
    CALL MESSAGE("F=%D V=%D STA=%*D C=%*D STR=%*D IMAP=%*D", &
        & I=(/ENT%FILEID, ENT%VARID, START, COUNT, STRIDE, IMAP/), &
        & N=(/NDIMS, NDIMS, NDIMS, NDIMS/))
    IOSTAT = ANFILEDATAMODE(ENT%FILEID)
    IF (IOSTAT /= NF_NOERR) RETURN
    IOSTAT = NF_PUT_VARM_REAL(ENT%FILEID, ENT%VARID, &
        & START, COUNT, STRIDE, IMAP, VALUE)
999 CONTINUE
    CALL ENDSUB(SUBNAME, "IOSTAT=%d", I=(/IOSTAT/))
END SUBROUTINE

! gtframe.f90 - GT_FRAME handlers
! Copyright (C) TOYODA Eizi, 2000.  All rights reserved.

subroutine GTFrameOpen(frame)
    use gtgraph_types, only: GT_FRAME
    use dc_string
    implicit none
    type(GT_FRAME), intent(out):: frame
    nullify(frame%figs)
    frame%title = "untitled frame"
end subroutine

subroutine GTFrameClose(frame)
    use gtgraph_types, only: GT_FRAME
    use gtgraph_generic, only: Close
    use dc_string
    implicit none
    type(GT_FRAME), intent(inout):: frame
    integer:: i
    if (associated(frame%figs)) then
        do, i = 1, size(frame%figs)
            call Close(frame%figs(i))
        enddo
        deallocate(frame%figs)
    endif
    frame%title = ""
end subroutine

subroutine GTFrameBindFig(frame, fig)
    use gtgraph_types, only: GT_FRAME, GT_FIGURE
    use dc_string
    implicit none
    type(GT_FRAME), intent(out):: frame
    type(GT_FIGURE), intent(in):: fig
    type(GT_FIGURE), pointer:: newfigbuf(:)
    integer:: newsize
continue
    if (.not. associated(frame%figs)) then
        allocate(frame%figs(1))
        frame%figs(1) = fig
        frame%title = fig%title
    else
        newsize = size(frame%figs) + 1
        allocate(newfigbuf(newsize))
        newfigbuf(1: newsize - 1) = frame%figs(1: newsize - 1)
        deallocate(frame%figs)
        frame%figs => newfigbuf
        frame%figs(newsize) = fig
        ! もうちょっと工夫がいる
        frame%title = trim(frame%title) // '/' // fig%title
    endif
end subroutine

subroutine GTFrameDisplay(dev, frame)
    use gtgraph_types, only: GT_DEVICE, GT_FRAME
    use gtgraph_generic, only: Draw, Option
    use dc_string
    use dcl
    use gtgraph_drawparam
    implicit none
    type(GT_DEVICE), intent(inout):: dev
    type(GT_FRAME), intent(inout):: frame
    character(len = 30):: title
    integer:: i
    logical:: err, all_reached_eof
continue
    if (dev%ws_id == 0) return
    !
    ! ウィンドウいっぱいに表示するための指定 
    !
    call DclSetParm('GRAPH:lfull', .TRUE.)
    call DclSetFrameMargin(left=0.0, right=0.0, bottom=0.05, top=0.08)
    call DclSetAspectRatio(x=1.0, y=0.6)
    title = GTStringQuoteForDcl(frame%title)

    call DclSetParmEX('GRAPH:INDEX',3)
    call DclSetParmEX('GRAPH:LCORNER',.false.)
    call DclSetFrameTitle(title=trim(title), side='t', &
        x_position=0.0, y_position=0.0, height=0.03, num=1)
    call DclSetFrameTitle(title='gtool4/Fortran90', side='b', &
        x_position=-1.0, y_position=-1.0, height=0.01, num=2)
    call DclSetFrameTitle(title='date:#date page:#page', side='b', &
        x_position=+1.0, y_position=-1.0, height=0.01, num=3)
    do
        call DclNewFrame
        frame%first_figure = .TRUE.
        do, i = 1, size(frame%figs)
            call Draw(frame%figs(i), parent=frame)
            frame%first_figure = .FALSE.
        enddo
        all_reached_eof = .TRUE.
        do, i = 1, size(frame%figs)
            call Option(frame%figs(i), "-next", "", err)
            if (.not. err) all_reached_eof = .FALSE.
        enddo
        if (all_reached_eof) exit
    enddo
end subroutine

! dc_string.f90 - character/string type support routines
! Copyright (C) by GFD Dennou Club, 2000.  All rights reserved.
! vi: set sw=4 ts=8:

module dc_string

    use dcstring_base
    use dcstring_list
    use dc_types, only: token, string
    implicit none

    ! === 文字から数値への変換 ===
    !
    ! INT, DBLE などの組み込み関数と同名にすべきか?

    public:: stoi
    interface stoi
        module procedure atoi_scalar
        module procedure stoi_scalar
    end interface

    public:: stod
    interface stod
        module procedure atod_scalar
        module procedure stod_scalar
    end interface

    public:: get_array
    interface get_array
        module procedure str2ip, strv2ip
        module procedure str2rp, strv2rp
        module procedure str2dp, strv2dp
    end interface

    public:: str_to_logical
    interface str_to_logical
        module procedure str2bool
    end interface

    ! === 数値から文字への変換 ===
    !
    ! VAR_STR と同名にすべきかもしれない

    public:: toChar
    interface toChar
        module procedure itoa_scalar
        module procedure itoa_array
        module procedure rtoa_scalar
        module procedure rtoa_array
        module procedure dtoa_scalar
        module procedure dtoa_array
    end interface

    ! === 文字列の解析 ===

    public:: index_ofs
    public:: replace

    ! === 大文字・小文字を無視した処理 ===

    public:: toUpper
    interface ToUpper
        ! that of DCL
        subroutine CUPPER(ch)
            character(len = *), intent(inout):: ch
        end subroutine
    end interface

    public:: toLower
    interface ToLower
        ! that of DCL
        subroutine CLOWER(ch)
            character(len = *), intent(inout):: ch
        end subroutine
    end interface

    public:: strieq
    interface strieq
        module procedure strieq_sc
        module procedure strieq_cc
    end interface

    public:: strHead
    interface StrHead
        module procedure StrHead_sc
        module procedure StrHead_cc
    end interface

    ! === 印字のための文字処理 ===

    public:: GTStringQuoteForDcl
    interface
        function GTStringQuoteForDcl(string) result(result)
            use dc_types, only: STRLEN => STRING
            character(*), intent(in):: string
            character(STRLEN):: result
        end function
    end interface

    public:: cprintf
    interface cprintf

        function &
        DCStringCPrintf(fmt, i, r, d, L, s, n, c1, c2, c3) result(result)
            use dc_types, only: string
            use dcstring_base, only: VSTRING
            character(len = string):: result
            character(*), intent(in):: fmt
            integer, intent(in), optional:: i(:), n(:)
            real, intent(in), optional:: r(:)
            double precision, intent(in), optional:: d(:)
            logical, intent(in), optional:: L(:)
            type(VSTRING), intent(in), optional:: s(:)
            character(*), intent(in), optional:: c1, c2, c3
        end function

    end interface

    public:: printf
    interface printf

        subroutine DCStringSPrintf(unit, fmt, i, r, d, L, s, n, c1, c2, c3)
            use dcstring_base, only: VSTRING
            character(*), intent(out):: unit
            character(*), intent(in):: fmt
            integer, intent(in), optional:: i(:), n(:)
            real, intent(in), optional:: r(:)
            double precision, intent(in), optional:: d(:)
            logical, intent(in), optional:: L(:)
            type(VSTRING), intent(in), optional:: s(:)
            character(*), intent(in), optional:: c1, c2, c3
        end subroutine

        subroutine DCStringPrintf(unit, fmt, i, r, d, L, s, n, c1, c2, c3)
            use dcstring_base, only: VSTRING
            type(VSTRING), intent(out):: unit
            character(*), intent(in):: fmt
            integer, intent(in), optional:: i(:), n(:)
            real, intent(in), optional:: r(:)
            double precision, intent(in), optional:: d(:)
            logical, intent(in), optional:: L(:)
            type(VSTRING), intent(in), optional:: s(:)
            character(*), intent(in), optional:: c1, c2, c3
        end subroutine

        subroutine DCStringFPrintf(unit, fmt, i, r, d, L, s, n, c1, c2, c3)
            use dcstring_base, only: VSTRING
            integer, intent(in), optional:: unit
            character(*), intent(in):: fmt
            integer, intent(in), optional:: i(:), n(:)
            real, intent(in), optional:: r(:)
            double precision, intent(in), optional:: d(:)
            logical, intent(in), optional:: L(:)
            type(VSTRING), intent(in), optional:: s(:)
            character(*), intent(in), optional:: c1, c2, c3
        end subroutine

    end interface

contains

    ! === 正規表現があれば.... ===

    logical function StrHead_SC(string_a, string_b) result(result)
        type(VSTRING), intent(in):: string_a
        character(len = *), intent(in):: string_b
        result = (extract(string_a, 1, len(string_b)) == string_b)
    end function

    logical function StrHead_CC(string_a, string_b) result(result)
        character(len = *), intent(in):: string_a
        character(len = *), intent(in):: string_b
        result = (len(string_a) > len(string_b))
        if (.not. result) return
        result = (string_a(1:len(string_b)) == string_b)
    end function

    ! === 大文字・小文字を無視した処理 ===

    logical function strieq_cc(string_a, string_b) result(result)
        character(len = *), intent(in):: string_a
        character(len = *), intent(in):: string_b
        character(len = len(string_a)):: abuf
        character(len = len(string_b)):: bbuf
        abuf = string_a
        bbuf = string_b
        call ToUpper(abuf)
        call ToUpper(bbuf)
        result = (abuf == bbuf)
    end function

    logical function strieq_sc(string_a, string_b) result(result)
        type(VSTRING), intent(in):: string_a
        character(len = *), intent(in):: string_b
        result = strieq_cc(string_a%body(1:string_a%len), string_b)
    end function

    ! === 文字から数値への変換 ===

    logical function str2bool(string) result(result)
        character(len = *), intent(in):: string
    continue
        select case(string)
        case ("", "0", "0.0", "0.0D0", "0.0d0", ".false.", ".FALSE.", &
            & "f", "F", "false", "FALSE")
            result = .false.
        case default
            result = .true.
        end select
    end function

    integer function atoi_scalar(string, default) result(result)
        character(len = *), intent(in):: string
        integer, intent(in), optional:: default
        integer:: ios
    continue
        read(unit=string, fmt="(i80)", iostat=ios) result
        if (ios /= 0) then
            if (present(default)) then
                result = default
            else
                result = 0
            endif
        endif
    end function

    integer function stoi_scalar(string) result(result)
        type(VSTRING), intent(in):: string
        integer:: ios
        character(len = 80):: buffer
    continue
        buffer = string
        read(unit=buffer, fmt="(i80)", iostat=ios) result
        if (ios /= 0) result = 0
    end function

    double precision function atod_scalar(string) result(result)
        character(len = *), intent(in):: string
        integer:: ios
        character(len = 80):: buffer
        integer:: ipoint, iexp
        intrinsic scan
    continue
        buffer = string
        ! もし整定数をいれてしまった場合は小数点を附加
        if (index(buffer, '.') == 0) then
            iexp = scan(buffer, "eEdD")
            if (iexp /= 0) then
                buffer(iexp+1: len(buffer)) = buffer(iexp: len(buffer)-1)
                ipoint = iexp
            else
                ipoint = len_trim(buffer) + 1
            endif
            buffer(ipoint: ipoint) = '.'
        endif
        read(unit=buffer, fmt="(g80.10)", iostat=ios) result
        if (ios /= 0) result = 0.0
    end function

    double precision function stod_scalar(string) result(result)
        type(VSTRING), intent(in):: string
        character(len = 80):: buffer
    continue
        buffer = string
        result = atod_scalar(buffer)
    end function

    subroutine str2ip(int_ptr, string)
        integer, pointer:: int_ptr(:)
        character(len = *), intent(in):: string
        integer:: i, j, idx, nvalues
    continue
	nvalues = 1
        i = 1
	do
            idx = index(string(i: ), ',')
	    if (idx == 0) exit
	    i = i + idx - 1 + 1 
	    nvalues = nvalues + 1
	enddo
        allocate(int_ptr(nvalues))
	i = 1
	j = 1
        do
            idx = index(string(i: ), ',')
	    if (idx == 0) then
                int_ptr(j) = stoi(string(i: ))
		exit
	    endif
	    int_ptr(j) = stod(string(i: i+idx-2))
	    i = i + idx - 1 + 1 
	    j = j + 1
        enddo
    end subroutine

    subroutine strv2ip(int_ptr, string)
        use dcstring_list
        integer, pointer:: int_ptr(:)
        type(VSTRING), intent(in):: string
        type(STRING_LIST):: vslist
        integer:: nvalues, i
    continue
        call Split(vslist, string, ", ")
        nvalues = len(vslist)
        allocate(int_ptr(nvalues))
        do, i = 1, nvalues
            int_ptr(i) = stoi(shift(vslist))
        enddo
        call dispose(vslist)
    end subroutine

    subroutine str2rp(real_ptr, string)
        real, pointer:: real_ptr(:)
        character(len = *), intent(in):: string
        integer:: i, j, idx, nvalues
    continue
	nvalues = 1
        i = 1
	do
            idx = index(string(i: ), ',')
	    if (idx == 0) exit
	    i = i + idx - 1 + 1 
	    nvalues = nvalues + 1
	enddo
        allocate(real_ptr(nvalues))
	i = 1
	j = 1
        do
            idx = index(string(i: ), ',')
	    if (idx == 0) then
                real_ptr(j) = stod(string(i: ))
		exit
	    endif
	    real_ptr(j) = stod(string(i: i+idx-2))
	    i = i + idx - 1 + 1 
	    j = j + 1
        enddo
    end subroutine

    subroutine strv2rp(real_ptr, string)
        use dcstring_list
        real, pointer:: real_ptr(:)
        type(VSTRING), intent(in):: string
        type(STRING_LIST):: vslist
        integer:: i, nvalues
    continue
        call Split(vslist, string, ", ")
        nvalues = len(vslist)
        allocate(real_ptr(nvalues))
        do, i = 1, nvalues
            real_ptr(i) = stod(shift(vslist))
        enddo
        call dispose(vslist)
    end subroutine

    subroutine str2dp(real_ptr, string)
        double precision, pointer:: real_ptr(:)
        character(len = *), intent(in):: string
        integer:: i, j, idx, nvalues
    continue
	nvalues = 1
        i = 1
	do
            idx = index(string(i: ), ',')
	    if (idx == 0) exit
	    i = i + idx - 1 + 1 
	    nvalues = nvalues + 1
	enddo
        allocate(real_ptr(nvalues))
	i = 1
	j = 1
        do
            idx = index(string(i: ), ',')
	    if (idx == 0) then
                real_ptr(j) = stod(string(i: ))
		exit
	    endif
	    real_ptr(j) = stod(string(i: i+idx-2))
	    i = i + idx - 1 + 1 
	    j = j + 1
        enddo
    end subroutine

    subroutine strv2dp(dble_ptr, string)
        use dcstring_list
        double precision, pointer:: dble_ptr(:)
        type(VSTRING), intent(in):: string
        type(STRING_LIST):: vslist
        integer:: i, nvalues
    continue
        call Split(vslist, string, ", ")
        nvalues = len(vslist)
        allocate(dble_ptr(nvalues))
        do, i = 1, nvalues
            dble_ptr(i) = stod(shift(vslist))
        enddo
        call dispose(vslist)
    end subroutine

    !
    ! === 数値から文字への変換 ===
    !

    character(token) function itoa_scalar(i) result(result)
        integer, intent(in):: i
        character(len = 32):: buffer
    continue
        write(unit=buffer, fmt="(i20)") i
        result = adjustl(buffer)
    end function

    character(string) function itoa_array(ibuf) result(result)
        integer, intent(in):: ibuf(:)
        integer:: i
    continue
        if (size(ibuf) <= 0) then
            result = ""
            return
        endif
        result = toChar(ibuf(1))
        do, i = 2, size(ibuf)
            result = trim(result) // ", " // trim(toChar(ibuf(i)))
        enddo
    end function

    character(token) function rtoa_scalar(x) result(result)
        real, intent(in):: x
        character(len = 16):: buffer
    continue
        write(unit=buffer, fmt="(g16.8)") x
        result = adjustl(buffer)
    end function

    character(string) function rtoa_array(rbuf) result(result)
        real, intent(in):: rbuf(:)
        integer:: i
    continue
        if (size(rbuf) <= 0) then
            result = ""
            return
        endif
        result = toChar(rbuf(1))
        do, i = 2, size(rbuf)
            result = trim(result) // ", " // trim(toChar(rbuf(i)))
        enddo
    end function

    character(token) function dtoa_scalar(d) result(result)
        double precision, intent(in):: d
        character(len = 32):: buffer
    continue
        write(unit=buffer, fmt="(g32.24)") d
        result = adjustl(buffer)
    end function

    character(STRING) function dtoa_array(dbuf) result(result)
        double precision, intent(in):: dbuf(:)
        integer:: i
    continue
        if (size(dbuf) <= 0) then
            result = ""
            return
        endif
        result = toChar(dbuf(1))
        do, i = 2, size(dbuf)
            result = trim(result) // ", " // trim(toChar(dbuf(i)))
        enddo
    end function

    ! === 文字列の解析 ===

    integer function index_ofs(string, start, substr) result(result)
        character(len = *), intent(in):: string
        integer, intent(in):: start
        character(len = *), intent(in):: substr
        intrinsic index
        if (start < 1) then
            result = 0
            return
        endif
        result = index(string(start: ), substr)
        if (result == 0) return
        result = start + result - 1
    end function

    function replace(string, from, to) result(result)
        use dc_types, only: strlen => string
    implicit none
        character(len = strlen):: result
        character(len = *), intent(in):: string, from, to
        integer:: i, isa, isb, iea, ieb
    continue
        result = string
        i = index(result, from)
        if (i == 0) return
        isa = i + len(from)
        isb = i + len(to)
        if (len(to) < len(from)) then
            iea = len(result)
            ieb = len(result) + len(to) - len(from)
        else
            iea = len(result) + len(from) - len(to)
            ieb = len(result)
        endif
        if (len(to) /= len(from)) result(isb:ieb) = result(isa:iea)
        result(i:i+len(to)-1) = to
    end function

end module

module dc_units

    use dc_types, only: double, token, string
    implicit none

    type units
        real(double):: factor
        integer:: nelems
        character(token), pointer:: name(:)
        character(token):: offset
        real(double), pointer:: power(:)
    end type

    interface clear
        module procedure dcunitsclear
    end interface

    interface deallocate
        module procedure dcunitsdeallocate
    end interface

    interface assignment(=)
        module procedure dcunitsbuild, dcunitstostring
    end interface

    interface operator(*)
        module procedure dcunitsmul
    end interface

    interface operator(/)
        module procedure dcunitsdiv
    end interface

    interface operator(+)
        module procedure dcunitsadd
    end interface

    private:: units_simplify

contains

    subroutine units_simplify(u, name, power)
        type(units), intent(inout):: u
        character(token), intent(in):: name(u%nelems)
        real(double), intent(in):: power(u%nelems)
        integer:: i, n, j, onazi
        integer:: table(u%nelems)

        if (u%nelems < 1) return
        table(:) = 0
        n = 0
        do, i = 1, u%nelems
            if (name(i) == '') cycle
            onazi = 0
            do, j = 1, i - 1
                if (name(j) == name(i)) then
                    onazi = j
                endif
            enddo
            if (onazi > 0) then
                table(i) = table(onazi)
            else
                n = n + 1
                table(i) = n
            endif
        enddo
        allocate(u%name(n), u%power(n))
        u%power = 0.0_double
        do, i = 1, u%nelems
            if (table(i) == 0) cycle
            u%name(table(i)) = name(i)
            u%power(table(i)) = u%power(table(i)) + power(i)
        enddo
        u%nelems = n
    end subroutine

    type(units) function dcUnitsMul(u1, u2) result(result)
        type(units), intent(in):: u1, u2
        integer:: n
        character(token), allocatable:: name(:)
        real(double), allocatable:: power(:)
        result%factor = u1%factor * u2%factor
        result%nelems = u1%nelems + u2%nelems
        result%offset = ""
        n = result%nelems
        if (n == 0) then
            nullify(result%name, result%power)
            return
        endif
        allocate(name(n), power(n))
        name = (/u1%name, u2%name/)
        power = (/u1%power, u2%power/)
        call units_simplify(result, name, power)
        deallocate(name, power)
    end function

    type(units) function dcUnitsDiv(u1, u2) result(result)
        type(units), intent(in):: u1, u2
        integer:: n, n1
        character(token), allocatable:: name(:)
        real(double), allocatable:: power(:)
        if (abs(u2%factor) < tiny(u2%factor)) then
            result%factor = sign(u1%factor, 1.0_double) * &
                & sign(u2%factor, 1.0_double) * &
                & huge(1.0_double)
        else
            result%factor = u1%factor / u2%factor
        endif
        result%nelems = u1%nelems + u2%nelems
        result%offset = ""
        n = result%nelems
        if (n == 0) then
            nullify(result%name, result%power)
            return
        endif
        allocate(name(n), power(n))
        n1 = u1%nelems
        if (n1 >= 1) then
            name(1:n1) = u1%name(1:n1)
            power(1:n1) = u1%power(1:n1)
        endif
        n1 = n1 + 1
        if (n >= n1) then
            name(n1:n) = u2%name(1:u2%nelems)
            power(n1:n) = -u2%power(1:u2%nelems)
        endif
        call units_simplify(result, name, power)
        deallocate(name, power)
    end function

    type(units) function dcUnitsAdd(u1, u2) result(result)
        type(units), intent(in):: u1, u2
        type(units):: x
        result%offset = u1%offset
        result%nelems = u1%nelems
        result%factor = u1%factor + u2%factor
        x = u1 / u2
        if (x%nelems == 0) then
            nullify(result%name, result%power)   
            return
        endif
        if (all(abs(x%power(1:result%nelems)) < tiny(0.0d0))) then
            allocate(result%name(result%nelems), result%power(result%nelems))
            result%name = u1%name
            result%power = u1%power
            return
        endif
        result%factor = 0.0
        result%nelems = -1
        result%offset = "MISMATCH"
        nullify(result%name, result%power)   
    end function

    logical function add_okay(u1, u2) result(result)
        type(units), intent(in):: u1, u2
        type(units):: x
        character(string):: debug
        call clear(x)
        x = u1 / u2
        debug = u1
        debug = u2
        debug = x
        if (x%nelems == 0) then
            result = .true.
        else if (all(abs(x%power(1:x%nelems)) < tiny(0.0d0))) then
            result = .true.
        else
            result = .false.
        endif
        call deallocate(x)
    end function

    subroutine dcunitsclear(u)
        type(units), intent(inout):: u
        nullify(u%name)
        nullify(u%power)
        u%factor = 1.0_double
        u%offset = ""
        u%nelems = 0
    end subroutine

    subroutine dcunitsdeallocate(u)
        type(units), intent(inout):: u
        if (associated(u%name)) deallocate(u%name)
        if (associated(u%power)) deallocate(u%power)
        u%factor = 1.0_double
        u%offset = ""
        u%nelems = 0
    end subroutine

    subroutine dcunitstostring(string, u)
        character(*), intent(out):: string
        type(units), intent(in):: u
        integer:: i, ip, npower
        character(token):: buffer
        character:: mul = '.'
        real(double), parameter:: allowed = epsilon(1.0d0) * 16.0

	if (u%nelems < 0) then
	    string = 'error from ' // u%offset
	    return 
	endif

        write(buffer, "(1pg20.12)") u%factor
        string = buffer
        if (u%nelems < 1) return

        if (abs(u%factor - 1.0) < allowed) then
            string = ""
        else if (abs(u%factor + 1.0) < allowed) then
            string = "-"
        endif

        ip = len_trim(string) + 1
        do, i = 1, u%nelems
            npower = nint(u%power(i))
            if (abs(1.0 - u%power(i)) < allowed) then
                buffer = " "
            else if (abs(npower - u%power(i)) < allowed) then
                write(buffer, "(i10)") npower
                buffer = adjustl(buffer)
            else
                write(buffer, "(1pg10.3)") u%power(i)
                buffer = adjustl(buffer)
            endif
            if (buffer == '0') cycle
            string = trim(string) // mul // trim(u%name(i)) // trim(buffer)
        enddo
        if (ip <= len(string)) string(ip:ip) = ' '
        if (string(1:1) == " ") string = adjustl(string)
        if (u%offset /= "") then
            string = trim(string) // '@' // trim(u%offset)
        endif
    end subroutine

    subroutine dcunitsbuild(u, cunits)
        use dcunits_com
        type(units), intent(out):: u
        character(string), intent(in):: cunits

        ! 構築中の情報、乗算対象の列として保持する。
        ! これは shift オペレータ付き単位を乗算できないことを示す。
        type elem_units
            character(token):: name
            real(double):: power, factor
        end type
        type(elem_units), target:: ustack(100)
        integer:: ui = 1

        ! 構文単位が占める乗算対象の stack における最初の添字
        type paren_t
            real(double):: factor
            integer:: factor_exp
            logical:: factor_inv
            integer:: power_exp
            integer:: paren_exp
        end type
        type(paren_t):: pstack(50)
        integer:: pi = 1

        ! パーサの状態遷移
        integer, parameter:: Y_INIT = 1, Y_NUMBER = 2, Y_NAME = 3, &
            & Y_NX = 4, Y_NI = 5, Y_MUL = 6, Y_SHIFT = 7
        integer:: yparse_status = Y_INIT

        ! 字句
        integer:: ltype
        integer:: ivalue(5)
        real(double):: dvalue
        character(token):: cvalue
        ! その他
        integer:: i
        
    ! --- 実行部 ---
        ! 初期化
        if (associated(u%name)) deallocate(u%name)
        if (associated(u%power)) deallocate(u%power)
        u%nelems = 0
        u%offset = ""
        u%factor = 1.0_double
        if (cunits == "") return
        call dcunitssetline(cunits)
        call ustack_clear
        call pstack_clear
        yparse_status = Y_INIT

        do
            call dcunitsgettoken(ltype, ivalue, dvalue, cvalue)
            select case(ltype)
            case (S_INTEGER)
                select case(yparse_status)
                case (Y_INIT, Y_MUL)
                    pstack(pi)%factor = pstack(pi)%factor * ivalue(1)
                    yparse_status = Y_NUMBER
                case (Y_NAME, Y_NX)
                    i = pstack(pi)%power_exp
                    ustack(i:ui)%power = ustack(i:ui)%power * ivalue(1) 
                    call power_next
                    yparse_status = Y_NI
                case (Y_SHIFT)
                    u%offset = cvalue
                case default
                    call error
                end select
            case (S_REAL)
                select case(yparse_status)
                case (Y_INIT, Y_MUL)
                    pstack(pi)%factor = pstack(pi)%factor * dvalue
                    yparse_status = Y_NUMBER
                case (Y_NAME, Y_NX)
                    i = pstack(pi)%power_exp
                    ustack(i:ui)%power = ustack(i:ui)%power * dvalue
                    call power_next
                    yparse_status = Y_NI
                case (Y_SHIFT)
                    u%offset = cvalue
                case default
                    call error
                end select
            case (S_TEXT)
                select case(yparse_status)
                case (Y_INIT, Y_NUMBER, Y_MUL)
                    ustack(ui)%name = cvalue
                    yparse_status = Y_NAME
                case (Y_NAME, Y_NI)
                    call ustack_grow
                    call power_next
                    ustack(ui)%name = cvalue
                    yparse_status = Y_NAME
                case (Y_SHIFT)
                    u%offset = cvalue
                case default
                    call error
                end select
            case (S_EXPONENT)
                select case(yparse_status)
                case (Y_NAME)
                    yparse_status = Y_NX
                case default
                    call error
                end select
            case (S_MULTIPLY)
                select case(yparse_status)
                case (Y_NUMBER, Y_NAME)
                    call factor_next
                    yparse_status = Y_MUL
                case default
                    call error
                end select
            case (S_DIVIDE)
                select case(yparse_status)
                case (Y_NUMBER, Y_NAME)
                    call factor_next
                    pstack(pi)%factor_inv = .TRUE.
                    yparse_status = Y_MUL
                case default
                    call error
                end select
            case (S_SHIFT)
                if (yparse_status == Y_NX) call cancel_exp
                call units_finalize
                yparse_status = Y_SHIFT
            case (S_OPENPAR)
                if (yparse_status == Y_NX) call cancel_exp
                call pstack_push
            case (S_CLOSEPAR)
                call units_finalize
                call pstack_pop
            case (S_EOF)
                exit
            case default
                call error
            end select
        enddo
        if (yparse_status == Y_NX) call cancel_exp
        call units_finalize

        u%nelems = ui
        u%factor = product(ustack(1:ui)%factor)
        call units_simplify(u, ustack(1:ui)%name, ustack(1:ui)%power)

    contains

        subroutine cancel_exp
            print *, "DCUnitsBuild: syntax error, operator(**) ignored"
        end subroutine

        subroutine error
            print *, "DCUnitsBuild: unexpected token <", &
                & trim(cvalue), "> ignored"
        end subroutine

        subroutine power_next
            ! power_exp の終了処理
            call ustack_grow
            pstack(pi)%power_exp = ui
        end subroutine

        subroutine factor_next
            ! factor_exp の終了処理
            real(double):: factor
            i = pstack(pi)%factor_exp
            factor = product(ustack(i:ui)%factor) * pstack(pi)%factor
            if (pstack(pi)%factor_inv) then
                ustack(i:ui)%power = -ustack(i:ui)%power
                factor = 1.0_double / factor
            endif
            ustack(i)%factor = factor
            ustack(i+1:ui)%factor = 1.0_double
            call power_next
            pstack(pi)%factor = 1.0_double
            pstack(pi)%factor_exp = ui
        end subroutine

        subroutine units_finalize
            call factor_next
        end subroutine

        subroutine ustack_clear
            ui = 0
            call ustack_grow
        end subroutine

        subroutine ustack_grow
            if (ui >= size(ustack)) stop 'DCUnitsBuild: too many elements'
            ui = ui + 1
            ustack(ui)%name = ""
            ustack(ui)%factor = 1.0_double
            ustack(ui)%power = 1.0_double
        end subroutine

        subroutine pstack_clear
            pi = 0
            call pstack_push
        end subroutine

        subroutine pstack_push
            if (pi >= size(pstack)) stop 'DCUnitsBuild: too many parens'
            pi = pi + 1
            call ustack_grow
            pstack(pi)%factor_exp = ui
            pstack(pi)%factor = 1.0_double
            pstack(pi)%factor_inv = .FALSE.
            pstack(pi)%power_exp = ui
            pstack(pi)%paren_exp = ui
        end subroutine

        subroutine pstack_pop
            ! factor_exp の終了処理
            call power_next
            pi = pi - 1
        end subroutine

    end subroutine

end module

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

subroutine ANVarDelAttr(var, name, err)
    use an_types, only: AN_VARIABLE, an_variable_entry
    use an_file, only: ANFileDefineMode
    use an_vartable, only: vtable_lookup
    use netcdf_f77, only: NF_NOERR, NF_DEL_ATT, NF_ENOTINDEFINE, NF_GLOBAL
    use dc_url, only: GT_PLUS
    use dc_error
    implicit none
    type(AN_VARIABLE), intent(in):: var
    character(len = *), intent(in):: name
    logical, intent(out), optional:: err
    type(an_variable_entry):: ent
    integer:: stat
continue
    stat = vtable_lookup(var, ent)
    if (stat /= NF_NOERR) goto 999
    stat = nf_del_att(ent%fileid, ent%varid, name=name)
    if (stat == 0) goto 999
    if (stat /= NF_ENOTINDEFINE) goto 999
    stat = ANFileDefineMode(ent%fileid)
    if (stat /= NF_NOERR) goto 999
    if (name(1:1) == GT_PLUS) then
        stat = nf_del_att(ent%fileid, NF_GLOBAL, name=name(2:))
    else
        stat = nf_del_att(ent%fileid, ent%varid, name=name)
    endif

999 continue
    call StoreError(stat, 'ANVarPutAttrChar', err)
end subroutine

subroutine GTVarInquire2(var, allcount)
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: inquire, open, close
    use dc_trace, only: beginsub, endsub
    type(GT_VARIABLE), intent(in):: var
    ! alldims ŒÂ•K—v
    integer, intent(out):: allcount(:)
    integer:: i, n
    type(GT_VARIABLE):: v
    call beginsub('gtvarinquire2')
    call inquire(var, alldims=n)
    do, i = 1, n
        call Open(v, var, i, count_compact=.true.)
        call inquire(var, allcount=allcount(i))
        call Close(v)
    enddo
    call endsub('gtvarinquire2')
end subroutine

! GTGraphSaveName - Save 手続が自動生成する名前
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

subroutine GTGraphSaveName(result)
    use dc_types, only: string
    use gtdata_generic, only: GTDataTmpNam
implicit none
    character(len = *), intent(out):: result
continue
    call GTDataTmpNam(file="gtgraph.nc", base="gr", result=result)
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.



! お客様向きではないけれど、情報落ちのないインターフェイスということで....
! stat < 0:  エラー、あるいはその属性は存在しなかった
! stat = 0 ... size(value):  その属性を全部読み取った。サイズは stat 個
! stat > size(value):  配列長不足のため属性が全部読み取れなかった。
!                      サイズは stat 個必要
!
! バグ:
!  属性が文字型で STRING 文字を越える場合、GT_ECHARSHORT が返る

SUBROUTINE ANATTRGETDOUBLE(VAR, NAME, VALUE, STAT, DEFAULT)
    USE AN_TYPES, ONLY: AN_VARIABLE, AN_VARIABLE_ENTRY
    USE AN_VARTABLE, ONLY: VTABLE_LOOKUP
    USE NETCDF_F77, ONLY: NF_NOERR, NF_EINVAL, NF_GLOBAL, NF_CHAR, NF_ENOMEM, &
        & NF_INQ_ATT, NF_GET_ATT_DOUBLE
    USE DC_URL, ONLY: GT_PLUS
    USE AN_GENERIC, ONLY: GET_ATTR
    USE DC_TYPES, ONLY: STRING
    USE DC_STRING
    IMPLICIT NONE
    TYPE(AN_VARIABLE), INTENT(IN):: VAR
    CHARACTER(LEN = *), INTENT(IN):: NAME
    DOUBLE PRECISION, INTENT(OUT):: VALUE(:)
    INTEGER, INTENT(OUT):: STAT
    DOUBLE PRECISION, INTENT(IN), OPTIONAL:: DEFAULT
    DOUBLE PRECISION, ALLOCATABLE:: RBUFFER(:)
    CHARACTER(LEN = STRING):: CBUFFER
    TYPE(STRING_LIST):: LBUFFER
    INTEGER:: ATTRLEN, XTYPE, I, XFEREND, INAME, VARID
    TYPE(AN_VARIABLE_ENTRY):: ENT
CONTINUE
    STAT = VTABLE_LOOKUP(VAR, ENT)
    IF (STAT /= NF_NOERR) THEN
        IF (PRESENT(DEFAULT)) VALUE(:) = DEFAULT
        RETURN
    ENDIF
    ! 型と長さを取得
    IF (NAME(1:1) == GT_PLUS) THEN
        INAME = 2
        VARID = NF_GLOBAL
    ELSE
        INAME = 1
        VARID = ENT%VARID
    ENDIF
    STAT = NF_INQ_ATT(ENT%FILEID, VARID, NAME(INAME:), XTYPE=XTYPE, LEN=ATTRLEN)
    IF (STAT /= NF_NOERR) THEN
        IF (PRESENT(DEFAULT)) VALUE(:) = DEFAULT
        RETURN
    ENDIF
    ! 文字型の場合は長さをコンマで分解した語数と読み替える
    IF (XTYPE == NF_CHAR) THEN
        CALL GET_ATTR(VAR, NAME, CBUFFER, "", STAT)
        IF (STAT /= 0) RETURN
        CALL SPLIT(LBUFFER, CBUFFER, ", ")
        ATTRLEN = LEN(LBUFFER)
    ENDIF
    ! 結果を入れるところがなければ長さだけを伝え終了
    IF (SIZE(VALUE) == 0) THEN
        IF (XTYPE == NF_CHAR) CALL DISPOSE(LBUFFER)
        STAT = ATTRLEN
        RETURN
    ENDIF
    ! 型に応じて要求されただけ値を転送
    XFEREND = MIN(SIZE(VALUE), ATTRLEN)
    IF (PRESENT(DEFAULT)) VALUE(XFEREND+1: ) = DEFAULT
    IF (XTYPE == NF_CHAR) THEN
        DO, I = 1, XFEREND
            VALUE(I) = STOD(ELEMENT(LBUFFER, I))
        ENDDO
        CALL DISPOSE(LBUFFER)
        STAT = ATTRLEN
        RETURN
    ELSE
        ALLOCATE(RBUFFER(ATTRLEN), STAT=STAT)
        IF (STAT /= 0) THEN
            STAT = NF_ENOMEM
            RETURN
        ENDIF
        STAT = NF_GET_ATT_DOUBLE(ENT%FILEID, VARID, NAME(INAME:), RBUFFER)
        IF (STAT == NF_NOERR) THEN
            VALUE(1:XFEREND) = RBUFFER(1:XFEREND)
            STAT = ATTRLEN
        ENDIF
        DEALLOCATE(RBUFFER)
        RETURN
    ENDIF
END SUBROUTINE

! gtaxisdefault.f90 - 軸操作
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

subroutine GTAxisOpen(this, base_var, dimno, vertical)
    use gtgraph_types, only: GT_AXIS
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: Open, get, Inquire, get_attr, attr_true
    use dc_trace, only: message, beginsub, endsub
    use sysdep, only: abortprogram
    use dc_string
    implicit none
    type(GT_AXIS), intent(out):: this
    type(GT_VARIABLE), intent(in):: base_var
    integer, intent(in):: dimno
    logical, intent(in), optional:: vertical
    real, pointer:: values(:)
    character(*), parameter:: sub = 'GTAxisOpen'
    character(token):: positive
    character(token):: topology
    real :: modulo
    real, pointer :: range(:)
continue
    call beginsub(sub, 'var=%d dimno=%d', i=(/base_var%mapid, dimno/))
    call Open(this%var, base_var, dimno)

    ! 縦軸か横軸かを決定
    this%vertical = .FALSE.
    if (present(vertical)) this%vertical = vertical

    ! 軸の上下限推奨値設定
    call get(this%var, values)
    if (.not. associated(values)) then
       call abortprogram('gtaxisopen: read error of variable')
    endif
    ! まずは gt_graph_range 属性をチェック
    call get_attr(this%var, "gt_graph_range", range)
    if ( associated(range) )then
       if ( size(range).lt. 2 )then
          call message('dim. of gt_axis_range should be 2') 
          ! 上下 2 つの値が与えられなければ無視. 
       else
          this%lower=range(1) ; this%upper=range(2)
       endif
    else
       ! 周期的座標の処理. 範囲を周期から定める.
       call get_attr(this%var, "topology", topology)
       if ( topology == "circular" ) then 
          call get_attr(this%var, "modulo", modulo, 0.0 )
          if ( modulo == 0.0 ) then
             call abortprogram('gtaxisopen: cyclic axis does not have modulo attribute')
          else
             this%lower = minval(values)
             this%upper = minval(values) + modulo
          endif
       else  
          ! それでもダメなら範囲を軸データから定める.
          ! 切りのよい値への変換は DclScalingPoint にゆだねる。
          this%upper = maxval(values) 
          this%lower = minval(values)
       end if
    endif
    deallocate(values)

    ! 文字属性を取得
    call get_attr(this%var, 'long_name', this%title)
    if (this%title == '') call Inquire(this%var, name=this%title)
    ! 単位に関してはいずれ GT_VARIABLE が
    ! インターフェイスを持つべきである
    call get_attr(this%var, 'units', this%units)
    if (this%units == '') then
        call get_attr(this%var, 'unit', this%units, &
            default="units missing")
    endif

    ! フラグ
    this%logscale = attr_true(this%var, "gt_graph_logscale")
    call get_attr(this%var, "positive", positive)
    this%negative = (positive == "down")

    ! 二重描画を防止するためのフラグ
    this%drawn = .FALSE.
    ! 二重セーブを防止するためのフラグ
    this%saved = ""

    call endsub(sub, 'vert=%y upper=%r lower=%r', L=(/this%vertical/), &
        & r=(/this%upper, this%lower/))
end subroutine

! サブルーチン名 Axes は Axis の複数であることに注意。
! 現在のところ必ず座標軸は 2 つ対で描画されなければならない。

subroutine GTAxesDraw(h_axis, v_axis, parent, set_space)
    use gtgraph_types, only: GT_AXIS, GT_FIGURE
    use gtdata_generic, only: Get, get_attr
    use dc_trace, only: message
    use dc_string
    use dc_error
    use dcl
    use gtgraph_drawparam
    implicit none
    type(GT_AXIS), intent(inout):: h_axis, v_axis
    type(GT_FIGURE), intent(in):: parent
    logical, intent(in), optional:: set_space
    logical:: set_space_mode
    real, pointer:: value(:)
    type(VSTRING):: xtitle, ytitle, xunits, yunits
    real:: radius
    logical::llnintsave
    integer::index
    character(token):: topology

continue
    ! それはないだろう
    if (.not. associated(parent%h_axis)) return
    if (.not. associated(parent%v_axis)) return
    ! オプション処理
    set_space_mode = .FALSE.
    if (present(set_space)) set_space_mode = set_space
    call message("gtaxesdraw: h(%r %r) v(%r %r)", &
        r=(/h_axis%lower, h_axis%upper, v_axis%lower, v_axis%upper/))

    ! Dcl 変数設定
    call DclSetParm('LABEL_HEIGHT1', gt_axis_label_height1)
    call DclSetParm('TITLE_HEIGHT1', gt_axis_title_height1)

    ! 軸を描くということは空間設定でもある。
    call DclSetWindow(h_axis%lower, h_axis%upper, &
                      v_axis%lower, v_axis%upper)
    select case(parent%projection)
    case (1:4)
       ! 軸の向き設定変数
        call DclSetParmEx('INV_X_AXIS', h_axis%negative )
        call DclSetParmEx('INV_Y_AXIS', v_axis%negative )
        call DclFitScalingParm
        call DCLSetTransNumber(parent%projection)
        call local_draw_normal_axes
    case (5:6) 
       ! 双曲線座標の場合はノーチェック
       ! radius = (0.7 - 0.3) / 2 / h_axis%upper
        radius = min( gt_figure_vxmax-gt_figure_vxmin, &
                      gt_figure_vymax-gt_figure_vymin) &
                 / 2 / h_axis%upper
        call DCLSetSimilarity(radius, 0.0, 0.0)
        call DCLSetTransNumber(parent%projection)
    case (10:15)
        call DCLSetTransNumber(parent%projection)
        call DCLSetMapContactPoint(parent%stdlon, parent%stdlat, parent%rotate)
        call DCLSetParm('MAP:LGLOBE', .true.)
        call DCLFitMapParm
    case (20:23)
        call DCLSetParm('GRAPH:stlat1', 45.0)
        call DCLSetParm('GRAPH:stlat2', 30.0)
        call DCLSetTransNumber(parent%projection)
        call DCLSetMapContactPoint(parent%stdlon, parent%stdlat, parent%rotate)
        call DCLSetParm('MAP:LGLOBE', .true.)
        call DCLFitMapParm
    case (30:33)
        call DCLSetTransNumber(parent%projection)
        call DCLSetMapContactPoint(parent%stdlon, parent%stdlat, parent%rotate)
        call DCLSetParm('MAP:LGLOBE', .true.)
        call DCLFitMapParm
    case default
        call DCLSetTransNumber(1)
        call local_draw_normal_axes
    end select
    call DclSetTransFunction()

    ! GTContDraw などのために格子位置を設定
    if (set_space_mode) then
        call get(h_axis%var, value)
        ! 周期的座標の処理. 格子点を最後に一つ追加. 
        call get_attr(h_axis%var, "topology", topology)
        if ( topology == "circular" ) then
           call DclSetXGrid((/value,h_axis%upper/)) 
        else
           call DclSetXGrid(value)
        endif
        deallocate(value)
        call get(v_axis%var, value)
        ! 周期的座標の処理. 格子点を最後に一つ追加. 
        call get_attr(v_axis%var, "topology", topology)
        if ( topology == "circular" ) then
           call DclSetYGrid((/value,v_axis%upper/))
        else
           call DclSetYGrid(value)
        endif
        deallocate(value)
    endif
    select case(parent%projection)
        case(5)
           ! 外枠描画. まだ内外円弧のみ. 完全に囲うには cyclic 判定が必要.
            llnintsave=DCLGetLogical('GRAPH:LLNINT')
            index=DCLGetInteger('AXIS:INDEXT2')
            call DCLSetParm('GRAPH:LLNINT',.true.)
            call DCLDrawLine((/h_axis%lower,h_axis%lower/),&
                 (/v_axis%lower,v_axis%upper/),type=1,index=index)
            call DCLDrawLine((/h_axis%upper,h_axis%upper/),&
                 (/v_axis%lower,v_axis%upper/),type=1,index=index)
            call DCLSetParm('GRAPH:LLNINT',llnintsave)
        case(10:15, 20:23, 30:33)
            call DCLDrawLimb()
    end select
    return
contains

        ! まさしく軸の描画そのもの
    subroutine local_draw_normal_axes
        if (.not. (h_axis%drawn .or. v_axis%drawn)) then
            xtitle = GTStringQuoteForDcl(h_axis%title)
            ytitle = GTStringQuoteForDcl(v_axis%title)
            xunits = GTStringQuoteForDcl(h_axis%units)
            yunits = GTStringQuoteForDcl(v_axis%units)
            call DclSetTitle( &
                & vchar(xtitle, len(xtitle)), &
                & vchar(ytitle, len(ytitle)), &
                & vchar(xunits, len(xunits)), &
                & vchar(yunits, len(yunits)))
            ! 外向き目盛り
            call DclSetParm('AXIS:INNER', -1)
            call DclDrawScaledAxis()
        else if (.not. v_axis%drawn) then
            ytitle = GTStringQuoteForDcl(v_axis%title)
            yunits = GTStringQuoteForDcl(v_axis%units)
            call DclSetTitle("", vchar(ytitle, len(ytitle)), &
                & "", vchar(yunits, len(yunits)))
            call DclDrawScaledAxis(side="rl")
        else if (.not. h_axis%drawn) then
            xtitle = GTStringQuoteForDcl(h_axis%title)
            xunits = GTStringQuoteForDcl(h_axis%units)
            call DclSetTitle(vchar(xtitle, len(xtitle)), "", &
                & vchar(xunits, len(xunits)), "")
            call DclDrawScaledAxis(side="tb")
        endif
        h_axis%drawn = .TRUE.
        v_axis%drawn = .TRUE.
        return
    end subroutine

end subroutine

subroutine GTAxesDrawGrid(h_axis, v_axis, parent)
    use gtgraph_types, only: GT_AXIS, GT_FIGURE
    use gtdata_generic, only: Get, get_attr
    use dc_string
    use dcl
    type(GT_AXIS), intent(inout):: h_axis, v_axis
    type(GT_FIGURE), intent(in):: parent
    real, pointer:: hvalue(:)
    real, pointer:: vvalue(:)
    real, pointer:: tmpval(:)
    integer:: innersave,index, i
    real:: simfac,vtick,rtick,thetatick
    character(token):: topology

    call get(h_axis%var, hvalue)
    ! 周期的座標の処理. 格子点を最後に一つ追加. 
    call get_attr(h_axis%var, "topology", topology)
    if ( topology == "circular" ) then
       allocate(tmpval(size(hvalue)+1))
       tmpval(1:size(hvalue))=hvalue
       tmpval(size(hvalue)+1)=h_axis%upper
       deallocate(hvalue)
       allocate(hvalue(size(tmpval)))
       hvalue=tmpval
       deallocate(tmpval)
    endif

    call get(v_axis%var, vvalue)
    ! 周期的座標の処理. 格子点を最後に一つ追加. 
    call get_attr(v_axis%var, "topology", topology)
    if ( topology == "circular" ) then
       allocate(tmpval(size(vvalue)+1))
       tmpval(1:size(vvalue))=vvalue
       tmpval(size(vvalue)+1)=v_axis%upper
       deallocate(vvalue)
       allocate(vvalue(size(tmpval)))
       vvalue=tmpval
       deallocate(tmpval)
    endif

    select case(parent%projection)
        case(1:4)
           innersave=DCLGetInteger('AXIS:INNER')
           call DCLSetParm('AXIS:INNER',1)

           call UXPTMK('B',1,hvalue,size(hvalue))
           call UXPTMK('T',1,hvalue,size(hvalue))

           call UYPTMK('L',1,vvalue,size(vvalue))
           call UYPTMK('R',1,vvalue,size(vvalue))

           call DCLSetParm('AXIS:INNER',innersave)

        case(5:6)
           ! 2 次元極座標のみ
           vtick=DCLGetReal('AXIS:RSIZET1')
           simfac=DCLGetReal('GRAPH:SIMFAC')
           index=DCLGetInteger('AXIS:INDEXT1')

           ! 目盛長さ(動径)
           rtick=vtick/simfac 
           ! 角度座標軸目盛
           do i=1,size(vvalue)
              call DCLDrawLine( (/h_axis%upper,h_axis%upper-rtick/),&
                   (/vvalue(i),vvalue(i)/),1,index)
              call DCLDrawLine( (/h_axis%lower,h_axis%lower+rtick/),&
                   (/vvalue(i),vvalue(i)/),1,index)
           enddo

           ! 目盛長さ(角度)
           thetatick=(vtick/simfac/h_axis%upper)*180.0/3.1415926
           ! 動径座標軸目盛
           do i=1,size(hvalue)
              call DCLDrawLine( (/hvalue(i),hvalue(i)/),&
                   (/v_axis%lower,v_axis%lower+thetatick/),1,index)
              call DCLDrawLine( (/hvalue(i),hvalue(i)/),&
                   (/v_axis%upper,v_axis%upper-thetatick/),1,index)
           enddo

        case(10:15, 20:23, 30:33)
            call DCLDrawGrid()

    end select
end subroutine 

subroutine GTAxisClose(axis)
    use gtgraph_types, only: GT_AXIS
    use gtdata_generic, only: Close
    type(GT_AXIS), intent(inout):: axis
continue
    ! 判定が面倒なので var を多重 close してしまう。
    call Close(axis%var)
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

subroutine GTFigLoad(fig, var)
    use gtgraph_types, only: GT_FIGURE, GT_OBJECT
    use gtgraph_generic, only: Load, Bind
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: get_attr, Inquire
    use dc_string
    use dc_error
    use dc_types, only: STRING
    use dc_url, only: UrlResolve
    use dc_trace, only: beginsub, endsub
implicit none
    type(GT_FIGURE), intent(out):: fig
    type(GT_VARIABLE), intent(in):: var
    type(GT_OBJECT):: it
    type(VSTRING):: members
    character(STRING):: member, aname, baseurl
    type(STRING_LIST):: member_list
continue
    call beginsub('gtfigload', 'var.mapid=%d', i=(/var%mapid/))
    call get_attr(var, "gt_structure_member", members)
    call split(member_list, members, " ")
    do, while (len(member_list) > 0)
        member = shift(member_list)
        aname = "gt_structure_link_" // trim(member)
        call get_attr(var, trim(aname), member)
        if (member == "") exit
        call Inquire(var, url=baseurl)
        member = UrlResolve(member, base=baseurl)
        call Load(it, member)
        call Bind(fig, it)
    enddo
    call endsub('gtfigload')
end subroutine

module shallow_water

    integer, parameter:: double = kind(0.0d0)

    type shallow
        real(double), pointer:: u(:, :), ux(:, :), uy(:, :)
        real(double), pointer:: v(:, :), vx(:, :), vy(:, :)
        real(double), pointer:: h(:, :), hx(:, :), hy(:, :)
        ! 関数結果の場合だけ真, 変数にストアされると偽.
        logical:: temporary
    end type

    interface allocate
        module procedure allocate_basic
        module procedure allocate_constant
    end interface

    interface assignment(=)
        module procedure assign
    end interface

    interface operator(+)
        module procedure add
    end interface

    interface operator(*)
        module procedure mul
    end interface

    interface size
        module procedure size_shallow
    end interface

contains

        ! 不定結合状態の変数を初期化
    subroutine nullify(shall)
        type(SHALLOW):: shall
        nullify(shall%u, shall%u, shall%v)
        nullify(shall%ux, shall%uy, shall%vx)
        nullify(shall%vy, shall%hx, shall%hy)
        shall%temporary = .FALSE.
    end subroutine

        ! 不定結合状態の変数を初期化
    subroutine allocate_basic(shall, nx, ny, temporary)
        type(SHALLOW):: shall
        integer, intent(in):: nx, ny
        logical, intent(in), optional:: temporary
    continue
        allocate(shall%u(nx, ny), shall%v(nx, ny), shall%h(nx, ny))
        nullify(shall%ux, shall%uy, shall%vx, shall%vy, shall%hx, shall%hy)
        shall%temporary = .FALSE.
        if (present(temporary)) shall%temporary = temporary
    end subroutine

    subroutine deallocate(shall)
        type(SHALLOW):: shall
        if (associated(shall%u)) deallocate(shall%u, shall%v, shall%h)
        call nullify(shall)
        shall%temporary = .FALSE.
    end subroutine

    subroutine assign(lhs, rhs)
        type(SHALLOW), intent(out):: lhs
        type(SHALLOW), intent(in):: rhs
        lhs%temporary = .FALSE.
        lhs%u => rhs%u
        lhs%v => rhs%v
        lhs%h => rhs%h
    end subroutine

    integer function size_shallow(stat, dimord) result(result)
        type(SHALLOW):: stat
        integer:: dimord
        select case(dimord)
        case(1)
            result = size(stat%h, 1)
        case(2)
            result = size(stat%h, 2)
        case default
            result = 0
        end select
    end function

    type(SHALLOW) function add(lhs, rhs) result(result)
        type(SHALLOW), intent(in):: lhs
        type(SHALLOW), intent(in):: rhs
        call allocate(result, size(lhs, 1), size(lhs, 2))
        result%temporary = .TRUE.
        result%u = lhs%u + rhs%u
        result%v = lhs%v + rhs%v
        result%h = lhs%h + rhs%h
        if (lhs%temporary) call deallocate(lhs)
        if (rhs%temporary) call deallocate(rhs)
    end function

    type(SHALLOW) function mul(lhs, rhs) result(result)
        real(DOUBLE), intent(in):: lhs
        type(SHALLOW), intent(in):: rhs
        call Allocate(result, size(rhs, 1), size(rhs, 2))
        result%temporary = .TRUE.
        result%u = lhs * rhs%u
        result%v = lhs * rhs%v
        result%h = lhs * rhs%h
        if (rhs%temporary) call deallocate(rhs)
    end function

        ! 不定結合状態の変数を初期化
    subroutine allocate_constant(stat, nx, ny, H)
        type(SHALLOW):: stat
        integer, intent(in):: nx, ny
        real(double), intent(in):: H
    continue
        call Allocate(stat, nx, ny)
        stat%u(:, :) = 0.0_double
        stat%v(:, :) = 0.0_double
        stat%h(:, :) = H
    end subroutine

end module shallow_water

! an_types.f90 - derived type interface for `abstract netcdf' variable if
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved
! vi: set ts=8 sw=4:

module an_types

    implicit none

    ! --- ユーザ (gtdata 層) が使うべきハンドル ---
    ! id は an_vartable モジュールの antab 表のインデックスとなる。
    type AN_VARIABLE
        integer:: id
    end type

    ! --- an_vartable モジュールの antab 表の要素 ---
    type AN_VARIABLE_ENTRY
        !
        ! ID 情報
        !        変数 (an_variable 実体) は (/fileid, varid, dimid/) で
        !         同定される。正当な変数の fileid は必ず正である。
        !  
        integer:: fileid
        integer:: varid
        integer:: dimid
        !
        ! 次元表
        !        次元変数については自次元が、非次元変数については
        !        自分にとっての次元の dimid の一覧が保存される。
        integer, pointer:: dimids(:)
        !
        ! 属性サーチ用イテレータ
        !
        integer:: attrid
    end type

    ! --- 変数リスト検索イテレータ用 ---
    !
    type AN_VARIABLE_SEARCH
        integer:: fileid
        integer:: varid
        integer:: dimid
    end type

end module

module gtdata_internal

    use gt_vartable
    implicit none

    interface dimrange
        module procedure dimrange_direct
    end interface

contains

    subroutine dimrange_direct(vid, dimlo, dimhi)
        use an_types, only: an_variable
        use an_generic, only: an_inquire => inquire
        use dc_error, only: storeerror, nf_einval, gt_efake
        integer, intent(in):: vid
        integer, intent(out):: dimlo, dimhi
        integer:: class, cid
        call VarTableLookup(vid, class, cid)
        select case(class)
            case(VTB_CLASS_MEMORY)
                call storeerror(gt_efake, 'gtdata::dimrange')
            case(VTB_CLASS_NETCDF)
                dimlo = 1
                call an_inquire(an_variable(cid), dimlen=dimhi)
            case default
                call storeerror(nf_einval, 'gtdata::dimrange')
        end select
    end subroutine

    integer function ndims(vid) result(result)
        use an_types, only: an_variable
        use an_generic, only: an_inquire => inquire
        use dc_error, only: storeerror, nf_einval
        integer, intent(in):: vid
        integer:: class, cid
        call VarTableLookup(vid, class, cid)
        select case(class)
            case(VTB_CLASS_MEMORY)
                result = 1
            case(VTB_CLASS_NETCDF)
                call an_inquire(an_variable(cid), ndims=result)
            case default
                call storeerror(nf_einval, 'gtdata::ndims')
        end select
    end function

    subroutine query_growable(vid, result)
        use an_types, only: an_variable
        use an_generic, only: inquire 
        use dc_error, only: storeerror, nf_einval
        integer, intent(in):: vid
        logical, intent(out):: result
        integer:: class, cid
        call vartablelookup(vid, class, cid)
        select case(class)
            case(vtb_class_memory)
                result = .false.
            case(vtb_class_netcdf)
                call inquire(an_variable(cid), growable=result)
            case default
                call storeerror(nf_einval, 'gtdata::ndims')
        end select
    end subroutine

end module

! dc_error.f90 - エラーの処置
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

module dc_error

    use netcdf_f77, only: NF_ENOTVAR, nf_einval
    implicit none
    public

    ! エラー等を保持

    integer, public, parameter:: DC_NOERR = 0
    integer, private:: errno = DC_NOERR
    integer, private:: cause_int = DC_NOERR
    character(80), private:: cause_string = ""
    character(80), private:: cause_location = ""

    ! 正のエラー番号は libc システムエラーメッセージのために
    ! あけてある。システム依存性が大きく、非常に大きな数値も
    ! 用いられるので空き領域を確保するのは困難である。
    !
    ! 負のエラー番号は netCDF が使っている。少々の拡張も見込んで、
    ! -99 までは使わないで置く。

    integer, parameter:: GT_EFAKE = -100
    !
    ! -101 以下: データ構造のエラー
    !
    integer, parameter:: GT_ENOMOREDIMS = -101
    integer, parameter:: GT_EDIMNODIM = -102
    integer, parameter:: GT_EDIMMULTIDIM = -103
    integer, parameter:: GT_EDIMOTHERDIM = -104
    integer, parameter:: GT_EBADDIMNAME = -105
    integer, parameter:: GT_ENOTVAR = -106
    integer, parameter:: GT_ENOMEM = -107
    integer, parameter:: GT_EOTHERFILE = -108
    integer, parameter:: GT_EARGSIZEMISMATCH = -109
    integer, parameter:: GT_ENOMATCHDIM = -110
    integer, parameter:: GT_ELIMITED = -111
    integer, parameter:: GT_EBADVAR = -112
    integer, parameter:: GT_ECHARSHORT = -113
    !
    ! -200 以下: 可視化構造のエラー
    !
    integer, parameter:: GT_EFIGNOHAXIS = -200
    integer, parameter:: GT_EFIGNOVAXIS = -201
    integer, parameter:: GT_EBADLINK = -202
    !
    ! -300 以下: GrADS 入出力のエラー
    !
    integer, parameter:: GR_ENOTGR = -300

    public:: StoreError, DumpError, GetErrorMessage, ErrorCode
    !
    ! === 手続引用仕様 ===
    !
    ! いずれ差し替えられるように外部関数にしておく。

    interface
        subroutine DumpError()
        end subroutine
    end interface

contains

    integer function ErrorCode() result(result)
        result = errno
    end function

    subroutine GetErrorMessage(msg)
        use netcdf_f77, only: nf_strerror
        character(len = *), intent(out):: msg
        character(len = 180):: message
    continue
        select case(errno)
        case(GT_EFAKE)
            msg = ": function not implemented"
        case(GT_ENOMOREDIMS)
            write(message, "(': dimension number', i4, ' is out of range')") cause_int
            msg = trim(message)
        case(GT_EBADDIMNAME)
            msg = '(' // trim(cause_string) // '): unknown dimension name'
        case(GT_ENOTVAR)
            msg = ": variable not opened"
        case(GT_ENOMEM)
            msg = ": allocate/deallocate error"
        case(GT_EDIMNODIM)
            msg = ": dimension variable has no dimension"
        case(GT_EDIMMULTIDIM)
            msg = ": dimension variable has many dimensions"
        case(GT_EDIMOTHERDIM)
            msg = ": dimension variable has another dimension"
        case(GT_EOTHERFILE)
            msg = ": specified dimensional variable not on the same file"
        case(GT_EARGSIZEMISMATCH)
            msg = ": argument array size mismatch"
        case(GT_ENOMATCHDIM)
            msg = ": dimension matching failed"
        case(GT_ELIMITED)
            msg = ": variable already limited"
        case(GT_EBADVAR)
            msg = ": variable type not supported"
        case(GT_EFIGNOHAXIS)
            msg = ": hozirontal axis is missing"
        case(GT_EFIGNOVAXIS)
            msg = ": vertical axis is missing"
        case(GT_EBADLINK)
            msg = ": bad variable reference"
        case(GT_ECHARSHORT)
            msg = ": character length not enough"
        case(GR_ENOTGR)
            msg = ": invalid GrADS file"
        case default
            goto 1000
        end select
        msg = trim(cause_location) // msg
        return

    1000 continue
        if (len(cause_string) > 0) then
            message = nf_strerror(errno)
            msg = trim(cause_location) // &
                & "(" // trim(cause_string) // ")" // &
                & ": " // trim(message)
        else if (cause_int /= 0) then
            write(message(1:8), '(i8)') cause_int
            message(9: ) = nf_strerror(errno)
            msg = trim(cause_location) // &
                & '(' // trim(message(1:8)) // ')' // &
                & ": " // trim(message(9: ))
        else
            message = nf_strerror(errno)
            msg = trim(cause_location) // ": " // trim(message)
        endif
    end subroutine

    ! 典型的ライブラリ関数のために作られたエラー処理関数。
    !
    ! エラー番号 number を errno に格納する。同時に付随的情報
    ! where, cause_s, cause_i を cause_location, cause_string,
    ! cause_int に格納する。 
    ! err が与えられている場合、err は number が 0 の場合だけ偽になる。
    ! number が 0 ならば即復帰する。
    ! err が与えられていなければエラーメッセージを装置 * に出力して
    ! プログラムを終了する。

    subroutine StoreError(number, where, err, cause_s, cause_c, cause_i)
        use dc_string, only: VSTRING, assignment(=)
        integer, intent(in):: number
        character(len = *), intent(in):: where
        logical, intent(out), optional:: err
        type(VSTRING), intent(in), optional:: cause_s
        character(len = *), intent(in), optional:: cause_c
        integer, intent(in), optional:: cause_i
    continue
        errno = number
        cause_location = where
        if (present(cause_s)) then
            cause_string = cause_s
        else if (present(cause_c)) then
            cause_string = trim(cause_c)
        else
            cause_string = ""
        endif
        if (present(cause_i)) cause_int = cause_i
        if (present(err)) then
            err = (number /= DC_NOERR)
            return
        endif
        if (number == DC_NOERR) return
        call DumpError
    end subroutine

end module

subroutine DumpError()
    use dc_types, only: string
    use dc_string, only: VSTRING, put_line
    use dc_error, only: GetErrorMessage
    use sysdep, only: AbortProgram
    character(len = string):: message
    call GetErrorMessage(message)
    call AbortProgram(message)
end subroutine

! C の fprintf(3) とは大分違うので注意。
!

subroutine DCStringFPrintf(unit, fmt, i, r, d, L, s, n, c1, c2, c3)
    use dcstring_base, only: VSTRING
    use dc_types, only: STRING
    use dc_string, only: DCStringSPrintf
    implicit none
    integer, intent(in), optional:: unit
    character(*), intent(in):: fmt
    integer, intent(in), optional:: i(:), n(:)
    real, intent(in), optional:: r(:)
    double precision, intent(in), optional:: d(:)
    logical, intent(in), optional:: L(:)
    type(VSTRING), intent(in), optional:: s(:)
    character(*), intent(in), optional:: c1, c2, c3
    character(STRING):: buf
continue
    call dcstringsprintf(buf, fmt, i=i, r=r, d=d, L=L, s=s, n=n, &
        & c1=c1, c2=c2, c3=c3)
    if (present(unit)) then
        write(unit, '(A)') trim(buf)
    else
        write(*, '(A)') trim(buf)
    endif
end subroutine

logical function GTAxisEquivalent(axis1, axis2) result(result)
    use gtgraph_types, only: gt_axis
    use dc_string, only: operator(/=)
    implicit none
    type(gt_axis), intent(in):: axis1
    type(gt_axis), intent(in):: axis2
    result = .false.
    if (axis1%title /= axis2%title) return
    if (axis1%units /= axis2%units) return
    result = .true.
end function

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.
! gtcopy - 変数複写ツール

! 書式
!   gtcopy 変数名 出力変数名
!   gtcopy 変数名 変数名 ... 出力ファイル名

program gtcopy
    use gtool
    use dc_trace, only: setdebug
    implicit none
    character(string):: source, dest, dest_f, dest_v, arg
    integer:: i, argc
    argc = GtArgCount()

    i = 1
    do, while (i <= argc)
        call GtArgGet(i, arg)
        if (arg == '-debug') then
            call setdebug()
        else
            exit
        endif
        i = i + 1
    enddo

    if (i + 1 > argc) then
        print *, "usage: gtcopy source ... dest"
        stop
    endif

    call GtArgGet(argc, dest)
    if (i + 1 == argc) then
        call GtArgGet(argc - 1, source)
        call do_copy(source, dest)
    else
        call UrlSplit(dest, file=dest_f)
        do, while (i <= argc - 1)
            call GtArgGet(i, source)
            call UrlSplit(source, var=dest_v)
            dest = UrlMerge(file=dest_f, var=dest_v)
            call do_copy(source, dest)
            i = i + 1
        enddo
    endif

contains

    subroutine do_copy(source, dest)
        character(len=*), intent(in):: source
        character(len=*), intent(in):: dest
        type(GT_VARIABLE):: vSource
        type(GT_VARIABLE):: vDest
        call Open(vSource, url=source)
        call Create(vDest, url=dest, copyfrom=vSource, copyvalue=.TRUE.)
        call Close(vSource)
        call Close(vDest)
    end subroutine

end program

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved
! コマンドライン引数の取得 - gt_argtable.f90 参照

subroutine GtArgGetC(ord, value, default)
    use dc_string
    use sysdep, only: SysdepArgGet
    use gt_argtable, only: BuildArgTable, argind_table, argind_count
    implicit none
    integer, intent(in):: ord
    character(len = *), intent(out):: value
    character(len = *), intent(in), optional:: default
    integer:: i
continue
    call BuildArgTable
    if (ord > argind_count) then
        value = default
    else
        i = ord
        if (ord /= 0) i = argind_table(abs(ord))
        call SysdepArgGet(i, value)
    endif
end subroutine

subroutine GtArgGetV(ord, value, default)
    use dc_string
    use dc_types, only: string
    use sysdep, only: SysdepArgGet
    use gt_argtable, only: BuildArgTable, argind_table, argind_count
    implicit none
    integer, intent(in):: ord
    type(VSTRING), intent(out):: value
    character(len = *), intent(in), optional:: default
    character(len = STRING):: buffer
    integer:: i
continue
    call BuildArgTable
    if (ord > argind_count) then
        value = default
    else
        i = ord
        if (ord /= 0) i = argind_table(abs(ord))
        call SysdepArgGet(i, buffer)
        value = trim(buffer)
    endif
end subroutine

! gtvargetattr.f90 - 数値型属性の入力
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

! 引数の型に応じていろいろあるが、どうせ下部構造では同じモノを使っている。

! スカラで受け取るのが一番簡単。解釈可能な値がとられ、残りは捨てられる。

subroutine GTVarGetAttrR(var, attrname, value, default)
    use gtdata_types, only: GT_VARIABLE
    use an_generic, only: get_attr, an_variable
    use gt_mem, only: get_attr, mem_variable
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use dc_error
    use dc_string, only: VSTRING, assignment(=), stod
    use netcdf_f77, only: NF_FILL_REAL
    implicit none
    type(GT_VARIABLE), intent(in):: var
    character(len = *), intent(in):: attrname
    real, intent(out):: value
    real, intent(in), optional:: default
    integer:: stat
    real:: buffer(1)
    type(VSTRING):: cbuffer
    integer:: class, cid
    logical:: err
continue
    call var_class(var, class, cid)
    if (class == vtb_class_netcdf) then
        call get_attr(an_variable(cid), attrname, value=buffer, &
            & stat=stat, default=default)
        if (stat >= 1) then
            value = buffer(1)
            return
        endif
    else if (class == vtb_class_memory) then
        call get_attr(mem_variable(cid), attrname, cbuffer, err)
        if (.not. err) then
            value = stod(cbuffer)
            return
        endif
    else
        call StoreError(GT_EBADVAR, "GTVarGetAttrR")
    endif
    if (present(default)) then
        value = default
    else
        value = NF_FILL_REAL
    endif
end subroutine

subroutine GTVarGetAttrD(var, attrname, value, default)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: get_attr, an_variable
    use gt_mem, only: get_attr, mem_variable
    use dc_string, only: VSTRING, assignment(=), stod
    use dc_error
    use netcdf_f77, only: NF_FILL_REAL
    implicit none
    type(GT_VARIABLE), intent(in):: var
    character(len = *), intent(in):: attrname
    double precision, intent(out):: value
    double precision, intent(in), optional:: default
    integer:: stat
    double precision:: buffer(1)
    type(VSTRING):: cbuffer
    integer:: class, cid
    logical:: err
continue
    call var_class(var, class, cid)
    select case(class)
    case (vtb_class_netcdf)
        call get_attr(an_variable(cid), attrname, value=buffer, &
            & stat=stat, default=default)
        value = buffer(1)
        if (stat >= 1) return
    case (vtb_class_memory)
        call get_attr(mem_variable(cid), attrname, cbuffer, err)
        if (.not. err) then
            value = stod(cbuffer)
            return
        endif
    case default
        call StoreError(GT_ENOTVAR, "GTVarGetAttrR")
    end select
    value = NF_FILL_REAL
    if (present(default)) value = default
end subroutine

subroutine GTVarGetAttrI(var, attrname, value, default)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: get_attr, an_variable
    use gt_mem, only: get_attr, mem_variable
    use netcdf_f77, only: NF_FILL_INT
    use dc_string, only: VSTRING, assignment(=), stoi
    use dc_error
    implicit none
    type(GT_VARIABLE), intent(in):: var
    character(len = *), intent(in):: attrname
    integer, intent(out):: value
    integer, intent(in), optional:: default
    integer:: stat, buffer(1), class, cid
    type(VSTRING):: cbuffer
    logical:: err
continue
    call var_class(var, class, cid)
    if (class == vtb_class_netcdf) then
        call get_attr(an_variable(cid), attrname, buffer, stat, default)
        value = buffer(1)
        if (stat >= 1) return
    else if (class == vtb_class_memory) then
        call get_attr(mem_variable(cid), attrname, cbuffer, err)
        if (.not. err) then
            value = stoi(cbuffer)
            return
        endif
    else
        call StoreError(GT_ENOTVAR, "GTVarGetAttrI")
    endif
    value = NF_FILL_INT
    if (present(default)) value = default
end subroutine

! ポインタ配列を使って受け取る場合は解釈可能な数だけ実体が割り付けられる。

subroutine GTVarGetAttrRP(var, name, value)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: get_attr, an_variable
    use gt_mem, only: get_attr, mem_variable
    use dc_string, only: VSTRING, assignment(=), get_array
    use dc_error
    implicit none
    type(GT_VARIABLE), intent(in):: var
    character(len = *), intent(in):: name
    real, pointer:: value(:)
    integer:: stat, class, cid
    type(VSTRING):: cbuffer
    logical:: err
continue
    call var_class(var, class, cid)
    if (class == vtb_class_netcdf) then
        allocate(value(1))
        call get_attr(an_variable(cid), name, value(1:0), stat)
        deallocate(value)
        if (stat < 1) return
        allocate(value(stat))
        call get_attr(an_variable(cid), name, value, stat)
        if (stat < 1) deallocate(value)
    else if (class == vtb_class_memory) then
        call get_attr(mem_variable(cid), name, cbuffer, err)
        if (err) then
            nullify(value)
            return
        endif
        call get_array(value, cbuffer)
        cbuffer = ""
    else
        nullify(value)
        call StoreError(GT_ENOTVAR, "GTVarGetAttrRP")
    endif
end subroutine

subroutine GTVarGetAttrDP(var, name, value)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: get_attr, an_variable
    use gt_mem, only: get_attr, mem_variable
    use dc_error
    use dc_string, only: VSTRING, get_array, assignment(=)
    implicit none
    type(GT_VARIABLE), intent(in):: var
    character(len = *), intent(in):: name
    double precision, pointer:: value(:)
    integer:: stat, class, cid
    type(VSTRING):: cbuffer
    logical:: err
continue
    call var_class(var, class, cid)
    if (class == vtb_class_netcdf) then
        allocate(value(1))
        call get_attr(an_variable(cid), name, value(1:0), stat)
        deallocate(value)
        if (stat < 1) return
        allocate(value(stat))
        call get_attr(an_variable(cid), name, value, stat)
        if (stat < 1) deallocate(value)
    else if (class == vtb_class_memory) then
        call get_attr(mem_variable(cid), name, cbuffer, err)
        if (err) then
            nullify(value)
            return
        endif
        call get_array(value, cbuffer)
        cbuffer = ""
    else
        call StoreError(GT_ENOTVAR, "GTVarGetAttrRP")
    endif
end subroutine

subroutine GTVarGetAttrIP(var, name, value)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: get_attr, an_variable
    use gt_mem, only: get_attr, mem_variable
    use dc_error
    use dc_string, only: VSTRING, get_array, assignment(=)
    implicit none
    type(GT_VARIABLE), intent(in):: var
    character(len = *), intent(in):: name
    integer, pointer:: value(:)
    integer:: stat, class, cid
    type(VSTRING):: cbuffer
    logical:: err
continue
    call var_class(var, class, cid)
    if (class == vtb_class_netcdf) then
        allocate(value(1))
        call get_attr(an_variable(cid), name, value(1:0), stat)
        deallocate(value)
        if (stat < 1) return
        allocate(value(stat))
        call get_attr(an_variable(cid), name, value, stat)
        if (stat < 1) deallocate(value)
    else if (class == vtb_class_memory) then
        call get_attr(mem_variable(cid), name, cbuffer, err)
        if (err) then
            nullify(value)
            return
        endif
        call get_array(value, cbuffer)
        cbuffer = ""
    else
        call StoreError(GT_ENOTVAR, "GTVarGetAttrIP")
    endif
end subroutine

! integer 配列, real 配列として受け取る
! 場合は属性長があまっている場合には切り捨てられ、
! 属性長が足りない場合は default 値 (ポインタと違い必須) を埋める。

subroutine GTVarGetAttrRA(var, name, value, default)
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: get_attr
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: get_attr, an_variable
    use dc_error
    implicit none
    type(GT_VARIABLE), intent(in):: var
    character(len = *), intent(in):: name
    real, intent(out):: value(:)
    real, intent(in):: default
    real, pointer:: ptr(:)
    integer:: n, class, cid, stat
continue
    call var_class(var, class, cid)
    if (class == vtb_class_netcdf) then
        call get_attr(an_variable(cid), name, value, stat, default)
    else if (class == vtb_class_memory) then
        call get_attr(var, name, ptr)
        if (.not. associated(ptr)) then
            value(:) = default
        else
            n = min(size(ptr), size(value))
            value(1:n) = ptr(1:n)
            if (n < size(ptr)) value(n+1: ) = default
            deallocate(ptr)
        endif
    else
        call StoreError(GT_ENOTVAR, "GTVarGetAttrRA")
    endif
end subroutine

subroutine GTVarGetAttrDA(var, name, value, default)
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: get_attr
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: get_attr, an_variable
    use dc_error
    implicit none
    type(GT_VARIABLE), intent(in):: var
    character(len = *), intent(in):: name
    double precision, intent(out):: value(:)
    double precision, intent(in):: default
    double precision, pointer:: ptr(:)
    integer:: n, stat, class, cid
continue
    call var_class(var, class, cid)
    if (class == vtb_class_netcdf) then
        call get_attr(an_variable(cid), name, value, stat, default)
    else if (class == vtb_class_memory) then
        call get_attr(var, name, ptr)
        if (.not. associated(ptr)) then
            value(:) = default
        else
            n = min(size(ptr), size(value))
            value(1:n) = ptr(1:n)
            if (n < size(ptr)) value(n+1: ) = default
            deallocate(ptr)
        endif
    else
        call StoreError(GT_ENOTVAR, "GTVarGetAttrRA")
    endif
end subroutine

subroutine GTVarGetAttrIA(var, name, value, stat, default)
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: get_attr
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: get_attr, an_variable
    use dc_error
    implicit none
    type(GT_VARIABLE), intent(in):: var
    character(len = *), intent(in):: name
    integer, intent(out):: value(:)
    integer, intent(in):: default
    integer, pointer:: ptr(:)
    integer:: n, stat, class, cid
continue
    call var_class(var, class, cid)
    if (class == vtb_class_netcdf) then
        call get_attr(an_variable(cid), name, value, stat, default)
    else if (class == vtb_class_memory) then
        call get_attr(var, name, ptr)
        if (.not. associated(ptr)) then
            value(:) = default
        else
            n = min(size(ptr), size(value))
            value(1:n) = ptr(1:n)
            if (n < size(ptr)) value(n+1: ) = default
            deallocate(ptr)
        endif
    else
        call StoreError(GT_ENOTVAR, "GTVarGetAttrIA")
    endif
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.
! gtbinary - 変数への二項演算子適用

! 書式
!   gtbinary 左辺 演算子 右辺 [オプション=値 ...] 
!
! 出力は output オプションまたは gtool.nc@default
! 演算子は任意個指定可. デフォルトで「加算」.

subroutine help
    use sysdep
    write(*, *) "usage: gtbinary lhs operator rhs [option=value ...]"
    call abortprogram('gtbinary')
end subroutine

program gtbinary
    use gtool
    use dc_trace, only: setdebug, message
    implicit none
    character(STRING):: lhs = "", rhs = ""
    character(string):: output = "gtool.nc@default"
    character(string):: operator = ""
    character(STRING):: arg, optname, optvalue
    type(GT_VARIABLE):: lvar, rvar, ovar
    double precision, allocatable:: lhsbuf(:), rhsbuf(:), obuf(:)
    character(string):: expand_dim = ""
    integer:: i, nargs, siz, stat
!--
    nargs = GtArgCount()
    do, i = 1, nargs
        call GtArgGet(i, arg) 
        if (gtoptionform(arg, optname, optvalue)) then
            if (optname == "output" .or. optname == "out") then
                output = optvalue
            else if (optname == '-expand') then
                expand_dim = optvalue
            else if (optname == '-debug') then
                call setdebug
            else
                call put(optname // ": unknown option")
                call help
            endif
        else if (lhs == "") then
            lhs = arg
        else if (operator == "") then
            operator = arg
        else if (rhs == "") then
            rhs = arg
        endif
    enddo
    if (rhs == "") then
        call help
    endif

    if (expand_dim /= "") then
        call do_expand
    else
        call do_equivalent
    endif
    stop
contains

subroutine do_expand
    character(string):: expand
    character(token):: dimname
    integer:: comma, islice
    logical:: err
    call Open(rvar, rhs)
    call Open(lvar, lhs)
    call Create(ovar, url=output, copyfrom=lvar, copyvalue=.false.)
    expand = expand_dim
    do, while (expand /= "")
        comma = index(expand, ',')
        if (comma == 0) then
            dimname = expand
            expand = ""
        else 
            dimname = expand(1: comma-1)
	    expand = expand(comma+1: )
        endif
        write(0, *) "expand for ", trim(dimname)
        dimname = trim(dimname) // "=1:1:1"
	call Slice(lvar, dimname, err)
        if (err) exit
	call Slice(ovar, dimname, err)
    enddo
    call Inquire(lvar, size=siz)
    allocate(lhsbuf(siz), rhsbuf(siz), obuf(siz))
    call Get(rvar, rhsbuf, siz)
    islice = 0
    do
        islice = islice + 1
        write(0, "(a,i4)") "slice", islice
        call Get(lvar, lhsbuf, siz)
        call BinOp(obuf, lhsbuf(1:siz), operator, rhsbuf(1:siz), siz)
        call Put(ovar, obuf, siz)
        call Slice_Next(lvar, stat=stat);  if (stat /= 0) exit
        call Slice_Next(ovar, stat=stat);  if (stat /= 0) exit
    enddo
    call Close(lvar)
    call Close(rvar)
    call Close(ovar)
end subroutine

subroutine do_equivalent
    call Open(lvar, lhs)
    call Open(rvar, rhs)
    call Transform(rvar, lvar)
    call Create(ovar, url=output, copyfrom=lvar, copyvalue=.false.)
    call Slice(lvar, compatible=rvar)
    call Slice(ovar, compatible=lvar)
    call inquire(rvar, size=siz)
    allocate(lhsbuf(siz), rhsbuf(siz), obuf(siz))
    do
        call Get(rvar, rhsbuf, siz)
        call Get(lvar, lhsbuf, siz)
        call BinOp(obuf, lhsbuf(1:siz), operator, rhsbuf(1:siz), siz)
        call Put(ovar, obuf, siz)
        call Slice_Next(lvar, stat=stat);  if (stat /= 0) exit
        call Slice_Next(rvar, stat=stat);  if (stat /= 0) exit
        call Slice_Next(ovar, stat=stat);  if (stat /= 0) exit
    enddo
    call Close(lvar)
    call Close(rvar)
    call Close(ovar)
end subroutine

subroutine binop(out, lhs, operator, rhs, n)
    integer, intent(in):: n
    double precision, intent(out):: out(n)
    character(*), intent(in):: operator
    double precision, intent(in):: lhs(n), rhs(n)
    if (operator == '+' .or. operator == 'add') then
        out(1:n) = lhs(1:n) + rhs(1:n)
    else if (operator == '-' .or. operator == 'sub') then
        out(1:n) = lhs(1:n) - rhs(1:n)
    else if (operator == '*' .or. operator == 'mul') then
        out(1:n) = lhs(1:n) * rhs(1:n)
    else if (operator == '/' .or. operator == 'div') then
        where (abs(rhs(1:n)) > epsilon(1.0d0))
            out(1:n) = lhs(1:n) / rhs(1:n)
        elsewhere
            out(1:n) = sign(huge(1.0d0), lhs(1:n) * rhs(1:n))
        end where   
    else
        print *, 'operator "', trim(operator), '" unknown'
        out(1:n) = lhs(1:n) + rhs(1:n)
    endif
end subroutine

end program

! Sample program for gtool_history/gtool4          2001/02/27 S.Takehiro
! 
! Solving diffusion equation 
!     du/dt = kappa d^2 u/dx^2
! for giving values of u at x=0 and 1. 
!
program diffusion

  use gtool_history                                          ! モジュール指定
  use dc_trace, only: setdebug

  integer:: i, it
  integer, parameter              :: nx=30                   ! グリッド数
  integer, parameter              :: nt=200                  ! 時間ステップ数
  integer, parameter              :: ndisp=10                ! 出力間隔
  double precision, parameter     :: dx=1.0/(nx-1)           ! グリッド間隔
  double precision, parameter     :: dt=0.0005               ! 時間間隔
  double precision, dimension(nx) :: x=(/(dx*(i-1),i=1,nx)/) ! 座標変数
  double precision, dimension(nx) :: temp                    ! 温度
  double precision, parameter     :: kappa=1.0               ! 熱拡散係数

  temp = exp(-((x-0.5)/0.1)**2)                              ! 初期値設定

  call setdebug
  call HistoryCreate( &                                      ! ヒストリー作成
       file='diffusion_1.nc', title='Diffusion equation', &
       source='Sample program of gtool_history/gtool4', &
       institution='GFD_Dennou Club davis project',     &
       dims=(/'x','t'/), dimsizes=(/nx,0/),             &
       longnames=(/'X-coordinate','time        '/),     &
       units=(/'m','s'/),                               &
       origin=0.0, interval=real(ndisp*dt) )

  call HistoryPut('x',x)                                     ! 次元変数出力

  call HistoryAddVariable( &                                 ! 変数定義
       varname='temp', dims=(/'x','t'/), & 
       longname='temperature', units='K', xtype='double')

  call HistoryPut('temp',temp)                               ! 変数出力

  do it=1,nt
     temp(2:nx-1) = temp(2:nx-1) &                           ! 時間積分
          +kappa*(temp(3:nx)-2*temp(2:nx-1)+temp(1:nx-2))/dx**2*dt

     if ( mod(nt,ndisp) .eq. 0 ) then
        call HistoryPut('temp',temp)                         ! 変数出力
     endif
  enddo

  call HistoryClose
  stop
end program diffusion

! vi: set sw=4 ts=8:

module gt3conv_dimtable
    use gtool
    use gt3read
    use gt3conv_vartable
    implicit none

    private
    public DisposeTables, Dimension
    public BuildDimensions, BuildTime, PutDimensionData, PutTimeData
    public DIMTABLE_ENTRY, TIMETABLE_ENTRY, dims_table, time_table

    type DIMTABLE_ENTRY
	type(NC_DIMENSION):: dim
	type(NC_VARIABLE):: var
	character(len = 30):: name
	character(len = 16):: item
	integer:: lower, upper
	real, pointer:: values(:)
    end type

    type(DIMTABLE_ENTRY), save, pointer:: dims_table(:)

    type TIMETABLE_ENTRY
	integer, pointer:: values(:)
	type(NC_DIMENSION):: dim
	type(NC_VARIABLE):: var
    end type
    type(TIMETABLE_ENTRY), save, pointer:: time_table(:)

    interface Dimension;  module procedure LookupDimension;  end interface

contains

    type(NC_DIMENSION) function LookupDimension(item) result(result)
	character(len = 16), intent(in):: item
	integer:: idim
    continue
	do, idim = 1, size(dims_table)
	    if (dims_table(idim)%item == item) then
		result = dims_table(idim)%dim;  return
	    endif
	enddo
	result = NC_DIMENSION_ERROR()
    end function

    subroutine DisposeTables
	integer:: i
    continue
	call DisposeVariableTable
	do, i = 1, size(dims_table)
	    deallocate(dims_table(i)%values)
	enddo
	deallocate(dims_table)
	do, i = 1, size(time_table)
	    deallocate(time_table(i)%values)
	enddo
	deallocate(time_table)
	nullify(time_table)
    end subroutine

    type(VSTRING) function AxisFilename(item, weight) result(result)
	character(len = 16), intent(in):: item
	logical, intent(in), optional:: weight
	character(len = *), parameter:: GTAXDIR_L = '/var/spool/gt3-dcl5/'
	character(len = *), parameter:: GTAXDIR_W = 'C:/DENNOU/GT3/'
	character(len = 8):: prefix
	logical:: exist
    continue
	prefix = 'GTAXLOC.'
	if (present(weight)) then
	    if (weight) prefix = 'GTAXWGT.'
	endif
	result = prefix // trim(item)
	inquire(file=char(result), exist=exist)
	if (exist) return
	result = GTAXDIR_L // prefix // trim(item)
	inquire(file=char(result), exist=exist)
	if (exist) return
	result = GTAXDIR_W // prefix // trim(item)
	inquire(file=char(result), exist=exist)
	if (exist) return
	result = GtoolGetenv('GTAXDIR') // prefix // trim(item)
	inquire(file=char(result), exist=exist)
    end function

    subroutine PutDimensionData
	integer:: idim
    continue
	do, idim = 1, size(dims_table)
	    call Put(dims_table(idim)%var, dims_table(idim)%values)
	enddo
    end subroutine

    subroutine ReadAxisFile(dim)
	type(DIMTABLE_ENTRY), intent(inout):: dim
	type(GT3_FILE):: axisfile
	type(GT3_HEADER):: header
	real, pointer:: buffer(:, :, :)
	integer:: lb, ub
	type(NC_ATTRIBUTE):: attr
    continue
	call Open(axisfile, char(AxisFilename(dim%item)))
	call Get(axisfile, header, buffer)
	call Close(axisfile)

	lb = lbound(buffer, 1)
	ub = ubound(buffer, 1)
	if (dim%lower < lb) then
	    print *, 'gt3conv#ReadAxisFile: requested lower bound ', &
		& dim%lower, ' is less than axis file value ', lb
	    stop
	endif
	if (dim%upper > ub) then
	    print *, 'gt3conv#ReadAxisFile: requested upper bound ', &
		& dim%upper, ' is greater than axis file value ', ub
	    stop
	endif
	allocate(dim%values(lb: ub))
	dim%values(:) = buffer(lb: ub, lbound(buffer, 2), lbound(buffer, 3))

	if (header%dataset(1: 1) == 'C') then
	    attr = Attribute(dim%var, 'topology')
	    attr = 'circular'
	    call Dispose(attr)
	endif
	if (header%unit /= '') then
	    attr = Attribute(dim%var, 'unit')
	    ! fake
	    attr = UnitString(header)
	    call Dispose(attr)
	endif
    end subroutine

    type(VSTRING) function Dimname3to4(item, usedname) result(result)
	character(len = *), intent(in):: item
	character(len = *), intent(in):: usedname(:)
	character(len = len(item)):: buffer
	type(VSTRING):: name, grids, suffix
	integer:: a, b, c
    continue
	buffer = adjustl(item)
	a = scan(buffer, '0123456789')
	name = buffer(1: a-1)
	b = verify(buffer(a: ), '0123456789')
	if (b == 0) b = len(buffer)
	grids = buffer(a: b)
	suffix = trim(buffer(b + 1: ))

	if (name == 'CSIG' .and. suffix == '.M') then
	    result = 'sigma_bound'
	else if (name == 'CSIG') then
	    result = 'sigma'
	else if (name == 'GLON') then
	    result = 'lon'
	else if (name == 'GGLA') then
	    result = 'lat'
	else
	    result = item
	endif
	if (all(usedname(:) /= char(result))) return

	result = result // grids
	if (all(usedname(:) /= char(result))) return

	name = result
	do, c = 1, huge(c)
	    result = name // itos(c)
	    if (all(usedname(:) /= char(result))) return
	enddo
	stop 'gt3conv#Dimname3to4'
    end function

    type(VSTRING) function UnitString(header)
	type(GT3_HEADER), intent(in):: header
    continue
	if (header%unit == 'deg') then
	    if (header%item(1: 4) == 'GLON') then
		UnitString = 'degree_east'
	    else
		UnitString = 'degree_north'
	    endif
	else
	    UnitString = header%unit
	endif
    end function

    subroutine BuildDimensions(file) 
	type(NC_FILE), intent(inout):: file
	type(DIMTABLE_ENTRY), pointer:: dims_tmp(:)
	integer:: iv, ia, idim, num_dims
    continue
	allocate(dims_table(3))

	num_dims = 0
	! すべての変数について軸 ITEM 名を検査し、重複しないものを登録
	do, iv = 1, size(vars_table)
	    do, ia = 1, 3
		call StoreDimension(vars_table(iv)%header, ia)
	    enddo
	enddo

	! 次元表の大きさを最低限に縮小
	if (size(dims_table) > num_dims) then
	    dims_tmp => dims_table
	    allocate(dims_table(1: num_dims))
	    dims_table(:) = dims_tmp(1: num_dims)
	    deallocate(dims_tmp)
	endif

	! 登録されたすべての次元を作成
	do, idim = 1, num_dims
	    call MakeDimension(file, dims_table(idim), &
		& dims_table(1: idim-1)%name)
	enddo

    contains

	subroutine MakeDimension(file, dim, usedname)
	    type(NC_FILE), intent(inout):: file
	    type(DIMTABLE_ENTRY), intent(inout):: dim
	    character(len = *), intent(in):: usedname(:)
	    integer:: length
	continue
	    dim%name = Dimname3to4(dim%item, usedname)
	    dim%upper = max(dim%upper, dim%lower)
	    length = dim%upper - dim%lower + 1
	    dim%dim = Dimension(file, trim(dim%name), length)
	    call NetcdfAssert
	    dim%var = Variable(file, trim(dim%name), NF_FLOAT, (/dim%dim/))
	    call NetcdfAssert
	    call ReadAxisFile(dim)
	end subroutine

	subroutine StoreDimension(header, ia)
	    type(GT3_HEADER), intent(in):: header
	    integer, intent(in):: ia
	    character(len = 16):: item
	    integer:: idim
	    type(DIMTABLE_ENTRY), pointer:: dims_tmp(:)
	continue
	    ! 空なら飛ばす
	    item = vars_table(iv)%header%axis_item(ia)
	    if (item == '') return
	    ! 登録済みなら上下端だけ確認
	    do, idim = 1, num_dims
		if (item == dims_table(idim)%item) then
		    dims_table(idim)%lower = min(dims_table(idim)%lower, &
			& header%axis_start(ia))
		    dims_table(idim)%upper = max(dims_table(idim)%upper, &
			& header%axis_end(ia))
		endif
	    enddo
	    ! 未登録なら次元表を確保し書き込み
	    num_dims = num_dims + 1
	    if (num_dims > size(dims_table)) then
		allocate(dims_tmp(size(dims_table) + 2))
		dims_tmp(1: size(dims_table)) = dims_table(:)
		deallocate(dims_table)
		dims_table => dims_tmp
	    endif
	    dims_table(num_dims)%item = item
	    dims_table(num_dims)%lower = header%axis_start(ia)
	    dims_table(num_dims)%upper = header%axis_end(ia)
	end subroutine

    end subroutine BuildDimensions

    subroutine PutTimeData(file)
	type(NC_FILE), intent(in):: file
	integer:: it
	integer, pointer:: values(:)
    continue
	do, it = 1, size(time_table)
	    values => time_table(it)%values
	    if (.not. NetcdfPutInt(time_table(it)%var, &
		& values, size(values))) then
		call NetcdfAssert()
	    endif
	enddo
    end subroutine

    subroutine BuildTime(file)
	type(NC_FILE), intent(inout):: file
	character(len = 16):: axisname
	integer:: iv, num_times
    continue
	allocate(time_table(1))

	num_times = 0
	do, iv = 1, size(vars_table)
	    call StoreTime
	enddo
	time_table => time_table(1: num_times)

	call CreateTimeDimensions

    contains

	subroutine CreateTimeDimensions
	    integer:: it
	continue
	    ! 時間軸がないばあい
	    if (num_times <= 0) then
		time_table(:)%dim = NC_DIMENSION_ERROR()
		return
	    endif

	    ! 時間軸が一つしかないばあい
	    time_table(1)%dim = &
		& Dimension(file, 'time', size(time_table(1)%values))
	    time_table(1)%var = &
		& Variable(file, 'time', NF_INT, (/time_table(1)%dim/))
	    if (num_times == 1) return

	    ! 時間軸が複数あるばあい
	    do, it = 2, num_times
		axisname = NetcdfName('time', it)
		time_table(it)%dim = &
		    & Dimension(file, axisname, size(time_table(1)%values))
		time_table(it)%var = &
		    & Variable(file, axisname, NF_INT, (/time_table(it)%dim/))
	    enddo
	end subroutine

	subroutine StoreTime
	    integer:: it, len
	    integer, pointer:: t(:)
	    type(TIMETABLE_ENTRY), pointer:: tt(:)
	continue
	    len = count(units_table(:)%var == iv)
	    if (len < 1) stop 'gt3conv_v#StoreTime barf'
	    allocate(t(len))
	    t = pack(units_table(:)%time, units_table(:)%var == iv)

	    ! 既存時間軸の探索
	    do, it = 1, num_times
		if (int_array_equiv(t, time_table(it)%values)) then
		    vars_table(iv)%time_ord = it
		    deallocate(t)
		    return
		endif
	    enddo

	    ! 新しい時間軸の登録
	    num_times = num_times + 1
	    len = size(time_table)
	    if (num_times > len) then
		allocate(tt(len + 1))
		tt(1: len) = time_table(1: len)
		deallocate(time_table)
		time_table => tt
	    endif
	    vars_table(iv)%time_ord = num_times
	    time_table(num_times)%values => t
	end subroutine

    end subroutine

    logical function int_array_equiv(a, b) result(result)
	integer, intent(in):: a(:), b(:)
    continue
	if (size(a) /= size(b)) then
	    result = .FALSE.;  return
	endif
	result = all(a(:) == b(:))
    end function

end module

! gtgraph_types.f90 - gtgraph 層の型宣言
! Copyright (C) TOYODA Eizi, 2000.  All rights reserved.

module gtgraph_types

    use dc_string, only: VSTRING
    use dc_types, only: STRING
    use gtdata_types, only: GT_VARIABLE
    implicit none

    type GT_AXIS
        type(GT_VARIABLE):: var
        real:: lower
        real:: upper
        logical:: vertical
        logical:: drawn
        character(STRING):: saved
        character(STRING):: title
        character(STRING):: units
        integer:: index
        logical:: logscale
        logical:: negative
    end type

    type GT_CONTOURS
        type(GT_VARIABLE):: var
        type(GT_AXIS), pointer:: h_axis
        type(GT_AXIS), pointer:: v_axis
        ! 真にしたときのみぬりわけを行う
        logical:: shade
        ! 真にしたときのみ等値線を引く
        logical:: contours
        ! --- どのレベルに等値線またはぬりわけ境界を置くか ---
        ! 確保されていれば size(levels) 本の線を引く手動設定
        real, pointer, dimension(:):: levels
        ! コンター(c), 色塗り(s) に関してレンジ指定
        ! デフォルトは無限区間
        real, pointer:: crange(:)
        real, pointer:: srange(:)
        ! 正に指定すればその間隔を用いて自動設定
        ! 負に指定すれば最大最小から int(abs(interval)) 本の線を引く自動設定
        ! 初期値 0.0 は手動処理がない場合だけ -12.0 と等価
        real:: sint
        real:: cint
        ! 自動設定を行うときにこの値を含むようにする
        real:: base
        ! 手動・自動設定のいかなる場合でもレベルを除去
        real, pointer, dimension(:):: skiplevels
        ! --- 等値線をどのように描くか ---
        ! icycle 本の等値線のうち1本を major line (ラベルつきの太線) にする
        integer:: icycle
        ! --- ぬりわけをどのようにするか ---
        ! もしひとつでも割り付けるならば大きさは
        ! size(levels) + 1 にしなければならない
        integer, pointer, dimension(:):: tones
        ! --- -next メッセージを受け付けるか
        logical:: animate
        ! --- 空でなければ地図を描画する
        character(STRING):: map
    end type

    type GT_VECTORS
        type(GT_VARIABLE):: var1
        type(GT_VARIABLE):: var2
        type(GT_AXIS), pointer:: h_axis
        type(GT_AXIS), pointer:: v_axis
	integer:: hskip
	integer:: vskip
        logical:: animate
        ! --- 空でなければ地図を描画する
        character(STRING):: map
    end type

    type GT_LINE
        type(GT_VARIABLE):: var
        type(GT_AXIS), pointer:: h_axis
        type(GT_AXIS), pointer:: v_axis
        integer:: index
        integer:: type
        integer:: mark
        logical:: animate
    end type

    type GT_FIGURE
        type(GT_AXIS), pointer:: h_axis
        type(GT_AXIS), pointer:: v_axis
        type(GT_CONTOURS), pointer:: contours(:)
	type(GT_VECTORS), pointer:: vectors(:)
        type(GT_LINE), pointer:: line(:)
        character(STRING):: title
        logical:: animate
        ! 投影法関係
        integer:: projection
        real:: stdlon, stdlat, rotate
        ! アスペクト比, 無指定は 0.0
        real:: aspect
	! ビューポート横幅, デフォルトは 0.55
	real:: fill
	! ビューポート中心と描画領域中心との差, デフォルトは 0.025
	real:: shift
	! 仮想的な図劃上端、デフォルトは 0.65
	real:: ceil
    end type

    type GT_FRAME
        type(GT_FIGURE), pointer:: figs(:)
        character(STRING):: title
        logical:: first_figure
    end type

    type GT_DEVICE
        integer:: ws_id
    end type

    ! 万物を併呑するための型
    type GT_OBJECT
        type(GT_AXIS), pointer:: axis
        type(GT_CONTOURS), pointer:: cont
        type(GT_VECTORS), pointer:: vect
        type(GT_LINE), pointer:: line
        type(GT_FIGURE), pointer:: fig
        type(GT_FRAME), pointer:: frame
        type(GT_OBJECT), pointer:: next
    end type

end module

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

! Create(var, url, copyfrom, [copyvalue], [overwrite], [err])
! は変数 copyfrom と同じ次元、属性を持った変数を作成する。
! 必要ならば次元変数も複製される。
! copyvalue を真に指定すると値も複製される。
!
! なお、次元変数の複製は copyfrom と url が異なるファイルに
! 載っている場合に行なわれる。これは netCDF/an を想定したものだが
! ほかのファイル形式が追加されたときには変更を要するかもしれない。

subroutine GTVarCreateCopyC(var, url, copyfrom, copyvalue, &
    & overwrite, err)
    use gtdata_types, only: GT_VARIABLE
    use dc_types, only: STRING
    use gtdata_generic, only: Open, Inquire, Close, Create, Copy_Attr
    use dc_url, only: UrlSplit, GT_ATMARK
    use dc_trace, only: beginsub, endsub
    use dc_error
    implicit none
    intrinsic trim
    type(GT_VARIABLE), intent(out):: var
    character(len = *), intent(in):: url
    type(GT_VARIABLE), intent(inout):: copyfrom
    logical, intent(in), optional:: copyvalue
    logical, intent(in), optional:: overwrite
    logical, intent(out), optional:: err
    type(GT_VARIABLE), allocatable:: vDimSource(:)
    type(GT_VARIABLE), allocatable:: vDimDest(:)
    integer:: i, nd, stat
    logical:: myerr
    character(STRING):: vpart, upart, desturl
continue
    call beginsub('gtvarcreatecopy', 'url=%c copyfrom=%d', &
        & c1=trim(url), i=(/copyfrom%mapid/))
    stat = 0
    myerr = .FALSE.
    call Inquire(copyfrom, alldims=nd)
    allocate(vDimSource(nd), vDimDest(nd), stat=stat)
    if (stat /= 0) goto 999
    desturl = url
    do, i = 1, nd
        call Open(vDimSource(i), copyfrom, dimord=i, &
            & count_compact=.TRUE., err=myerr)
        call GTVarCopyDim(to=vDimDest(i), from=vDimSource(i), &
            & target=desturl)
    end do
    call UrlSplit(url, var=vpart)
    if (vpart == "") then
        call Inquire(copyfrom, url=upart)
        call UrlSplit(upart, var=vpart)
        desturl = trim(desturl) // GT_ATMARK // trim(vpart)
    end if
    call Create(var, trim(desturl), dims=vDimDest, overwrite=overwrite, &
        & err=myerr)
    if (myerr) goto 990
    call copy_attr(to=var, from=copyfrom, err=myerr)
    if (myerr) goto 990
    if (present(copyvalue)) then
        if (copyvalue) then
            call GTVarCopyValue(to=var, from=copyfrom)
        endif
    endif
    do, i = 1, nd
        call Close(vDimSource(i))
        call Close(vDimDest(i))
    end do
990 continue
    deallocate(vDimSource, vDimDest, stat=stat)
999 continue
    if (stat /= 0) then
        call StoreError(GT_ENOMEM, "GTVarCreateCopy", err)
    else if (present(err)) then
        err = myerr
    else if (myerr) then
        call DumpError
    end if
    call endsub('gtvarcreatecopy', 'result=%d', i=(/var%mapid/))
contains

    ! from と同じ内容の変数を URL target で示される変数の作成時に
    ! 次元として使えるように to に複写。
    ! なるべく再オープンで済まそうとする。
    ! 複写する場合もなるべく次元名を合わせようとする。
    !
    subroutine GTVarCopyDim(to, from, target)
        use gtdata_types
        use dc_string, only: var_str
        use dc_types, only: token, string
        use dc_url, only: UrlSplit, UrlMerge, operator(.onthesamefile.)
        use gtdata_generic, only: Open, Inquire, Create, copy_attr
        type(GT_VARIABLE), intent(out):: to
        type(GT_VARIABLE), intent(inout):: from
        character(len = *), intent(in):: target
        character(len = string):: url, file, dimname
        character(len = token):: xtype
        logical:: growable, myerr
        integer:: length
        call beginsub('gtvarcopydim', 'from=%d target=<%c>', &
            & i=(/from%mapid/), c1=trim(target))
        call Inquire(var=from, url=url)
        if (var_str(url) .onthesamefile. var_str(target)) then
            call Open(to, from, dimord=0)
            call endsub('gtvarcopydim', 'dup-handle')
            return
        endif
        call UrlSplit(target, file=file)
        if (LookupEquivalent(to, from, file)) then
            call endsub('gtvarcopydim', 'equivalent-exists')
            return
        else
            call Inquire(var=from, growable=growable, allcount=length)
            if (growable) length = 0
            call Inquire(var=from, xtype=xtype, name=dimname)
            !
            url = urlmerge(file, dimname)
            call Create(to, trim(url), length, xtype, err=myerr)
            if (myerr) then
                ! 指定名称でうまくいかない場合は自動生成名にする
                call Create(to, trim(file), length, xtype)
            endif
            call copy_attr(to, from, myerr)
            call GTVarCopyValue(to, from)
            call endsub('gtvarcopydim', 'created')
            return
        endif
    end subroutine

    logical function LookupEquivalent(to, from, file) result(result)
        use dc_types, only: string
        use dc_string, only: var_str
        use gtdata_generic, only: Inquire, GTVarSearch, Open, get_attr
        type(GT_VARIABLE), intent(out):: to
        type(GT_VARIABLE), intent(in):: from
        character(len = *), intent(in):: file
        character(len = string):: url, units1, units2
        logical:: end
        integer:: len1, len2
        call beginsub('lookupequivalent', 'from=%d file=<%c>', &
            & i=(/from%mapid/), c1=trim(file))
        result = .FALSE.
        call Inquire(from, allcount=len1)
        call get_attr(from, 'units', units1, default='')
        call GTVarSearch(file)
        do
            call GTVarSearch(url, end)
            if (end) exit
            call Open(to, url, writable=.TRUE., err=end)
            if (end) exit
            call Inquire(to, allcount=len2)
            if (len1 /= len2) then
                call Close(to)
                cycle
            endif
            call get_attr(to, 'units', units2, default='')
            ! 本当は dc_units で比較すべきだがとりあえず文字列比較
            if (units1 /= units2) then
                call Close(to)
                cycle
            endif
            result = .TRUE.
            call endsub('lookupequivalent', 'found')
            return
        enddo
        call endsub('lookupequivalent', 'not found')
    end function

    ! すでに存在する変数について、値をコピーする。
    !
    subroutine GTVarCopyValue(to, from)
        use gtdata_types, only: GT_VARIABLE
        use gtdata_generic, only: GTVarGetReal, GTVarPutReal, Inquire, Slice, Slice_Next
        use dc_error, only: DumpError
        use dc_string
        type(GT_VARIABLE), intent(inout):: to
        type(GT_VARIABLE), intent(inout):: from
        real, allocatable:: rbuffer(:)
        logical:: err
        integer:: siz, stat
        !
        call beginsub('gtvarcopyvalue')
        ! 値のコピー
        call Slice(from)
        call Slice(to, compatible=from)
        call Inquire(from, size=siz)
        allocate (rbuffer(siz))
        do
            call GTVarGetReal(from, rbuffer, siz, err)
            if (err) call DumpError()
            call GtVarPutReal(to, rbuffer, siz, err)
            if (err) call DumpError()
            call Slice_Next(from, stat=stat)
            if (stat /= 0) exit
            call Slice_Next(to, stat=stat)
        enddo
        deallocate (rbuffer)
        call endsub('gtvarcopyvalue')
    end subroutine

end subroutine

! gtool.f90 - gtool4 のユーザインターフェイス

module gtool

    use dc_string
    use dc_string
    use sysdep
    use gt_args
    use dc_error
    use dc_url
    use gtdata_types
    use gtdata_generic
    use gtgraph_types
    use gtgraph_generic
    use gtgraph_com
!    use gtool_history
    implicit none

    public:: GT_VARIABLE
    public:: GT_FIGURE, GT_DEVICE, GT_CONTOURS, GT_AXIS
    public:: Open, Create, Close, Display, Put
    public:: gtargget, gtargcount

end module

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.
! gtunary - 変数への単項演算子適用

! 書式
!   gtunary [オプション=値 ...] 演算子 [...]
!
! 入力は input オプションまたは gtool.nc@default
! 出力は output オプションまたは gtool.nc@default
! 演算子は任意個指定可. デフォルトで「なにもしない=コピー」.

program gtunary
    use gtool
    use netcdf_f77, only: NF_EINVAL
    use dc_trace, only: setdebug
    implicit none
    character(len = STRING):: output, input
    character(len = STRING):: arg, optname, optvalue
    type(GT_VARIABLE):: in, out
    integer:: argind, argc, argstart, siz, stat, chunk
    double precision, allocatable:: buf(:)
!--
    input = "gtool.nc@"
    output = "gtool.nc@default"
    argc = GtArgCount()
    argind = 0
    if (argc == 0) then
        print *, "usage: gtunary [in=<input>] [out=<output>] operator ..."
        stop
    endif
    do, while (argind <= argc)
        argind = argind + 1
        call GtArgGet(argind, arg)
        if (.not. GtOptionForm(arg, optname, optvalue)) exit
        if (optname == "in") then
            input = optvalue
        else if (optname == "out") then
            output = optvalue
        else if (optname == "-debug") then
            call setdebug
        else
            call StoreError(NF_EINVAL, 'unknown option')
        endif
    enddo
    argstart = argind
    chunk = 1
    call Open(in, input)
    call Create(out, url=output, copyfrom=in, copyvalue=.FALSE.)
    call Slice(in)
    call Slice(out, compatible=in)
    call Inquire(out, size=siz)
    allocate(buf(siz))
    do
        call Get(in, buf, siz)
        do, argind = argstart, argc
            call GtArgGet(argind, arg)
            call put_line(trim(arg))
            call UnaryOperation(buf, trim(arg))
        enddo
        call Put(out, buf, siz)
        call Slice_Next(in, stat=stat)
        if (stat == GT_ENOMOREDIMS) exit
        call Slice_Next(out) 
        call printf(fmt="chunk %d:", i=(/chunk/))
        chunk = chunk + 1
    enddo
    call Close(in)
    call Close(out)
    stop
contains

    subroutine UnaryOperation(buf, cmd)
        implicit none
        double precision, intent(inout):: buf(:)
        character(len = *), intent(in):: cmd
        double precision:: param
        logical, save:: lfirst = .TRUE.
        double precision, parameter:: undef = -9.99e5
        if (strieq(cmd, "NEGATE")) then
            buf(:) = -buf(:)
        else if (strieq(cmd, "SQRT")) then
            where (buf(:) >= 0.0)
                buf(:) = sqrt(buf(:))
            elsewhere
                buf(:) = undef
            endwhere
        else if (strieq(cmd, "LOG")) then
            where (buf(:) >= 0.0)
                buf(:) = log(buf(:))
            elsewhere
                buf(:) = undef
            endwhere
        else if (strieq(cmd, "LOG10")) then
            where (buf(:) >= 0.0)
                buf(:) = log10(buf(:))
            elsewhere
                buf(:) = undef
            endwhere
        else if (cmd(1:2) == '-=' .or. strieq(cmd(1:2), 's:')) then
            read(cmd(3: ), *) param
            buf(:) = buf(:) - param
        else if (cmd(1:2) == '+=' .or. strieq(cmd(1:2), 'a:')) then
            read(cmd(3: ), *) param
            buf(:) = buf(:) + param
        else if (cmd(1:2) == '*=' .or. strieq(cmd(1:2), 'm:')) then
            read(cmd(3: ), *) param
            buf(:) = buf(:) * param
        else if (cmd(1:2) == '/=' .or. strieq(cmd(1:2), 'd:')) then
            read(cmd(3: ), *) param
            if (abs(param) > tiny(0.0d0)) then
                buf(:) = buf(:) / param
            endif
        else if (cmd(1:2) == '^=' .or. strieq(cmd(1:2), 'p:')) then
            read(cmd(3: ), *) param
            buf(:) = param ** buf(:)
        else if (lfirst) then
            lfirst = .FALSE.
            call printf(fmt="unknown operation <%c>", c1=cmd)
        end if
    end subroutine

end program

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

subroutine GTContLoad(Cont, var)
    use gtgraph_types, only: GT_CONTOURS
    use gtdata_types, only: GT_VARIABLE
    use gtgraph_generic, only: Load
    use gtdata_generic  ! いっぱい使うから書くのはやめ
    use dc_types, only: STRING
    use dc_error
    implicit none
    type(GT_CONTOURS), intent(out):: Cont
    type(GT_VARIABLE), intent(in):: var
    character(STRING):: varname
    character(*), parameter:: GTCT = 'gt_graph_contours_'
    ! リンク名が data であることを仮定
    call get_attr(var, "gt_structure_link_data", varname)
    if (varname == "") then
        call StoreError(GT_EBADLINK, "GTContLoad(data variable)")
        return
    endif
    call Open(cont%var, varname)
    cont%contours = attr_true(var, GTCT//'draw_contours', default=.TRUE.)
    cont%shade = attr_true(var, GTCT//'draw_shade', default=.FALSE.)
    allocate(cont%h_axis, cont%v_axis)
    call get_attr(var, "gt_structure_link_haxis", varname)
    call Load(cont%h_axis, varname)
    call get_attr(var, "gt_structure_link_vaxis", varname)
    call Load(cont%v_axis, varname)
    ! オプションの初期化
    call get_attr(var, GTCT//'interval', cont%cint, default=0.0)
    call get_attr(var, GTCT//'thick_cycle', cont%icycle, default=0)
    call get_attr(var, GTCT//'levels', cont%levels)
    call get_attr(var, GTCT//'skiplevels', cont%skiplevels)
    call get_attr(var, GTCT//'tone_number', cont%tones) ! experimental
    call get_attr(var, GTCT//'base_level', cont%base, default=0.0) ! experimental
    call get_attr(var, "gt_graph_draw_map", cont%map, default="")
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

subroutine GTVarPutAttrChar(var, name, value, xtype, err)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: put_attr, an_variable
    use gt_mem, only: put_attr, mem_variable
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_VARIABLE), intent(inout):: var
    character(len = *), intent(in):: name
    character(len = *), intent(in):: value
    character(len = *), intent(in), optional:: xtype
    logical, intent(out), optional:: err
    integer:: class, cid
    character(*), parameter:: subnam = "gtvarputattrchar"
    call beginsub(subnam, "%d:%c = %c", i=(/var%mapid/), c1=trim(name), c2=trim(value))
    call var_class(var, class, cid)
    if (class == vtb_class_netcdf) then
        call put_attr(an_variable(cid), name, value, xtype, err)
    else if (class == vtb_class_memory) then
        call put_attr(mem_variable(cid), name, value)
        if (present(err)) err = .false.
    endif
    call endsub(subnam)
end subroutine

    ! VSTRING 型を引き取り上記 put_attr を呼び出す。下位層のことは関知しない
subroutine GTVarPutAttrString(var, name, value, err)
    use gtdata_types, only: GT_VARIABLE
    use dc_string, only: VSTRING, vchar, operator(==), len
    use gtdata_generic, only: put_attr
    implicit none
    type(GT_VARIABLE), intent(inout):: var
    character(len = *), intent(in):: name
    type(VSTRING), intent(in):: value
    logical, intent(out), optional:: err
    call put_attr(var, name, vchar(value, len(value)), err=err)
end subroutine

subroutine GTVarPutAttrReal(var, name, value, err)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: put_attr, an_variable
    use gt_mem, only: put_attr, mem_variable
    use dc_string, only: toChar
    implicit none
    type(GT_VARIABLE), intent(inout):: var
    character(len = *), intent(in):: name
    real, intent(in):: value(:)
    logical, intent(out), optional:: err
    integer:: class, cid
    call var_class(var, class, cid)
    if (class == vtb_class_netcdf) then
        call put_attr(an_variable(cid), name, value, err)
    else if (class == vtb_class_memory) then
        call put_attr(mem_variable(cid), name, trim(toChar(value)))
        if (present(err)) err = .false.
    endif
end subroutine

subroutine GTVarPutAttrDouble(var, name, value, err)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: put_attr, an_variable
    use gt_mem, only: put_attr, mem_variable
    use dc_string, only: toChar
    implicit none
    type(GT_VARIABLE), intent(inout):: var
    character(len = *), intent(in):: name
    double precision, intent(in):: value(:)
    logical, intent(out), optional:: err
    integer:: class, cid
    call var_class(var, class, cid)
    if (class == vtb_class_netcdf) then
        call put_attr(an_variable(cid), name, value, err)
    else if (class == vtb_class_memory) then
        call put_attr(mem_variable(cid), name, trim(toChar(value)))
        if (present(err)) err = .false.
    endif
end subroutine

subroutine GTVarPutAttrInt(var, name, value, err)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: put_attr, an_variable
    use gt_mem, only: put_attr, mem_variable
    use dc_string, only: toChar
    type(GT_VARIABLE), intent(inout):: var
    character(len = *), intent(in):: name
    integer, intent(in):: value(:)
    logical, intent(out), optional:: err
    integer:: class, cid
    call var_class(var, class, cid)
    if (class == vtb_class_netcdf) then
        call put_attr(an_variable(cid), name, value, err)
    else if (class == vtb_class_memory) then
        call put_attr(mem_variable(cid), name, trim(toChar(value)))
        if (present(err)) err = .false.
    endif
end subroutine

subroutine GTVarPutAttrLogical(var, name, value, err)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: put_attr, an_variable
    use gt_mem, only: put_attr, mem_variable
    use dc_string, only: toChar
    implicit none
    type(GT_VARIABLE), intent(inout):: var
    character(len = *), intent(in):: name
    logical, intent(inout):: value
    logical, intent(out), optional:: err
    integer:: class, cid
    call var_class(var, class, cid)
    if (class == vtb_class_netcdf) then
        if (value) then
            call put_attr(an_variable(cid), name, "true", err=err)
        else
            call put_attr(an_variable(cid), name, "false", err=err)
        endif
    else if (class == vtb_class_memory) then
        if (value) then
            call put_attr(mem_variable(cid), name, "true")
        else
            call put_attr(mem_variable(cid), name, "false")
        endif
        if (present(err)) err = .false.
    endif
end subroutine

! gtool_history.f90 - traditional interface for `history' output
! vi: set sw=4 ts=8: 
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

!=begin
!= module gtool_history
!a sequential output interface for gtool4 netCDF dataset.
!
!== Description
!This module is designed for output to gtool4 netCDF dataset
!sequentially along an axis (hereafter it will be called 'time').
!The name indicates that the module is originally intended to serve as
!the 'history' of atmospheric forecast models.
!=end

module gtool_history

    !=begin
    !== Dependency
    !* ((<module gtdata_types|URL:gtdata_types.html>)) for internal data access
    !* ((<module dc_types|URL:dc_types.html>)) for constants STRING and TOKEN
    !* ((<module dc_trace|URL:dc_trace.html>)) for error trace function
    !=end

    use gtdata_types
    use dc_types, only: string, token
    use dc_trace, only: beginsub, endsub, message
    implicit none

    private
    public:: GT_HISTORY
    public:: HistoryCreate, HistoryAddVariable, HistoryClose
    public:: HistoryPutEx, HistoryPut, HistoryAddAttr, GT_HISTORY_AXIS
    public:: HistorySetTime, GT_HISTORY_VARINFO

    interface HistoryCreate
        module procedure HistoryCreate1, HistoryCreate2
    end interface

    interface HistoryAddVariable
        module procedure HistoryAddVariable1, HistoryAddVariable2
    end interface

    interface HistoryPut
        module procedure HistoryPut1, HistoryPut2, HistoryPut3, HistoryPut0
        module procedure HistoryPutDouble1, HistoryPutDouble2
        module procedure HistoryPutDouble3, HistoryPutDouble0
    end interface

    interface HistoryAddAttr
        module procedure HistoryAddAttrC, HistoryAddAttrS
        module procedure HistoryAddAttrL
        module procedure HistoryAddAttrR, HistoryAddAttrRA
        module procedure HistoryAddAttrD, HistoryAddAttrDA
        module procedure HistoryAddAttrI, HistoryAddAttrIA
    end interface

    !=begin
    !== Derived Types
    !=== type GT_HISTORY
    !Data entity of this type represents a netCDF dataset controlled by
    !gtool4 library.
    !It must be initialized by ((<HistoryOpen>)),
    !then used in many subroutines, and must be finalized by ((<HistoryClose>)).
    !Note that the resultant file is undefined if you forget to finalize it. 
    !
    !Users are recommended to retain the object of this type
    !returned by ((<HistoryOpen>)),
    !to use it as the last argument (called ((|history|))) for
    !all following subroutine calls.
    !However, it is not mandatory.
    !When you are going to write ((*ONLY*)) one dataset,
    !argument ((|history|)) of all subroutine calls can be omitted, and
    !the history entity will be internally managed within this module.
    !=end

    type GT_HISTORY
        type(GT_VARIABLE), pointer:: dimvars(:)
        logical, pointer:: dim_value_written(:)
        !
        ! NOTE: it is index of dimvars(:), not that of vars(:).
        integer:: unlimited_index
        real:: origin, interval, newest, oldest
        type(GT_VARIABLE), pointer:: vars(:)
        integer, pointer:: growable_indices(:)
        integer, pointer:: count(:)
    end type

    type(GT_HISTORY), save, target:: default

!=begin
!=== type GT_HISTORY_AXIS
!This type may be used as a argument ((|axes|)) of ((<HistoryCreate>))
!to define features of axes of a history dataset.
!Typically, a constant array of this type will be used for
!fixed specification.
!=end

    !=begin
    type GT_HISTORY_AXIS
        character(len = token):: name
        integer:: length
        character(len = string):: longname, units
        character(len = token):: xtype
    end type
    !=end

!=begin
!=== type GT_HISTORY_VARINFO
!This type may be used as a argument ((|varinfo|)) of ((<HistoryAddVariable>))
!to define features of variable of a history dataset.
!=end

    type GT_HISTORY_VARINFO
        character(len = token):: name
        character(len = token), pointer:: dims(:)
        character(len = string):: longname, units
        character(len = token):: xtype
    end type

contains

    !=begin
    !== Procedure Interface
    !=end

    !=begin
    !=== HistoryCreate subroutines
    !Two specific subroutines shares common part:
    !
    !(({call HistoryCreate(}))((|file|)), ((|title|)), ((|source|)),
    !((|institution|)), ..., ((|origin|)), ((|interval|)),
    ![((|history|))](({)}))
    !
    !Both two ones initializes a dataset ((|file|)).
    !The result of ((<type GT_HISTORY>)) will be returned by ((|history|))
    !or managed internally if omitted.
    !Mandatory global attributes are defined by arguments
    !((|title|)), ((|source|)), and ((|institution|));
    !they are all declared as (({character(len = *)})).
    !Spatial axis definitions have two different forms:
    !a primitive one uses several arrays of various types:
    !((|dims|)), ((|dimsizes|)), ((|longnames|)), ((|units|)), and ((|xtypes|)).
    !Another sophisticated one has only array of ((<type GT_HISTORY_AXIS>)),
    !((|axes|)).
    !Temporal definition is done without ((|origin|)), ((|interval|)).
    !=end

    !=begin
    subroutine HistoryCreate2(file, title, source, institution, &
        & axes, origin, interval, history)
    implicit none
        character(len=*), intent(in):: file
        character(len=*), intent(in):: title, source, institution
        type(GT_HISTORY_AXIS), intent(in):: axes(:)
        real, intent(in):: origin, interval
        type(GT_HISTORY), intent(out), optional:: history
    !=end
    continue
        call HistoryCreate1(file, title, source, institution, &
            & dims=axes(:)%name, dimsizes=axes(:)%length, &
            & longnames=axes(:)%longname, units=axes(:)%units, &
            & xtypes=axes(:)%xtype, &
            & origin=origin, interval=interval, history=history)
    end subroutine

    !=begin
    subroutine HistoryCreate1(file, title, source, institution, &
        & dims, dimsizes, longnames, units, origin, interval, &
        & xtypes, history)
        use gtdata_generic
        use dc_url
        use dc_error
        use dc_string
        use dc_types, only: string, token
    implicit none
        character(len=*), intent(in):: file
        character(len=*), intent(in):: title, source, institution
        character(len=*), intent(in):: dims(:)
        integer, intent(in):: dimsizes(:)
        character(len=*), intent(in):: longnames(:)
        character(len=*), intent(in):: units(:)
        real, intent(in):: origin, interval
        character(len=*), intent(in), optional:: xtypes(:)
        type(GT_HISTORY), intent(out), optional, target:: history
    !=end
        integer:: numdims, i
        type(GT_HISTORY), pointer:: hst
        character(len = token):: my_xtype
        character(len = string):: merged, x_inst, nc_history
    continue
        call beginsub('history-create', 'file=%c ndims=%d', &
            & c1=trim(file), i=(/size(dims)/))
        if (present(history)) then
            hst => history
        else
            hst => default
        endif
        numdims = size(dims)
        if (size(dimsizes) /= numdims .or. size(longnames) /= numdims .or. &
            & size(units) /= numdims) then
            call StoreError(GT_EARGSIZEMISMATCH, "HistoryCreate")
            call endsub('history-create', 'err')
            return
        endif

        ! 次元変数表作成
        allocate(hst%dimvars(numdims), hst%dim_value_written(numdims))
        hst%dim_value_written(:) = .FALSE.
        hst%unlimited_index = 0

        nc_history = 'unknown unknown> gtool_history: HistoryCreate' &
            & // achar(10)

        my_xtype = ""
        do, i = 1, numdims
            if (present(xtypes)) my_xtype = xtypes(i)
            merged = UrlMerge(file=file, var=dims(i))
            call Create(hst%dimvars(i), &
                & trim(merged) , &
                & dimsizes(i), xtype=trim(my_xtype), overwrite=.TRUE.)
            call put_attr(hst%dimvars(i), '+title', title)
            call put_attr(hst%dimvars(i), '+source', source)
            if (institution /= "") then
                x_inst = institution
            else
                x_inst = "a gtool_history (by GFD Dennou Club) user"
            endif
            call put_attr(hst%dimvars(i), '+institution', trim(x_inst))
            call put_attr(hst%dimvars(i), '+history', trim(nc_history))
            call put_attr(hst%dimvars(i), 'long_name', trim(longnames(i)))
            call put_attr(hst%dimvars(i), 'units', trim(units(i)))
            if (dimsizes(i) == 0) hst%unlimited_index = i
        enddo

        ! 変数表
        nullify(hst%vars, hst%growable_indices, hst%count)

        ! 時間カウンタ
        hst%origin = origin
        hst%interval = interval
        hst%newest = origin
        hst%oldest = origin
        call endsub('history-create', 'std')
    end subroutine

    !
    ! --- 属性の設定 ---
    !

    subroutine HistoryAddAttrC(varname, attrname, value, history)
        use gtdata_generic, only: Put_Attr
        implicit none
        character(len = *), intent(in):: varname
        character(len = *), intent(in):: attrname
        character(len = *), intent(in):: value
        type(GT_HISTORY), target, optional:: history
        type(GT_HISTORY), pointer:: hst
        type(GT_VARIABLE):: var
        integer:: v_ord, stat
        character(len = *), parameter:: subname = "HistoryAddAttrC"
    continue
        call beginsub(subname)
        ! 操作対象決定
        if (present(history)) then
            hst => history
        else
            hst => default
        endif
        if (varname == "") then
            ! "+" に大域属性の意味が期待できない場合はループ必要
            do, v_ord = 1, size(hst%vars)
                call Put_Attr(hst%vars(v_ord), "+" // attrname, value)
            enddo
        else
            call lookup_var_or_dim(hst, varname, var, stat)
            if (stat == 0) then
                call Put_Attr(var, attrname, value)
            endif
        endif
        call endsub(subname)
     end subroutine

    subroutine HistoryAddAttrS(varname, attrname, value, history)
        use dc_string, only: VSTRING    
        use gtdata_generic, only: Put_Attr
        implicit none
        character(len = *), intent(in):: varname
        character(len = *), intent(in):: attrname
        type(VSTRING), intent(in):: value
        type(GT_HISTORY), target, optional:: history
        type(GT_HISTORY), pointer:: hst
        type(GT_VARIABLE):: var
        integer:: v_ord, stat
        character(len = *), parameter:: subname = "HistoryAddAttrS"
    continue
        call beginsub(subname)
        ! 操作対象決定
        if (present(history)) then
            hst => history
        else
            hst => default
        endif
        if (varname == "") then
            ! とりあえず無駄だが大域属性を何度もつける
            do, v_ord = 1, size(hst%vars)
                call Put_Attr(hst%vars(v_ord), "+" // attrname, value)
            enddo
        else
            call lookup_var_or_dim(hst, varname, var, stat)
            if (stat == 0) then
                call Put_Attr(var, attrname, value)
            endif
        endif
        call endsub(subname)
     end subroutine

    subroutine HistoryAddAttrL(varname, attrname, value, history)
        use gtdata_generic, only: Put_Attr
        implicit none
        character(len = *), intent(in):: varname
        character(len = *), intent(in):: attrname
        logical, intent(in):: value
        type(GT_HISTORY), target, optional:: history
        type(GT_HISTORY), pointer:: hst
        type(GT_VARIABLE):: var
        integer:: v_ord, stat
        character(len = *), parameter:: subname = "HistoryAddAttrL"
    continue
        call beginsub(subname)
        ! 操作対象決定
        if (present(history)) then
            hst => history
        else
            hst => default
        endif
        if (varname == "") then
            ! とりあえず無駄だが大域属性を何度もつける
            do, v_ord = 1, size(hst%vars)
                call Put_Attr(hst%vars(v_ord), "+" // attrname, value)
            enddo
        else
            call lookup_var_or_dim(hst, varname, var, stat)
            if (stat == 0) then
                call Put_Attr(var, attrname, value)
            endif
        endif
        call endsub(subname)
     end subroutine

    subroutine HistoryAddAttrR(varname, attrname, value, history)
        use gtdata_generic, only: Put_Attr
        implicit none
        character(len = *), intent(in):: varname
        character(len = *), intent(in):: attrname
        real, intent(in):: value
        type(GT_HISTORY), target, optional:: history
        type(GT_HISTORY), pointer:: hst
        type(GT_VARIABLE):: var
        integer:: v_ord, stat
        character(len = *), parameter:: subname = "HistoryAddAttrR"
    continue
        call beginsub(subname)
        ! 操作対象決定
        if (present(history)) then
            hst => history
        else
            hst => default
        endif
        if (varname == "") then
            ! とりあえず無駄だが大域属性を何度もつける
            do, v_ord = 1, size(hst%vars)
                call Put_Attr(hst%vars(v_ord), "+" // attrname, (/value/))
            enddo
        else
            call lookup_var_or_dim(hst, varname, var, stat)
            if (stat == 0) then
                call Put_Attr(var, attrname, (/value/))
            endif
        endif
        call endsub(subname)
     end subroutine

    subroutine HistoryAddAttrRA(varname, attrname, value, history)
        use gtdata_generic, only: Put_Attr
        implicit none
        character(len = *), intent(in):: varname
        character(len = *), intent(in):: attrname
        real, intent(in):: value(:)
        type(GT_HISTORY), target, optional:: history
        type(GT_HISTORY), pointer:: hst
        type(GT_VARIABLE):: var
        integer:: v_ord, stat
    continue
         ! 操作対象決定
         if (present(history)) then
             hst => history
         else
             hst => default
         endif
        if (varname == "") then
            ! とりあえず無駄だが大域属性を何度もつける
            do, v_ord = 1, size(hst%vars)
                call Put_Attr(hst%vars(v_ord), "+" // attrname, value)
            enddo
        else
            call lookup_var_or_dim(hst, varname, var, stat)
            if (stat == 0) then
                call Put_Attr(var, attrname, value)
            endif
        endif
     end subroutine

    subroutine HistoryAddAttrD(varname, attrname, value, history)
        use gtdata_generic, only: Put_Attr
        implicit none
        character(len = *), intent(in):: varname
        character(len = *), intent(in):: attrname
        double precision, intent(in):: value
        type(GT_HISTORY), target, optional:: history
        type(GT_HISTORY), pointer:: hst
        type(GT_VARIABLE):: var
        integer:: v_ord, stat
    continue
         ! 操作対象決定
         if (present(history)) then
             hst => history
         else
             hst => default
         endif
        if (varname == "") then
            ! とりあえず無駄だが大域属性を何度もつける
            do, v_ord = 1, size(hst%vars)
                call Put_Attr(hst%vars(v_ord), "+" // attrname, (/value/))
            enddo
        else
            call lookup_var_or_dim(hst, varname, var, stat)
            if (stat == 0) then
                call Put_Attr(var, attrname, (/value/))
            endif
        endif
     end subroutine

    subroutine HistoryAddAttrDA(varname, attrname, value, history)
        use gtdata_generic, only: Put_Attr
        implicit none
        character(len = *), intent(in):: varname
        character(len = *), intent(in):: attrname
        double precision, intent(in):: value(:)
        type(GT_HISTORY), target, optional:: history
        type(GT_HISTORY), pointer:: hst
        type(GT_VARIABLE):: var
        integer:: v_ord, stat
    continue
         ! 操作対象決定
         if (present(history)) then
             hst => history
         else
             hst => default
         endif
        if (varname == "") then
            ! とりあえず無駄だが大域属性を何度もつける
            do, v_ord = 1, size(hst%vars)
                call Put_Attr(hst%vars(v_ord), "+" // attrname, value)
            enddo
        else
            call lookup_var_or_dim(hst, varname, var, stat)
            if (stat == 0) then
                call Put_Attr(var, attrname, value)
            endif
        endif
     end subroutine

    subroutine HistoryAddAttrI(varname, attrname, value, history)
        use gtdata_generic, only: Put_Attr
        implicit none
        character(len = *), intent(in):: varname
        character(len = *), intent(in):: attrname
        integer, intent(in):: value
        type(GT_HISTORY), target, optional:: history
        type(GT_HISTORY), pointer:: hst
        type(GT_VARIABLE):: var
        integer:: v_ord, stat
    continue
         ! 操作対象決定
         if (present(history)) then
             hst => history
         else
             hst => default
         endif
        if (varname == "") then
            ! とりあえず無駄だが大域属性を何度もつける
            do, v_ord = 1, size(hst%vars)
                call Put_Attr(hst%vars(v_ord), "+" // attrname, (/value/))
            enddo
        else
            call lookup_var_or_dim(hst, varname, var, stat)
            if (stat == 0) then
                call Put_Attr(var, attrname, (/value/))
            endif
        endif
     end subroutine

    subroutine HistoryAddAttrIA(varname, attrname, value, history)
        use gtdata_generic, only: Put_Attr
        implicit none
        character(len = *), intent(in):: varname
        character(len = *), intent(in):: attrname
        integer, intent(in):: value(:)
        type(GT_HISTORY), target, optional:: history
        type(GT_HISTORY), pointer:: hst
        type(GT_VARIABLE):: var
        integer:: stat, v_ord
    continue
        ! 操作対象決定
        if (present(history)) then
            hst => history
        else
            hst => default
        endif
        if (varname == "") then
            ! とりあえず無駄だが大域属性を何度もつける
            do, v_ord = 1, size(hst%vars)
                call Put_Attr(hst%vars(v_ord), "+" // attrname, value)
            enddo
        else
            call lookup_var_or_dim(hst, varname, var, stat)
            if (stat == 0) then
                call Put_Attr(var, attrname, value)
            endif
        endif
    end subroutine

    !
    ! --- 変数の追加 ---
    !

    subroutine HistoryAddVariable2(varinfo, history)
        type(GT_HISTORY_VARINFO), intent(in):: varinfo
        type(GT_HISTORY), intent(inout), optional:: history
    continue
        call HistoryAddVariable1(trim(varinfo%name), &
            & varinfo%dims, trim(varinfo%longname), &
            & trim(varinfo%units), trim(varinfo%xtype), history)
    end subroutine

    subroutine HistoryAddVariable1(varname, dims, longname, units, &
        & xtype, history)
        use dc_string
        use gtdata_generic
        use dc_url
        use dc_types, only: STRING
        implicit none
        character(len = *), intent(in):: varname
        character(len = *), intent(in):: dims(:)
        character(len = *), intent(in):: longname, units
        character(len = *), intent(in), optional:: xtype
        type(GT_HISTORY), intent(inout), optional, target:: history
        type(GT_HISTORY), pointer:: hst
        type(GT_VARIABLE), pointer:: vwork(:), dimvars(:)
        character(len = STRING):: fullname, url
        integer, pointer:: count_work(:)
        integer:: nvars, numdims, i, dimord
    continue
        ! 操作対象決定
        if (present(history)) then
            hst => history
        else
            hst => default
        endif
        call beginsub('history-add-variable', 'name=%c', c1=varname)

        ! 変数表拡張
        if (associated(hst%vars)) then
            nvars = size(hst%vars(:))
            vwork => hst%vars
            count_work => hst%count
            nullify(hst%vars, hst%count)
            allocate(hst%vars(nvars + 1), hst%count(nvars + 1))
            hst%vars(1:nvars) = vwork(1:nvars)
            hst%count(1:nvars) = count_work(1:nvars)
            deallocate(vwork, count_work)
            count_work => hst%growable_indices
            nullify(hst%growable_indices)
            allocate(hst%growable_indices(nvars + 1))
            hst%growable_indices(1:nvars) = count_work(1:nvars)
            deallocate(count_work)
        else
            ! トリッキーだが、ここで count だけ 2 要素確保するのは、
            ! HistorySetTime による巻き戻しに備えるため。
            allocate(hst%vars(1), hst%count(2), hst%growable_indices(1))
            hst%count(2) = 0
        endif
        nvars = size(hst%vars(:))
        hst%growable_indices(nvars) = 0
        hst%count(nvars) = 0

        ! 変数添字次元を決定
        numdims = size(dims(:))
        allocate(dimvars(numdims))
        do, i = 1, numdims
            dimvars(i) = lookup_dimension(hst, dims(i), ord=dimord)
            if (dimord == hst%unlimited_index) then
                hst%growable_indices(nvars) = i
            endif
        enddo

        ! 変数作成
        call Inquire(hst%dimvars(1), url=url)
        fullname = UrlResolve(('@' // trim(varname)), trim(url))
        call Create(hst%vars(nvars), trim(fullname), dimvars, xtype=xtype)
        ! 拡張可能次元があったらそれをサイズ 1 に拡張しておく
        if (hst%growable_indices(nvars) /= 0) then
            call Slice(hst%vars(nvars), hst%growable_indices(nvars), &
                & start=1, count=1, stride=1)
        endif
        call put_attr(hst%vars(nvars), 'long_name', longname)
        call put_attr(hst%vars(nvars), 'units', units)
        deallocate(dimvars)
        call endsub('history-add-variable')
    end subroutine

    ! 時刻を明示設定している状態で、巻き戻しを含めた時間設定。
    ! 前進している間は検索をしないようになっている。
    
    subroutine HistorySetTime(time, history)
        use gtdata_generic
    implicit none
        real, intent(in):: time
        type(GT_HISTORY), intent(inout), optional, target:: history
        type(GT_HISTORY), pointer:: hst
        type(GT_VARIABLE):: var
        real, pointer:: buffer(:)
        logical:: err
    continue
        if (present(history)) then
            hst => history
        else
            hst => default
        endif
        if (hst%unlimited_index == 0) then
            return
        endif
        var = hst%dimvars(hst%unlimited_index)
        hst%dim_value_written(hst%unlimited_index) = .TRUE.
        if (time < hst%oldest .or. time > hst%newest .or. hst%count(2) == 0) then
            hst%count(:) = maxval(hst%count(:)) + 1
            hst%newest = max(hst%newest, time)
            hst%oldest = min(hst%oldest, time)
            call Slice(var, 1, start=hst%count(1), count=1)
            call Put(var, (/time/), 1, err)
            if (err) call DumpError()
            return
        endif
        call Slice(var, 1, start=1, count=hst%count(2))
        nullify(buffer)
        call Get(var, buffer, err)
        hst%count(1:1) = minloc(abs(buffer - time))
    end subroutine

    ! デフォルトでは変数ごとにカウンタを設置し、呼んだ数だけ「時刻」
    ! 方向を進める。
    ! これに対し、時刻の変数に一度でもスカラ値を投入すると、
    ! 明示的にそれを設定したときにだけ時刻が進むようになる。
    ! このルーチンでは後退はできない。

    subroutine TimeGoAhead(varname, var, head, history)
        use gtdata_generic
        character(len = *), intent(in):: varname
        type(GT_VARIABLE), intent(out):: var
        real, intent(in):: head
        type(GT_HISTORY), intent(inout), optional, target:: history
        type(GT_HISTORY), pointer:: hst
        integer, pointer:: time
        integer:: v_ord, d_ord
    continue
        if (present(history)) then
            hst => history
        else
            hst => default
        endif
        var = lookup_variable(hst, varname, ord=v_ord)
        if (v_ord == 0) goto 1000
        if (hst%growable_indices(v_ord) == 0) return

        if (hst%dim_value_written(hst%unlimited_index)) then
            time => hst%count(1)
            call Slice(var, hst%growable_indices(v_ord), &
                & start=time, count=1)
        else
            time => hst%count(v_ord)
            time = time + 1
            call Slice(var, hst%growable_indices(v_ord), &
                & start=time, count=1)
        endif
        return

    1000 continue
        var = lookup_dimension(hst, varname, ord=d_ord)
        hst%dim_value_written(d_ord) = .TRUE.
        if (d_ord /= hst%unlimited_index) return

        ! ややトリッキーだが、count の2番目以降の要素にも時刻を入れて
        ! おくことで、HistorySetTime による巻き戻し後にも値を保持する。
        hst%count(:) = maxval(hst%count(:)) + 1
        hst%newest = max(hst%newest, head)
        hst%oldest = min(hst%oldest, head)
        call Slice(var, 1, start=hst%count(1), count=1)
        return

    end subroutine

    subroutine HistoryPutEx(varname, array, arraysize, history)
        use gtdata_generic
        character(len = *), intent(in):: varname
        integer, intent(in):: arraysize
        real, intent(in):: array(arraysize)
        type(GT_HISTORY), intent(inout), optional:: history
        type(GT_VARIABLE):: var
        logical:: err
        character(*), parameter:: subname = "HistoryPutEx"
    continue
        call beginsub(subname, '%c', c1=trim(varname))
        call TimeGoAhead(varname, var, array(1), history)
        call Put(var, array, arraysize, err)
        if (err) call DumpError()
	call GTVarSync(var)
        call endsub(subname)
    end subroutine

    subroutine HistoryPut0(varname, value, history)
        character(len = *), intent(in):: varname
        real, intent(in):: value
        type(GT_HISTORY), intent(inout), optional:: history
        character(len = *), parameter:: subname = "HistoryPut0"
    continue
        call beginsub(subname)
        call HistoryPutEx(varname, (/value/), 1, history)
        call endsub(subname)
    end subroutine

    subroutine HistoryPut1(varname, array, history)
        character(len = *), intent(in):: varname
        real, intent(in):: array(:)
        type(GT_HISTORY), intent(inout), optional:: history
        character(len = *), parameter:: subname = "HistoryPut1"
    continue
        call beginsub(subname)
        call HistoryPutEx(varname, array, size(array), history)
        call endsub(subname)
    end subroutine

    subroutine HistoryPut2(varname, array, history)
        character(len = *), intent(in):: varname
        real, intent(in):: array(:, :)
        type(GT_HISTORY), intent(inout), optional:: history
        character(len = *), parameter:: subname = "HistoryPut2"
    continue
        call beginsub(subname)
        call HistoryPutEx(varname, array, size(array), history)
        call endsub(subname)
    end subroutine

    subroutine HistoryPut3(varname, array, history)
        character(len = *), intent(in):: varname
        real, intent(in):: array(:, :, :)
        type(GT_HISTORY), intent(inout), optional, target:: history
        character(len = *), parameter:: subname = "HistoryPut3"
    continue
        call beginsub(subname)
        call HistoryPutEx(varname, array, size(array), history)
        call endsub(subname)
    end subroutine

    subroutine HistoryPutExDouble(varname, array, arraysize, history)
        use gtdata_generic
        character(len = *), intent(in):: varname
        integer, intent(in):: arraysize
        double precision, intent(in):: array(arraysize)
        type(GT_HISTORY), intent(inout), optional, target:: history
        type(GT_VARIABLE):: var
        logical:: err
        character(len = *), parameter:: subname = "HistoryPutExDouble"
    continue
        call beginsub(subname, '%c', c1=trim(varname))
        call TimeGoAhead(varname, var, real(array(1)), history)
        call Put(var, array, arraysize, err)
        if (err) call DumpError()
	call GTVarSync(var)
        call endsub(subname)
    end subroutine

    subroutine HistoryPutDouble0(varname, value, history)
        character(len = *), intent(in):: varname
        double precision, intent(in):: value
        type(GT_HISTORY), intent(inout), optional:: history
        character(len = *), parameter:: subname = "HistoryPutDouble0"
    continue
        call beginsub(subname)
        call HistoryPutExDouble(varname, (/value/), 1, history)
        call endsub(subname)
    end subroutine

    subroutine HistoryPutDouble1(varname, array, history)
        character(len = *), intent(in):: varname
        double precision, intent(in):: array(:)
        type(GT_HISTORY), intent(inout), optional, target:: history
        character(len = *), parameter:: subname = "HistoryPutDouble1"
    continue
        call beginsub(subname)
        call HistoryPutExDouble(varname, array, size(array), history)
        call endsub(subname)
    end subroutine

    subroutine HistoryPutDouble2(varname, array, history)
        character(len = *), intent(in):: varname
        double precision, intent(in):: array(:, :)
        type(GT_HISTORY), intent(inout), optional, target:: history
        character(len = *), parameter:: subname = "HistoryPutDouble2"
    continue
        call beginsub(subname)
        call HistoryPutExDouble(varname, array, size(array), history)
        call endsub(subname)
    end subroutine

    subroutine HistoryPutDouble3(varname, array, history)
        character(len = *), intent(in):: varname
        double precision, intent(in):: array(:, :, :)
        type(GT_HISTORY), intent(inout), optional, target:: history
        character(len = *), parameter:: subname = "HistoryPutDouble3"
    continue
        call beginsub(subname)
        call HistoryPutExDouble(varname, array, size(array), history)
        call endsub(subname)
    end subroutine

    subroutine HistoryClose(history)
        use gtdata_generic
        type(GT_HISTORY), intent(inout), optional, target:: history
        type(GT_HISTORY), pointer:: hst
        integer:: i
        character(len = *), parameter:: subname = "HistoryClose"
    continue
        call beginsub(subname)
        if (present(history)) then
            hst => history
        else
            hst => default
        endif
        do, i = 1, size(hst%dimvars)
            if (.not. hst%dim_value_written(i)) &
                call set_fake_dim_value(hst, i)
            call Close(hst%dimvars(i))
        enddo
        deallocate(hst%dimvars)
        do, i = 1, size(hst%vars)
            call Close(hst%vars(i))
        enddo
        if (associated(hst%vars)) deallocate(hst%vars)
        if (associated(hst%count)) deallocate(hst%count)
        call endsub(subname)
    end subroutine

    subroutine set_fake_dim_value(history, dimord)
        use gtdata_generic
        use dc_error
        type(GT_HISTORY), intent(inout):: history
        integer, intent(in):: dimord
        integer:: length, i
        real, allocatable:: value(:)
        logical:: err
    continue
        if (dimord == history%unlimited_index) then
            if (.not. associated(history%count)) return
            length = maxval(history%count(:))
        else
            call Inquire(history%dimvars(dimord), size=length)
        endif
        if (length == 0) return
        allocate(value(length))
        if (dimord == history%unlimited_index) then
            value(:) = (/(real(i), i = 1, length)/)
            value(:) = history%origin + (value(:) - 1.0) * history%interval
            call Slice(history%dimvars(dimord), 1, start=1, count=length)
        else
            value(:) = (/(real(i), i = 1, length)/)
        endif

        call Put(history%dimvars(dimord), value, size(value), err)
        if (err) call DumpError
        deallocate(value)
    end subroutine

    integer &
    function lookup_variable_ord(history, varname) result(result)
        use dc_types, only: string
        use gtdata_generic, only: inquire
        type(GT_HISTORY), intent(in):: history
        character(len = *):: varname
        character(len = string):: name
        character(len = *), parameter:: subname = 'lookup_variable_ord'
    continue
        call beginsub(subname)
        if (associated(history%vars)) then
            do, result = 1, size(history%vars)
                call Inquire(history%vars(result), name=name)
                if (name == varname) goto 999
                call message('no match <%c> <%c>', c1=trim(name), c2=trim(varname))
            enddo
        endif
        result = 0
    999 continue
        call endsub(subname, "result=%d", i=(/result/))
    end function

    type(GT_VARIABLE) &
    function lookup_variable(history, varname, ord) result(result)
        use gtdata_generic
        type(GT_HISTORY), intent(in):: history
        character(len = *):: varname
        integer, intent(out), optional:: ord
        integer:: i
        character(len = *), parameter:: subname = 'lookup_variable'
    continue
        call beginsub(subname, '%c', c1=trim(varname))
        i = lookup_variable_ord(history, varname)
        if (i > 0) then
            result = history%vars(i)
            if (present(ord)) ord = i
            call endsub(subname, "ord=%d", i=(/i/))
            return
        endif
        if (present(ord)) then
            ord = 0
        else
            print *, 'gtool_history: var lookup for ', varname, ' failed'
            stop
        endif
        call endsub(subname)
    end function

    type(GT_VARIABLE) &
    function lookup_dimension(history, dimname, ord) result(result)
        use gtdata_generic
        use dc_string
        use dc_types, only: STRING
        type(GT_HISTORY), intent(in):: history
        character(len = *), intent(in):: dimname
        integer, intent(out), optional:: ord
        character(len = STRING):: name
        integer:: i
        character(len = *), parameter:: subname = 'lookup_dimension'
    continue
        call beginsub(subname)
        if (associated(history%dimvars)) then
            do, i = 1, size(history%dimvars)
                call Inquire(history%dimvars(i), name=name)
                if (name == dimname) then
                    result = history%dimvars(i)
                    if (present(ord)) ord = i
                    call endsub(subname, "ord=%d", i=(/i/))
                    return
                endif
            enddo
        endif
        if (present(ord)) then
            ord = 0
        else
            print *, 'gtool_history: dim lookup for ', dimname, ' failed'
            stop
        endif
        call endsub(subname, 'ord=0 (not found)')
    end function

    subroutine lookup_var_or_dim(history, name, var, stat)
        type(GT_HISTORY), intent(in):: history
        character(len = *), intent(in):: name
        type(GT_VARIABLE), intent(out):: var
        integer, intent(out):: stat
        integer:: ord
    continue
        var = lookup_variable(history, name, ord)
        if (ord /= 0) then
            stat = 0
            return
        endif
        var = lookup_dimension(history, name, ord)
        if (ord /= 0) then
            stat = 0
            return
        endif
        stat = 1
    end subroutine

end module

! Copyright (C) GFD Dennou Club, 2002.  All rights reserved
! gtvectdefault.f90 - Definitions of Gtool vectors subroutines

subroutine GTVectOpen(result, var1, var2)
    use gtgraph_types, only: GT_VECTORS
    use gtgraph_generic, only: GOpen => Open
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: Open
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_VECTORS), intent(out):: result
    type(GT_VARIABLE), intent(in):: var1
    type(GT_VARIABLE), intent(in):: var2
continue
    call beginsub('gtvectopen')
    call Open(result%var1, var1, 0)
    call Open(result%var2, var2, 0)
    result%animate = .FALSE.
    allocate(result%h_axis, result%v_axis)
    call GOpen(result%h_axis, var1, 1)
    call GOpen(result%v_axis, var1, 2)
    ! オプションの初期化
    result%map = ""
    result%hskip = 0
    result%vskip = 0
    call endsub('gtvectopen')
end subroutine

subroutine GtvectClose(vect)
    use gtgraph_types, only: GT_VECTORS
    use gtgraph_generic, only: GClose => Close
    use gtdata_generic, only: Close
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_VECTORS), intent(inout):: vect
    call beginsub('gtvectclose')
    call GClose(vect%h_axis)
    call GClose(vect%v_axis)
    deallocate(vect%h_axis, vect%v_axis)
    call Close(vect%var1)
    call Close(vect%var2)
    call endsub('gtvectclose')
end subroutine

subroutine GtvectOption(vect, optname, value, err)
    use gtgraph_types, only: GT_VECTORS
    use gtdata_generic, only: slice_next
    use dc_string, only: stoi, stod, toUpper, get_array
    use dc_error, only: GT_ENOMOREDIMS, DC_NOERR
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(GT_VECTORS), intent(inout):: vect
    character(len = *), intent(in):: optname
    character(len = *), intent(in):: value
    logical, intent(out):: err
    character(len = len(optname)):: uc_name
    integer:: stat
continue
    err = .FALSE.
    uc_name = optname
    call toUpper(uc_name)
    call beginsub('gtvectoption', '%c=%c', c1=trim(uc_name), c2=trim(value))
    select case(uc_name)
    case("-ANIMATE")
        call message('vect animation enabled')
        vect%animate = .TRUE.
    case("-NEXT")
        if (vect%animate) then
            call slice_next(vect%var1, stat=stat)
            call slice_next(vect%var2, stat=stat)
            err = (stat /= DC_NOERR)
            call message('vect next okay=%y stat=%d', L=(/.not. err/), i=(/stat/))
        else
            err = .TRUE.
        endif
    case("-MAP")
        vect%map = "coast_world"
    case("MAP")
        vect%map = value 
    case("HSKIP", "HS")
	vect%hskip = stoi(value)
    case("VSKIP", "VS")
	vect%vskip = stoi(value)
    case("SKIP", "SK")
	vect%hskip = stoi(value)
	vect%vskip = vect%hskip
    case("-EXCH")
        call option_exch(vect, err)
    case default
        err = .TRUE.
    end select
    call endsub('gtvectoption')
    return

contains

    subroutine option_exch(vect, err)
        use gtgraph_types, only: GT_VECTORS, GT_AXIS
        use gtdata_generic, only: exch_dim
        use dc_trace, only: beginsub, endsub, message
    implicit none
        type(GT_VECTORS), intent(inout):: vect
        character(len = *), parameter:: subname &
            & = "GTVectOption%%Option_Exch"
        type(GT_AXIS), pointer:: tmp_axis
        logical, intent(out):: err
    continue
        call beginsub(subname)
        tmp_axis => vect%h_axis
        vect%h_axis => vect%v_axis
        vect%v_axis => tmp_axis
        call exch_dim(vect%var1, 1, 2, count_compact=.false., err=err)
	if (.not. err) then
	call exch_dim(vect%var2, 1, 2, count_compact=.false., err=err)
	endif
        call endsub(subname)
    end subroutine

end subroutine

subroutine GTFigBindVect(fig, vect)
    use gtgraph_types, only: GT_FIGURE, GT_VECTORS
    use gtgraph_generic, only: Close
    use gtdata_generic, only: get_attr, inquire
    use dc_string, only: STRING
    use dc_error
    use netcdf_f77, only: NF_ENOMEM
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(GT_FIGURE), intent(inout):: fig
    type(GT_VECTORS), intent(inout):: vect
    type(GT_VECTORS), pointer:: newvects(:)
    character(STRING):: title, units
    integer:: nvects, stat
    !
    call beginsub('gtfigbindvect')
    ! stat = GT_EFAKE
    if (associated(fig%h_axis)) then
	call message('resource for fig%h_axis may leak')
	vect%h_axis => fig%h_axis
    else
	fig%h_axis => vect%h_axis
    endif
    if (associated(fig%v_axis)) then
	call message('resource for fig%v_axis may leak')
	vect%v_axis => fig%v_axis
    else
        fig%v_axis => vect%v_axis
    endif
    !
    call get_attr(vect%var1, 'long_name', title)
    if (title == '') call Inquire(vect%var1, name=title)
    call get_attr(vect%var1, 'units', units, default='no units')
    title = trim(title) // ' [' // trim(units) // ']'
    if (fig%title == "untitled") then
        fig%title = title
    else
        fig%title = trim(fig%title) // ", " // trim(title)
    endif
    if (fig%aspect == 0.0) then
        call get_attr(vect%var1, 'gt_graph_aspect_ratio', fig%aspect, &
            default=fig%aspect)
    endif
    if (vect%animate) fig%animate = .TRUE.
    !
    stat = 0
    if (associated(fig%vectors)) then
        nvects = size(fig%vectors)
        allocate(newvects(nvects + 1), stat=stat)
        newvects(1: nvects) = fig%vectors(1: nvects)
        deallocate(fig%vectors)
    else
        nvects = 0
        allocate(newvects(1), stat=stat)
    endif
    if (stat /= 0) stat = NF_ENOMEM
    newvects(nvects + 1) = vect
    fig%vectors => newvects
999 continue
    call StoreError(stat, 'GTFigPutVect')
    call endsub('gtfigbindvect', 'stat=%d', i=(/stat/))
end subroutine

subroutine GTVectDraw(vect, parent)
    use gtgraph_generic, only: Draw
    use gtgraph_types, only: GT_VECTORS, GT_FIGURE
    use gtdata_generic, only: Get
    use dcl
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_VECTORS), intent(inout):: vect
    type(GT_FIGURE), intent(in):: parent
    real, pointer:: buffer1(:, :)
    real, pointer:: buffer2(:, :)
    real, pointer:: axvalue(:)
    integer:: xs, ys, nx, ny
continue
    call beginsub('gtvectdraw')
    ! 空間を設定するため座標軸を描画
    call Draw(vect%h_axis, vect%v_axis, parent, set_space=.FALSE.)
    ! データの取得と描画
    call Get(vect%var1, buffer1)
    call Get(vect%var2, buffer2)
    ! スキップ
    xs = vect%hskip
    ys = vect%vskip
    nx = size(buffer1, 1)
    ny = size(buffer1, 2)
    if (xs == 0) xs = nx / 20
    if (ys == 0) ys = ny / 20
    xs = max(nx / 40, min(nx / 3, xs))
    ys = max(ny / 40, min(ny / 3, ys))
    !
    !
    call get(vect%h_axis%var, axvalue)
    call DclSetXGrid(axvalue(1:nx:xs))
    deallocate(axvalue)
    call get(vect%v_axis%var, axvalue)
    call DclSetYGrid(axvalue(1:ny:ys))
    deallocate(axvalue)
    ! 描画
    call DclDrawVectors(buffer1(1:nx:xs, 1:ny:ys), buffer2(1:nx:xs, 1:ny:ys))
    deallocate(buffer1)
    deallocate(buffer2)
    if (vect%map /= "") then
        call DclDrawMap(vect%map)
        if (vect%h_axis%upper > 180.0) then
            call DclSetWindow(vect%h_axis%lower - 360.0, &
                & vect%h_axis%upper - 360.0, &
                & vect%v_axis%lower, vect%v_axis%upper)
            call DclSetTransFunction()
            call DclDrawMap(vect%map)
            call DclSetWindow(vect%h_axis%lower, vect%h_axis%upper, &
                & vect%v_axis%lower, vect%v_axis%upper)
            call DclSetTransFunction()
        endif
    endif
    call GTAxesDrawGrid(vect%h_axis, vect%v_axis, parent)
999 continue
    call endsub('gtvectdraw')
end subroutine

subroutine GTVectLoad(vect, var)
    use gtgraph_types, only: GT_VECTORS
    use gtdata_types, only: GT_VARIABLE
    use gtgraph_generic, only: Load
    use gtdata_generic  ! いっぱい使うから書くのはやめ
    use dc_types, only: STRING
    use dc_error
    implicit none
    type(GT_VECTORS), intent(out):: vect
    type(GT_VARIABLE), intent(in):: var
    character(STRING):: varname
    ! リンク名が data であることを仮定
    call get_attr(var, "gt_structure_link_data", varname)
    if (varname == "") then
        call StoreError(GT_EBADLINK, "GTVectLoad(data1 variable)")
        return
    endif
    call Open(vect%var1, varname)
    call get_attr(var, "gt_structure_link_data2", varname)
    if (varname == "") then
        call StoreError(GT_EBADLINK, "GTVectLoad(data2 variable)")
        return
    endif
    call Open(vect%var2, varname)
    allocate(vect%h_axis, vect%v_axis)
    call get_attr(var, "gt_structure_link_haxis", varname)
    call Load(vect%h_axis, varname)
    call get_attr(var, "gt_structure_link_vaxis", varname)
    call Load(vect%v_axis, varname)
    ! オプションの初期化
    call get_attr(var, "gt_graph_draw_map", vect%map, default="")
    call get_attr(var, "gt_graph_vectors_hskip", vect%hskip, default=0)
    call get_attr(var, "gt_graph_vectors_vskip", vect%vskip, default=0)
end subroutine

! GTVectSave - 図を変数として保存

subroutine GTVectSave(vect, name, name_result)
    use gtgraph_generic, only: Save, GTGraphSaveName
    use gtgraph_types, only: GT_VECTORS
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: Create, Close, Put_Attr, get_attr, add_member, &
        & Inquire
    use dc_string
    use dc_types, only: STRING
    implicit none
    type(GT_VECTORS), intent(inout):: vect
    type(VSTRING), intent(in), optional:: name
    type(VSTRING), intent(out), optional:: name_result
    type(VSTRING):: member
    character(STRING):: member_c, url, vname, title, title2
    type(GT_VARIABLE):: var
    character(len = *), parameter:: GTCT = "gt_graph_vectors_"
continue
    if (present(name)) then
        vname = name
    else
        call GTGraphSaveName(result=vname)
    endif
    call get_attr(vect%var1, "long_name", title)
    call get_attr(vect%var2, "long_name", title2)
    title = "vectors of " // trim(title) // " + " // trim(title2)
    call Create(var, trim(vname), xtype="int", overwrite=.TRUE., &
        long_name=trim(title))
    call Put_Attr(var, "gt_structure_class", "vectors")
    call Put_Attr(var, "gt_graph_vectors_hskip", (/vect%hskip/))
    call Put_Attr(var, "gt_graph_vectors_vskip", (/vect%vskip/))
    if (vect%map /= "") then
        call Put_Attr(var, "gt_graph_draw_map", trim(vect%map))
    endif

    ! 図のメンバになっているものたちの書き出し
    call Inquire(vect%var1, url=url)
    call add_member(var, url, link_name="data")
    call Inquire(vect%var2, url=url)
    call add_member(var, url, link_name="data2")
    if (associated(vect%v_axis)) then
        if (vect%v_axis%saved /= "") then
            call add_member(var, vect%v_axis%saved, link_name="vaxis")
        else
            call Save(vect%v_axis, resultname=member)
            member_c = member
            call add_member(var, member_c, link_name="vaxis")
        endif
    endif
    if (associated(vect%h_axis)) then
        if (vect%h_axis%saved /= "") then
            call add_member(var, vect%h_axis%saved, link_name="haxis")
        else
            call Save(vect%h_axis, resultname=member)
            member_c = member
            call add_member(var, member_c, link_name="haxis")
        endif
    endif
    
    call Close(var)
    print *, trim(title), " stored at ", trim(vname), "."
    if (present(name_result)) name_result = vname
end subroutine

!表題  gtool_history Fortran 77 用インターフェース
!
!履歴  2000/12/26  竹広真一
!      2001/02/27  竹広真一  サブルーチン毎のファイルに分割
!
!  サブルーチン対応表
!     HistoryCreate                HSCREA
!
subroutine hscrea(fname,title,source,institution,  &
                  idim,dims,dimsiz,xtypes,longnames,units, &
                  origin,interval )

    use gtool_history
    implicit none

    character(len=*)              :: fname           ! 出力ファイル
    character(len=*)              :: title           ! タイトル
    character(len=*)              :: source          ! タイトル
    character(len=*)              :: institution     ! タイトル
    integer                       :: idim            ! 定義する軸変数の数
    character(len=1),dimension(idim)   :: dims            ! 軸変数名
    integer,dimension(idim)       :: dimsiz          ! 軸変数の大きさ
    character(len=*),dimension(idim) :: xtypes          ! 軸変数のタイプ
    character(len=*),dimension(idim) :: longnames       ! 軸変数の長い名前
    character(len=*),dimension(idim) :: units           ! 単位
    real                          :: origin          ! 開始時間
    real                          :: interval        ! 出力時間間隔

    call HistoryCreate(                              &
         file=fname, title=title,                    &
         source=source, institution=institution,     &
         dims=dims, dimsizes=dimsiz, xtypes=xtypes,  &
         longnames=longnames, units=units,           &
         origin=origin, interval=interval            &
         )

  end subroutine hscrea

! C の sprintf(3) とは大分違うので注意。
!

subroutine DCStringSPrintf(unit, fmt, i, r, d, L, s, n, c1, c2, c3)
    use dcstring_base, only: VSTRING, assignment(=)
    implicit none
    character(*), intent(out):: unit
    character(*), intent(in):: fmt
    integer, intent(in), optional:: i(:), n(:)
    real, intent(in), optional:: r(:)
    double precision, intent(in), optional:: d(:)
    logical, intent(in), optional:: L(:)
    type(VSTRING), intent(in), optional:: s(:)
    character(*), intent(in), optional:: c1, c2, c3
    ! 上記配列引数のカウンタ
    integer:: ni, nr, nd, nl, ns, nc, nn
    integer:: ucur       ! unit に書かれた文字数
    integer:: endp       ! 既に処理された fmt の文字数
    integer:: cur        ! 現在着目中の文字は fmt(cur:cur) である
    integer:: ptr        ! fmt から検索をするときに使用
    integer:: repeat     ! %数字 または %* から決定された繰返し数
    integer:: m          ! 1:repeat の範囲で動くループ変数
    integer:: stat       ! エラー処理
    character(80):: cbuf ! read/write 文のバッファ
continue
    ni = 0;  nr = 0;  nd = 0;  nl = 0;  ns = 0;  nc = 0;  nn = 0
    unit = ""
    ucur = 0
    endp = 0
    MainLoop: do
        cur = endp + 1
        if (cur > len(fmt)) exit MainLoop
        !
        ! リテラルに転写できる文字列 fmt(cur:endp-1) を発見処理
        !
        endp = cur - 1 + scan(fmt(cur: ), '%')
        if (endp > cur) then
            call append(unit, ucur, fmt(cur:endp-1), stat)
            if (stat /= 0) exit MainLoop
        else if (endp == cur - 1) then
            call append(unit, ucur, fmt(cur: ), stat)
            exit MainLoop
        endif
        !
        ! % から書式指定文字までを fmt(cur:endp) とする
        !
        cur = endp + 1
        endp = cur - 1 + scan(fmt(cur: ), 'DdOoXxFfRrBbYySsCc%')
        if (endp < cur) then
            call append(unit, ucur, fmt(cur-1: ), stat)
            exit MainLoop
        endif
        cbuf = fmt(cur:endp-1)
        if (cbuf(1:1) == '*') then
            nn = nn + 1
            if (nn > size(n)) then
                repeat = 1
            else
                repeat = n(nn)
            endif
        else if (cbuf == '') then
            repeat = 1
        else
            ptr = verify(cbuf, " 0123456789")
            if (ptr > 0) cbuf(ptr: ) = " "
            read(cbuf, "(I80)", iostat=ptr) repeat
        endif
        PercentRepeat: do, m = 1, repeat
            if (m > 1) then
                call append(unit, ucur, ", ", stat)
                if (stat /= 0) exit MainLoop
            endif
            select case(fmt(endp:endp))
            case('d', 'D')
                if (.not. present(i)) cycle MainLoop
                ni = ni + 1;  if (ni > size(i)) cycle MainLoop
                write(cbuf, "(i20)") i(ni)
                call append(unit, ucur, trim(adjustl(cbuf)), stat)
                if (stat /= 0) exit MainLoop
            case('o', 'O')
                if (.not. present(i)) cycle MainLoop
                ni = ni + 1;  if (ni > size(i)) cycle MainLoop
                write(cbuf, "(o20)") i(ni)
                call append(unit, ucur, trim(adjustl(cbuf)), stat)
                if (stat /= 0) exit MainLoop
            case('x', 'X')
                if (.not. present(i)) cycle MainLoop
                ni = ni + 1;  if (ni > size(i)) cycle MainLoop
                write(cbuf, "(z20)") i(ni)
                call append(unit, ucur, trim(adjustl(cbuf)), stat)
                if (stat /= 0) exit MainLoop
            case('f', 'F')
                if (.not. present(d)) cycle MainLoop
                nd = nd + 1;  if (nd > size(d)) cycle MainLoop
                write(cbuf, "(g80.40)") d(nd)
                cbuf = adjustl(cbuf)
                ptr = verify(cbuf, " 0", back=.TRUE.)
                if (ptr > 0) cbuf(ptr+1: ) = " "
                call append(unit, ucur, trim(adjustl(cbuf)), stat)
                if (stat /= 0) exit MainLoop
            case('r', 'R')
                if (.not. present(r)) cycle MainLoop
                nr = nr + 1;  if (nr > size(r)) cycle MainLoop
                write(cbuf, "(g80.40)") r(nr)
                cbuf = adjustl(cbuf)
                ptr = verify(cbuf, " 0", back=.TRUE.)
                if (ptr > 0) cbuf(ptr+1: ) = " "
                call append(unit, ucur, trim(adjustl(cbuf)), stat)
                if (stat /= 0) exit MainLoop
            case('b', 'B')
                if (.not. present(L)) cycle MainLoop
                nl = nl + 1;  if (nl > size(L)) cycle MainLoop
                write(cbuf, "(L1)") L(nl)
                call append(unit, ucur, trim(adjustl(cbuf)), stat)
                if (stat /= 0) exit MainLoop
            case('y', 'Y')
                if (.not. present(L)) cycle MainLoop
                nl = nl + 1;  if (nl > size(L)) cycle MainLoop
                if (L(nl)) then
                    call append(unit, ucur, "yes", stat)
                    if (stat /= 0) exit MainLoop
                else
                    call append(unit, ucur, "no", stat)
                    if (stat /= 0) exit MainLoop
                endif
            case('s', 'S')
                if (.not. present(S)) cycle MainLoop
                ns = ns + 1;  if (ns > size(S)) cycle MainLoop
                call append(unit, ucur, s(ns)%body(1: s(ns)%len), stat)
                if (stat /= 0) exit MainLoop
            case('c', 'C')
                nc = nc + 1
                if (nc == 1) then
                    if (.not. present(c1)) cycle PercentRepeat
                    call append(unit, ucur, c1, stat)
                    if (stat /= 0) exit MainLoop
                else if (nc == 2) then
                    if (.not. present(c2)) cycle PercentRepeat
                    call append(unit, ucur, c2, stat)
                    if (stat /= 0) exit MainLoop
                else if (nc == 3) then
                    if (.not. present(c3)) cycle PercentRepeat
                    call append(unit, ucur, c3, stat)
                    if (stat /= 0) exit MainLoop
                endif
            case('%')
                call append(unit, ucur, '%', stat)
                if (stat /= 0) exit MainLoop
            end select
        enddo PercentRepeat
    enddo MainLoop
    return
contains

    subroutine append(unit, ucur, val, stat)
        character(*), intent(inout):: unit
        integer, intent(inout):: ucur
        character(*), intent(in):: val
        integer, intent(out):: stat
        integer:: wrsz
    continue
        if (ucur >= len(unit)) then
            stat = 2
        else
            wrsz = min(len(val), len(unit) - ucur)
            unit(1+ucur: wrsz+ucur) = val(1: wrsz)
            ucur = ucur + wrsz
            stat = 0
            if (wrsz < len(val)) stat = 1
        endif
    end subroutine

end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved
! コマンドライン引数の数の取得 - gt_argtable.f90 参照

integer function GtArgCount() result(result)
    use gt_argtable, only: BuildArgTable, argind_count
    implicit none
    call BuildArgTable
    result = argind_count
end function

! vi: set sw=4 ts=8:

module gt3conv_tools

    use dc_string
    use gt3read
    use gt3conv_vartable
    use gt3conv_dimtable
    use gtool
    implicit none

    private
    public DefineVariable, PutVariableData

contains

    subroutine DefineVariableSingle(file, iv)
	type(NC_FILE), intent(inout):: file
	integer, intent(in):: iv
	integer:: ia, idim, num_dims
	type(NC_DIMENSION):: dims(4), dim
	type(VSTRING):: name
	type(VARTABLE_ENTRY), pointer:: varent
	type(NC_ATTRIBUTE):: attr
    continue
	varent => vars_table(iv)

	! 変数の定義
	num_dims = 0
	do, ia = 1, 3
	    dim = Dimension(varent%header%axis_item(ia))
	    if (.error. dim) cycle
	    num_dims = num_dims + 1
	    dims(num_dims) = dim
	enddo
	num_dims = num_dims + 1
	dims(num_dims) = time_table(varent%time_ord)%dim
	name = varent%netcdf_name
	varent%var = Variable(file, char(name), NF_FLOAT, dims(1: num_dims))

	! 変数属性
	attr = Attribute(varent%var, 'long_name')
	attr = trim(varent%header%title)
	attr = Attribute(varent%var, 'units')
	attr = trim(varent%header%unit)
	attr = Attribute(varent%var, 'missing_value')
	attr = (/varent%header%missing_value/)
	call Dispose(attr)
    end subroutine

    subroutine DefineVariable(file)
	type(NC_FILE), intent(inout):: file
	integer:: iv, i
	type(GT3_HEADER), pointer:: firstheader
	type(NC_ATTRIBUTE):: attr
	character, parameter:: LF = achar(10), SPC = ' '
	type(VSTRING):: edit
    continue
	! 変数定義
	do, iv = 1, size(vars_table)
	    call DefineVariableSingle(file, iv)
	enddo

	! 大域属性
	firstheader => vars_table(1)%header
	attr = Attribute(file, 'source')
	attr = 'gt3conv (GTOOL3 DSET=' // trim(firstheader%dataset) // ')'
	attr = Attribute(file, 'title')
	attr = trim(firstheader%title)
	attr = Attribute(file, 'institution')
	attr = GtoolUsername()
	attr = Attribute(file, 'history')
	edit = ''
	do, i = 1, 8
	    if (firstheader%edit(i) == '') exit
	    if (i /= 1) edit = edit // ', '
	    edit = edit // trim(firstheader%edit(i)) // '(' // &
		& trim(firstheader%edit_title(i)) // ')'
	enddo
	attr = trim(firstheader%create_date) // SPC &
	    & // trim(firstheader%create_user) // '> (GTOOL3 creation)' &
	    & // LF // trim(firstheader%modify_date) // SPC &
	    & // trim(firstheader%modify_user) &
	    & // '> [GTOOL3 last modify; edit=' // edit // ']' &
	    & // LF // GtoolCurrentTime() // SPC &
	    & // GtoolUsername() // '> gt3conv'
	call Dispose(attr)
    end subroutine

    subroutine PutVariableRecord(file, iv, it)
	type(NC_FILE), intent(inout):: file
	integer, intent(in):: iv, it
	type(GT3_HEADER):: header
	real, pointer:: buffer(:, :, :)
	type(NC_LIMIT):: limit
	integer:: ndims
    continue
	call Get(input, header, buffer)
	limit = WholeVariable(vars_table(iv)%var)
	ndims = DimensionsNumber(vars_table(iv)%var)
	if (.not. Slice(limit, ndims, start=it, count=1)) then
	    print *, 'gt3conv#PutVariableRecord: fail slice', iv, ndims
	    stop
	endif
	call Put(vars_table(iv)%var, buffer, limit)
    end subroutine

    subroutine PutVariableData(file)
	type(NC_FILE), intent(inout):: file
	integer, allocatable:: t_counter(:)
	integer:: iu, iv
    continue
	allocate(t_counter(size(vars_table)))
	t_counter(:) = 0
	call Rewind(input)
	do, iu = 1, size(units_table)
	    iv = units_table(iu)%var
	    t_counter(iv) = t_counter(iv) + 1
	    call PutVariableRecord(file, iv, t_counter(iv))
	enddo
	deallocate(t_counter)
    end subroutine

end module


program gt3conv
    use gt3conv_vartable
    use gt3conv_dimtable
    use gt3conv_tools
    use gtool

    type(VSTRING):: input_filename, output_filename
    type(GT_FILE):: gtfile
    type(NC_FILE):: file

    input_filename = GtoolArgument(1, default='gtool.out')
    output_filename = GtoolArgument(2, default='gtool.nc')

    call BuildVariableTable(input_filename)

    call Create(gtfile, output_filename)
    file = gtfile
    call BuildDimensions(file)
    call BuildTime(file)
    call DefineVariable(file)

    call Datamode(file)

    call PutTimeData(file)
    call PutVariableData(file)
    call PutDimensionData
    call DisposeTables
    gtfile = file
    call Close(gtfile)

    print "(a, ' created.')", char(output_filename)
end program

! Copyright (C) GFD Dennou Club, 2000-2001.  All rights reserved
! sysdepabort.m4 - 環境依存性ルーチン（プログラム停止)

! メッセージを表示してプログラムを停止する。
! 通常の処理系では abort() があるのでこれでいい。たいていは異常終了する。
! abort() が実装されていない処理系では何もしない abort() を造ると
! あとの stop でとめることができる。

SUBROUTINE SYSDEPABORT(STRING)
    USE GTDATA_GENERIC, ONLY: GTVARSYNC
    USE DC_TRACE, ONLY: DBG_SCRATCH
    IMPLICIT NONE
    CHARACTER(LEN = *), INTENT(IN):: STRING
    INTEGER:: STAT
    WRITE(*, *) TRIM(STRING)
    CALL DBG_SCRATCH(.FALSE.)
    CALL GTVARSYNC(STAT=STAT)
    ! --- LAHEY ---
    CALL ERRTRA
    CALL SETRCD(13)
    CALL EXIT(3)

    STOP 'FAILSAFE'
END SUBROUTINE

subroutine GTVarSliceNDims(var, ndims, shape, err)
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: Inquire, Get_Slice
    implicit none
    type(GT_VARIABLE), intent(inout):: var
    integer, intent(in):: ndims
    integer, intent(in), optional:: shape(:)
    logical, intent(out), optional:: err
    integer:: nd
    integer, allocatable:: vcount(:)
    call Inquire(var, alldims=nd)
    allocate(vcount(nd))
    call Get_Slice(var, count=vcount(:))
    if (present(err)) err = .true.
    stop 'gtvarslicendims: not implemented'
end subroutine

! 正規表現モジュール
! 正規表現からオートマトンへの変換は行わず、再帰手続によって表現する。
! Fortran の文字型として便利なように、パターン、テキストともに
! trailing spaces は必要ならば無限に補充されるもののように扱われる。
! '$' 文字はパターンの終了をあらわす。

module regex

    implicit none

    character, save:: C_ESCAPE = '#'
    integer, parameter:: SYM_EOL = -128
    integer, parameter:: SYM_ANYCHAR = 500
    integer, parameter:: SYM_QUESTION = 501
    integer, parameter:: SYM_PLUS = 502
    integer, parameter:: SYM_STAR = 503
    integer, parameter:: SYM_NORMAL_SET = 520
    integer, parameter:: SYM_REVERSED_SET = 521
    integer, parameter:: SYM_HEADFIX = 540
    integer, parameter:: SYM_TAILFIX = 541
    integer, parameter:: SYM_ISDIGIT = 560
    integer, parameter:: SYM_ISALPHA = 561
    integer, parameter:: SYM_ISWORD = 562
    integer, parameter:: SYM_ISSPACE = 563
    integer, parameter:: SYM_ISXDIGIT = 564
    integer, parameter:: SYM_COUNT_BASE = 1000

contains

    ! メタキャラクタと普通の文字を分離
    subroutine preprocess_pattern(pattern, symbols)
        character(len = *), intent(in):: pattern
        integer, intent(out):: symbols(:)
        integer:: i, j, code, imax, j_last_set
        integer:: status, stat_return
        integer, parameter:: STAT_INIT = 1, STAT_ESCAPE = 2, &
            STAT_OPEN_SET = 3, STAT_IN_SET = 4, STAT_HEXADECIMAL = 5
        character:: c
    continue
        status = STAT_INIT
        stat_return = STAT_INIT
        symbols(:) = SYM_EOL
        j_last_set = 0
        imax = len_trim(pattern)
        j = 1
        do, i = 1, imax
            c = pattern(i:i)
            select case(status)
            case(STAT_INIT)
                if (c == C_ESCAPE) then
                    status = STAT_ESCAPE
                    cycle
                else if (c == "[") then
                    symbols(j) = SYM_NORMAL_SET
                    status = STAT_OPEN_SET
                else if (c == ".") then
                    symbols(j) = SYM_ANYCHAR
                else if (c == "?") then
                    symbols(j) = SYM_QUESTION
                else if (c == "+") then
                    symbols(j) = SYM_PLUS
                else if (c == "*") then
                    symbols(j) = SYM_STAR
                else if (c == "^" .and. i == 1) then
                    symbols(j) = SYM_HEADFIX
                else if (c == "$" .and. i == imax) then
                    symbols(j) = SYM_TAILFIX
                else
                    symbols(j) = ichar(c)
                endif
            case(STAT_ESCAPE)
                if (c == 'd' .or. c == 'D') then
                    symbols(j) = SYM_ISDIGIT
                else if (c == 'a' .or. c == 'A') then
                    symbols(j) = SYM_ISALPHA
                else if (c == 'w' .or. c == 'W') then
                    symbols(j) = SYM_ISWORD
                else if (c == 's' .or. c == 'S') then
                    symbols(j) = SYM_ISSPACE
                else if (c == 'z' .or. c == 'Z') then
                    symbols(j) = SYM_ISXDIGIT
                else if (c == 'x' .or. c == 'X') then
                    symbols(j) = -1
                    status = STAT_HEXADECIMAL
                    cycle
                else
                    symbols(j) = ichar(c)
                end if
                status = stat_return
            case(STAT_HEXADECIMAL)
                code = index("123456789ABCDEFabcdef", c)
                if (code >= 16) code = code - 6
                if (symbols(j) == -1) then
                    symbols(j) = code
                    cycle
                else
                    symbols(j) = symbols(j) * 16 + code
                    status = stat_return
                endif
            case(STAT_OPEN_SET)
                symbols(j) = SYM_COUNT_BASE
                j_last_set = j
                stat_return = STAT_IN_SET
                if (c == '^') then
                    symbols(j - 1) = SYM_REVERSED_SET
                    status = STAT_IN_SET
                else if (c == C_ESCAPE) then
                    status = STAT_ESCAPE
                else
                    j = j + 1
                    symbols(j) = ichar(c)
                    status = STAT_IN_SET
                endif
            case(STAT_IN_SET)
                if (c == ']') then
                    symbols(j_last_set) = SYM_COUNT_BASE + j - j_last_set - 1
                    stat_return = STAT_INIT
                    status = STAT_INIT
                    cycle
                else if (c == C_ESCAPE) then
                    status = STAT_ESCAPE
                    cycle
                else
                    symbols(j) = ichar(c)
                endif
            end select
            j = j + 1
        enddo
        select case(status)
        case(STAT_ESCAPE)
            symbols(j) = ichar(' ')
        case(STAT_OPEN_SET)
            symbols(j) = SYM_COUNT_BASE
        case(STAT_IN_SET)
            symbols(j_last_set) = SYM_COUNT_BASE + j - j_last_set - 1
        end select
    end subroutine

    ! マッチすれば length は非負になる。
    ! マッチしなければ length == -1 となる。
    recursive subroutine match_here(ipat, text, length)
        integer, intent(in):: ipat(:)
        character(len = *), intent(in):: text
        integer, intent(out):: length
        integer:: s1, s2, remain, i, hitmax, hitcount, hit_at_least
        logical:: normal_hit
    continue
        ! パターンの終わり。空パターンには何でもマッチ
        if (size(ipat) == 0 .or. ipat(1) == SYM_EOL) then
            length = 0
            return
        endif
        ! パターンの文末固定指示
        if (ipat(1) == SYM_TAILFIX) then
            if (text == "") then
                length = 0
            else
                length = -1
            endif
            return
        endif
        if (len(text) == 0) then
            length = -1
            return
        endif
        ! 1字指定(範囲または1字リテラル)の抽出 ... ipat(s1:s2)
        if (ipat(1) == SYM_NORMAL_SET) then
            s1 = 3
            s2 = 2 + ipat(2) - SYM_COUNT_BASE
            normal_hit = .TRUE.
        else if (ipat(1) == SYM_REVERSED_SET) then
            s1 = 3
            s2 = 2 + ipat(2) - SYM_COUNT_BASE
            normal_hit = .FALSE.
        else
            s1 = 1
            s2 = 1
            normal_hit = .TRUE.
        endif
        ! その次の記号 ipat(s2+1) は量化子か次の1字指定である
        remain = s2 + 2
        select case (ipat(s2 + 1))
        case(SYM_STAR)
            hitmax = len(text)
            hit_at_least = 0
        case(SYM_PLUS)
            hitmax = len(text)
            hit_at_least = 1
        case(SYM_QUESTION)
            hitmax = 1
            hit_at_least = 0
        case default
            hitmax = 1
            hit_at_least = 1
            remain = s2 + 1
        end select
        ! 現位置以降の1字指定のヒット数を数える
        hitcount = 0
        do, i = 1, hitmax
            if (hit(ipat(s1:s2), text(i:i)) .neqv. normal_hit) then
                exit
            endif
            hitcount = i
        enddo
        ! 現位置で無ヒットの場合、ヒットを要するならマッチ失敗
        if (hitcount < hit_at_least) then
            length = -1
            return
        endif
        ! 最長原理: なるべく長くヒットしたものから、残りのマッチする
        ! ものを探す。いわゆる最左最長探索の最長である。
        do, i = 1 + hitcount, 1 + hit_at_least, -1
            call match_here(ipat(remain: ), text(i: ), length)
            if (length >= 0) then
                length = length + i - 1
                return
            endif
        enddo
        length = -1
    end subroutine

    logical function hit(ipat, c) result(result)
        integer, intent(in):: ipat(:)
        character, intent(in):: c
        character(len=*), parameter:: &
            & DIGIT = "0123456789", &
            & XDIGIT = "ABCDEFabcdef", &
            & ALPHA = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
        integer:: i
    continue
        do, i = 1, size(ipat)
            select case(ipat(i))
            case(SYM_ANYCHAR)
                result = .TRUE.
            case(SYM_ISALPHA)
                result = (index(ALPHA, c) > 0)
            case(SYM_ISDIGIT)
                result = (index(DIGIT, c) > 0)
            case(SYM_ISWORD)
                result = (index(DIGIT, c) > 0 .or. index(ALPHA, c) > 0 .or. &
                    & c == '_')
            case(SYM_ISXDIGIT)
                result = (index(DIGIT, c) > 0 .or. index(XDIGIT, c) > 0)
            case(SYM_ISSPACE)
                result = (c == ' ' .or. (iachar(c) >= 8 .and. iachar(c) <= 13))
            case default
                result = (ipat(i) == ichar(c))
            end select
            if (result) return
        enddo
        result = .FALSE.
    end function

    ! マッチすれば length は非負に、start は正になる。
    ! マッチしなければ length == -1, start == 0 となる。
    subroutine match(pattern, text, start, length)
        character(len = *), intent(in):: pattern, text
        integer, intent(out):: start, length
        integer, allocatable:: ipattern(:)
        integer:: text_length
        ! 空 pattern は空文字列に適合
        if (len(pattern) <= 0) then
            length = 0
            start = 1
            return
        endif
        ! メタキャラクタの認識
        allocate(ipattern(len(pattern) + 2))
        call preprocess_pattern(pattern, ipattern)
        ! 頭寄せ指定のある場合
        if (ipattern(1) == SYM_HEADFIX) then
            start = 1
            call match_here(ipattern(2: ), text, length)
            if (length < 0) goto 995
            goto 999
        endif
        ! 最左原理
        text_length = len(text)
        do, start = 1, text_length + 1
            call match_here(ipattern, text(start:text_length), length)
            if (length >= 0) goto 999
        end do
        ! みつからない場合
    995 continue
        start = 0
        length = -1
    999 continue
        deallocate(ipattern)
    end subroutine

end module regex

! MessageBox Version of MSGDMP

SUBROUTINE MSGDMP(CLEV,CSUB,CMSG)
    USE DFWIN
    IMPLICIT NONE
    CHARACTER:: CLEV*(*),CSUB*(*),CMSG*(*)
    CHARACTER:: buffer*(len(csub) + len(cmsg) + 4)
    INTEGER(4):: ret

    buffer = csub // ": " // cmsg // char(0)
    if (CLEV == "E") then
        ret = MessageBox(0, buffer, "DCL Error"C, &
            ior(MB_OK, MB_ICONSTOP))
    else if (CLEV == "W") then
        ret = MessageBox(0, buffer, "DCL Warning"C, &
            ior(MB_OKCANCEL, MB_ICONEXCLAMATION))
    else
        ret = MessageBox(0, buffer, "DCL Message"C, &
            ior(MB_OK, MB_ICONINFORMATION))
    endif

END SUBROUTINE

function ANVarToString(var) result(result)
    use dc_types, only: STRING
    use dc_string, only: cprintf
    use an_vartable, only: an_variable_entry, vtable_lookup
    use an_types, only: AN_VARIABLE
    implicit none
    character(string):: result
    type(AN_VARIABLE), intent(in):: var
    type(an_variable_entry):: ent
    if (vtable_lookup(var, ent) /= 0) then
        result = cprintf("AN_VARIABLE(bad id %d)", i=(/var%id/))
    else
        result = cprintf("AN_VARIABLE(file=%d, var=%d, dim=%d)", &
            & i=(/ent%fileid, ent%varid, ent%dimid/))
    endif
end function

! dc_STRING_LIST.f90 - 任意個の文字列を収納するスタック
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved
! vi: set sw=4:

module DCSTRING_LIST

    use dcstring_base
    implicit none
    private
    public:: STRING_LIST, init, clear, dispose, assignment(=)
    public:: push, pop, shift, unshift
    public:: len, extract, element, split
  
    type STRING_NODE
        type(VSTRING):: body
        type(STRING_NODE), pointer:: next
    end type

    type STRING_LIST
        private
        type(STRING_NODE), pointer:: head
    end type

    interface init;  module procedure init_vs;  end interface
    interface clear;  module procedure clear_vs;  end interface
    interface dispose;  module procedure dispose_vs;  end interface
    interface len;  module procedure len_vs;  end interface
    interface push;  module procedure push_vs, push_vc;  end interface
    interface pop;  module procedure pop_vs;  end interface
    interface shift;  module procedure shift_vs;  end interface
    interface unshift;  module procedure unshift_vs;  end interface
    interface extract;  module procedure extract_vs;  end interface
    interface element;  module procedure element_vs;  end interface
    interface copy;  module procedure copy_vs;  end interface

    interface split
        module procedure CharSplit
        module procedure VstSplit
    end interface

contains

    subroutine init_vs(vs)
        type(STRING_LIST), intent(out):: vs
    continue
        nullify(vs%head)
    end subroutine

    subroutine copy_vs(lhs, rhs, items)
        type(STRING_LIST), intent(inout):: lhs
        type(STRING_LIST), intent(in):: rhs
        integer, intent(in), optional:: items
        type(STRING_NODE), pointer:: rhs_cursor
        type(STRING_NODE), pointer:: lhs_cursor
        integer:: c, ncopy
    continue
        ncopy = huge(ncopy)
        if (present(items)) ncopy = items
        rhs_cursor => rhs%head
        if (.not. associated(rhs_cursor)) then
            nullify(lhs%head)
            return
        endif
        allocate(lhs%head)
        lhs_cursor => lhs%head
        c = 0
        do
            c = c + 1
            lhs_cursor%body = rhs_cursor%body
            if (c == ncopy .or. .not. associated(rhs_cursor%next)) then
                nullify(lhs_cursor%next)
                return
            endif
            rhs_cursor => rhs_cursor%next
            allocate(lhs_cursor%next)
            lhs_cursor => lhs_cursor%next
        enddo
    end subroutine

    subroutine clear_vs(vs)
        type(STRING_LIST), intent(inout):: vs
    continue
        nullify(vs%head)
    end subroutine

    subroutine dispose_vs(vs)
        type(STRING_LIST), intent(inout):: vs
        type(STRING_NODE), pointer:: cursor
        type(STRING_NODE), pointer:: nextp
    continue
        cursor => vs%head
        do
            if (.not. associated(cursor)) exit
            nextp => cursor%next
            cursor%body = ""
            deallocate(cursor)
            cursor => nextp
        enddo
    end subroutine

    integer function len_vs(vs) result(result)
        type(STRING_LIST), intent(in):: vs
        type(STRING_NODE), pointer:: cursor
    continue
        result = 0
        cursor => vs%head
        do
            if (.not. associated(cursor)) exit
            result = result + 1
            cursor => cursor%next
        enddo
    end function

    type(VSTRING) function element_vs(vs, pos) result(result)
        type(STRING_LIST), intent(in):: vs
        type(STRING_NODE), pointer:: cursor
        integer, intent(in):: pos
        integer:: c
    continue
        c = 0
        cursor = vs%head
        do
            if (.not. associated(cursor)) exit
            c = c + 1
            if (c == pos) then
                result = cursor%body
                return
            endif
            cursor => cursor%next
        enddo
        result = ""
    end function

    ! deep copy を作る
    function extract_vs(vs, start, finish) result(result)
        type(STRING_LIST):: result
        type(STRING_LIST), intent(in):: vs
        integer, intent(in), optional:: start, finish
        type(STRING_LIST):: shallow_copy
        type(STRING_NODE), pointer:: cursor
        integer:: c, first, items
    continue
        first = 1
        if (present(start)) first = max(start, first)
        c = 0
        cursor = vs%head
        do
            if (.not. associated(cursor)) then
                nullify(result%head)
                return
            endif
            c = c + 1
            if (c == first) then
                shallow_copy%head => cursor
                exit
            endif
            cursor => cursor%next
        enddo
        items = HUGE(1)
        if (present(finish)) items = finish - first
        call copy_vs(result, shallow_copy, items)
    end function

    subroutine push_vs(vs, string)
        type(STRING_LIST), intent(inout):: vs
        type(VSTRING), intent(in):: string
        type(STRING_NODE), pointer:: cursor
    continue
        if (.not. associated(vs%head)) then
            allocate(vs%head)
            vs%head%body = string
            nullify(vs%head%next)
            return
        endif
        cursor => vs%head
        do
            if (.not. associated(cursor%next)) exit
            cursor => cursor%next
        enddo
        allocate(cursor%next)
        cursor%next%body = string
        nullify(cursor%next%next)
    end subroutine

    subroutine push_vc(vs, string)
        type(STRING_LIST), intent(inout):: vs
        character(len = *), intent(in):: string
        type(STRING_NODE), pointer:: cursor
    continue
        cursor => vs%head
        if (.not. associated(cursor)) then
            allocate(vs%head)
            nullify(vs%head%next)
            vs%head%body = string
            return
        endif
        do
            if (.not. associated(cursor%next)) exit
            cursor => cursor%next
        enddo
        allocate(cursor%next)
        cursor => cursor%next
        cursor%body = string
        nullify(cursor%next)
    end subroutine

    type(VSTRING) function pop_vs(vs) result(result)
        type(STRING_LIST), intent(inout):: vs
        type(STRING_NODE), pointer:: cursor
    continue
        cursor => vs%head
        if (.not. associated(cursor)) then
            result = ""
        else if (.not. associated(cursor%next)) then
            result = cursor%body
            deallocate(cursor)
            nullify(vs%head)
        else
            do
                if (.not. associated(cursor%next%next)) exit
                cursor => cursor%next
            enddo
            result = cursor%next%body
            deallocate(cursor%next)
        endif
    end function

    type(VSTRING) function shift_vs(vs) result(result)
        type(STRING_LIST), intent(inout):: vs
        type(STRING_NODE), pointer:: cursor
    continue
        if (associated(vs%head)) then
            result = vs%head%body
        else
            result = ""
            return
        endif
        cursor => vs%head%next
        deallocate(vs%head)
        vs%head => cursor
    end function

    subroutine unshift_vs(vs, string)
        type(STRING_LIST), intent(inout):: vs
        type(VSTRING), intent(in):: string
        type(STRING_NODE), pointer:: cursor
    continue
        cursor => vs%head
        allocate(vs%head)
        vs%head%body = string
        vs%head%next => cursor
    end subroutine

    ! --- Split ---
    !
    ! fs で文字列を分解して STRING_LIST に格納する。
    ! このとき分解された語の先頭の空白は無視される。

    subroutine VstSplit(LIST, string, fs)
        type(STRING_LIST), intent(out):: LIST
        type(VSTRING), intent(in):: string
        character(len = *), intent(in):: FS
        integer:: ifind
        type(VSTRING):: watch
    continue
        call init(LIST)
        watch = string
        do
            ! watch に空白文字があるなら除去
            ifind = vverify(watch, " ")
            if (ifind == 0) exit
            watch = extract(watch, ifind)
            ! FS に含まれる最初の文字の直前か、それがなければ文末を取り出す
            ifind = vscan(watch, FS)
            if (ifind == 0) then
                call push(LIST, watch)
                exit
            endif
            call push(LIST, extract(watch, 1, ifind - 1))
            watch = extract(watch, ifind + 1)
        enddo
    end subroutine

    subroutine CharSplit(list, string, fs)
        type(STRING_LIST), intent(out):: list
        character(len = *), intent(in):: string
        character(len = *), intent(in):: FS
        integer:: istart, iend, ifind
    continue
        call init(list)
        istart = 1
        do
            ! istart 以降に空白でない文字があるか?
            ifind = verify(string(istart: ), " ")
            if (ifind == 0) exit
            istart = istart + ifind - 1
            ! FS に含まれる最初の文字の直前か、それがなければ文末を取り出す
            ifind = scan(string(istart: ), FS)
            if (ifind == 0) then
                iend = len(string)
            else
                iend = istart + ifind - 1
            endif
            call push(list, string(istart:iend))
            ! もし文字が残っていれば継続
            istart = iend + 2
            if (istart > len(string)) exit
        enddo
    end subroutine

end module

! Copyright (C) GFD Dennou Club, 2000-2001.  All rights reserved.

subroutine GTVarInquire(var, growable, rank, alldims, allcount, &
    & size, xtype, name, url)
    use gtdata_types, only: gt_variable
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: inquire, an_variable
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(gt_variable), intent(in):: var
    ! 外部型の名前
    character(len=*), intent(out), optional:: xtype
    ! name は変数名の最小の単位を返す。
    ! ファイル名を含まないためプログラム内での一意性は保証されない。
    character(len=*), intent(out), optional:: name
    ! url はファイル名のついた変数名を返す。プログラム内で
    ! 一意である。
    character(len=*), intent(out), optional:: url
    ! コンパクト(縮退)次元を数えない, 次元の数
    integer, intent(out), optional:: rank
    ! 縮退次元を含む全次元数。dimord には基本的にこちらを使う
    integer, intent(out), optional:: alldims
    ! 変数が次元変数である場合、総数を返す。エラーはゼロ。
    integer, intent(out), optional:: allcount
    ! 変数の入出力領域の大きさ。
    integer, intent(out), optional:: size
    ! growable: 変数が次元変数である場合、自動拡張可能か否かを返す。
    ! 次元変数でない場合は不定。
    logical, intent(out), optional:: growable
    integer:: class, cid
continue
    call beginsub('gtvarinquire', 'var.mapid=%d', i=(/var%mapid/))
    call var_class(var, class, cid)
    select case(class)
    case(vtb_class_netcdf)
        if (present(xtype) .or. present(name) .or. present(url)) then
            call inquire(an_variable(cid), xtype=xtype, name=name, url=url)
            if (present(xtype)) call message('xtype=%c', c1=trim(xtype))
            if (present(name)) call message('name=%c', c1=trim(name))
            if (present(url)) call message('url=%c', c1=trim(url))
        endif
        if (present(growable)) then
            call inquire(an_variable(cid), growable=growable)
            call message('growable=%y', L=(/growable/))
        endif
    case(vtb_class_memory)
        call message('vtb_class_memory not implemented: skipped')
    end select
    if (present(alldims)) alldims = internal_get_alldims(var)
    if (present(allcount)) allcount = internal_get_allcount(var)
    if (present(size)) size = internal_get_size(var)
    if (present(rank)) rank = internal_get_rank(var)
    call endsub('gtvarinquire')
    return
contains

    integer function internal_get_alldims(var) result(result)
        use gt_map, only: map_lookup
        implicit none
        type(gt_variable), intent(in):: var
        call map_lookup(var, ndims=result)
        call message('alldims=%d', i=(/result/))
    end function

    integer function internal_get_allcount(var) result(result)
        use gt_map, only: gt_dimmap, map_lookup
        implicit none
        type(gt_variable), intent(in):: var
        type(gt_dimmap), allocatable:: map(:)
        integer:: nd
        intrinsic size
        call map_lookup(var, ndims=nd)
        if (nd <= 0) then
            call message('internal_get_allcount: no map')
            result = 1
            return
        endif
        allocate(map(nd))
        call map_lookup(var, map=map)
        result = product(map(1:nd)%allcount)
        call message('internal_get_allcount: %d map.size=%d', &
            & i=(/result, nd/))
        deallocate(map)
    end function

    integer function internal_get_size(var) result(result)
        use gt_map, only: gt_dimmap, map_lookup
        implicit none
        type(gt_variable), intent(in):: var
        type(gt_dimmap), allocatable:: map(:)
        integer:: nd
        intrinsic size
        call map_lookup(var, ndims=nd)
        if (nd <= 0) then
            call message('internal_get_size: no map')
            result = 1
            return
        endif
        allocate(map(nd))
        call map_lookup(var, map=map)
        result = product(map(1:nd)%count)
        call message('internal_get_size: %d map.size=%d', &
            & i=(/result, nd/))
        deallocate(map)
    end function

    integer function internal_get_rank(var) result(result)
        use gt_map, only: gt_dimmap, map_lookup
        implicit none
        type(gt_variable), intent(in):: var
        type(gt_dimmap), allocatable:: map(:)
        integer:: nd

        call map_lookup(var, ndims=nd)
        if (nd <= 0) then
            call message('internal_get_rank: no map')
            result = 1
            return
        endif
        allocate(map(nd))
        call map_lookup(var, map=map)
        result = count(map(1:nd)%count > 1)
        call message('internal_get_rank: %d', i=(/result/))
        deallocate(map)
    end function

end subroutine

subroutine GTVarInquireD(var, dimord, url, allcount)
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: open, close, inquire
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_VARIABLE), intent(in):: var
    integer, intent(in):: dimord
    character(len=*), intent(out), optional:: url
    integer, intent(out), optional:: allcount
    type(GT_VARIABLE):: dimvar
    character(len = *), parameter:: subnam = "gtvarinquireD"
continue
    call beginsub(subnam, "%d", i=(/dimord/))
    call open(dimvar, source_var=var, dimord=dimord)
    if (present(url)) call inquire(dimvar, url=url)
    if (present(allcount)) call inquire(dimvar, allcount=allcount)
    call close(dimvar)
    call endsub(subnam)
end subroutine

! 文字数が合わなければ当然変なことが起こるが、気にしない。
subroutine GTVarInquireA(var, attrname, xtype)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use dc_trace, only: beginsub, endsub
    use an_generic, only: inquire, an_variable
    type(GT_VARIABLE), intent(in):: var
    character(len=*), intent(in):: attrname
    character(len=*), intent(out), optional:: xtype
    integer:: class, cid
    character(len = *), parameter:: subnam = "gtvarinquireA"
continue
    call beginsub(subnam, "%c", c1=trim(attrname))
    call var_class(var, class, cid)
    select case(class)
    case(vtb_class_netcdf)
        call inquire(an_variable(cid), attrname=attrname, xtype=xtype)
    end select
    call endsub(subnam)
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

subroutine GTVarSync(var, stat)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: ANVarSync, an_variable
    type(GT_VARIABLE), intent(inout), optional:: var
    integer, intent(out), optional:: stat
    integer:: class, cid
    if (.not. present(var)) then
        call ANVarSync(stat=stat)
    else
        call var_class(var, class, cid)
        select case (class)
        case(vtb_class_netcdf)
            call ANVarSync(an_variable(cid), stat=stat)
        end select
    endif
end subroutine

! Copyright (C) GFD Dennou Club, 2001.  All rights reserved.

subroutine gtvardeldim(var, dimord, err)
    use gtdata_types, only: gt_variable
    use gt_map, only: map_lookup, gt_dimmap, map_set_ndims, map_set
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(gt_variable), intent(in):: var
    integer, intent(in):: dimord
    logical, intent(out):: err
    type(gt_dimmap), allocatable:: map(:)
    type(gt_dimmap):: tmpmap
    integer:: ndimsp, stat
    character(*), parameter:: subname = 'gtvardeldim'
continue
    err = .true.
    call beginsub(subname)
    if (dimord < 1) then
        call endsub(subname, "negative dimord=%d invalid", i=(/dimord/))
        return
    endif
    call map_lookup(var, ndims=ndimsp)
    if (ndimsp <= 0) then
        call endsub(subname, "variable invalid")
        return
    else if (dimord > ndimsp) then
        call endsub(subname, "dimord=%d not exist", i=(/dimord/))
        return
    endif

    allocate(map(ndimsp))
    call map_lookup(var, map=map)
    tmpmap = map(dimord)
    map(dimord: ndimsp-1) = map(dimord+1: ndimsp)
    map(ndimsp) = tmpmap
    call map_set(var, map, stat)
    deallocate(map)

    call map_set_ndims(var, ndims = ndimsp - 1, stat=stat)
    err = stat /= 0
    call endsub(subname)
end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved
! gtcontdefault.f90 - Definitions of Gtool Contours subroutines

subroutine GTContOpen(result, var)
    use gtgraph_types, only: GT_CONTOURS
    use gtgraph_generic, only: GOpen => Open
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: Open
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_CONTOURS), intent(out):: result
    type(GT_VARIABLE), intent(in):: var
continue
    call beginsub('gtcontopen')
    call Open(result%var, var, 0)
    result%contours = .TRUE.
    result%shade = .FALSE.
    result%animate = .FALSE.
    allocate(result%h_axis, result%v_axis)
    call GOpen(result%h_axis, var, 1)
    call GOpen(result%v_axis, var, 2)
    ! オプションの初期化
    result%cint = 0.0
    result%sint = 0.0
    result%base = 0.0
    result%icycle = 0
    result%map = ""
    nullify(result%srange, result%crange)
    nullify(result%levels, result%skiplevels, result%tones)
    call endsub('gtcontopen')
end subroutine

subroutine GtContClose(cont)
    use gtgraph_types, only: GT_CONTOURS
    use gtgraph_generic, only: GClose => Close
    use gtdata_generic, only: Close
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_CONTOURS), intent(inout):: cont
    call beginsub('gtcontclose')
    if (associated(cont%levels)) deallocate(cont%levels)
    if (associated(cont%skiplevels)) deallocate(cont%skiplevels)
    if (associated(cont%tones)) deallocate(cont%tones)
    call GClose(cont%h_axis)
    call GClose(cont%v_axis)
    deallocate(cont%h_axis, cont%v_axis)
    call Close(cont%var)
    call endsub('gtcontclose')
end subroutine

subroutine GtContOption(cont, optname, value, err)
    use gtgraph_types, only: GT_CONTOURS
    use gtdata_generic, only: slice_next
    use dc_string, only: stoi, stod, toUpper, get_array
    use dc_error, only: GT_ENOMOREDIMS, DC_NOERR
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(GT_CONTOURS), intent(inout):: cont
    character(len = *), intent(in):: optname
    character(len = *), intent(in):: value
    logical, intent(out):: err
    character(len = len(optname)):: uc_name
    real:: rtmp
    integer:: stat
continue
    err = .FALSE.
    uc_name = optname
    call toUpper(uc_name)
    call beginsub('gtcontoption', '%c=%c', c1=trim(uc_name), c2=trim(value))
    select case(uc_name)
    case("-SHADE")
        cont%shade = .TRUE.
    case("-NOSHADE")
        cont%shade = .FALSE.
    case("-NOCONT")
        cont%shade = .TRUE.
        cont%contours = .FALSE.
    case("-ANIMATE")
        call message('cont animation enabled')
        cont%animate = .TRUE.
    case("-NEXT")
        if (cont%animate) then
            call slice_next(cont%var, stat=stat)
            err = (stat /= DC_NOERR)
            call message('cont next okay=%y stat=%d', L=(/.not. err/), i=(/stat/))
        else
            err = .TRUE.
        endif
    case("INTERVAL", "INT")
        cont%cint = stod(value)
        cont%sint = cont%cint
    case("CINT")
        cont%cint = stod(value)
    case("SINT")
        cont%sint = stod(value)
    case("ICYCLE", "LABEL_CYCLE")
        cont%icycle = stoi(value)
    case("LEVELS")
        call get_array(cont%levels, value)
    case("SKIPLEVELS")
        call get_array(cont%skiplevels, value)
    case("TONE", "TONES")
        call get_array(cont%tones, value)
    case("-MAP")
        cont%map = "coast_world"
    case("MAP")
        cont%map = value 
    case("-EXCH")
        call option_exch(cont, err)
    case("CRANGE", "CRG")
        call get_array(cont%crange, value)
        if (associated(cont%crange)) then
            if (size(cont%crange) == 1) then
                rtmp = cont%crange(1)
                deallocate(cont%crange)
                allocate(cont%crange(2))
                cont%crange(1:2) = rtmp
            endif
        endif
    case("SRANGE", "SRG")
        call get_array(cont%srange, value)
        if (associated(cont%srange)) then
            if (size(cont%srange) == 1) then
                rtmp = cont%srange(1)
                deallocate(cont%srange)
                allocate(cont%srange(2))
                cont%srange(1:2) = rtmp
            endif
        endif
    case default
        err = .TRUE.
    end select
    call endsub('gtcontoption')
    return

contains

    subroutine option_exch(cont, err)
        use gtgraph_types, only: GT_CONTOURS, GT_AXIS
        use gtdata_generic, only: exch_dim
        use dc_trace, only: beginsub, endsub, message
    implicit none
        type(GT_CONTOURS), intent(inout):: cont
        character(len = *), parameter:: subname &
            & = "GTContOption%%Option_Exch"
        type(GT_AXIS), pointer:: tmp_axis
        logical, intent(out):: err
    continue
        call beginsub(subname)
        tmp_axis => cont%h_axis
        cont%h_axis => cont%v_axis
        cont%v_axis => tmp_axis
        call exch_dim(cont%var, 1, 2, count_compact=.false., err=err)
        call endsub(subname)
    end subroutine

end subroutine

subroutine GTFigBindCont(fig, cont)
    use gtgraph_types, only: GT_FIGURE, GT_CONTOURS
    use gtdata_generic, only: get_attr, inquire
    use dc_string, only: STRING
    use dc_error
    use netcdf_f77, only: NF_ENOMEM
    use dc_trace, only: beginsub, endsub, message
    implicit none
    type(GT_FIGURE), intent(inout):: fig
    type(GT_CONTOURS), intent(inout):: cont
    type(GT_CONTOURS), pointer:: newconts(:)
    character(STRING):: title, units
    integer:: nconts, stat
    !
    call beginsub('gtfigbindcont')
    stat = GT_EFAKE
    if (associated(fig%h_axis)) then
	call message('resource for fig%h_axis may leak')
        cont%h_axis => fig%h_axis
    else
        fig%h_axis => cont%h_axis
    endif
    if (associated(fig%v_axis)) then
	call message('resource for fig%v_axis may leak')
        cont%v_axis => fig%v_axis
    else
        fig%v_axis => cont%v_axis
    endif
    !
    call get_attr(cont%var, 'long_name', title)
    if (title == '') call Inquire(cont%var, name=title)
    call get_attr(cont%var, 'units', units, default='no units')
    title = trim(title) // ' [' // trim(units) // ']'
    if (fig%title == "untitled") then
        fig%title = title
    else
        fig%title = trim(fig%title) // ", " // trim(title)
    endif
    if (fig%aspect == 0.0) then
        call get_attr(cont%var, 'gt_graph_aspect_ratio', fig%aspect, &
            default=fig%aspect)
    endif
    if (cont%animate) fig%animate = .TRUE.
    !
    stat = 0
    if (associated(fig%contours)) then
        nconts = size(fig%contours)
        allocate(newconts(nconts + 1), stat=stat)
        newconts(1: nconts) = fig%contours(1: nconts)
        deallocate(fig%contours)
    else
        nconts = 0
        allocate(newconts(1), stat=stat)
    endif
    if (stat /= 0) stat = NF_ENOMEM
    newconts(nconts + 1) = cont
    fig%contours => newconts
999 continue
    call StoreError(stat, 'GTFigPutCont')
    call endsub('gtfigbindcont', 'stat=%d', i=(/stat/))
end subroutine

subroutine GTContDraw(cont, parent)
    use gtgraph_generic, only: Draw
    use gtgraph_types, only: GT_CONTOURS, GT_FIGURE, GT_AXIS
    use gtdata_generic, only: Get, get_attr
    use dcl
    use dc_trace, only: beginsub, endsub
    use dc_string
    use gtgraph_drawparam
    implicit none
    type(GT_CONTOURS), intent(inout):: cont
    type(GT_FIGURE), intent(in):: parent
    real, pointer:: buffer(:, :)
    real, pointer:: buffer1(:, :)
    character(len = 16):: fmt
    character(token):: topology

continue
    call beginsub('gtcontdraw')
    ! ユーザ空間を確定するために座標軸を描画
    call Draw(cont%h_axis, cont%v_axis, parent, set_space=.TRUE.)
    ! データの取得と描画
    call Get(cont%var, buffer)

   ! 周期的座標の処理. データ格子点を最後に一つ追加. 
    call get_attr(cont%h_axis%var, "topology", topology)
    if ( topology == "circular" ) then
       allocate(buffer1(size(buffer,1)+1,size(buffer,2)))
       buffer1(1:size(buffer,1),:) = buffer
       buffer1(size(buffer,1)+1,:) = buffer(1,:)
       deallocate(buffer)
       allocate(buffer(size(buffer1,1),size(buffer1,2)))
       buffer = buffer1
       deallocate(buffer1)
    endif

   ! 周期的座標の処理. データ格子点を最後に一つ追加.
    call get_attr(cont%v_axis%var, "topology", topology) ! added by S.Takehiro
    if ( topology == "circular" ) then               ! added by S.Takehiro
       allocate(buffer1(size(buffer,1),size(buffer,2)+1))
       buffer1(:,1:size(buffer,2)) = buffer
       buffer1(:,size(buffer,2)+1) = buffer(:,1)
       deallocate(buffer)
       allocate(buffer(size(buffer1,1),size(buffer1,2)))
       buffer = buffer1
       deallocate(buffer1)
    endif
    if (cont%shade) then
        call set_shade_levels
        call DclShadeContour(buffer)
        call draw_tonescale
    endif
    if (cont%contours) then
        ! コンターレベルを設定する前にデフォルト書式を決める
        call make_label_format(fmt, hi=maxval(buffer), lo=minval(buffer))
        call DclSetContourLabelFormat(fmt) 
        call set_contour_levels()
        call DclSetParmEX('CONTOUR:RSIZET',&
                           gt_contour_contour_msg_height)
        call DclDrawContour(buffer)
    endif
    deallocate(buffer)
    if (cont%map /= "") then
        call DclDrawMap(cont%map)
        if (cont%h_axis%upper > 180.0) then
            call DclSetWindow(cont%h_axis%lower - 360.0, &
                & cont%h_axis%upper - 360.0, &
                & cont%v_axis%lower, cont%v_axis%upper)
            call DclSetTransFunction()
            call DclDrawMap(cont%map)
            call DclSetWindow(cont%h_axis%lower, cont%h_axis%upper, &
                & cont%v_axis%lower, cont%v_axis%upper)
            call DclSetTransFunction()
        endif
    endif
    call GTAxesDrawGrid(cont%h_axis, cont%v_axis, parent)
    call endsub('gtcontdraw')
contains

    subroutine set_shade_levels
    !   integer:: i, nlevs
        logical, save:: lfirst = .TRUE.
        if (lfirst) then
            call GLLSTX('LEPSL', .TRUE.)
            lfirst = .FALSE.
        endif
        if (associated(cont%srange)) then
            call DclSetShadeLevel(cont%srange(1), cont%srange(2), cont%sint)
        ! デフォルトトーンはどうやってきめるか?
!       else if (associated(cont%levels)) then
!            if (.not. associated(cont%tones)) then
!                nlevs = size(cont%levels)
!                allocate(cont%tones(nlevs - 1))
!                cont%tones = (/(i, i = nlevs, 0, -1)/)
!            endif
!            call DclSetShadeLevel(buffer, )
        else
            call DclSetShadeLevel(buffer, cont%sint)
        endif
    end subroutine

    subroutine set_contour_levels
        integer:: i, my_icycle
        ! ここでやらなくちゃ
        my_icycle = cont%icycle
        if (my_icycle == 0) my_icycle = 2
        call UDISET("ICYCLE", my_icycle)
        ! いまのところ base は無視
        if (associated(cont%levels)) then
            do, i = 1, size(cont%levels)
                call DclSetContourLine(cont%levels(i))
            enddo
        else if (associated(cont%crange)) then
            call DclSetContourLevel(cont%crange(1), cont%crange(2), cont%cint)
        else
            call DclSetContourLevel(buffer, cont%cint)
        endif
        if (associated(cont%skiplevels)) then
            do, i = 1, size(cont%skiplevels)
                call DclDelContourLevel(cont%skiplevels(i))
            enddo
        endif
    end subroutine

    ! CHVAL が理解できるような書式仕様を与える。
    ! 本サブルーチンの身勝手な目的は天気図をマトモに描くことにある。
    ! CHVAL は有効数字 3 桁であるが、最大8桁なのだから 5 桁くらい
    ! にはしてくれてもいいじゃないの、というわけである。
    ! 
    subroutine make_label_format(fmt, hi, lo)
        character(len = *), intent(out):: fmt
        real, intent(in):: hi, lo
        real:: order, interval
    continue
        ! デフォルト
        fmt = "D"
        order = max(abs(hi), abs(lo))
        ! ほとんどの場合小さめに見積もってよかろう
        interval = abs(hi - lo) / 100.0
        ! 整数で書けそうならば
        if (interval < 10.0) then
            ! 切捨てが起こる場合書き換えをする
            if (order >= 1000.0 .and. order < 1.0e5) then
                fmt = "(f5.0,tl1,' ')"
            else if (order >= 1.0e5 .and. order < 1.0e6) then
                fmt = "(f6.0,tl1,' ')"
            else if (order >= 1.0e6 .and. order < 1.0e7) then
                fmt = "(f7.0,tl1,' ')"
            endif
        endif
    end subroutine

    ! トーンスケール描画ルーチン(2002/09/24 S.Takehiro)
    ! gt3-dcl5 を移植し Fortran90 スタイルに変更 
    !
    subroutine draw_tonescale

      integer, parameter :: LABELLEN=10
      character(len=LABELLEN), dimension(:), allocatable :: hlabel  ! ラベル文字列
      real, dimension(:), allocatable   :: ux1, ux2       ! メモリ位置(小,大)
      real, dimension(4)                :: upx, upy       ! トーン塗用四辺形座標

      ! 作業用変数
      integer :: ipat, itonl, itint
      real    :: tlev1,tlev2 
      integer :: it, il
      real    :: vmiss

      ! 正規化変換パラメターセーブ変数
      integer :: itr, nton                       
      real :: vxmin,vxmax,vymin,vymax
      real :: uxmin,uxmax,uymin,uymax
      real :: radi,vxoff,vyoff
      real :: longitude,latitude,rotation
      real :: roffxb

      ! ---- 正規化変換セーブ ----
      itr = DCLGetTransNumber()
      call DCLGetViewPort(vxmin,vxmax,vymin,vymax)
      select case (itr)
      case(1:4)
         call DCLGetWindow(uxmin,uxmax,uymin,uymax)
      case(5:6)
         call DCLGetSimilarity(radi,vxoff,vyoff)
      case(10:33)
         call DCLGetMapProjectionAngle(longitude,latitude,rotation)
      end select
      call UZPGET('ROFFXB',roffxb)   !" 座標軸からのラベルの距離(DCL 内部変数)

 !" 座標軸からのラベルの距離をセーブ

      ! ---- トーンスケール用正規化変換設定 ----
      nton = DCLGetShadeLevelNumber()             !" トーンレベル数
      itonl = min(gt_contour_tonescale_labelnum,nton+1)
      call DCLSetViewPort( &
            gt_contour_tonescale_vyloc, &
            gt_contour_tonescale_vxloc+gt_contour_tonescale_vxwidth, &
            gt_contour_tonescale_vyloc, &
            gt_contour_tonescale_vyloc+gt_contour_tonescale_vywidth )
      call DCLSetWindow( 1.0, real(nton+1), 0.0, 1.0 )
      call DCLSetTransNumber(1)
      call DCLSetTransFunction()
      call UZPSET('ROFFXB',0.0)      !" 座標軸からのラベルの距離(DCL 内部変数)

      ! ---- スケール描画 ----
      upy = (/ 0.0, 1.0, 1.0, 0.0/)
      do it=1,nton
         upx = (/it, it, it+1, it+1/)
         call DCLGetShadeLevel(it,tlev1,tlev2,ipat)
         call DCLShadeRegion(upx,upy,ipat)
      enddo

      ! ---- スケール目盛 ----
      call DCLSetParmEX('AXIS:RSIZEL1', &
                        gt_contour_tonescale_labelheit)  ! ラベル文字高さ設定
      call DCLSetParmEX('AXIS:INNER',1)                    ! 内向きに目盛を打つ

      allocate(ux1(nton+1))
      ux1 = (/(real(it),it=1,nton+1)/)

      allocate(ux2(itonl),hlabel(itonl))
      ux2 (1) = 1.0
      call DCLGetParm('GLOBAL:RMISS',vmiss)
      call DCLGetShadeLevel(1,tlev1,tlev2,ipat)
      if ( tlev1 .ne. vmiss ) then
         call chval( 'D', tlev1, hlabel(1) )
      else
         hlabel(1) = '-'//char(189)                            ! -∞
      endif

      il = 1
      itint = nton/itonl + 1
      do it = itint+1, nton-itint+1, itint
         il = il + 1
         ux2( il ) = real( it )
         call DCLGetShadeLevel( it, tlev1, tlev2, ipat )
         call chval( 'D', tlev1, hlabel(il) )
      enddo

      il = il + 1
      ux2 ( il ) = real( nton+1 )
      call DCLGetShadeLevel( nton, tlev1, tlev2, ipat )
      if ( tlev2 .ne. vmiss ) then
         call chval  ( 'D', tlev2, hlabel(IL) )
      else
         hlabel(il) = char(189)                                ! ∞
      endif

      call UXAXLB( 'B', UX1, NTON+1, UX2, HLABEL, LABELLEN, size(ux2) ) ! 目盛描画
      deallocate(ux1,ux2,hlabel)

     ! ---- 正規化変換を戻す ----
      call DCLSetViewPort(vxmin,vxmax,vymin,vymax)
      select case (itr)
      case(1:4)
         call DCLSetWindow(uxmin,uxmax,uymin,uymax)
      case(5:6)
         call DCLSetSimilarity(radi,vxoff,vyoff)
      case(10:33)
         call DCLSetMapProjectionAngle(longitude,latitude,rotation)
      end select
      call DCLSetTransNumber(itr)
      call DCLSetTransFunction()
      call UZPSET('ROFFXB',roffxb)   !" 座標軸からのラベルの距離(DCL 内部変数)

    end subroutine draw_tonescale

end subroutine

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

module gt_vartable

! このモジュールは gtool モジュールから直接には引用されないため、
! 相当むちゃな名前の使い方をしている。ユーザは呼んではならない。

! GTOOL 変数表
!
! gtool 変数というのは実は単なるハンドルと多次元イテレータであり、
! ハンドルは小さな整数値である。
! 実体にアクセスするためには、ハンドル値をキーにしてまずマップ表を引き、
! そこで得られた vid をキーにして変数表を引いて、
! 種別と種別ごとの変数番号を得る。これらはたかだかポインタ＋オフセット
! 参照程度のコストである。
! gtool 変数は実体変数からイテレータが必要なだけ作成されるが、
! この変数表は実体変数につき１エントリしか作成しないので、参照数を持つ。
! このため、実体変数は変数に付いて参照数管理をしなくてもよくなる。

    use dc_types, only: STRING
    implicit none

    integer, parameter:: vid_invalid = -1

    integer, parameter:: VTB_CLASS_UNUSED = 0
    integer, parameter:: VTB_CLASS_MEMORY = 1
    integer, parameter:: VTB_CLASS_NETCDF = 2
    integer, parameter:: CLASSES_MAX = 2

    type VAR_TABLE_ENTRY
        integer:: class
        integer:: cid
        integer:: refcount
    end type

    type(VAR_TABLE_ENTRY), save, allocatable:: table(:)
    integer, parameter:: table_ini_size = 16

    public:: VarTableAdd, VarTableDelete, VarTableMore, VarTableLookup
    public:: vartable_dump
    private:: var_table_entry, table, table_ini_size
    private:: entry_cleanup

contains

    subroutine vartable_dump(vid)
        use dc_trace, only: message
        use an_generic, only: an_variable, tostring
        integer, intent(in):: vid
        character(10):: class
        if (.not. allocated(table)) return
        if (vid <= 0 .or. vid > size(table)) return
        select case(table(vid)%class)
        case(vtb_class_netcdf)
            class = 'netcdf'
        case(vtb_class_memory)
            class = 'memory'
        case default
            write(class, fmt="(i10)") table(vid)%class
        end select
        call message('[vartable %d: class=%c cid=%d ref=%d]', &
            & i=(/vid, table(vid)%cid, table(vid)%refcount/), &
            & c1=trim(class))
        select case(table(vid)%class)
        case(vtb_class_netcdf)
            call message('[%c]', c1=trim(tostring(an_variable(table(vid)%cid))))
        end select
    end subroutine

    subroutine entry_cleanup(vtb_entry)
        type(VAR_TABLE_ENTRY), intent(out):: vtb_entry(:)
        vtb_entry(:)%class = VTB_CLASS_UNUSED
        vtb_entry(:)%cid = -1
        vtb_entry(:)%refcount = 0
    end subroutine

    subroutine VarTableAdd(vid, class, cid)
        use dc_trace, only: message
        integer, intent(out):: vid
        integer, intent(in):: class, cid
        type(VAR_TABLE_ENTRY), allocatable:: tmp_table(:)
        integer:: n
    continue
        ! 必要ならば初期幅確保
        if (.not. allocated(table)) then
            allocate(table(table_ini_size))
            call entry_cleanup(table(:))
        endif
        ! 該当があれば参照数増加
        do, n = 1, size(table)
            if (table(n)%class == class .and. table(n)%cid == cid) then
                table(n)%refcount = table(n)%refcount + 1
                call message('gt_vartable.add(class=%d cid=%d) found (ref=%d)', &
                    & i=(/table(n)%class, table(n)%cid, table(n)%refcount/))
                vid = n
                return
            endif
        enddo
        ! もし空きが無ければ表を拡張
        if (all(table(:)%class /= VTB_CLASS_UNUSED)) then
            n = size(table)
            allocate(tmp_table(n))
            tmp_table(:) = table(:)
            deallocate(table)
            allocate(table(n * 2))
            table(1:n) = tmp_table(1:n)
            table(n+1:n*2) = var_table_entry(VTB_CLASS_UNUSED, -1, 0)
        endif
        do, n = 1, size(table)
            if (table(n)%class == VTB_CLASS_UNUSED) then
                table(n)%class = class
                table(n)%cid = cid
                table(n)%refcount = 1
                vid = n
                return
            endif
        enddo
        vid = vid_invalid
    end subroutine

    subroutine VarTableDelete(vid, action, err)
        integer, intent(in):: vid
        logical, intent(out):: action
        logical, intent(out), optional:: err
        if (.not. allocated(table)) goto 999
        if (vid <= 0 .or. vid > size(table)) goto 999
        if (table(vid)%class <= VTB_CLASS_UNUSED) goto 999
        if (table(vid)%class > CLASSES_MAX) goto 999
        table(vid)%refcount = max(table(vid)%refcount - 1, 0)
        action = (table(vid)%refcount == 0)
        if (present(err)) err = .false.
        return
    999 continue
        action = .false.
        if (present(err)) err = .true.
    end subroutine

    ! 同じファイル番号の変数表の中身を返す
    subroutine VarTableLookup(vid, class, cid)
        integer, intent(in):: vid
        integer, intent(out), optional:: class, cid
        if (.not. allocated(table)) goto 999
        if (vid <= 0 .or. vid > size(table)) goto 999
        if (table(vid)%class <= VTB_CLASS_UNUSED) goto 999
        if (table(vid)%class > CLASSES_MAX) goto 999
        if (present(class)) class = table(vid)%class
        if (present(cid)) cid = table(vid)%cid
        return
    999 continue
        if (present(class)) class = VTB_CLASS_UNUSED
    end subroutine

    ! 同じファイル番号の参照カウントを増加する。
    subroutine VarTableMore(vid, err)
        integer, intent(in):: vid
        logical, intent(out), optional:: err
        if (.not. allocated(table)) goto 999
        if (vid <= 0 .or. vid > size(table)) goto 999
        if (table(vid)%class <= VTB_CLASS_UNUSED) goto 999
        if (table(vid)%class > CLASSES_MAX) goto 999
        table(vid)%refcount = table(vid)%refcount + 1
        if (present(err)) err = .false.
        return
    999 continue
        if (present(err)) err = .true.
    end subroutine

end module

! f90grep - Fortran 90 で作られた grep(1) の模倣
!

program f90grep
    use regex, only: match
    use dc_string, only: put
    use gtool, only: gtargget
    character(100):: line, pattern
    integer::        ios, start, length, linelen
    call gtargget(1, pattern)
    if (pattern == "") then
        call put("f90grep: pattern not given, so type here:")
        read(*, "(A)") pattern
    endif
    do
        read(*, '(A)', iostat=ios) line
        if (ios /= 0) exit
	linelen = len_trim(line)
        call match(trim(pattern), line(1:linelen), start, length)
        if (start > 0) then
            write(*, '(A)') line(1:start-1) // &
                & char(27) // "[42;30;1m" // line(start:start+length-1) &
                & // char(27) // '[m' // line(start+length:linelen)
	endif
    enddo
end program

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

subroutine ANVarPutAttrChar(var, name, value, xtype, err)
    use an_types, only: AN_VARIABLE, AN_VARIABLE_ENTRY
    use an_vartable, only: vtable_lookup
    use an_file, only: ANFileDefineMode
    use netcdf_f77, only: NF_PUT_ATT_TEXT, NF_NOERR, NF_DEL_ATT, &
        & NF_ENOTINDEFINE, NF_GLOBAL
    use dc_url, only: GT_PLUS
    use dc_error
    use dc_string, only: get_array
    use an_generic, only: put_attr
    implicit none
    type(AN_VARIABLE), intent(in):: var
    character(len = *), intent(in):: name
    character(len = *), intent(in):: value
    character(len = *), intent(in), optional:: xtype
    logical, intent(out), optional:: err
    integer, pointer:: ip(:)
    real, pointer:: rp(:)
    double precision, pointer:: dp(:)
    integer:: stat
    type(an_variable_entry):: ent
continue
    stat = vtable_lookup(var, ent)
    if (stat /= NF_NOERR) goto 999
    if (len(value) == 0) then
        if (name(1:1) == GT_PLUS) then
            stat = nf_del_att(ent%fileid, NF_GLOBAL, name=name(2:))
        else
            stat = nf_del_att(ent%fileid, ent%varid, name=name)
        endif
        goto 999
    endif
    if (present(xtype)) then
        select case(xtype)
        case("INTEGER", "integer", "int")
            goto 200
        case("REAL", "real", "float")
            goto 300
        case("DOUBLEPRECISION", "DOUBLE", "double")
            goto 400
        end select
    end if

    stat = ANFileDefineMode(ent%fileid)
    if (stat /= NF_NOERR) goto 999
    if (name(1:1) == GT_PLUS) then
        stat = nf_put_att_text(ent%fileid, NF_GLOBAL, name=name(2:), &
            & len=len(value), text=value)
    else
        stat = nf_put_att_text(ent%fileid, ent%varid, name=name, &
            & len=len(value), text=value)
    endif

999 continue
    call StoreError(stat, 'ANVarPutAttrChar', err, cause_c=name)
    return

200 continue
    call get_array(ip, value)
    if (associated(ip)) then
        call put_attr(var, name, ip, err)
        deallocate(ip)
    endif
    return

300 continue
    call get_array(rp, value)
    if (associated(rp)) then
        call put_attr(var, name, rp, err)
        deallocate(rp)
    endif
    return

400 continue
    call get_array(dp, value)
    if (associated(dp)) then
        call put_attr(var, name, dp, err)
        deallocate(dp)
    endif
    return
end subroutine

! Copyright (C) GFD Dennou Club, 2000-2001.  All rights reserved.

SUBROUTINE GTVARPUTDOUBLE(VAR, VALUE, NVALUE, ERR)
    USE GTDATA_TYPES, ONLY: GT_VARIABLE
    USE GT_MAP, ONLY: VAR_CLASS, VTB_CLASS_NETCDF, &
        & MAP_TO_INTERNAL_SPECS
    USE AN_GENERIC, ONLY: PUT, AN_VARIABLE
    USE DC_ERROR
    USE DC_TRACE, ONLY: BEGINSUB, ENDSUB
    IMPLICIT NONE
    TYPE(GT_VARIABLE), INTENT(IN):: VAR
    INTEGER, INTENT(IN):: NVALUE
    DOUBLE PRECISION, INTENT(IN):: VALUE(NVALUE)
    LOGICAL, INTENT(OUT), OPTIONAL:: ERR
    INTEGER:: CLASS, CID, STAT, NDIMS
    INTEGER, POINTER:: SPECS(:, :)
    CHARACTER(LEN = *), PARAMETER:: SUBNAME = "GTVARPUTDOUBLE"
CONTINUE
    CALL BEGINSUB(SUBNAME, 'VAR.MAPID=%d', I=(/VAR%MAPID/))
    CALL VAR_CLASS(VAR, CLASS, CID)
    CALL MAP_TO_INTERNAL_SPECS(VAR, SPECS, NDIMS)
    IF (CLASS == VTB_CLASS_NETCDF) THEN
        CALL PUT(AN_VARIABLE(CID), START=SPECS(:, 1), COUNT=SPECS(:, 2), &
            & STRIDE=SPECS(:, 3), IMAP=SPECS(:, 4), VALUE=VALUE, &
            & SIZ=NVALUE, IOSTAT=STAT)
    ELSE
        STAT = GT_EFAKE
    ENDIF
    CALL STOREERROR(STAT, "gtvarputDOUBLE", ERR=ERR)
    DEALLOCATE(SPECS)
    CALL ENDSUB(SUBNAME)
END SUBROUTINE

*-----------------------------------------------------------------------
*     USPACK REAL TO CHARACTER                       S. Sakai  90/03/16
*-----------------------------------------------------------------------
*     Copyright (C) 2000 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE USCHVL(X, CHX)

      CHARACTER CHX*(*), CFMT*16, CVAL*16, CEXP*8, CEXP2*8, CSGI*1
      REAL X
      LOGICAL LEXP, LCNTL

      CALL SGLGET('LCNTL', LCNTL)
      CALL GLRGET('REPSL', PREC)
      NPREC = -LOG10(PREC)
      IF(NPREC.GT.8) NPREC = 8

      CFMT = '(E16.xE3)'
      WRITE(CFMT(6:6), '(I1)') NPREC
      WRITE(CVAL, CFMT) X

      CFMT = '(F11.x, TR1, I4)'
      WRITE(CFMT(6:6), '(I1)') NPREC
      READ (CVAL, CFMT) XX, NEXP

*------------------------ effective digits -----------------------------

      DO 10 N=11, 4, -1
        NDIG=N
        IF(CVAL(N:N).NE.'0') GOTO 20
   10 CONTINUE
   20 CONTINUE
      NDIG = NDIG - INDEX(CVAL, '.')

*----------------------------- mantissa --------------------------------

      NLOW = NEXP - NDIG + 1
      LEXP = NEXP.LE.-3 .OR. NLOW.GE.5

      IF(LEXP) THEN
        XX = XX*10
        NPREC = NDIG - 1
      ELSE
        XX = XX*1.D1**NEXP
        NPREC = -NLOW + 1
      ENDIF

      IF(NPREC.GE.1) THEN
        CFMT = '(SP, F16.x)'
        WRITE(CFMT(10:10), '(I1)')  NPREC
        WRITE(CVAL, CFMT) XX
      ELSE
        CFMT = '(SP, I16)'
        IX = NINT(XX)
        WRITE(CVAL, CFMT) IX
      ENDIF

      CALL CLADJ(CVAL)

*-------------------------- characteristic -----------------------------

      IF(LEXP) THEN
        NEXP = NEXP - 1
        WRITE(CEXP2, '(I3)') NEXP
        CALL CLADJ(CEXP2)
        IF(LCNTL) THEN
          CALL SGIGET('ISUP', ISUP)
          CALL SGIGET('IRST', IRST)
          CEXP = CSGI(194)//'10'//CHAR(ISUP)//CEXP2(1:LENC(CEXP2))
     +      //CHAR(IRST)
        ELSE
          CEXP = 'E'//CEXP2(1:LENC(CEXP2))
        ENDIF
      ELSE
        CEXP = ' '
      ENDIF

*-----------------------------------------------------------------------

      IF(LCNTL .AND. CVAL(2:3).EQ.'1 ' .AND. CEXP.NE.'  ') THEN
        CHX = CVAL(1:1) // CEXP(2:8)
      ELSE
        CHX = CVAL(1:LENC(CVAL)) // CEXP
      ENDIF

      RETURN
      END
*-----------------------------------------------------------------------
*     Copyright (C) 2000 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE ULXLOG ( CSIDE, NLBL, NTICKS )

*     CSIDE : 'T','B','U'
*     NLBL  : 1-4          ... Label buffer number used in the axis
*     NTICKS: 1-9          ... Number of small ticks in 10**N-10**(N+1)

      PARAMETER(MAXL=50,MAXS=200)
      DIMENSION BL(10),BS(10),UX1(MAXS),UX2(MAXL),UXT(MAXL)
      CHARACTER CH(MAXL)*16,CHR*8,CFMT*16,CSGI,CSIDE
      LOGICAL LRLT,LRGT,LABEL,LEPSL,LCNTL,LUXCHK,LOFF

      SAVE

      IF(.NOT.LUXCHK(CSIDE))
     #   CALL MSGDMP('E', 'ULXLOG', 'INVALID CSIDE.')
      IF(NLBL.LT.1 .OR. NLBL.GT.4)
     #   CALL MSGDMP('E', 'ULXLOG', 'INVALID NLBL.')
      IF(NTICKS.LT.1 .OR. NTICKS.GT.9)
     #   CALL MSGDMP('E', 'ULXLOG', 'INVALID NTICKS.')

      CALL SGQWND(UXMIN,UXMAX,UYMIN,UYMAX)

      CALL UZLGET('LOFFSET', LOFF)
      IF(LOFF) THEN
        CALL UZRGET('XFACT',   FACTOR)
        XMIN = UXMIN/FACTOR
        XMAX = UXMAX/FACTOR
        CALL SGSWND(XMIN,XMAX,UYMIN,UYMAX)
        CALL SGSTRF
      ELSE
        XMIN = UXMIN
        XMAX = UXMAX
      ENDIF

      IF(XMIN.GT.XMAX)THEN
        XXX=XMIN
        XMIN=XMAX
        XMAX=XXX
      END IF

      CALL ULIGET('IXTYPE', ITYPE)
      CALL ULIGET('IXCHR' , IXCHR)
      CALL ULXLBL( BL, NB , NLBL)

      CALL SGIGET('ISUP', ISUP)
      CALL SGIGET('IRST', IRST)

      CALL GLLGET('LEPSL',LEPSL)
      CALL SGLGET('LCNTL',LCNTL)
      CALL GLLSET('LEPSL',.TRUE.)
      CALL GNSAVE

*     SMALL TICKS

      CALL VRGNN(BS, 10, 1)
      BS(NTICKS+1)=10.
      CALL GNSBLK(BS,NTICKS+1)
      CALL GNLE(XMAX,BXMAX,IPMAX)
      CALL GNGE(XMIN,BXMIN,IPMIN)

      NBS=0
      DO 100 IP=IPMIN,IPMAX
      DO 100 IB=1,NTICKS
        IF(IP.EQ.IPMIN.AND.LRLT(BS(IB),BXMIN))GOTO 100
        IF(IP.EQ.IPMAX.AND.LRGT(BS(IB),BXMAX))GOTO 100
        NBS=NBS+1
        IF(NBS.GT.MAXS) CALL MSGDMP('E', 'ULXLOG', 'TOO MANY TICKS.')
        UX1(NBS)=BS(IB)*10.**IP
  100 CONTINUE

*     LARGE LABELS AND TICKS

      CALL GNSBLK(BL,NB+1)
      CALL GNLE(XMAX,BXMAX,IPMAX)
      CALL GNGE(XMIN,BXMIN,IPMIN)

      NBL=0
      NBT=0
      JTYPE = MOD(ITYPE, 2)

      DO 201 IP=IPMIN,IPMAX
      DO 201 IB=1,NB
        IF(IP.EQ.IPMIN.AND.LRLT(BL(IB),BXMIN))GOTO 201
        IF(IP.EQ.IPMAX.AND.LRGT(BL(IB),BXMAX))GOTO 201

        IF(IB.EQ.1)THEN
          NBT=NBT+1
          UXT(NBT)=10.**IP
        END IF

        NBL=NBL+1
        IF(NBL.GT.MAXL) CALL MSGDMP('E', 'ULXLOG', 'TOO MANY LABELS.')
        UX2(NBL)=BL(IB)*10.**IP

        IF(ITYPE.LE.2) THEN
          IF(JTYPE.EQ.0 .AND. IB.NE.1) THEN
            WRITE(CH(NBL),'(I1)') INT(BL(IB))
          ELSE
            IF(JTYPE.EQ.1 .AND. NB.NE.1) THEN
              WRITE(CH(NBL),'(I1,A1)') INT(BL(IB)), CSGI(IXCHR)
            ELSE
              CH(NBL)=' '
            ENDIF

            WRITE(CHR,'(I8)') IP
            CALL CLADJ(CHR)
            IF(LCNTL) THEN
              CH(NBL)(3:16)='10'//CSGI(ISUP)//CHR(1:LENZ(CHR))
     +          //CSGI(IRST)
            ELSE
              CH(NBL)(2:16)='E'//CHR
            ENDIF
            CALL CLADJ(CH(NBL))
          END IF

        ELSE
          IF(JTYPE.EQ.0 .AND. IB.NE.1) THEN
            WRITE(CH(NBL),'(I1)') INT(BL(IB))
          ELSE
            CALL UZCGET('CXFMT', CFMT)
            CALL CHVAL(CFMT, UX2(NBL), CH(NBL))
            CALL CLADJ(CH(NBL))
          ENDIF
        ENDIF
  201 CONTINUE

*     DRAW AXIS, TICKS, AND LABELS

      CALL UXPAXS(CSIDE,2)
      IF(NBS.NE.0) CALL UXPTMK(CSIDE,1,UX1,NBS)
      IF(NBT.NE.0) CALL UXPTMK(CSIDE,2,UXT,NBT)
      CALL UZLGET('LABELX'//CSIDE,LABEL)
      IF(LABEL) CALL UXPLBL(CSIDE,1,UX2,CH,16,NBL)

      CALL GLLSET('LEPSL',LEPSL)
      CALL GNRSET

      IF (LOFF) THEN
        CALL SGSWND(UXMIN,UXMAX,UYMIN,UYMAX)
        CALL SGSTRF
      ENDIF

      END
*-----------------------------------------------------------------------
*     Copyright (C) 2000 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE ULYLOG ( CSIDE, NLBL, NTICKS )

*     CSIDE : 'L','R','U'
*     NLBL  : 1-4          ... Label buffer number used in the axis
*     NTICKS: 1-9          ... Number of small ticks in 10**N-10**(N+1)

      PARAMETER(MAXL=50,MAXS=200)
      DIMENSION BL(10),BS(10),UY1(MAXS),UY2(MAXL),UYT(MAXL)
      CHARACTER CH(MAXL)*16,CHR*8,CFMT*16,CSGI,CSIDE
      LOGICAL LRLT,LRGT,LABEL,LEPSL,LCNTL,LUYCHK,LOFF

      SAVE

      IF(.NOT.LUYCHK(CSIDE))
     #   CALL MSGDMP('E', 'ULYLOG', 'INVALID CSIDE.')
      IF(NLBL.LT.1 .OR. NLBL.GT.4)
     #   CALL MSGDMP('E', 'ULYLOG', 'INVALID NLBL.')
      IF(NTICKS.LT.1 .OR. NTICKS.GT.9)
     #   CALL MSGDMP('E', 'ULYLOG', 'INVALID NTICKS.')

      CALL SGQWND(UXMIN,UXMAX,UYMIN,UYMAX)

      CALL UZLGET('LOFFSET', LOFF)
      IF(LOFF) THEN
        CALL UZRGET('YFACT',   FACTOR)
        YMIN = UYMIN/FACTOR
        YMAX = UYMAX/FACTOR
        CALL SGSWND(UXMIN, UXMAX , YMIN, YMAX)
        CALL SGSTRF
      ELSE
        YMIN = UYMIN
        YMAX = UYMAX
      ENDIF

      IF(YMIN.GT.YMAX)THEN
        YYY=YMIN
        YMIN=YMAX
        YMAX=YYY
      END IF

      CALL ULIGET('IYTYPE', ITYPE)
      CALL ULIGET('IYCHR' , IYCHR)
      CALL ULYLBL( BL, NB , NLBL)

      CALL GLLGET('LEPSL',LEPSL)
      CALL SGLGET('LCNTL',LCNTL)
      CALL SGIGET('ISUP', ISUP)
      CALL SGIGET('IRST', IRST)
      CALL GLLSET('LEPSL',.TRUE.)
      CALL GNSAVE

*     SMALL TICKS

      CALL VRGNN(BS, 10, 1)
      BS(NTICKS+1)=10.
      CALL GNSBLK(BS,NTICKS+1)
      CALL GNLE(YMAX,BYMAX,IPMAX)
      CALL GNGE(YMIN,BYMIN,IPMIN)

      NBS=0
      DO 100 IP=IPMIN,IPMAX
      DO 100 IB=1,NTICKS
        IF(IP.EQ.IPMIN.AND.LRLT(BS(IB),BYMIN))GOTO 100
        IF(IP.EQ.IPMAX.AND.LRGT(BS(IB),BYMAX))GOTO 100
        NBS=NBS+1
        IF(NBS.GT.MAXS) CALL MSGDMP('E', 'ULYLOG', 'TOO MANY TICKS.')
        UY1(NBS)=BS(IB)*10.**IP
  100 CONTINUE

*     LARGE LABELS AND TICKS

      CALL GNSBLK(BL,NB+1)
      CALL GNLE(YMAX,BYMAX,IPMAX)
      CALL GNGE(YMIN,BYMIN,IPMIN)

      NBL=0
      NBT=0
      JTYPE = MOD(ITYPE, 2)

      DO 201 IP=IPMIN,IPMAX
      DO 201 IB=1,NB
        IF(IP.EQ.IPMIN.AND.LRLT(BL(IB),BYMIN))GOTO 201
        IF(IP.EQ.IPMAX.AND.LRGT(BL(IB),BYMAX))GOTO 201

        IF(IB.EQ.1)THEN
          NBT=NBT+1
          UYT(NBT)=10.**IP
        END IF

        NBL=NBL+1
        IF(NBL.GT.MAXL) CALL MSGDMP('E', 'ULYLOG', 'TOO MANY LABELS.')
        UY2(NBL)=BL(IB)*10.**IP

        IF(ITYPE.LE.2) THEN
          IF(JTYPE.EQ.0 .AND. IB.NE.1) THEN
            WRITE(CH(NBL),'(I1)') INT(BL(IB))
          ELSE
            IF(JTYPE.EQ.1 .AND. NB.NE.1) THEN
              WRITE(CH(NBL),'(I1,A1)') INT(BL(IB)), CSGI(IYCHR)
            ELSE
              CH(NBL)=' '
            ENDIF

            WRITE(CHR,'(I8)') IP
            CALL CLADJ(CHR)
            IF(LCNTL) THEN
              CH(NBL)(3:16)='10'//CSGI(ISUP)//CHR(1:LENZ(CHR))
     +          //CSGI(IRST)
            ELSE
              CH(NBL)(2:16)='E'//CHR
            ENDIF
            CALL CLADJ(CH(NBL))
          ENDIF

        ELSE
          IF(JTYPE.EQ.0 .AND. IB.NE.1) THEN
            WRITE(CH(NBL),'(I1)') INT(BL(IB))
          ELSE
            CALL UZCGET('CYFMT', CFMT)
            CALL CHVAL(CFMT, UY2(NBL), CH(NBL))
            CALL CLADJ(CH(NBL))
          ENDIF
        ENDIF
  201 CONTINUE

*     DRAW AXIS, TICKS, AND LABELS

      CALL UYPAXS(CSIDE,2)
      IF(NBS.NE.0) CALL UYPTMK(CSIDE,1,UY1,NBS)
      IF(NBT.NE.0) CALL UYPTMK(CSIDE,2,UYT,NBT)
      CALL UZLGET('LABELY'//CSIDE,LABEL)
      IF(LABEL) CALL UYPLBL(CSIDE,1,UY2,CH,16,NBL)

      CALL GLLSET('LEPSL',LEPSL)
      CALL GNRSET

      IF(LOFF) THEN
        CALL SGSWND(UXMIN,UXMAX,UYMIN,UYMAX)
        CALL SGSTRF
      ENDIF

      END

! gtvaropen.f90 - gtool4 file interface
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

subroutine GTVarOpen(var, url, writable, err)
    use dc_string, only: StrHead
    use dc_types, only: string
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: limit
    use gt_map, only: map_create, vtb_class_netcdf, vtb_class_memory, gtvar_dump
    use an_generic, only: ANVarOpen, an_variable, inquire
    use dc_url, only: url_chop_iorange
    use dc_error, only: StoreError, GT_EFAKE
    use dc_trace, only: beginsub, endsub
    implicit none
    type(GT_VARIABLE), intent(inout):: var
    character(*), intent(in):: url
    logical, intent(in), optional:: writable
    logical, intent(out), optional:: err
    integer:: ndims
    integer, allocatable:: dimlen(:)
    type(an_variable):: an
    character(len = string):: filevar, iorange
continue
    call beginsub('gtvaropen', fmt='<%c>', c1=url)
    call url_chop_iorange(url, iorange=iorange, remainder=filevar)
    if (StrHead(filevar, "memory:")) then
        call StoreError(GT_EFAKE, "GTVarOpen(memory:)", err)
        var = gt_variable(-1)
    else
        call ANVarOpen(an, filevar, writable, err)
        call inquire(an, ndims=ndims)
        allocate(dimlen(max(1, ndims)))
        call inquire(an, dimlen=dimlen)
        call map_create(var, vtb_class_netcdf, an%id, ndims, dimlen)
        deallocate(dimlen)
    endif
    call limit(var, trim(iorange))
    call gtvar_dump(var)
    call endsub('gtvaropen', 'mapid=%d', i=(/var%mapid/))
end subroutine

! GTAxisSave - 座標軸を変数として保存
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

subroutine GTAxisSave(axis, name, name_result)
    use gtgraph_generic, only: Save, GTGraphSaveName
    use gtgraph_types, only: GT_Axis
    use gtdata_types, only: GT_VARIABLE
    use gtdata_generic, only: Create, Close, Put_Attr, add_member, Inquire
    use dc_string
    use dc_types, only: STRING
    implicit none
    type(GT_AXIS), intent(inout):: axis
    type(VSTRING), intent(in), optional:: name
    type(VSTRING), intent(out), optional:: name_result
    character(STRING):: url, vname, title
    type(GT_VARIABLE):: var
continue
    if (present(name)) then
        vname = name
    else
        call GTGraphSaveName(result=vname)
    endif
    if (axis%vertical) then
        title = "vertical axis of " // trim(axis%title)
    else
        title = "horizontal axis of " // trim(axis%title)
    endif
    call Create(var, trim(vname), xtype="int", overwrite=.TRUE., &
        & long_name=trim(title))
    call Put_Attr(var, "gt_structure_class", "axis")
    call Put_Attr(var, "gt_graph_axis_vertical", axis%vertical)

    ! 図のメンバになっているものたちの書き出し
    call Inquire(axis%var, url=url)
    call add_member(var, url, link_name="data")
    
    call Close(var)
    print *, trim(title), " stored at ", trim(vname)
    axis%saved = vname
    if (present(name_result)) name_result = vname
end subroutine

! dcstring_main.f90 - warning at string module for Fortran90
! Copyright (C) GFD Dennou Club, 2001.  All rights reserved
! vi: set ts=8 sw=4:

subroutine dcstringbase_warnlim(cause)
    use dc_trace, only: dbg, debug, sublevel
    implicit none
    character(len = *), intent(in):: cause
    integer:: stat
    intrinsic repeat
continue
    if (.not. debug()) return
    write(unit=dbg, fmt="(a)", iostat=stat) &
        '#' // repeat(' ', sublevel()) // &
        'dcstring_base(' // cause // '): too long string warning'
    if (stat /= 0) dbg = -1
end subroutine

! Copyright (C) TOYODA Eizi, 2000.  All rights reserved.

subroutine GTVarDelAttr(var, name, err)
    use gtdata_types, only: GT_VARIABLE
    use gt_map, only: var_class, vtb_class_netcdf, vtb_class_memory
    use an_generic, only: del_attr, an_variable
    use gt_mem, only: del_attr, mem_variable
    use dc_error, only: GT_EBADVAR, StoreError
    implicit none
    type(GT_VARIABLE), intent(inout):: var
    character(len = *), intent(in):: name
    logical, intent(out), optional:: err
    integer:: class, cid
continue
    call var_class(var, class, cid)
    if (class == vtb_class_netcdf) then
        call del_attr(an_variable(cid), name, err)
    else if (class == vtb_class_memory) then
        call del_attr(mem_variable(cid), name, err)
    else
        call StoreError(GT_EBADVAR, 'GTVarDelAttr', err)
    endif
end subroutine

! dcstring_main.f90 - string module for Fortran90
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved
! vi: set ts=8 sw=4:

! 解説
!        本モジュールはポインタが使えない環境で 508 字までの
!        可変長文字列を保持する構造体を提供する。

module dcstring_base

    implicit none

    private
    public VSTRING, len, var_str, vchar, get, put, put_line, &
        & assignment(=), operator(==), operator(/=), &
        & operator(<), operator(<=), operator(>), operator(>=), &
        & vindex, vscan, vverify, extract, split, &
        & operator(.cat.)

    integer, public, parameter::                STRING_MAX = 500

    type VSTRING
        ! あえて private にはしない。
        integer::                     len
        character(len = STRING_MAX):: body
    end type

    interface len
        module procedure string_len
    end interface

    interface var_str
        module procedure char_to_string
    end interface

    interface vchar
        module procedure string_to_char_length
    end interface

    interface extract
        module procedure extract_string
    end interface

    interface split
        module procedure split_c
        module procedure split_s
    end interface

    interface get
        module procedure string_get
        module procedure string_get_default
    end interface

    interface put
        module procedure string_put
        module procedure string_put_default
        module procedure char_put
        module procedure char_put_default
    end interface

    interface put_line
        module procedure string_put_line
        module procedure string_put_line_default
        module procedure char_put_line
        module procedure char_put_line_default
    end interface

    interface vscan
        module procedure string_scan_string
        module procedure string_scan_char
    end interface

    interface vverify
        module procedure string_verify_string
        module procedure string_verify_char
    end interface

    interface vindex
        module procedure string_index_string
        module procedure string_index_char
        module procedure char_index_string
    end interface

    interface assignment(=)
        module procedure string_let_char
        module procedure string_let_char_array
        module procedure char_let_string
        module procedure char_array_let_string
    end interface

    interface operator(//)
        module procedure string_add_string
        module procedure char_add_string
        module procedure string_add_char
    end interface

    interface operator(.cat.)
        module procedure string_add_string
        module procedure char_add_string
        module procedure string_add_char
    end interface

    interface operator(==)
        module procedure string_eq_string
        module procedure string_eq_char
        module procedure char_eq_string
    end interface

    interface operator(/=)
        module procedure string_ne_string
        module procedure string_ne_char
        module procedure char_ne_string
    end interface

    interface operator(<)
        module procedure string_lt_string
        module procedure string_lt_char
        module procedure char_lt_string
    end interface

    interface operator(<=)
        module procedure string_le_string
        module procedure string_le_char
        module procedure char_le_string
    end interface

    interface operator(>)
        module procedure string_gt_string
        module procedure string_gt_char
        module procedure char_gt_string
    end interface

    interface operator(>=)
        module procedure string_ge_string
        module procedure string_ge_char
        module procedure char_ge_string
    end interface

contains

    !
    ! === 公開手続 ===
    !

    !
    ! 総称 len 関数の実体
    !

    integer function string_len(str) result(result)
        type(VSTRING), intent(in)::        str
    continue
        result = str%len
    end function

    !
    ! 総称 var_str 関数の実体
    !

    type(VSTRING) function char_to_string(char) result(result)
        character(len=*), intent(in)::                char
        interface
            subroutine dcstringbase_warnlim(cause)
                character(len = *), intent(in):: cause
            end subroutine
        end interface
    continue
        if (len(char) > STRING_MAX) call dcstringbase_warnlim('cast')
        result%len = min(len(char), STRING_MAX)
        result%body = char
    end function

    !
    ! 総称 vchar 関数の実体
    !

    function string_to_char_length(str, length) result(result)
        type(VSTRING), intent(in)::        str
        integer, intent(in)::                        length
        character(len = length)::                result
    continue
        call char_let_string(result, str)
    end function

    !
    ! 総称代入文の実体
    !

    subroutine string_let_char(str, char)
        type(VSTRING), intent(inout):: str
        character(len=*), intent(in):: char
    continue
        str%len = len(char)
        str%body = char
    end subroutine

    subroutine string_let_char_array(str, char)
        type(VSTRING), intent(inout):: str
        character, intent(in):: char(:)
        integer:: i
    continue
        str%len = min(STRING_MAX, size(char))
        do, i = 1, str%len
            str%body(i:i) = char(i)
        enddo
    end subroutine

    subroutine char_let_string(char, str)
        character(len=*), intent(out):: char
        type(VSTRING), intent(in):: str
    continue
        char = str%body(1: str%len)
    end subroutine

    subroutine char_array_let_string(char, str)
        character, intent(out):: char(:)
        type(VSTRING), intent(in):: str
        integer:: i
    continue
        do, i = 1, min(str%len, size(char))
            char(i) = str%body(i:i)
        enddo
        char(str%len + 1: size(char)) = ' '
    end subroutine

    !
    ! 総称 // 演算子の実体
    !

    type(VSTRING) function string_add_string(lhs, rhs) result(result)
        type(VSTRING), intent(in)::                lhs, rhs
    continue
        result = char_add_char(lhs%body(1: lhs%len), rhs%body(1: rhs%len))
    end function

    type(VSTRING) function string_add_char(lhs, rhs) result(result)
        type(VSTRING), intent(in)::                lhs
        character(len = *), intent(in)::                rhs
    continue
        result = char_add_char(lhs%body(1: lhs%len), rhs)
    end function

    function char_add_string(char, str) result(result)
        type(VSTRING)::                                result
        character(len=*), intent(in)::                        char
        type(VSTRING), intent(in)::                str
    continue
        result = char_add_char(char, str%body(1: str%len))
    end function

    !
    ! 総称演算子 == の実体
    !

    logical function string_eq_string(lhs, rhs) result(result)
        type(VSTRING), intent(in)::        lhs, rhs
    continue
        result = (lhs%body(1: lhs%len) == rhs%body(1: rhs%len))
    end function

    logical function string_eq_char(str, char) result(result)
        type(VSTRING), intent(in)::        str
        character(len=*), intent(in)::                char
    continue
        result = (str%body(1: str%len) == char)
    end function

    logical function char_eq_string(char, str) result(result)
        character(len=*), intent(in)::                char
        type(VSTRING), intent(in)::        str
    continue
        result = (char == str%body(1: str%len))
    end function

    !
    ! 総称演算子 /= の実体
    !

    logical function string_ne_string(lhs, rhs) result(result)
        type(VSTRING), intent(in)::        lhs, rhs
    continue
        result = (lhs%body(1: lhs%len) /= rhs%body(1: rhs%len))
    end function

    logical function string_ne_char(str, char) result(result)
        type(VSTRING), intent(in)::        str
        character(len=*), intent(in)::                char
    continue
        result = (str%body(1: str%len) /= char)
    end function

    logical function char_ne_string(char, str) result(result)
        character(len=*), intent(in)::                char
        type(VSTRING), intent(in)::        str
    continue
        result = (char /= str%body(1: str%len))
    end function

    !
    ! 総称演算子 < の実体
    !

    logical function string_lt_string(lhs, rhs) result(result)
        type(VSTRING), intent(in)::        lhs, rhs
    continue
        result = (lhs%body(1: lhs%len) < rhs%body(1: rhs%len))
    end function

    logical function string_lt_char(str, char) result(result)
        type(VSTRING), intent(in)::        str
        character(len=*), intent(in)::                char
    continue
        result = (str%body(1: str%len) < char)
    end function

    logical function char_lt_string(char, str) result(result)
        character(len=*), intent(in)::                char
        type(VSTRING), intent(in)::        str
    continue
        result = (char < str%body(1: str%len))
    end function

    !
    ! 総称演算子 <= の実体
    !

    logical function string_le_string(lhs, rhs) result(result)
        type(VSTRING), intent(in)::        lhs, rhs
    continue
        result = (lhs%body(1: lhs%len) <= rhs%body(1: rhs%len))
    end function

    logical function string_le_char(str, char) result(result)
        type(VSTRING), intent(in)::        str
        character(len=*), intent(in)::                char
    continue
        result = (str%body(1: str%len) <= char)
    end function

    logical function char_le_string(char, str) result(result)
        character(len=*), intent(in)::                char
        type(VSTRING), intent(in)::        str
    continue
        result = (char <= str%body(1: str%len))
    end function

    !
    ! 総称演算子 > の実体
    !

    logical function string_gt_string(lhs, rhs) result(result)
        type(VSTRING), intent(in)::        lhs, rhs
    continue
        result = (lhs%body(1: lhs%len) > rhs%body(1: rhs%len))
    end function

    logical function string_gt_char(str, char) result(result)
        type(VSTRING), intent(in)::        str
        character(len=*), intent(in)::                char
    continue
        result = (str%body(1: str%len) > char)
    end function

    logical function char_gt_string(char, str) result(result)
        character(len=*), intent(in)::                char
        type(VSTRING), intent(in)::        str
    continue
        result = (char > str%body(1: str%len))
    end function

    !
    ! 総称演算子 >= の実体
    !

    logical function string_ge_string(lhs, rhs) result(result)
        type(VSTRING), intent(in)::        lhs, rhs
    continue
        result = (lhs%body(1: lhs%len) >= rhs%body(1: rhs%len))
    end function

    logical function string_ge_char(str, char) result(result)
        type(VSTRING), intent(in)::        str
        character(len=*), intent(in)::                char
    continue
        result = (str%body(1: str%len) >= char)
    end function

    logical function char_ge_string(char, str) result(result)
        character(len=*), intent(in)::                char
        type(VSTRING), intent(in)::        str
    continue
        result = (char >= str%body(1: str%len))
    end function

    !
    ! 入出力
    !

    subroutine string_get_default(str, maxlen, iostat)
        type(VSTRING), intent(out)::        str
        integer, intent(in), optional::                maxlen
        integer, intent(out), optional::        iostat
    continue
        call string_get(-1, str, maxlen, iostat)
    end subroutine

    subroutine string_get(unit, str, maxlen, iostat)
        integer, intent(in)::                        unit
        type(VSTRING), intent(out)::        str
        integer, intent(in), optional::                maxlen
        integer, intent(out), optional::        iostat
        integer::                alreadyread, buflen, nowread, ios, maxsize
        integer, parameter::        BUFFERSIZE = 80
        character(len = BUFFERSIZE)::                buffer
    continue
        if (present(maxlen)) then
            maxsize = min(maxlen, STRING_MAX)
        else
            maxsize = STRING_MAX
        endif
        alreadyread = 0
        str = ''
        do
            if (alreadyread >= maxsize) return
            buflen = min(BUFFERSIZE, maxsize - alreadyread)
            ! SUPER-UX 対策
            buffer = ''                
            ! 読み取り
            if (unit >= 0) then
                read(unit=unit, fmt='(A)', advance='NO', &
                    & size=nowread, eor=100, iostat=ios) buffer(1: buflen)
            else
                read(unit=*, fmt='(A)', advance='NO', &
                    & size=nowread, eor=100, iostat=ios) buffer(1: buflen)
            endif
            if (ios /= 0) then
                if (present(iostat)) then
                    iostat = ios
                    return
                else
                    print *, 'get_string: read error ', ios
                    stop
                endif
            endif
            ! なぜか SUPER-UX SX4 Fortran 90 では行末でこうなる
            if (nowread == 0 .and. len_trim(buffer) /= 0) then
                nowread = len_trim(buffer)
                goto 100
            endif
            alreadyread = alreadyread + nowread
            str = str // buffer(1: nowread)
        enddo
        if (present(iostat)) iostat = 0
        return

        ! in case of EOR
100        continue
        str = str // buffer(1: nowread)
        if (present(iostat)) iostat = 0
    end subroutine string_get

    subroutine char_put_default(char, iostat)
        character(len=*), intent(in)::                char
        integer, intent(out), optional::        iostat
    continue
        call char_put(-1, char, iostat)
    end subroutine

    subroutine char_put(unit, char, iostat)
        integer, intent(in)::                        unit
        character(len=*), intent(in)::                char
        integer, intent(out), optional::        iostat
        integer:: ios
    continue
        if (unit >= 0) then
            write(unit=unit, fmt='(A)', advance='NO', iostat=ios) char
        else
            write(unit=*, fmt='(A)', advance='NO', iostat=ios) char
        endif
        if (present(iostat)) then
            iostat = ios
        else
            if (ios /= 0) then
                print *, 'char_put: write error ', ios
            endif
        endif
    end subroutine

    subroutine string_put_default(str, iostat)
        type(VSTRING), intent(in)::        str
        integer, intent(out), optional::        iostat
    continue
        call string_put(-1, str, iostat)
    end subroutine

    subroutine string_put(unit, str, iostat)
        integer, intent(in)::                        unit
        type(VSTRING), intent(in)::        str
        integer, intent(out), optional::        iostat
        integer:: ios
    continue
        if (unit >= 0) then
            write(unit=unit, fmt='(A)', advance='NO', iostat=ios) str%body(1:str%len)
        else
            write(unit=*, fmt='(A)', advance='NO', iostat=ios) str%body(1:str%len)
        endif
        if (present(iostat)) then
            iostat = ios
        else
            if (ios /= 0) then
                print *, 'string_put: write error ', ios
            endif
        endif
    end subroutine

    subroutine char_put_line_default(char, iostat)
        character(len=*), intent(in)::                char
        integer, intent(out), optional::        iostat
    continue
        call char_put_line(-1, char, iostat)
    end subroutine

    subroutine char_put_line(unit, char, iostat)
        integer, intent(in)::                        unit
        character(len=*), intent(in)::                char
        integer, intent(out), optional::        iostat
        integer:: ios
    continue
        if (unit >= 0) then
            write(unit=unit, fmt='(A)', advance='YES', iostat=ios) char
        else
            write(unit=*, fmt='(A)', advance='YES', iostat=ios) char
        endif
        if (present(iostat)) then
            iostat = ios
        else
            if (ios /= 0) then
                print *, 'char_put_line: write error ', ios
            endif
        endif
    end subroutine

    subroutine string_put_line_default(str, iostat)
        type(VSTRING), intent(in)::        str
        integer, intent(out), optional::        iostat
    continue
        call string_put_line(-1, str, iostat)
    end subroutine

    subroutine string_put_line(unit, str, iostat)
        integer, intent(in)::                        unit
        type(VSTRING), intent(in)::        str
        integer, intent(out), optional::        iostat
        integer:: ios
    continue
        if (unit >= 0) then
            write(unit=unit, fmt='(A)', advance='YES', iostat=ios) str%body(1:str%len)
        else
            write(unit=*, fmt='(A)', advance='YES', iostat=ios) str%body(1:str%len)
        endif
        if (present(iostat)) then
            iostat = ios
        else
            if (ios /= 0) then
                print *, 'string_put_line: write error ', ios
            endif
        endif
    end subroutine

    !
    ! --- 組み込み関数たちの上書き ---
    !

    !
    ! index の代用
    !

    function string_index_string(str, substring, back) result(result)
        integer::                                result
        type(VSTRING), intent(in)::        str, substring
        logical, intent(in), optional::                back
        logical:: backward
        integer:: index
        intrinsic index
    continue
        backward = .FALSE.
        if (present(back)) backward = back
        result = index(str%body(1:str%len), &
            & substring%body(1:substring%len), backward)
    end function

    function string_index_char(str, substring, back) result(result)
        integer::                                result
        type(VSTRING), intent(in)::        str
        character(len = *), intent(in)::        substring
        logical, intent(in), optional::                back
        logical:: backward
        integer:: index
        intrinsic index
    continue
        backward = .FALSE.
        if (present(back)) backward = back
        result = index(str%body(1:str%len), substring, backward)
    end function

    function char_index_string(str, substring, back) result(result)
        integer::                                result
        character(len = *), intent(in)::        str
        type(VSTRING), intent(in)::        substring
        logical, intent(in), optional::                back
        logical:: backward
    continue
        backward = .FALSE.
        if (present(back)) backward = back
        result = index(str, substring%body(1:substring%len), backward)
    end function

    !
    ! scan の代用
    !

    function string_scan_string(str, set, back) result(result)
        integer::                                result
        type(VSTRING), intent(in)::        str, set
        logical, optional::                        back
        logical:: backward
    continue
        backward = .FALSE.
        if (present(back)) backward = back
        result = scan(str%body(1:str%len), set%body(1:set%len), backward)
    end function

    function string_scan_char(str, set, back) result(result)
        integer::                                result
        type(VSTRING), intent(in)::        str
        character(len = *), intent(in)::        set
        logical, optional::                        back
        logical:: backward
    continue
        backward = .FALSE.
        if (present(back)) backward = back
        result = scan(str%body(1:str%len), set, backward)
    end function

    !
    ! verify の代用
    !

    function string_verify_string(string, set, back) result(result)
        integer::                                result
        type(VSTRING), intent(in)::        string, set
        logical, optional::                        back
        logical:: b
        intrinsic verify
    continue
        b = .FALSE.
        if (present(back)) b = back
        result = verify(string%body(1:string%len), set%body(1:set%len), b)
    end function

    function string_verify_char(string, set, back) result(result)
        integer::                                result
        type(VSTRING), intent(in)::        string
        character(len = *), intent(in)::        set
        logical, optional::                        back
        logical:: backward
        intrinsic verify
    continue
        backward = .FALSE.
        if (present(back)) backward = back
            result = verify(string%body(1:string%len), set, backward)
    end function

    !
    ! --- 新設手続 ---
    !

    type(VSTRING) function extract_string(string, start, finish)
        type(VSTRING), intent(in):: string
        integer, intent(in), optional::        start, finish
        integer:: first, last
    continue
        first = 1
        if (present(start)) first = max(start, first)
        last = len(string)
        if (present(finish)) last = min(finish, last)
        extract_string = string%body(first: last)
    end function

    subroutine split_c(string, word, set, separator, back)
        type(VSTRING), intent(inout):: string
        type(VSTRING), intent(out):: word
        character(len = *), intent(in):: set
        type(VSTRING), intent(out), optional:: separator
        logical, intent(in), optional:: back
        logical:: backward
        integer:: is, endword
    continue
        backward = .FALSE.
        if (present(back)) backward = back
        if (backward) then
            find_backward: do, endword = len(string), 1, -1
                do, is = 1, len(set)
                    if (element(string, endword) == set(is:is)) &
                        & exit find_backward
                enddo
            enddo find_backward
            word = extract(string, endword)
            if (present(separator)) then
                if (endword == 0) then
                    separator = ""
                else
                    separator = element(string, endword)
                endif
            endif
            call shorten(string, len(string) - 1)
        else
            find_forward: do, endword = 1, len(string)
                do, is = 1, len(set)
                    if (element(string, endword) == set(is:is)) &
                        & exit find_forward
                enddo
            enddo find_forward
            word = extract(string, 1, endword-1)
            if (present(separator)) then
                if (endword > len(string)) then
                    separator = ""
                else
                    separator = element(string, endword)
                endif
            endif
            call left_shift(string, endword)
        endif
    end subroutine

    subroutine split_s(string, word, set, separator, back)
        type(VSTRING), intent(inout):: string
        type(VSTRING), intent(out):: word
        type(VSTRING), intent(in):: set
        type(VSTRING), intent(out), optional:: separator
        logical, intent(in), optional:: back
    continue
        call split_c(string, word, vchar(set, len(set)), separator, back)
    end subroutine

    !
    ! === 内部的に利用 ===
    !

    subroutine shorten(string, newlen)
        type(VSTRING), intent(inout):: string
        integer, intent(in):: newlen
    continue
        string%len = max(min(newlen, string%len), 1)
    end subroutine

    subroutine left_shift(string, width)
        type(VSTRING), intent(inout):: string
        integer, intent(in):: width
        integer:: len
    continue
        len = string%len
        string%body(1: len-width) = string%body(width+1: len)
        string%len = string%len - width
    end subroutine

    ! ある位置の文字を返す。不可能ならば空白を返す。
    character(len=1) function element(string, pos) result(result)
        type(VSTRING), intent(in):: string
        integer, intent(in):: pos
    continue
        if (pos <= 0 .or. pos > string%len) then
            result = ' '
        else
            result = string%body(pos:pos)
        endif
    end function

    ! 連結 // 演算子
    type(VSTRING) function char_add_char(lhs, rhs) result(result)
        character(len = *), intent(in)::        lhs, rhs
        integer::                                lhslen, first, last
        interface
            subroutine dcstringbase_warnlim(cause)
                character(len = *), intent(in):: cause
            end subroutine
        end interface
    continue
        if (len(rhs) == 0) then
            result = lhs
            return
        else if (len(lhs) == 0) then
            result = rhs
            return
        endif
        if (len(lhs) + len(rhs) > STRING_MAX) call dcstringbase_warnlim('//')
        result%len = min(len(lhs) + len(rhs), STRING_MAX)
        lhslen = min(len(lhs), STRING_MAX)
        result%body(1: lhslen) = lhs
        first = min(lhslen + 1, STRING_MAX)
        last = min(lhslen + len(rhs), STRING_MAX)
        result%body(first: last) = rhs
    end function

end module 

! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

subroutine ANVarSync(var, stat)
    use an_types, only: AN_VARIABLE, an_variable_entry
    use an_file, only: ANFileSync
    use an_vartable, only: vtable_lookup
    use netcdf_f77, only: nf_noerr
    implicit none
    type(AN_VARIABLE), intent(in), optional:: var
    integer, intent(out), optional:: stat
    type(an_variable_entry):: ent
    integer:: mystat
    if (.not. present(var)) then
        call ANFileSync(stat=stat)
        return
    endif
    mystat = vtable_lookup(var, ent)
    if (mystat /= NF_NOERR) then
        if (present(stat)) stat = mystat
    else
        call ANFileSync(ent%fileid, stat=stat)
    endif
end subroutine

! sysdep.f90 - module providing interface for system dependent procedures
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved
!
!=begin
!= module sysdep
!It provides interface for system dependent procedures.
!In other words, there is interface declaration of a function and subroutines
!whose feature is regarded as system dependent.
!Implementation of these procedures are given in files with corresponding name
!(i.e. that begins with (({sysdep}))-).
!
!Note that a procedure with one name may have several implementations.
!The most typical and recommended installation uses 
!((<DCL|URL:http://www.gfd-dennou.org/arch/dcl/>)) internally.
!However, you can use other options when you have to use a misconfigured
!installation of DCL or when you care about more advanced issues like
!the exit code of process.
!
!The (({sysdep})) has no dependence to other modules.
!=end

module sysdep

    !=begin
    !== procedure interface
    !=end

    private
    public:: AbortProgram, SysdepArgGet, SysdepArgCount

    !=begin
    !--- AbortProgram(str) subroutine
    !    ((|str|)) is (({character(len = *)})).
    !    ((*AbortProgram*)) terminates program.
    !    It is a generic name of a subroutine.
    !    In fact, the subroutine was given another name ((<SysdepAbort>)),
    !    in order to make it easier to find the source code.
    !    Though many implementations are trying to set exit code
    !    other than zero, that should ((*not*)) be relied upon.
    !=end

    interface AbortProgram
        subroutine SysdepAbort(string)
            character(len = *):: string
        end subroutine
    end interface

    interface

        !=begin
        !--- SysdepArgCount() integer function
        !    gets the number of commandline arguments.
        !    Most typically, it is implemented by nonstandard built-in
        !    function (({IARGC()})) through a DCL subroutine ((<OSQARN>)).
        !=end

        integer function SysdepArgCount()
        end function

        !=begin
        !--- SysdepArgGet(index, value) integer function
        !    ((|index|)) is (({integer, intent(in)})).
        !    ((|value|)) is (({character(len = *)})).
        !    gets the ((|index|))th commandline argument.
        !    If ((|index|)) is more than the number of arguments,
        !    ((|value|)) will be filled with blank.
        !    Most typically, it is implemented by nonstandard built-in
        !    subroutine (({GETARG()})) through a DCL subroutine ((<OSGARG>)).
        !=end

        subroutine SysdepArgGet(index, value)
            integer, intent(in):: index
            character(len = *):: value
        end subroutine

    end interface

end module

! Copyright (C) TOYODA Eizi, 2000.  All rights reserved.
! クイックビューア

! データを溜め込むための枠と図をひとつづつ用意する。
! コマンドライン引数をひとつひとつ変数として開いて、
!    図形変数ならばそのまま (it) を枠に投入し、
!    データ変数ならば標準作図を行ったもの (it) を図に投入し、
!    変数ではなくオプション指定形ならば it、標準図、標準枠の順に
!    オプションとして与えることを試みる。
! コマンドライン引数がなければデータ変数 "" を開いて図に投入する
! 図に何か投入されていれば枠に投入する
! 枠を表示する

program gtview
    use gtool
    use dcl, only: DclSetParm
    use dc_trace, only: setdebug
    implicit none
    character(STRING):: argument, optname, optvalue
    character(STRING):: var_stack = ""
    character(STRING):: figure_title = ""
    character(STRING):: slice_spec = ""
    type(GT_OBJECT):: it
    type(GT_FIGURE):: fig
    type(GT_FRAME):: frame
    type(GT_DEVICE):: dev
    integer:: i
    logical:: it_built = .FALSE.
    logical:: save_mode = .FALSE.
    logical:: disp_mode = .TRUE.
    logical:: double_mode = .FALSE.
    logical:: err
continue
    call Open(frame)
    call Open(fig)
    call Open(it)
    arg_loop: do, i = 1, GtArgCount()
        call GtArgGet(i, argument)
        if (GtOptionForm(argument, optname, optvalue)) then
            if (optname == 'wsn') then
                gtdev_wsn_default = stoi(optvalue)
            else if (optname == '-debug' .or. optname == '-D') then
                call setdebug
            else if (optname == '-save') then
                save_mode = .TRUE.
            else if (optname == '-batch') then
                disp_mode = .FALSE.
                save_mode = .TRUE.
            else if (optname == '-vect' .or. optname == '-Ve') then
                double_mode = .TRUE.
            else if (optname == '-smooth' .or. optname == '-Gaw') then
                call SWLSTX('LALT', .TRUE.)
                call SWLSTX('LWAIT', .FALSE.)
            else if (optname == '-nowait' .or. optname == '-Gw') then
                call SWLSTX('LWAIT', .FALSE.)
            else if (optname == '-alternate' .or. optname == '-Ga') then
                call SWLSTX('LALT', .TRUE.)
            else if (optname == "title") then
                figure_title = optvalue
            else if (optname == "slice") then
                slice_spec = optvalue
            else
                call Option(it, trim(optname), &
                    & trim(optvalue), err=err)
                if (err) then
                    call Option(fig, trim(optname), trim(optvalue), err=err)
                    if (err) then
                        call put_line("option " // trim(argument) // " ignored")
                    endif
                endif
            endif
        else
            if (it_built) then
        !        if (type(it) == "") then
                    call Bind(fig, it)
        !        else
        !            call Bind(frame, it)
        !        endif
            endif
            if (double_mode) then
                if (var_stack == '') then
                    var_stack = argument
                else
                    call Load(it, var_stack, argument, slice=slice_spec)
                    double_mode = .false.
                    var_stack = ""
                        it_built = .TRUE.
                endif
            else
                call Load(it, argument, slice=slice_spec)
                it_built = .TRUE.
            endif
        endif
    enddo arg_loop
    if (.not. it_built) then
        argument = ""
        call Load(it, argument, slice="")
    endif
    call Bind(fig, it)
    if (figure_title /= "") fig%title = figure_title
    ! いよいよ figure の利用
    if (disp_mode) then
        call Open(dev)
        call Display(dev, fig)
    endif
    if (save_mode) call Save(fig)
    call Close(fig)
    if (disp_mode) call Close(dev)
end program

! gtgraph_generic.f90 - 
! Copyright (C) TOYODA Eizi, 2000.  All rights reserved.

module gtgraph_generic

    implicit none
    interface Inquire
        subroutine GtObjInquire(obj, type)
            use gtgraph_types, only: GT_OBJECT
            type(GT_OBJECT), intent(in):: obj
            character(len = *), intent(out), optional:: type
        end subroutine
    end interface

    interface Open

        ! --- デフォルトコンストラクタ ---

        subroutine GTObjOpen(obj)
            use gtgraph_types, only: GT_OBJECT
            type(GT_OBJECT), intent(out):: obj
        end subroutine

        subroutine GTDevOpen(dev, ws_id, err)
            use gtgraph_types, only: GT_DEVICE
            type(GT_DEVICE), intent(out):: dev
            integer, intent(in), optional:: ws_id
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTFrameOpen(frame)
            use gtgraph_types, only: GT_FRAME
            type(GT_FRAME), intent(out):: frame
        end subroutine

        subroutine GTFigOpen(fig)
            use gtgraph_types, only: GT_FIGURE
            type(GT_FIGURE), intent(out):: fig
        end subroutine

        ! --- GTOOL_VARIABLE を引数に取る Open ---

        subroutine GTContOpen(cont, var)
            use gtgraph_types, only: GT_CONTOURS
            use gtdata_types, only: GT_VARIABLE
            type(GT_CONTOURS), intent(out):: cont
            type(GT_VARIABLE), intent(in):: var
        end subroutine

        subroutine GTVectOpen(vect, var1, var2)
            use gtgraph_types, only: GT_VECTORS
            use gtdata_types, only: GT_VARIABLE
            type(GT_VECTORS), intent(out):: vect
            type(GT_VARIABLE), intent(in):: var1
            type(GT_VARIABLE), intent(in):: var2
        end subroutine

        subroutine GTLineOpen(Line, var)
            use gtgraph_types, only: GT_Line
            use gtdata_types, only: GT_VARIABLE
            type(GT_Line), intent(out):: Line
            type(GT_VARIABLE), intent(in):: var
        end subroutine

        subroutine GTAxisOpen(axis, var, dimno, vertical)
            use gtgraph_types, only: GT_AXIS
            use gtdata_types, only: GT_VARIABLE
            type(GT_AXIS), intent(out):: axis
            type(GT_VARIABLE), intent(in):: var
            integer, intent(in):: dimno
            logical, intent(in), optional:: vertical
        end subroutine

    end interface

    interface Close

        subroutine GTDevClose(dev)
            use gtgraph_types, only: GT_DEVICE
            type(GT_DEVICE), intent(inout):: dev
        end subroutine

        recursive subroutine GTObjClose(obj)
            use gtgraph_types, only: GT_OBJECT
            type(GT_OBJECT), intent(inout):: obj
        end subroutine

        subroutine GTFrameClose(frame)
            use gtgraph_types, only: GT_FRAME
            type(GT_FRAME), intent(inout):: frame
        end subroutine

        subroutine GTFigClose(fig)
            use gtgraph_types, only: GT_FIGURE
            type(GT_FIGURE), intent(inout):: fig
        end subroutine

        subroutine GTContClose(cont)
            use gtgraph_types, only: GT_CONTOURS
            type(GT_CONTOURS), intent(inout):: cont
        end subroutine

        subroutine GTVectClose(vect)
            use gtgraph_types, only: GT_VECTORS
            type(GT_VECTORS), intent(inout):: vect
        end subroutine

        subroutine GTLineClose(Line)
            use gtgraph_types, only: GT_LINE
            type(GT_LINE), intent(inout):: Line
        end subroutine

        subroutine GTAxisClose(axis)
            use gtgraph_types, only: GT_AXIS
            type(GT_AXIS), intent(inout):: axis
        end subroutine

    end interface

        ! 内部的に使用
    interface Clear
        subroutine GTObjClear(obj)
            use gtgraph_types, only: GT_OBJECT
            type(GT_OBJECT), intent(inout):: obj
        end subroutine
    end interface

    interface Option

        subroutine GtObjOption(obj, optname, value, err)
            use gtgraph_types, only: GT_OBJECT
            type(GT_OBJECT), intent(in):: obj
            character(len = *), intent(in):: optname
            character(len = *), intent(in):: value
            logical, intent(out):: err
        end subroutine

        subroutine GtFigOption(fig, optname, value, err)
            use gtgraph_types, only: GT_FIGURE
            type(GT_FIGURE), intent(inout):: fig
            character(len = *), intent(in):: optname
            character(len = *), intent(in):: value
            logical, intent(out):: err
        end subroutine

        subroutine GtContOption(cont, optname, value, err)
            use gtgraph_types, only: GT_CONTOURS
            type(GT_CONTOURS), intent(inout):: cont
            character(len = *), intent(in):: optname
            character(len = *), intent(in):: value
            logical, intent(out):: err
        end subroutine

        subroutine GtVectOption(vect, optname, value, err)
            use gtgraph_types, only: GT_VECTORS
            type(GT_VECTORS), intent(inout):: vect
            character(len = *), intent(in):: optname
            character(len = *), intent(in):: value
            logical, intent(out):: err
        end subroutine

        subroutine GtLineOption(line, optname, value, err)
            use gtgraph_types, only: GT_LINE
            type(GT_LINE), intent(inout):: line
            character(len = *), intent(in):: optname
            character(len = *), intent(in):: value
            logical, intent(out):: err
        end subroutine

    end interface

    interface Bind

        subroutine GTObjBindObj(parent, child)
            use gtgraph_types, only: GT_OBJECT
            type(GT_OBJECT), intent(inout):: parent
            type(GT_OBJECT), intent(in):: child
        end subroutine

        subroutine GTFigBindObject(fig, obj)
            use gtgraph_types, only: GT_OBJECT, GT_FIGURE
            type(GT_FIGURE), intent(inout):: fig
            type(GT_OBJECT), intent(in):: obj
        end subroutine

        subroutine GTFigBindAxis(fig, axis, vertical)
            use gtgraph_types, only: GT_FIGURE, GT_AXIS
            type(GT_FIGURE), intent(inout):: fig
            type(GT_AXIS), pointer:: axis
            logical, intent(in), optional:: vertical
        end subroutine

        subroutine GTFigBindCont(fig, cont)
            use gtgraph_types, only: GT_FIGURE, GT_CONTOURS
            type(GT_FIGURE), intent(inout):: fig
            type(GT_CONTOURS), intent(inout):: cont
        end subroutine

        subroutine GTFigBindVect(fig, vect)
            use gtgraph_types, only: GT_FIGURE, GT_VECTORS
            type(GT_FIGURE), intent(inout):: fig
            type(GT_VECTORS), intent(inout):: vect
        end subroutine

        subroutine GTFigBindLine(fig, line)
            use gtgraph_types, only: GT_FIGURE, GT_LINE
            type(GT_FIGURE), intent(inout):: fig
            type(GT_LINE), intent(in):: line
        end subroutine

        subroutine GTFrameBindFig(frame, fig)
            use gtgraph_types, only: GT_FRAME, GT_FIGURE
            type(GT_FRAME), intent(out):: frame
            type(GT_FIGURE), intent(in):: fig
        end subroutine

    end interface

    !
    ! 普通のユーザは Display() を呼び出す。ここから
    ! 内部的に Draw サブルーチン群を呼び出している。
    ! 
    interface Display
 
        subroutine GTFrameDisplay(dev, frame)
            use gtgraph_types, only: GT_DEVICE, GT_FRAME
            type(GT_DEVICE), intent(inout):: dev
            type(GT_FRAME), intent(inout):: frame
        end subroutine

        subroutine GTFigDisplay(dev, fig)
            use gtgraph_types, only: GT_DEVICE, GT_FIGURE
            type(GT_DEVICE), intent(inout):: dev
            type(GT_FIGURE), intent(inout):: fig
        end subroutine

    end interface

    !
    ! Draw(..., paent) は内部的に Display(dev, ...) が
    ! 用いるためにある。parent 引数は通常無用だがユーザが
    ! ミスタイプで呼び出さないために Put と逆位置に
    ! 付加している。
    !
    interface Draw

        subroutine GTAxesDraw(h_axis, v_axis, parent, set_space)
            use gtgraph_types, only: GT_AXIS, GT_FIGURE
            type(GT_AXIS), intent(inout):: h_axis, v_axis
            type(GT_FIGURE), intent(in):: parent
            logical, intent(in), optional:: set_space
        end subroutine

        subroutine GTContDraw(cont, parent)
            use gtgraph_types, only: GT_CONTOURS, GT_FIGURE
            type(GT_CONTOURS), intent(inout):: cont
            type(GT_FIGURE), intent(in):: parent
        end subroutine

        subroutine GTVectDraw(vect, parent)
            use gtgraph_types, only: GT_VECTORS, GT_FIGURE
            type(GT_VECTORS), intent(inout):: vect
            type(GT_FIGURE), intent(in):: parent
        end subroutine

        subroutine GTLineDraw(line, parent)
            use gtgraph_types, only: GT_LINE, GT_FIGURE
            type(GT_LINE), intent(inout):: line
            type(GT_FIGURE), intent(in):: parent
        end subroutine

        subroutine GTFigDraw(fig, parent)
            use gtgraph_types, only: GT_FRAME, GT_FIGURE
            type(GT_FIGURE), intent(inout):: fig
            type(GT_FRAME), intent(in):: parent
        end subroutine

    end interface

    !
    ! 入出力
    !

    interface Load

        recursive subroutine GTObjLoadC(obj, varname, slice)
            use gtgraph_types, only: GT_OBJECT
            type(GT_OBJECT), intent(out):: obj
            character(len = *), intent(in):: varname
            character(len = *), intent(in):: slice
        end subroutine

        recursive subroutine GTObjLoadC2(obj, vnam1, vnam2, slice)
            use gtgraph_types, only: GT_OBJECT
            type(GT_OBJECT), intent(out):: obj
            character(len = *), intent(in):: vnam1
            character(len = *), intent(in):: vnam2
            character(len = *), intent(in):: slice
        end subroutine

        recursive subroutine GTObjLoadVar2(obj, var1, var2)
            use gtgraph_types, only: GT_OBJECT
            use gtdata_types, only: GT_VARIABLE
            type(GT_OBJECT), intent(out):: obj
            type(GT_VARIABLE), intent(in):: var1
            type(GT_VARIABLE), intent(in):: var2
        end subroutine

        recursive subroutine GTObjLoadVar(obj, var)
            use gtgraph_types, only: GT_OBJECT
            use gtdata_types, only: GT_VARIABLE
            type(GT_OBJECT), intent(out):: obj
            type(GT_VARIABLE), intent(in):: var
        end subroutine

        subroutine GTFrameLoad(frame, var)
            use gtgraph_types, only: GT_FRAME
            use gtdata_types, only: GT_VARIABLE
            type(GT_FRAME), intent(out):: frame
            type(GT_VARIABLE), intent(in):: var
        end subroutine

        subroutine GTFigLoad(Fig, var)
            use gtgraph_types, only: GT_FIGURE
            use gtdata_types, only: GT_VARIABLE
            type(GT_FIGURE), intent(out):: Fig
            type(GT_VARIABLE), intent(in):: var
        end subroutine

        subroutine GTContLoad(Cont, var)
            use gtgraph_types, only: GT_CONTOURS
            use gtdata_types, only: GT_VARIABLE
            type(GT_CONTOURS), intent(out):: Cont
            type(GT_VARIABLE), intent(in):: var
        end subroutine

        subroutine GTVectLoad(Vect, var)
            use gtgraph_types, only: GT_VECTORS
            use gtdata_types, only: GT_VARIABLE
            type(GT_VECTORS), intent(out):: Vect
            type(GT_VARIABLE), intent(in):: var
        end subroutine

        subroutine GTLineLoad(Line, var)
            use gtgraph_types, only: GT_Line
            use gtdata_types, only: GT_VARIABLE
            type(GT_Line), intent(out):: Line
            type(GT_VARIABLE), intent(in):: var
        end subroutine

        subroutine GTAxisLoadByName(Axis, varname)
            use gtgraph_types, only: GT_AXIS
            type(GT_AXIS), intent(out):: axis
            character(*), intent(in):: varname
        end subroutine

        subroutine GTAxisLoad(Axis, var)
            use gtgraph_types, only: GT_Axis
            use gtdata_types, only: GT_VARIABLE
            type(GT_Axis), intent(out):: Axis
            type(GT_VARIABLE), intent(in):: var
        end subroutine

    end interface

    ! --- Save ---
    !
    ! Save は図形変数を格納する。varname を省略すれば
    ! 変数名は自動生成される。

    interface Save

        subroutine GTFrameSave(frame, varname, resultname)
            use gtgraph_types, only: GT_FRAME
            use dc_string, only: VSTRING
            type(GT_FRAME), intent(in):: frame
            type(VSTRING), intent(in), optional:: varname
            type(VSTRING), intent(out), optional:: resultname
        end subroutine

        subroutine GTFigSave(fig, varname, resultname)
            use gtgraph_types, only: GT_FIGURE
            use dc_string, only: VSTRING
            type(GT_FIGURE), intent(in):: fig
            type(VSTRING), intent(in), optional:: varname
            type(VSTRING), intent(out), optional:: resultname
        end subroutine

        subroutine GTLineSave(line, varname, resultname)
            use gtgraph_types, only: GT_LINE
            use dc_string, only: VSTRING
            type(GT_LINE), intent(in):: line
            type(VSTRING), intent(in), optional:: varname
            type(VSTRING), intent(out), optional:: resultname
        end subroutine

        subroutine GTContSave(cont, varname, resultname)
            use gtgraph_types, only: GT_CONTOURS
            use dc_string, only: VSTRING
            type(GT_CONTOURS), intent(in):: cont
            type(VSTRING), intent(in), optional:: varname
            type(VSTRING), intent(out), optional:: resultname
        end subroutine

        subroutine GTVectSave(Vect, varname, resultname)
            use gtgraph_types, only: GT_VECTORS
            use dc_string, only: VSTRING
            type(GT_VECTORS), intent(in):: Vect
            type(VSTRING), intent(in), optional:: varname
            type(VSTRING), intent(out), optional:: resultname
        end subroutine

        subroutine GTAxisSave(axis, varname, resultname)
            use gtgraph_types, only: GT_AXIS
            use dc_string, only: VSTRING
            type(GT_AXIS), intent(in):: axis
            type(VSTRING), intent(in), optional:: varname
            type(VSTRING), intent(out), optional:: resultname
        end subroutine

    end interface

    interface operator(.equivalent.)

        logical function GTAxisEquivalent(axis1, axis2)
            use gtgraph_types, only: gt_axis
            type(gt_axis), intent(in):: axis1
            type(gt_axis), intent(in):: axis2
        end function

    end interface

    ! Save が使う名前

    interface
        subroutine GTGraphSaveName(result)
            character(len = *), intent(out):: result
        end subroutine
    end interface

end module

#!/bin/sh

set -e

${MAKE:-make} histtest

test ! -f xhist1.nc || rm -f xhist1.nc
test ! -f xhist2.nc || rm -f xhist2.nc
test ! -f xhist3.nc || rm -f xhist3.nc

./histtest $debug

ncdump xhist1.nc > xhist1.cdl

diff xhist1.cdl - <<EOF
netcdf xhist1 {
dimensions:
	time = UNLIMITED ; // (24 currently)
variables:
	float time(time) ;
		time:long_name = "time" ;
		time:units = "s @ 2001-12-16T10:00" ;
	float u(time) ;
		u:long_name = "any quantity" ;
		u:units = "non-dimensional" ;

// global attributes:
		:title = "gtool_history test 1" ;
		:source = "gtool4/Fortran library test kit" ;
		:institution = "GFD Dennou Club" ;
		:history = "unknown unknown> gtool_history: HistoryCreate\n",
    "" ;
data:

 time = 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 
    20, 21, 22, 23, 24 ;

 u = 0.09983342, 0.1986693, 0.2955202, 0.3894183, 0.4794255, 0.5646425, 
    0.6442177, 0.7173561, 0.7833269, 0.841471, 0.8912074, 0.9320391, 
    0.9635582, 0.9854497, 0.997495, 0.9995736, 0.9916648, 0.9738476, 
    0.9463001, 0.9092974, 0.8632094, 0.8084964, 0.7457052, 0.6754631 ;
}
EOF

ncdump xhist2.nc > xhist2.cdl

diff xhist2.cdl - <<EOF
netcdf xhist2 {
dimensions:
	x = 3 ;
	time = UNLIMITED ; // (3 currently)
variables:
	float x(x) ;
		x:long_name = "eastward length" ;
		x:units = "m" ;
	float time(time) ;
		time:long_name = "time" ;
		time:units = "s" ;
	float u(time, x) ;
		u:long_name = "foo quantity" ;
		u:units = "m/s" ;
	float v(time, x) ;
		v:long_name = "foo quantity" ;
		v:units = "m/s" ;

// global attributes:
		:title = "gtool_history test 2" ;
		:source = "gtool4/Fortran library test kit" ;
		:institution = "GFD DennouClub" ;
		:history = "unknown unknown> gtool_history: HistoryCreate\n",
    "" ;
data:

 x = 0, 1, 2 ;

 time = 0, 1, 2 ;

 u =
  0, 0.1, 0.2,
  2, 2.1, 2.2,
  3, 3.1, 3.2 ;

 v =
  1, 1.1, 1.2,
  _, _, _,
  4, 4.1, 4.2 ;
}
EOF

ncdump xhist3.nc > xhist3.cdl; diff xhist3.cdl - <<EOF
netcdf xhist3 {
dimensions:
	x = 3 ;
	time = UNLIMITED ; // (3 currently)
variables:
	float x(x) ;
		x:long_name = "eastward length" ;
		x:units = "m" ;
	float time(time) ;
		time:long_name = "time" ;
		time:units = "s" ;
	float u(time, x) ;
		u:long_name = "foo quantity" ;
		u:units = "m/s" ;
	float v(time, x) ;
		v:long_name = "foo quantity" ;
		v:units = "m/s" ;

// global attributes:
		:title = "gtool_history test 3" ;
		:source = "gtool4/Fortran library test kit" ;
		:institution = "GFD DennouClub" ;
		:history = "unknown unknown> gtool_history: HistoryCreate\n",
    "" ;
data:

 x = 0, 1, 2 ;

 time = 0, 1, 2 ;

 u =
  0, 0.1, 0.2,
  2, 2.1, 2.2,
  3, 3.1, 3.2 ;

 v =
  1, 1.1, 1.2,
  4, 4.1, 4.2,
  5, 5.1, 5.2 ;
}
EOF

rm -f xhist?.*

echo okay

exit 0

IF NOT EXIST INSTALL.BAT cd c:\home\c\gtool4
IF NOT EXIST c:\dennou\gt4\CON mkdir c:\dennou\gt4
XCOPY gtview\debug\gtview.exe c:\dennou\gt4 /d
XCOPY gtlist\debug\gtlist.exe c:\dennou\gt4 /d
XCOPY gtattr\debug\gtattr.exe c:\dennou\gt4 /d
XCOPY gtprint\debug\gtprint.exe c:\dennou\gt4 /d
XCOPY gtcopy\debug\gtcopy.exe c:\dennou\gt4 /d

#!/bin/sh
# test of gtattr

set -e

ncgen -b - <<EOF
netcdf xxa {
dimensions:
	x = 12;
variables:
	float	a(x);
data:
	a = -1.0, 0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0, 10.0;
}
EOF

ncgen -b - <<EOF
netcdf xxb {
dimensions:
	x = 12;
variables:
	float	b(x);
data:
	b = 0.0, 0.0, 0.0, 3.0, 3.0, 3.0, 6.0, 6.0, 6.0, 9.0, 9.0, 9.0;
}
EOF

test ! -f xo.nc || rm -f xo.nc

#	sed '/^::/d' <<-EOF > fdb.scr
#:: break an_vartable@vtable_lookup_
#:: break gtvarlimitbinary_+40
#:: run -Wl,-Re xxa.nc?a + xxb.nc?b -debug output=xo.nc
#   run xxa.nc?a + xxb.nc?b -debug output=xo.nc
#:: continue 18
#EOF
# 	fdb -script=fdb.scr ../gtbinary/gtbinary 

../gtbinary/gtbinary xxa.nc?a + xxb.nc?b $debug output=xo.nc

ncdump xo.nc > xo.cdl

diff xo.cdl - <<EOF
netcdf xo {
dimensions:
	x = 12 ;
variables:
	float x(x) ;
	float a(x) ;
data:

 x = 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12 ;

 a = -1, 0, 1, 5, 6, 7, 11, 12, 13, 17, 18, 19 ;
}
EOF

rm -f xo.nc xo.cdl xxa.nc xxb.nc

echo okay

#!/bin/sh

report_me() {
	echo Error: $*
	echo please report it to GFD-Dennou Club.
	exit 1
}

help() {
	cat <<'END_OF_HELP'
chkfort.sh - Fortran (at least 90) compiler auto-detector

 --- input ---
    FC         - fortran compiler command
    F90MODTYPE - see below
 --- input (sometimes ignored) ---
    SYSFFLAGS - fortran compiler flags required always
    SYSFLIBS  - fortran library flags required always
 --- output ---
    output is written on 'chkfort.cfg' (or \$OUT if set)
    FC        - fortran compiler command
    SYSFFLAGS - fortran compiler flags required always
    SYSFLIBS  - fortran library required always
    MOD       - suffix of module dependency files (usually .mod)
    F90MODTYPE - one of (std.mod HP.mod fqs.mod intel.d hitachi.f90)
    IFCCEM    - PUC file editor, set non-null if F90MODTYPE=intel.d
    
END_OF_HELP
	exit 1
}

#
# Step 1: initialization; read chkfort.cfg if exists
#

output=${OUT:-chkfort.cfg}

killcache=no
for arg in "$@"; do
	case $arg in
	-reinit|-nocache)
		killcache=yes
		;;
	-help)
		help
		;;
	esac
done
[ X"$killcache" = X"yes" ] && [ -f $output ] && rm -f $output

if [ -f $output ] && [ X"$FC" = X"" ]; then
	echo previous configuration result \`$output\' used.
	. ./$output
fi

#
# Step 2: determine FC;  search if not specified.
#

if [ X"$FC" = X"" ] && [ X"$F90MODTYPE" = X"" ]; then
    if [ X"$FC" = X"" ]; then
	FC=none
	for fc in frt f95 f90 xlf cf95 cf90 lf95 lf90 ifc
	do
	    fcp=`which $fc 2> /dev/null` || continue
	    [ -x $fcp ] || continue
	    FC=$fc
	    break
	done
	if [ X"$FC" = X"none" ]; then
	    echo Fortran Compiler not found. If you have, specify with \$FC.
	fi
    fi

    cat <<END_OF_TEST_PROGRAM > conftest.f90
program conftest
print *, "Hello, World!"
end program conftest
END_OF_TEST_PROGRAM

    if $FC conftest.f90 > /dev/null 2>&1 && [ -x a.out ] ; then
	echo your fortran compiler is \`$FC\' and it works.
    else
	cat <<END_OF_TEST_F77 > conftest.f
      PROGRAM CONFTEST
      PRINT *, 'HELLO, WORLD'
      END PROGRAM
END_OF_TEST_F77
	if $FC conftest.f > /dev/null 2>&1 && [ -x a.out ] ; then
	    echo $FC is only FORTRAN 77 compiler. This is no good.
	else
	    echo $FC is NOT a fortran compiler
	fi
	rm -f conftest.* a.out work.pc*
	exit 1
    fi
    rm -f conftest.* a.out
else
    echo your fortran compiler is \`$FC\'.
fi

#
# Step 3: check module handling type
#

: ${F90MODTYPE:=undef}
if [ X"$F90MODTYPE" = X"undef" ]; then
	:
	echo I will examine how $FC pass module info to another files.
	rm -f conftes?.* CONFTES?.* work.pc*
	cat > conftes1.f90 <<EOF
module conftesa
logical:: b = .false.
end module conftesa
EOF
	$FC -c conftes1.f90 > /dev/null 2>&1
	if [ ! -f conftes1.o ]; then
		report_me $FC conftes1 failed.
	fi
	if [ -f conftes1.d ]; then
		F90MODTYPE=intel.d
	elif [ -f CONFTESA.mod ]; then
		F90MODTYPE=HP.mod
	elif [ -f conftesa.mod ]; then
		F90MODTYPE=std.mod
	else
		cat > conftes2.f90 <<EOF
program conftes2
use conftesa, only: b
b = .true.
end
EOF
		ln conftes1.f90 conftesa.f90
		if $FC -c conftes2.f90 > /dev/null 2>&1 && [ -f conftes2.o ]
		then
			F90MODTYPE=hitachi.f90
		elif $FC -c -Am conftes1.f90 && $FC -c -Am conftes2.f90 > /dev/null 2>&1
		then
			F90MODTYPE=fqs.mod
		else
			report_me unknown module system
		fi
	fi
	rm -f conftes?.* CONFTES?.* work.pc*
fi

#
# Step 4: check for F90MODTYPE
#

case "${F90MODTYPE:-undef}" in
intel.d)
	MOD=.d
	: ${IFCCEM:=ifccem}
	;;
HP.mod)
	MOD=.mod
	;;
std.mod)
	MOD=.mod
	;;
hitachi.f90)
	MOD=.f90
	;;
fqs.mod)
	case "$SYSFFLAGS" in
		*-Am*) : ;;
		*) SYSFFLAGS="-Am $SYSFFLAGS" ;;
	esac
	MOD=.mod
	;;
esac

#
# Step 5: special considerations to some environments
#

: ${SYSTYPE:=`uname -s`-`uname -r`-`uname -m`}

case $SYSTYPE in
HI-OSF*-*)
	SYSFFLAGS="-i,E,L,EU"
        ;;
HP-UX*)
        SYSFLIBS="-lU77"
	;;
SunOS-5*)
	libpath=`which $FC`
	libpath=`dirname $libpath`
	libpath=`dirname $libpath`/lib
	SYSFLIBS="-R$libpath"
	;;
esac

if [ X"$IFCCEM" != X"" ]; then
	IFCCEM=`which $IFCCEM`
	if [ X"$IFCCEM" = X"" ]; then
		echo IFCCEM command not found.
		exit 1
	fi
fi

#
# Last step: output
#

cat <<END_OF_REPORT > $output
 FC=$FC
 SYSFFLAGS=$SYSFFLAGS
 SYSFLIBS=$SYSLIBS
 MOD=$MOD
 F90MODTYPE=$F90MODTYPE
 IFCCEM=$IFCCEM
 SYSTYPE=$SYSTYPE
END_OF_REPORT
echo my guess about the fortran compiler is written onto $output.
exit 0

#!/bin/sh

set -e

test ! -f gtgraph.nc || rm -f gtgraph.nc
test ! -f dcl.ps || rm -f dcl.ps

../gtview/gtview wsn=2 -save $opt1 ../gtview/gtool.nc?ps

ncdump gtgraph.nc > gtgraph.cdl
diff gtgraph.cdl - <<END_OF_NETCDF
netcdf gtgraph {
variables:
	int gr1 ;
		gr1:long_name = "surface pressure [mb]" ;
		gr1:gt_structure_class = "figure" ;
		gr1:gt_structure_member = " gr2" ;
		gr1:gt_structure_link_gr2 = "gtgraph.nc@gr2" ;
	int gr2 ;
		gr2:long_name = "contours of surface pressure" ;
		gr2:gt_structure_class = "contours" ;
		gr2:gt_graph_contours_draw_shade = "false" ;
		gr2:gt_graph_contours_draw_contours = "true" ;
		gr2:gt_structure_member = " data vaxis haxis" ;
		gr2:gt_structure_link_data = "../gtview/gtool.nc?ps" ;
		gr2:gt_structure_link_vaxis = "gtgraph.nc@gr3" ;
		gr2:gt_structure_link_haxis = "gtgraph.nc@gr4" ;
	int gr3 ;
		gr3:long_name = "horizontal axis of lat" ;
		gr3:gt_structure_class = "axis" ;
		gr3:gt_graph_axis_vertical = "false" ;
		gr3:gt_structure_member = " data" ;
		gr3:gt_structure_link_data = "../gtview/gtool.nc?lat" ;
	int gr4 ;
		gr4:long_name = "horizontal axis of lon" ;
		gr4:gt_structure_class = "axis" ;
		gr4:gt_graph_axis_vertical = "false" ;
		gr4:gt_structure_member = " data" ;
		gr4:gt_structure_link_data = "../gtview/gtool.nc?lon" ;
data:

 gr1 = _ ;

 gr2 = _ ;

 gr3 = _ ;

 gr4 = _ ;
}
END_OF_NETCDF

mv -f dcl.ps dcl.ps.bak

../gtview/gtview wsn=2 $opt2 gtgraph.nc 

diff dcl.ps dcl.ps.bak

rm -f dcl.ps dcl.ps.bak gtgraph.nc  gtgraph.cdl

echo okay

set C=unknown
if exist export.bat cd ..
cdate "+set C=%%y%%m%%d" > _export.bat
call _export.bat
pause output is gtool4-%c%.tgz
deltree gtool4-beta
mkdir gtool4-beta
xcopy /s gtool4 gtool4-beta

cd gtool4-beta
deltree /Y Debug gt*.plg gtool4.ncb gtool4.opt *.bak
qkc /U Makefile Config.mk

cd f90grep
deltree /Y Debug gt*.plg cvs
qkc /U Makefile *.f90
cd ..

cd gtview
deltree /Y Debug gt*.plg cvs
qkc /U Makefile *.f90
cd ..

cd gtunary
deltree /Y Debug gt*.plg cvs
qkc /U Makefile *.f90
cd ..

cd gtbinary
deltree /Y Debug gt*.plg cvs
qkc /U Makefile *.f90
cd ..

cd gtprint
deltree /Y Debug gt*.plg cvs
qkc /U Makefile *.f90
cd ..

cd gtattr
deltree /Y Debug gt*.plg cvs
qkc /U Makefile *.f90
cd ..

cd gtlist
deltree /Y Debug gt*.plg cvs
qkc /U Makefile *.f90
cd ..

cd gtcopy
deltree /Y Debug gt*.plg cvs
qkc /U Makefile *.f90
cd ..

cd gtshallow
deltree /Y Debug gt*.plg cvs
qkc /U Makefile *.f *.f90
cd ..

cd src
deltree /Y Debug gt*.plg cvs
qkc /M Makefile Config.mk
qkc /U Makefile *.f *.f90
cd ..

deltree /y vbgttree\package vbgttree\cvs
del vbgttree\vbgttree.pdm
del vbgttree\vbgttree.exe

deltree /y gtool4\debug gtool4\cvs cvs not-yet-used\cvs
deltree /y doc\_vti_cnf doc\cvs doc\images\cvs
deltree /y doc\images\_vti_cnf
cd ..
tar cvfz gtool4-%C%.tgz dc-isovst gtool4-beta
deltree /y gtool4-beta
del _export.bat
SET C=

#!/bin/sh
#
# Copyright (C) GFD Dennou Club, 2000.  All rights reserved.
#
fc="`which ${FC:?}`"
fflags="-I${MODINSTDIR:?} ${SYSFFLAGS}"
libs="-L${LIBINSTDIR:?} -l${LIBNAME:?}"

ldflags=${SYSLDFLAGS}
ldlibs=${SYSLDLIBS:?}
out=${1:-dclf90}

if [ ${F90MODTYPE:?} = intel.d ]; then
	ldlibs=`echo $ldlibs | sed s/-lm//`
fi

cat > $out <<EOF
#!/bin/sh

fc="$fc"
fflags="$fflags"
libs="$libs"
ldflags="$ldflags"
ldlibs="$ldlibs"

EOF

if [ ${F90MODTYPE:?} = intel.d ]; then

	cat >> $out <<EOF
# support for Intel Fortran
	if [ ! -f work.pcl ]; then
		echo work.pc > work.pcl
	fi
	for arg in \$fflags
	do
	    case "\$arg" in
	    -I*)
		dir=\`echo \$arg | sed s/-I//\`
		if [ ! -f \$dir/work.pc ]; then
			echo Notice: \$dir/work.pc not exist, and ignored.
			touch work.pcl
			break
		fi
		if ! grep -q "^\$dir/work.pc\\$" work.pcl
		then
			echo adding \$dir
			echo \$dir/work.pc >> work.pcl
		fi
		;;
	    esac
	done
EOF

fi

cat >> $out <<EOF

echo \$fc \$fflags "\$@" \$libs \$ldflags \$ldlibs
exec \$fc \$fflags "\$@" \$libs \$ldflags \$ldlibs
EOF

#!/bin/sh
# test of gtattr

set -e

ncgen -b - <<EOF
netcdf xx {
variables:
	int	a;
}
EOF

../gtattr/gtattr xx.nc@a ii=4 ir=432.97 it=quux > /dev/null
../gtattr/gtattr xx.nc@a -type=int i=4 > /dev/null
../gtattr/gtattr xx.nc@a -type=real r=432.97 > /dev/null
../gtattr/gtattr xx.nc@a -type=double d=432.97 > /dev/null
../gtattr/gtattr xx.nc@a -type=text t=432.97 > /dev/null

ncdump xx.nc > xx.cdl

diff xx.cdl - <<EOF
netcdf xx {
variables:
	int a ;
		a:ii = "4" ;
		a:ir = "432.97" ;
		a:it = "quux" ;
		a:i = 4 ;
		a:r = 432.97f ;
		a:d = 432.97 ;
		a:t = "432.97" ;
data:

 a = _ ;
}
EOF

rm -f xx.nc xx.cdl
echo okay

#!/bin/sh
#
# Copyright (C) GFD Dennou Club, 2000.  All rights reserved.
#
fc="`which ${FC:?}`"
fflags="-I${MODINSTDIR:?} $SYSFFLAGS"
ldflags="$SYSLDFLAGS -L$LIBINSTDIR"
ldlibs="-l$LIBNAME $SYSLDLIBS"
out=${1:-dclf90config}

if [ $F90MODTYPE = intel.d ]; then
	ldlibs=`echo $ldlibs | sed s/-lm//`
fi

cat > $out <<END_OF_SCRIPT
#!/bin/sh

fc="$fc"
fflags="$fflags"
ldflags="$ldflags"
ldlibs="$ldlibs"

usage() {
	cat <<EOF
usage: gt4config [OPTIONS]
options: one of --dcllang --fc --fflags --ldflags --ldlibs
EOF
	exit 1
}

if test \$# -eq 0; then
	usage
fi

while test \$# -gt 0; do
    case \$1 in
	--fc)		echo \$fc ;;
	--fflags)	echo \$fflags ;;
	--ldflags)	echo \$ldflags ;;
	--ldlibs)	echo \$ldlibs ;;
	--dcllang)	echo f90 ;;
	*)		usage ;;
    esac
    shift
done

END_OF_SCRIPT

#!/bin/sh

# update Intel Fortran's work.pcl file

if [ ! -f work.pcl ]; then
	echo work.pc > work.pcl
fi

for arg in "$@"
do
	case "$arg" in
	-I*)
		dir=`echo $arg | sed s/-I//`
		if [ ! -f $dir/work.pc ]; then
			echo Notice: $dir/work.pc not exist, and ignored.
			touch work.pcl
			break
		fi
		if ! grep -q "^$dir/work.pc\$" work.pcl
		then
			echo adding $dir
			echo $dir/work.pc >> work.pcl
		fi
		;;
	esac
done
